TIMEZONES = (
 (1, 1, '-12:00', 'International Date Line West', -720),
 (2, 2, '-11:00', 'Midway Island, Samoa', -660),
 (3, 3, '-10:00', 'Hawaii', -600),
 (4, 4, '-9:00', 'Alaska', -540),
 (5, 5, '-8:00', 'Pacific Time (US & Canada); Tijuana', -480),
 (6, 6, '-7:00', 'Arizona', -420),
 (7, 6, '-7:00', 'Chihuahua, La Paz, Mazatlan', -420),
 (8, 6, '-7:00', 'Mountain Time (US & Canada)', -420),
 (9, 7, '-6:00', 'Central America', -360),
 (10, 7, '-6:00', 'Central Time (US & Canada)', -360),
 (11, 7, '-6:00', 'Guadalaraja, Mexico City, Monterrey', -360),
 (12, 7, '-6:00', 'Saskatchewan', -360),
 (13, 8, '-5:00', 'Bogota, Lima, Quito', -300),
 (14, 8, '-5:00', 'Eastern Time (US & Canada)', -300),
 (15, 8, '-5:00', 'Indiana (East)', -300),
 (16, 9, '-4:00', 'Atlantic Time (Canada)', -240),
 (17, 9, '-4:00', 'Caracas, La Paz', -240),
 (18, 9, '-4:00', 'Santiago', -240),
 (19, 10, '-3:00', 'Newfoundland', -180),
 (20, 10, '-3:00', 'Brazilia', -180),
 (21, 10, '-3:00', 'Buenos Aires, Georgetown', -180),
 (22, 10, '-3:00', 'Greenland', -180),
 (23, 11, '-2:00', 'Mid-Atlantic', -120),
 (24, 12, '-1:00', 'Azores', -60),
 (25, 12, '-1:00', 'Cape Verde Is.', -60),
 (26, 13, '', 'Casablanca, Monrovia', 0),
 (27, 13, '', 'Greenwich Mean Time : Dublin, Edinburgh, Lisbon, London', 0),
 (28, 14, '+1:00', 'Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna', 60),
 (29, 14, '+1:00', 'Belgrade, Bratislava, Budapest, Ljubljana, Prague', 60),
 (30, 14, '+1:00', 'Brussels, Copenhagen, Madrid, Paris', 60),
 (31, 14, '+1:00', 'Sarajevo, Skopje, Warsaw, Zagreb', 60),
 (32, 14, '+1:00', 'West Central Africa', 60),
 (33, 15, '+2:00', 'Athens, Istanbul, Minsk', 120),
 (34, 15, '+2:00', 'Bucharest', 120),
 (35, 15, '+2:00', 'Cairo', 120),
 (36, 15, '+2:00', 'Harare, Pretoira', 120),
 (37, 15, '+2:00', 'Helsinki, Kyiv, Riga, Sofia, Tallinn, Vilnius', 120),
 (38, 15, '+2:00', 'Jerusalem', 120),
 (39, 16, '+3:00', 'Baghdad', 180),
 (40, 16, '+3:00', 'Kuwait, Riyadh', 180),
 (41, 16, '+3:00', 'Moscow, St Petersburg, Volgograd', 180),
 (42, 16, '+3:00', 'Nairobi', 180),
 (43, 16, '+3:30', 'Tehran', 210),
 (44, 17, '+4:00', 'Abu Dhabi, Muscat', 240),
 (45, 17, '+4:00', 'Baku, Tbilisi, Yerevan', 240),
 (46, 17, '+4:30', 'Kabul', 270),
 (47, 18, '+5:00', 'Ekaterinbrug', 300),
 (48, 18, '+5:00', 'Islamabad, Karachi, Tashkent', 300),
 (49, 18, '+5:30', 'Chennai, Kolkata, Mumbai, New Delhi', 330),
 (50, 18, '+5:45', 'Kathmandu', 345),
 (51, 19, '+6:00', 'Almaty, Novosibirsk', 360),
 (52, 19, '+6:00', 'Astana, Dhaka', 360),
 (53, 19, '+6:00', 'Sri Jayawardenepura', 360),
 (54, 19, '+6:30', 'Rangoon', 390),
 (55, 20, '+7:00', 'Bangkok, Hanoi, Jakarta', 420),
 (56, 20, '+7:00', 'Krasnoyarsk', 420),
 (57, 21, '+8:00', 'Bejing, Chongqing, Hong Kong, Urumqi', 480),
 (58, 21, '+8:00', 'Irkutsk, Ulaan Bataar', 480),
 (59, 21, '+8:00', 'Kuala Lumpur, Singapore', 480),
 (60, 21, '+8:00', 'Perth', 480),
 (61, 21, '+8:00', 'Taipei', 480),
 (62, 22, '+9:00', 'Osaka, Sappopo, Tokyo', 540),
 (63, 22, '+9:00', 'Seoul', 540),
 (64, 22, '+9:00', 'Yakutsk', 540),
 (65, 22, '+9:30', 'Adelaide', 570),
 (66, 22, '+9:30', 'Darwin', 570),
 (67, 23, '+10:00', 'Brispane', 600),
 (68, 23, '+10:00', 'Canberra, Melbourne, Sydney', 600),
 (69, 23, '+10:00', 'Guam, Port Moresby', 600),
 (70, 23, '+10:00', 'Hobart', 600),
 (71, 23, '+10:00', 'Vladivostok', 600),
 (72, 24, '+11:00', 'Magadan, Solomon Is., New Caledonia', 660),
 (73, 25, '+12:00', 'Auckland, Wellington', 720),
 (74, 25, '+12:00', 'Fiji, Kamchatka, Marshall Is.', 720)
)

TIMEZONES_D = {}
for i in TIMEZONES:
    TIMEZONES_D[i[0]] = i
