import os

FALLBACK_ENCODING = "ISO8859-1"

# Default settings
DEFAULT_LANG = "en_US"
DEFAULT_DATE = "en_US"

DB_NAME = "confluxpro"
DB_USER = "conflux"
DB_PASS = "confluxdb"
DB_HOST = ""
DB_PORT = "5432"

PG_DUMP_PATH = "/usr/bin/pg_dump"

PARSER_PDF = "/usr/bin/pdftotext"
PARSER_DOC = "/usr/bin/wvHtml"
SPELL_CHECKER = "/usr/bin/aspell"

SMTPSERVER = 'localhost'

MAX_REPEAT_EVENTS = 10000
REPEAT_DAY_TRESHOLD   = 60
REPEAT_WEEK_TRESHOLD  = 40
REPEAT_MONTH_TRESHOLD = 20
REPEAT_YEAR_TRESHOLD  = 10

BASE_PATH = "/var/lib/conflux/"
BASE_URL = "/conflux/"
DAV_URL = "/conflux/DAV/"

BASE_DOCUMENT_PATH = os.path.join(BASE_PATH, "DOCROOT")
BACKUP_DOCUMENT_PATH = os.path.join(BASE_PATH, "DOCBACKUP")
TEMP_DOCUMENT_PATH = os.path.join(BASE_PATH, "tmp")
BACKUP_PATH = os.path.join(BASE_PATH, "BACKUP")

ERROR_SHOW_TB = 1 # Zero if reporting errors is disabled, one if on.
                  # Will display a python traceback in the comments of the error page
ERROR_EMAIL_ADMIN = "collector@inversion.ee" # If the error reporting is on and this value is non-empty,
                       # the tracebacks will also be emailed to this address.
