"""

Contact Object

$Id: _Contact.py,v 1.3 2003/12/12 21:36:22 incxcvs Exp $
"""

import _RootObject, _Utils
import _InitTypes

class Contact(_RootObject.RootObject):
    table_name = 'contacts'
    field_name = 'contact_id'
    item_type_id = _InitTypes.ITEM_TYPE_CONTACT
    is_container = 0
    object_fields = {
'contact_id':	{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'first_name':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'last_name':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'middle_name':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'company':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'department':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'jobtitle':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'phone_work':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'phone_home':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'phone_cell':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'phone_fax':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'e_mail':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'e_mail2':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'e_mail3':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'mailing_address':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'description':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'homepage':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'contact_category':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'birth_date':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'contact_sex':	{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
    }

    fti_keys = ['first_name','last_name','middle_name','company','department','jobtitle',
                'phone_work','phone_home','phone_cell','phone_fax','e_mail','e_mail2','e_mail3', 'mailing_address',
                'description','homepage', 'contact_category']

    def get_name(self):
        if self.get('first_name') is not None and self.get('last_name') is not None:
            return self.get('first_name') + ' ' + self.get('last_name')
        elif self.get_id() is None:
            return self.REQUEST.TLS('contactobj_notsaved')
        else:
            return self.REQUEST.TLS('contactobj_noname') % self.get_id()
