"""

Dussan Job Object

"""

import _RootObject, _Utils
import _InitTypes

JOB_STATUS_START = 0
JOB_STATUS_TRANSLATED = 1
JOB_STATUS_EDITED = 2
JOB_STATUS_CHECKED = 3
JOB_STATUS_RELEASED = 4

JOB_MOD_FAST = 1
JOB_MOD_SPEC = 2
JOB_MOD_HAND = 4

JOBROW_MAIN = 1

class DusJob(_RootObject.RootObject):
    table_name = 'dus_jobs'
    field_name = 'job_id'
    item_type_id = _InitTypes.ITEM_TYPE_DUSJOB
    is_container = 0
    object_fields = {
'job_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'job_number':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	 'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'job_status':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'received':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'description':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'due_translation':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'due_editing':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'due_checking':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'client_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'category':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'person_translation':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'person_editing':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'person_checking':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'job_flags':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
    }

    fti_keys = ['description']

    def get_name(self):
        return 'N/A'

    def add_row(self, service_id, price, price_mod_percent, unit_count, jobrow_flags=0):
        SQL = u"""INSERT INTO dus_job_rows (job_id, service_id, price, price_mod_percent, unit_count, jobrow_flags) VALUES
(%d, %d, %.2f, %d, %.2f, %d)""" % (self.get_id(), service_id, price, price_mod_percent, unit_count, jobrow_flags)
        self.REQUEST.db.execute(SQL.encode('UTF8'))

    def del_row(self, service_id):
        SQL = u"""DELETE FROM dus_job_rows WHERE job_id=%d AND service_id=%d""" % (self.get_id(), service_id)
        self.REQUEST.db.execute(SQL.encode('UTF8'))

    def del_rows(self):
        SQL = u"""DELETE FROM dus_job_rows WHERE job_id=%d""" % self.get_id()
        self.REQUEST.db.execute(SQL.encode('UTF8'))

    def get_rows(self):
        SQL = u"""SELECT * FROM dus_job_rows WHERE job_id=%d""" % self.get_id()
        self.REQUEST.db.execute(SQL.encode('UTF8'))
        return self.REQUEST.db.dictfetchall()

