"""

eaccount Object

$Id: _Eaccount.py,v 1.2 2003/08/18 10:43:41 incxcvs Exp $
"""

import _RootObject, _Utils
import _InitTypes, _Efolder

# _flags bits
EACCOUNT_NONE = 0
EACCOUNT_POP3 = 1
EACCOUNT_IMAP4 = 2
EACCOUNT_ACTIVE = 4
EACCOUNT_DELETE_MESSAGES = 8
EACCOUNT_IMAP4_REMOTE = 16

class Eaccount(_RootObject.RootObject):
    table_name = 'eaccounts'
    field_name = 'eaccount_id'
    item_type_id = _InitTypes.ITEM_TYPE_EACCOUNT
    is_container = 0
    object_fields = {
'eaccount_id':	 { 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'eaccount_name': { 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'eaccount_user': { 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'eaccount_password': { 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'eaccount_flags':{ 'type': _Utils.sql_cast_int,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'eaccount_sendername': { 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'eaccount_sendermail': { 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    def get_name(self):
        if self.get('eaccount_name') is not None:
            return self.get('eaccount_name')
        elif self.get_id() is None:
            return self.REQUEST.TLS('eaccountobj_notsaved')
        else:
            return self.REQUEST.TLS('eaccount_noname') % self.get_id()

    def delete_hook(self): # delete all related efilters
        self.REQUEST.db.execute("""SELECT i.item_id FROM items i, efolders e WHERE i.item_id=e.efolder_id AND i.item_type_id=%d AND e.eaccount_id=%d""" %(_InitTypes.ITEM_TYPE_EFOLDER, self.get_id()))
        res = self.REQUEST.db.dictfetchall()
        for efolder in res:
            obj = _Efolder.Efolder(self.REQUEST, _InitTypes.INIT_TYPE_ID, efolder['item_id'])
            obj.delete()
