"""

email Object

$Id: _Email.py,v 1.5 2003/12/12 21:13:48 incxcvs Exp $
"""

import md5, base64
import _RootObject, _Utils, _Efolder, _Exceptions
import _InitTypes, _Conf

EMAIL_NONE = 0
EMAIL_READ = 1
EMAIL_ANSWERED = 2
EMAIL_ATTACH = 4
EMAIL_DRAFT = 8
EMAIL_PRIORITY = 16

EFOLDER_EVENT_MOVE = 1
EFOLDER_EVENT_DELETE = 2

class Email(_RootObject.RootObject):
    table_name = 'emails'
    field_name = 'email_id'
    item_type_id = _InitTypes.ITEM_TYPE_EMAIL
    is_container = 0
    object_fields = {
'email_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'email_from':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'email_subject':{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'email_to':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'email_date':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'email_size':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'email_flags':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'email_message_id':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
#'email_contents':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'email_contacts':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'email_from_addr':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'email_to_addr':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'eaccount_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    fti_keys = ['email_from','email_subject','email_to']

    def get(self, key):
        if key == 'email_contents' and self.get_id() and self.__itemdata__.get(key, None) is None:
            self.REQUEST.db.execute("""SELECT email_base64 FROM email_contents WHERE email_id=%d""" % self.get_id())
            res = self.REQUEST.db.fetchone()
            if res: return res[0]
            else: return None
        else:
            return _RootObject.RootObject.get(self, key)

    def get_name(self):
        if self.get('email_subject') is not None:
            return self.get('email_subject')
        elif self.get_id() is None:
            return self.REQUEST.TLS('emailobj_notsaved')
        else:
            return self.REQUEST.TLS('emailobj_noname') % self.get_id()

    def AfterInsertHook(self):
        self.REQUEST.db.execute("""INSERT INTO email_contents (email_id, email_base64) VALUES ( %d, %s )""" % (self.get_id(), _Utils.sql_cast_str(self.REQUEST, self.__itemdata__.get('email_contents', ''))))
        self.save_received()

    def BeforeUpdateHook(self):
        if self.REQUEST.USER.get_id() not in [_Conf.SUPERUSER, self.get('creator_id')]:
            raise _Exceptions.AccessError, self.REQUEST.TLS('rootobj_noupdateaccess')

    def BeforeDeleteHook(self):
        if self.REQUEST.USER.get_id() not in [_Conf.SUPERUSER, self.get('creator_id')]:
            raise _Exceptions.AccessError, self.REQUEST.TLS('rootobj_noupdateaccess')

    def AfterUpdateHook(self):
        if not self.__olddata__.has_key('email_contents') or not self.__itemdata__.has_key('email_contents') or self.__olddata__['email_contents'] <> self.__itemdata__['email_contents']:
            self.REQUEST.db.execute("""UPDATE items SET index_this_item=1 WHERE item_id=%d""" % self.get_id())
            SQL = """UPDATE email_contents SET email_base64=%s WHERE email_id=%d""" % (_Utils.sql_cast_str(self.REQUEST, self.get('email_contents') or ''), self.get_id())
            self.REQUEST.db.execute(SQL)
        if self.get('eaccount_id') and self.__olddata__.has_key('parent_id') and self.__olddata__['parent_id'] <> self.get_parent_id():
            oldparent = _Efolder.Efolder(self.REQUEST, _InitTypes.INIT_TYPE_ID, self.__olddata__['parent_id'])
            newparent = self.get_parent()
            if oldparent.get('efolder_flags') & _Efolder.EFOLDER_IMAPF or newparent.get('efolder_flags') & _Efolder.EFOLDER_IMAPF:
                if newparent.get('efolder_flags') & _Efolder.EFOLDER_IMAPF and newparent.get('eaccount_id'):
                    SQL = u"""UPDATE emails SET eaccount_id=%d WHERE email_id=%d""" % (newparent.get('eaccount_id'),self.get_id())
                    self.set('eaccount_id', newparent.get('eaccount_id'))
                else:
                    SQL = u"""UPDATE emails SET eaccount_id=null WHERE email_id=%d""" % self.get_id()
                    self.set('eaccount_id', None)
                self.REQUEST.db.execute(SQL.encode('UTF8'))

    def AfterDeleteHook(self):
        self.REQUEST.db.execute("""DELETE FROM imap_emails WHERE conflux_id=%d""" % self.get_id())

    def save_received(self):
        if self.get('email_pop3_uid') and self.get('email_message_id'):
            SQL = u"""INSERT INTO emails_received (parent_id, email_account, email_message_id, email_pop3_uid) VALUES (%d, %s, %s, %s)""" % \
                (self.REQUEST.USER.get_id(), _Utils.sql_cast_str(self.REQUEST, self.get('email_account')), _Utils.sql_cast_str(self.REQUEST, self.get('email_message_id')), _Utils.sql_cast_str(self.REQUEST, self.get('email_pop3_uid')))
        elif self.get('email_pop3_uid'):
            md5sum = md5.md5(base64.decodestring(self.get('email_contents'))).hexdigest()
            SQL = u"""INSERT INTO emails_received (parent_id, email_account, email_message_id, email_pop3_uid) VALUES (%d, %s, %s, %s)""" % \
                (self.REQUEST.USER.get_id(), _Utils.sql_cast_str(self.REQUEST, self.get('email_account')), _Utils.sql_cast_str(self.REQUEST, md5sum), _Utils.sql_cast_str(self.REQUEST, self.get('email_pop3_uid')))
        elif self.get('email_message_id'):
            SQL = u"""INSERT INTO emails_received (parent_id, email_account, email_message_id, email_pop3_uid) VALUES (%d, %s, %s, null)""" % \
                (self.REQUEST.USER.get_id(), _Utils.sql_cast_str(self.REQUEST, self.get('email_account')), _Utils.sql_cast_str(self.REQUEST, self.get('email_message_id')))
        else:
            md5sum = md5.md5(base64.decodestring(self.get('email_contents'))).hexdigest()
            SQL = u"""INSERT INTO emails_received (parent_id, email_account, email_message_id, email_pop3_uid) VALUES (%d, %s, %s, null)""" % \
                (self.REQUEST.USER.get_id(), _Utils.sql_cast_str(self.REQUEST, self.get('email_account')), _Utils.sql_cast_str(self.REQUEST, md5sum))

        self.REQUEST.db.execute(SQL.encode('UTF8'))

    def get_size(self):
        if self.get('email_contents') is None:
            return 0
        else:
            return len(self.get('email_contents'))
