"""

Calendar Object

$Id: _Event.py,v 1.3 2004/02/15 13:10:58 incxcvs Exp $
"""

import _RootObject, _Utils
import _InitTypes

REPEAT_DAY = 0
REPEAT_WEEK = 1
REPEAT_MONTH = 2
REPEAT_YEAR = 5

DAYS = [2, 4, 8, 16, 32, 64, 1] # Starting from Monday

TIME_WEEKDAY = 5 # time.time() weekday

EVENT_REMINDER_OTHERS = 1

class Event(_RootObject.RootObject):
    table_name = 'events'
    field_name = 'event_id'
    item_type_id = _InitTypes.ITEM_TYPE_EVENT
    is_container = 0
    object_fields = {
'event_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	 'has_default': 1,       'can_insert': 0 },
'event_name':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'event_priority':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'event_activity':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'start_stamp':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'end_stamp':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'description':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'comments':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'remind_type':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'remind_time':	{ 'type': _Utils.sql_cast_interval,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'related_persons':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'seen_persons':		{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'accepted_persons':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'rejected_persons':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'repeat_interval':	{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'dayofweek':		{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,     'can_insert': 1 },
'dayofmonth':		{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,     'can_insert': 1 },
'monthofyear':		{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,     'can_insert': 1 },
'repeat_type':		{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,     'can_insert': 1 },
'last_reminder':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'related_groups':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'event_flags':		{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,	'can_insert': 1 },
'master_id':		{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,     'can_insert': 1 },
    }

    fti_keys = ['event_name', 'description', 'comments']

    def get_name(self):
        if self.get('event_name') is not None:
            return self.get('event_name')
        elif self.get_id() is None:
            return self.REQUEST.TLS('eventobj_notsaved')
        else:
            return self.REQUEST.TLS('eventobj_noname') % self.get_id()
