import _Conf

class Menu:
    START_MENU = """<TABLE cellpadding=0 width="100%%" cellspacing=0 class="table_menu" style="background-image: url('%(BASE_ICON_URL)s%(back_icon)s')">\n <TR>"""
    END_MENU = """\
    <TD align="right" width="100%%"><IMG src="%(BASE_ICON_URL)sspacer.gif" border="0" width="3" height="1" alt=""></TD>
    %(search_link)s
    <TD>%(im_link)s</TD>
    <TD>%(help_link)s</TD>
  </TR>
</TABLE>
<BR>"""
    END_MENU_NOBR = """\
    %(search_link)s
    <TD align="right" width="100%%"><IMG src="%(BASE_ICON_URL)sspacer.gif" border="0" width="3" height="1" alt=""></TD>
    <TD>%(im_link)s</TD>
    <TD>%(help_link)s</TD>
  </TR>
</TABLE>
"""
    ROW_MENU = """\
    <TD onclick="%sdocument.location='%s'" width="8" class="%s" %s><img src="%sspacer.gif" width="8" height="26" border=0 alt=""></TD>
    <TD onclick="%sdocument.location='%s'" class="%s" valign=top nowrap %s>%s</TD>
    <TD onclick="%sdocument.location='%s'" class="%s" valign="middle" nowrap %s>%s</TD>
    <TD onclick="%sdocument.location='%s'" width="10" class="%s" %s><img src="%sspacer.gif" width="10" height="26" border=0 alt=""></TD>"""
    def __init__(self, REQUEST, MY_MENU_ID=None, nobr = 0):
        if MY_MENU_ID is None:
            self.selected = 0
        else:
            self.selected = MY_MENU_ID
        self.__items__ = []
        self.back_icon = 'treetopbg2.gif'
        self.help_link = None
        self.im_link = None
        self.search_link = None
        self.nobr = 0

    def add_item(self, name, link, icon, target="", onOver = None):
        item = {}
        item['name'] = name
        item['target'] = target
        item['link'] = link
        item['icon'] = icon
        self.__items__.append(item)

    def set_helplink(self, value):
        self.help_link = value
    def set_imlink(self, value):
        self.im_link = value

    def set_searchlink(self, value):
        self.search_link = value

    def set_nobr(self, value):
        self.nobr = value

    def draw(self, header=""):
        output = []
        output.append(self.START_MENU % {'back_icon':self.back_icon, 'BASE_ICON_URL':_Conf.BASE_ICON_URL})
        output.append(header)
        index = 0
        for item in self.__items__:
            if item['link']:
                link1 = """<IMG src="%s" border="0" alt="">""" % (item['icon'])
                link2 = """<SPAN class="topmenu_link">%s</SPAN>""" % (item['name'])
                link3 = item['link']
                if item['target']:
                    link4 = item['target']
                else:
                    link4 = ""
            else:
                link1 = ""
                link2 = ""
                link3 = ""
                link4 = ""
            if index == self.selected:
                tdclass = "td_menu_selected"
                tdclass2 = "td_menu_selected2"
                style = """style="cursor: pointer; cursor: hand; background-image: url('%streetopbg3.gif');\"""" % _Conf.BASE_ICON_URL
            else:
                tdclass = "td_menu"
                tdclass2 = "td_menu2"
                style = """style = "cursor: pointer; cursor: hand;\""""
            output.append(self.ROW_MENU % (link4, link3, tdclass, style, _Conf.BASE_ICON_URL, link4, link3, tdclass2, style, link1, link4, link3, tdclass, style, link2, link4, link3, tdclass, style, _Conf.BASE_ICON_URL)) # FIXME
            index += 1

        if self.help_link:
            help_link = u"""<A target="_blank" href="%s"><IMG src="%shelp.gif" border="0" width="25" height="12" alt=""></A>""" % (self.help_link, _Conf.BASE_ICON_URL)
        else:
            help_link = u'&nbsp;'
        if self.im_link:
            im_link = u"""<A href="javascript:void(0);" onclick="show_bl();"><IMG src="%sim.gif" border="0" width="20" height="16" alt="" style="position: relative; bottom: 2px;"></A>""" % (_Conf.BASE_ICON_URL)
        else:
            im_link = u'&nbsp;'
        if self.search_link:
            search_link = u"""\
    <TD align="right" width="100%%"><IMG src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD valign="top"><IMG src="%(BASE_ICON_URL)ssearchicon.gif" onclick="show_search()" border="0" width="19" height="16" alt="" style="cursor: hand; cursor: pointer; position: relative; top: 3px;"></TD>
    """ % {'BASE_ICON_URL':_Conf.BASE_ICON_URL}
        else:
            search_link = ""
        if self.nobr:
            output.append(self.END_MENU_NOBR % {'help_link': help_link, 'search_link':search_link, 'im_link':im_link, 'BASE_ICON_URL':_Conf.BASE_ICON_URL})
        else:
            output.append(self.END_MENU % {'help_link': help_link, 'search_link':search_link, 'im_link':im_link, 'BASE_ICON_URL':_Conf.BASE_ICON_URL})
        return "\n".join(output)
