"""

Message Object

$Id$
"""

import _RootObject, _Utils
import _InitTypes

class Message(_RootObject.RootObject):
    table_name = 'messages'
    field_name = 'message_id'
    item_type_id = _InitTypes.ITEM_TYPE_MESSAGE
    is_container = 0
    object_fields = {
'message_id':	{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'message_title':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'message_source':{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'sender_org_id':{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'sender_org_name':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'sender_nr':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'receiver_org_id':{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'receiver_org_name':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'receiver_person_id':{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'receiver_person_name':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'responsible_person':{ 'type': _Utils.sql_cast_int,		'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'message_contents':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'message_type':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'delivery_method':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'priority':	{ 'type': _Utils.sql_cast_str,		'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'date_dispatch':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'date_arrival':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'date_deadline':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'date_answered':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    fti_keys = ['message_title','sender_org_name','sender_nr','receiver_org_name','receiver_person_name','message_contents','message_type', 'delivery_method', 
                'priority', 'date_dispatch', 'date_arrival','date_deadline','date_answered']

    def get_name(self):
        if self.get('message_title') is not None:
            return self.get('message_title')
        else:
            return str(self.get_id())
