"""

Opportunity Object

$Id$
"""

import _RootObject, _Utils
import _InitTypes

class Opportunity(_RootObject.RootObject):
    table_name = 'opportunities'
    field_name = 'opp_id'
    item_type_id = _InitTypes.ITEM_TYPE_OPPORTUNITY
    is_container = 0
    object_fields = {
'opp_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'opp_name':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'client_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'opp_stage':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'opp_next_stage':{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'description':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'req_descr':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'amount':	{ 'type': _Utils.sql_cast_float,'simple_type': float,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'close_date':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'opp_lost':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'lead_source':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'client_type':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    fti_keys = ['opp_name','opp_next_stage','description','req_descr', 'opp_lost', 'lead_source', 'client_type']

    def get_name(self):
        if self.get('opp_name') is not None:
            return self.get('opp_name')
        else:
            return str(self.get_id())

    def add_product(self, product_id, amount, price, key_requirement):
        opp_id = self.get_id()
        self.REQUEST.db.execute("""SELECT * FROM opp_products WHERE opp_id=%(opp_id)d AND product_id=%(product_id)d LIMIT 1""" % locals())
        if self.REQUEST.db.fetchone():
            return -1
        else:
            key_requirement = _Utils.sql_quote(key_requirement)
            SQL = u"""INSERT INTO
opp_products (
 opp_id,
 product_id,
 amount,
 price,
 key_requirement
 ) VALUES (
 %(opp_id)d,
 %(product_id)d,
 %(amount).2f,
 %(price).2f,
 %(key_requirement)s
)""" % locals()
            self.REQUEST.db.execute(SQL.encode('UTF8'))
            return 0
