"""

Product Object

$Id$
"""

import _RootObject, _Utils
import _InitTypes

class Product(_RootObject.RootObject):
    table_name = 'products'
    field_name = 'product_id'
    item_type_id = _InitTypes.ITEM_TYPE_PRODUCT
    is_container = 0
    object_fields = {
'product_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'product_name':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'product_group':{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'product_unit':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'product_price':{ 'type': _Utils.sql_cast_float,	'simple_type': float,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'description':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    fti_keys = ['product_name','description','product_unit', 'product_group', 'product_price']

    def get_name(self):
        if self.get('product_name') is not None:
            return self.get('product_name')
        else:
            return str(self.get_id())
