"""

Quota Object

$Id$
"""

import _RootObject, _Utils
import _InitTypes


class Quota(_RootObject.RootObject):
    table_name = 'quotas'
    field_name = 'quota_id'
    item_type_id = _InitTypes.ITEM_TYPE_QUOTA
    is_container = 0
    object_fields = {
'quota_id':		{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'quota_soft_size':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'quota_hard_size':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'quota_used'	:	{ 'type': _Utils.sql_cast_long,	'simple_type': long,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
    }

    def get_name(self):
        return "Quota: %s" % self.get_parent_id()

    def get_current_used(self):
        tp = _Utils.sql_cast_bit(self.REQUEST, self.get_parent().get('treepos')).encode('UTF8')
        self.REQUEST.db.execute("""SELECT sum(item_size) FROM items WHERE treepos > %s and treepos < (%s || B'1')""" % (tp, tp))
        return self.REQUEST.db.fetchone()[0]
