"""

ToDo Object

$Id: _Todo.py,v 1.5 2004/02/15 13:10:58 incxcvs Exp $
"""

import _RootObject, _Utils
import _InitTypes
import _Workflow

class Todo(_RootObject.RootObject):
    table_name = 'todos'
    field_name = 'todo_id'
    item_type_id = _InitTypes.ITEM_TYPE_TODO
    is_container = 0
    object_fields = {
'todo_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'related_persons':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'seen_persons':		{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'accepted_persons':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'rejected_persons':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'title':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'percent_complete':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'start_time':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'due_time':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'priority':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'description':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'workflow_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'workflow_sequence_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    fti_keys = ['title','description','comments', 'priority']

    def get_name(self):
        if self.get('title') is not None:
            return self.get('title')
        elif self.get_id() is None:
            return self.REQUEST.TLS('todoobj_notsaved')
        else:
            return self.REQUEST.TLS('todoobj_noname') % self.get_id()
    
    def save(self):
        _RootObject.RootObject.save(self)
        a = self.get("workflow_id")
        if a:
            wf = _Workflow.Workflow(self.REQUEST, _InitTypes.INIT_TYPE_ID, a)
            old_complete = wf.get('percent_complete')
            wf.refresh_complete()
            if old_complete <> 100 and wf.get('percent_complete') >= 100:
                wf.send_workflow_complete()
            elif self.get('percent_complete') >= 100 and self.__olddata__['percent_complete'] <> 100:
                wf.nexttask(task=self)

    def AfterDeleteHook(self):
        a = self.get("workflow_id")
        if a:
            self.REQUEST.db.execute("""SELECT count(*) FROM items WHERE item_id=%d""" % self.get("workflow_id"))
            count_wf = self.REQUEST.db.fetchone()[0]
            if count_wf:
                wf = _Workflow.Workflow(self.REQUEST, _InitTypes.INIT_TYPE_ID, a)
                wf.refresh_complete()
