class UserGroup:
    SQL_SELECT = """\
SELECT
 ug.*,
 o.*,
 o2.organization_name AS top_org_name
FROM
 user_groups ug
LEFT JOIN organizations o ON ug.group_org_id = o.organization_id
LEFT JOIN organizations o2 ON ug.top_org_id = o2.organization_id
WHERE ug.group_id=%(group_id)s"""

    SQL_SELECT_PERSONS = """\
SELECT
 ag.person_id,
 ag.group_id,
 p.first_name,
 p.last_name,
 p.middle_name,
 p.username
FROM
 access_groups ag
LEFT JOIN persons p ON ag.person_id=p.person_id
WHERE
 ag.group_id=%(group_id)s"""

    SQL_SELECT_RIGHTS = """\
SELECT
 ar.*,
 i.item_name
FROM
 access_rights ar
LEFT JOIN items i ON ar.item_id=i.item_id
WHERE
 ar.group_id=%(group_id)s"""

    SQL_ADD_PERSON = """\
INSERT INTO
 access_groups (
group_id,
person_id )
VALUES (
%(group_id)d,
%(person_id)d )"""

    SQL_DEL_PERSON = """\
DELETE FROM
 access_groups
WHERE
 group_id=%(group_id)d AND
 person_id=%(person_id)d"""

    def __init__(self, REQUEST, group_id):
        self.group_id = group_id
        self.REQUEST = REQUEST
        self.load_db()

    def load_db(self): # FIXME error management
        group_id = self.group_id
        self.REQUEST.db.execute(self.SQL_SELECT % locals())
        self.data = self.REQUEST.db.dictfetchall()[0]
        self.persons = None
        self.rights = None

    def load_persons(self):
        group_id = self.group_id
        self.REQUEST.db.execute(self.SQL_SELECT_PERSONS % locals())
        self.persons = self.REQUEST.db.dictfetchall()

    def load_rights(self):
        group_id = self.group_id
        self.REQUEST.db.execute(self.SQL_SELECT_RIGHTS % locals())
        self.rights = self.REQUEST.db.dictfetchall()

    def add_person(self, person_id):
        group_id = self.group_id
        self.REQUEST.db.execute(self.SQL_ADD_PERSON % locals())
        self.load_persons()

    def del_person(self, person_id):
        group_id = self.group_id
        self.REQUEST.db.execute(self.SQL_DEL_PERSON % locals())
        self.load_persons()

