"""

Usernote Object

$$
"""

import _RootObject, _Utils
import _InitTypes, _Conf, _Access, _InitTypes
import mx.DateTime

class Usernote(_RootObject.RootObject):
    table_name = 'usernotes'
    field_name = 'note_id'
    item_type_id = _InitTypes.ITEM_TYPE_USERNOTE
    is_container = 0
    object_fields = {
'note_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'note_message':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'note_color':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
    }

    fti_keys = ['note_message']

    def get_name(self):
        msg = self.get('note_message') or ''
        if len(msg) >= 20:
            return msg[:20] + '...'
        elif len(msg) == 0:
            return self.REQUEST.TLS('noteobj_noname') % self.get_id()
        else:
            return msg


def note_out(REQUEST, obj, obj_id, returl, menu, show_menu):
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_notes = REQUEST.TLS('tls_notes')
    tls_from = REQUEST.TLS('email_from')
    tls_contents = REQUEST.TLS('tls_contents')
    tls_del = REQUEST.TLS('tls_deletesel')
    tls_add = REQUEST.TLS('tls_add')
    tls_confirm = REQUEST.TLS('email_confirm_del')

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT u.*, i.parent_id, i.creator_id, i.create_time, p.item_name AS note_from FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s ORDER BY i.create_time DESC""" % (obj_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    output = []
    output.append(u"""
<SCRIPT type="text/javascript">
<!--
function markAll(formvar)
{
    for(var x=0;x<formvar.elements.length;x++) {
       var y=formvar.elements[x];
       if(y.name != 'all')
          y.checked = formvar.all.checked;
    }
}
//-->
</SCRIPT>
%(menu)s
<TABLE class="td_normal" cellpadding=0 cellspacing=0>
<FORM method="post" action="%(BASE_TODO_URL)snotes.py">
<input type="hidden" name="returl" value="%(returl)s">
<input type="hidden" name="menu" value="%(show_menu)s">
<input type="hidden" name="obj_id" value="%(obj_id)s">
<TR>
  <TD class="td_listing1b"><INPUT type="checkbox" name="all" onClick="javascript:markAll(this.form);"></TD>
  <TD class="td_listing1b" nowrap>%(tls_from)s</TD>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="100%%">%(tls_contents)s</TD>
</TR>""" % locals())
    index = 0
    now = _Utils.utc_now_mx()
    now = mx.DateTime.DateTime(now.year, now.month, now.day)
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_TODO_URL'] = _Conf.BASE_TODO_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['note_from'] = item['note_from'].decode("UTF8")
        item['create_time'] = REQUEST.iso2userdatetime(REQUEST, item['create_time'])
        item['note_message'] = _Utils.newline2br(_Utils.html_quote_show(item['note_message'].decode("UTF8")))
        item['returl'] = returl
        item['obj_id'] = obj_id
        item['show_menu'] = show_menu
        if item['creator_id'] == REQUEST.USER.get_id() or REQUEST.USER.get_id() == _Conf.SUPERUSER:
            item['checkbox_str'] = u"""<INPUT type="checkbox" name="sel_%(note_id)d">""" % item
            item['linkstart'] = u"""<A class="td_listing" href="%(BASE_TODO_URL)snotes.py/edit?note_id=%(note_id)d&obj_id=%(obj_id)s&menu=%(show_menu)s&returl=%(returl)s">""" % item
            item['linkend'] = u"</a>"
        else:
            item['checkbox_str'] = u""
            item['linkstart'] = u""
            item['linkend'] = u""
        output.append(u"""\
<TR valign="top">
  <TD class="td_listing%(class_type)d">%(checkbox_str)s</TD>
  <TD class="td_listing%(class_type)d" nowrap align="center">%(linkstart)s%(note_from)s%(linkend)s<br>%(create_time)s</TD>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d">%(note_message)s</TD>
</TR>""" % item)
    class_type = index % 2
    if  _Access.get_item_right(REQUEST, obj.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        output.append(u"""\
<TR>
 <TD class="td_listing%(class_type)s" colspan="4">
   <INPUT type="submit" name="_add" value="%(tls_add)s" class="input2"> 
   <INPUT type="submit" name="_delete" value="%(tls_del)s" class="input2" onClick="return confirm('%(tls_confirm)s');"></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    else: output.append(u"""\n</TABLE>\n</FORM>""")
    return "\n".join(output)
