"""

VirtFolder Object

"""

import _RootObject, _Utils
import _InitTypes, _Exceptions

import os

class VirtFolder(_RootObject.RootObject):
    table_name = 'virt_folders'
    field_name = 'virt_folder_id'
    item_type_id = _InitTypes.ITEM_TYPE_VIRTFOLDER
    is_container = 1
    object_fields = {
'virt_folder_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	 'has_default': 1,       'can_insert': 0 },
'folder_name':	{ 'type': _Utils.sql_cast_str,	'simple_type': str,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'comments':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': str,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 }
    }

    fti_keys = ['folder_name', 'comments']

    def get_name(self):
        if self.get('folder_name') is not None:
            return self.get('folder_name')
        elif self.get_id() is None:
            return self.REQUEST.TLS('folderobj_notsaved')
        else:
            return self.REQUEST.TLS('folderobj_noname') % self.get_id()

