import _Conf, _Utils, urllib

def html_header(REQUEST, extra_headers="", extra_body="", js=1):
    ns = {}
    ns['BASE_URL'] = _Conf.BASE_URL
    ns['BASE_WEB_URL'] = _Conf.BASE_WEB_URL
    ns['BASE_MESSENGER_URL'] = _Conf.BASE_MESSENGER_URL
    ns['extra_headers'] = extra_headers
    ns['extra_body'] = extra_body
    ns['script'] = ""
    ns['app_name'] = _Conf.APP_NAME
    try:
        interface = REQUEST.get_setting('interface_type')
    except:
        interface = "0"
    if interface and interface=="1" and js:
        ns['script'] = """
<script type="text/javascript">
function show_startmenu(){ var ie=document.all && !window.opera; var dom=document.getElementById; iebody=(document.compatMode=="CSS1Compat")? document.documentElement : document.body; objref=(dom)? document.getElementById("start_menu") : document.all.start_menu; var scroll_top=(ie)? iebody.scrollTop : window.pageYOffset; docheight=(ie)? iebody.clientHeight: window.innerHeight; objheight=objref.offsetHeight; objref.style.left=1+"px"; objref.style.top=scroll_top+docheight-objheight+"px"; showonscrollvar=setInterval("mv_mnu()", 50); }
function mv_mnu(){ try{ var ie=document.all && !window.opera; var scroll_top=(ie)? iebody.scrollTop : window.pageYOffset; objref.style.top=scroll_top+docheight-objheight+"px"; } catch(e){;}}
function initf(){  setTimeout("show_startmenu()", 25); }
if (window.addEventListener)        window.addEventListener("load", initf, false); else if (window.attachEvent)        window.attachEvent("onload", initf); else if (document.getElementById)   window.onload=initf;
</script> """

    menu_put = []
    try:
        rightmenu_view = REQUEST.get_setting('rightmenu_view')
    except:
        rightmenu_view = "1"
    if rightmenu_view and rightmenu_view=="1":
        BASE_URL = _Conf.BASE_URL
        BASE_ICON_URL = _Conf.BASE_ICON_URL
        BASE_WEB_URL = _Conf.BASE_WEB_URL
        BASE_TODO_URL = _Conf.BASE_TODO_URL
        BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
        BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
        BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
        tls_logoff = REQUEST.TLS('tls_logoff')
        tls_m_add = REQUEST.TLS('tls_add')
        tls_m_addto = REQUEST.TLS('menu_add_to')
        tls_menu_disable = REQUEST.TLS('menu_disable')
        menu_put.append(u"""
    <script type="text/javascript">
    _d = document;ns4 = false;contextDisabled = false;coord_x = 0;coord_y = 0;time_out_id = 0;time_out_id2 = 0;time_out_id3 = 0;
    function hideSelect(){if(document.all){ for (j=0; j<document.forms.length; j++) { var theForm = document.forms[j]; for(i=0; i<theForm.elements.length; i++){ if(theForm.elements[i].type == "select-one" || theForm.elements[i].type == "select-multiple") { theForm.elements[i].style.visibility = "hidden";}}}}}
    function unhideSelect(){if(document.all){for (j=0; j<document.forms.length; j++) {var theForm = document.forms[j]; for(i=0; i<theForm.elements.length; i++){ if(theForm.elements[i].type == "select-one" || theForm.elements[i].type == "select-multiple") { theForm.elements[i].style.visibility = "visible";}}}}}
    function rclick(e){ if(contextDisabled){_d.oncontextmenu=null; return true; } if(_d.all) { ev=event.button; contextObject=event.srcElement; coord_x = window.event.clientX;coord_y = window.event.clientY;} else {ev=e.which; contextObject=e.target; coord_x = e.pageX; coord_y = e.pageY;} if(document.all) { if(ev==2||ev==3){ show_my_menu(); return false; } } else { if(ev==3){ show_my_menu(); return false; } } return true; }
    function hide_menu(){ unhideSelect();el = _d.getElementById('cont_menu'); el.style.visibility = "hidden";}
    function hide_menu2(){ el = _d.getElementById('cont_menu_add'); el.style.visibility = "hidden"; }
    function hide_menu3(){ el = _d.getElementById('cont_menu_add_rel'); el.style.visibility = "hidden";}
    function show_my_menu(){ hideSelect();clearTimeout(time_out_id); el = _d.getElementById('cont_menu'); el.style.top = coord_y - 5 + 'px'; el.style.left = coord_x - 5 + 'px'; el.style.visibility = "visible"; }
    function show_my_menu_add(){ clearTimeout(time_out_id2); el = _d.getElementById('cont_menu_add'); el.style.top = coord_y + 98 + 'px'; el.style.left = coord_x + 119 + 'px'; el.style.visibility = "visible"; }
    function show_my_menu_add_rel() { clearTimeout(time_out_id2); el = _d.getElementById('cont_menu_add_rel'); el.style.top = coord_y + 112 + 'px'; el.style.left = coord_x + 119 + 'px'; el.style.visibility = "visible"; }
    if(!ns4){_d.onmouseup=rclick; _d.oncontextmenu=new Function("return false");}
    </script>
    """)
        
        types_menus = [
                        (0,  _Conf.MODULES_DESKTOP,     REQUEST.TLS('topmenu_desktop'),    "desktop",        _Conf.BASE_URL,        "frontpage.py"),
                        (1,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('type_Documents'),    "documents",        _Conf.BASE_DOCUMENT_URL,        "docframe.py"),
                        (2,  _Conf.MODULES_CALENDAR,      REQUEST.TLS('topmenu_calendar'),       "calendar",         _Conf.BASE_CALENDAR_URL,        "day.py"),
                        (3,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_Todos'),        "tasks",            _Conf.BASE_TODO_URL,            "todoindex.py"),
                        (4,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_UserNotes'),    "notes",            _Conf.BASE_TODO_URL,            "notes.py"),
                        (5,  _Conf.MODULES_WORKFLOWS,     REQUEST.TLS('type_Workflows'),    "workflows",        _Conf.BASE_WORKFLOWS_URL,       "workflowindex.py"),
                        (6,  _Conf.MODULES_DISCUSSION,    REQUEST.TLS('type_Discussions'),  "discussions",      _Conf.BASE_DISCUSSION_URL,      "discindex.py"),
                        (7,  _Conf.MODULES_CLIENTS,       REQUEST.TLS('type_Client'),       "clients",          _Conf.BASE_CLIENT_URL,          "clients.py"),
                        (8,  _Conf.MODULES_CONTACTS,      REQUEST.TLS('type_Contacts'),     "contacts",         _Conf.BASE_CONTACT_URL,         "contactindex.py?only_mine=1"),
                        (9, _Conf.MODULES_OPPORTUNITIES, REQUEST.TLS('type_Opportunity'),   "opportunities",    _Conf.BASE_OPPORTUNITIES_URL,   "opportunities.py"),
                        (10, _Conf.MODULES_PRODUCTS,      REQUEST.TLS('type_Product'),      "products",         _Conf.BASE_PRODUCTS_URL,        "products.py"),
                        (11, _Conf.MODULES_EMAIL,      REQUEST.TLS('topmenu_email'),      "email",         _Conf.BASE_EMAIL_URL,        "efolder1.py"),
                        (12, _Conf.MODULES_ADMIN,      REQUEST.TLS('topmenu_admin'),      "admin",         _Conf.BASE_ADMIN_URL,        "settings.py"),
        ]
        types_add = [
                        (0,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('menu_add_folder'),    "folders",        _Conf.BASE_DOCUMENT_URL,        "docadd.py/addfolderform"),
                        (1,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('menu_add_document'),    "documents",        _Conf.BASE_DOCUMENT_URL,        "docadd.py"),
                        (2,  _Conf.MODULES_CALENDAR,      REQUEST.TLS('menu_add_event'),       "calendar",         _Conf.BASE_CALENDAR_URL,        "addevent.py"),
                        (3,  _Conf.MODULES_TODOS,         REQUEST.TLS('menu_add_task'),        "tasks",            _Conf.BASE_TODO_URL,            "todoadd.py"),
                        (4,  _Conf.MODULES_TODOS,         REQUEST.TLS('menu_add_note'),    "notes",            _Conf.BASE_TODO_URL,            "notes.py/add"),
                        (5,  _Conf.MODULES_WORKFLOWS,     REQUEST.TLS('menu_add_workflow'),    "workflows",        _Conf.BASE_WORKFLOWS_URL,       "workflowadd.py"),
                        (6,  _Conf.MODULES_CLIENTS,       REQUEST.TLS('menu_add_client'),       "clients",          _Conf.BASE_CLIENT_URL,          "clientadd.py"),
                        (7,  _Conf.MODULES_CONTACTS,      REQUEST.TLS('menu_add_contact'),     "contacts",         _Conf.BASE_CONTACT_URL,         "contactadd.py"),
                        (8, _Conf.MODULES_OPPORTUNITIES,  REQUEST.TLS('menu_add_opportunity'),   "opportunities",    _Conf.BASE_OPPORTUNITIES_URL,   "oppadd.py"),
                        (9, _Conf.MODULES_PRODUCTS,       REQUEST.TLS('menu_add_product'),      "products",         _Conf.BASE_PRODUCTS_URL,        "addproduct.py"),
                        (10, _Conf.MODULES_EMAIL,         REQUEST.TLS('menu_add_mail'),      "email",         _Conf.BASE_EMAIL_URL,        "compose.py"),
        ]

        types_to_relate = {
                        'editevent.py':[0, _Conf.MODULES_CALENDAR, 'event_id', 'events'],
                        'todoedit.py':[1, _Conf.MODULES_TODOS, 'todo_id', 'todo'],
                        'workflowedit.py':[2, _Conf.MODULES_WORKFLOWS, 'workflow_id', 'workflows'],
                        'clientedit.py':[3, _Conf.MODULES_CLIENTS, 'client_id', 'clients'],
                        'contactedit.py':[4, _Conf.MODULES_CONTACTS, 'contact_id', 'contacts'],
                        'oppedit.py':[5, _Conf.MODULES_OPPORTUNITIES, 'opp_id', 'opp'],
                        'editproduct.py':[6, _Conf.MODULES_PRODUCTS, 'product_id', 'products'],
        }


        access_str = _Utils.get_module_access(REQUEST)

        relation = u""
        relations = u""
        add_rel = []
        f_path = REQUEST.mod_req.uri
        f_name = f_path.split("/")[-1]
        if f_name in types_to_relate:
            module_id = types_to_relate[f_name][1]
            this_object = REQUEST.TLS('menu_relate_to_%d' % module_id)
            if access_str[module_id]=="1":
                menu_name = types_to_relate[f_name][3]
                key = types_to_relate[f_name][2]
                key_id = REQUEST.form[key].value
                types_relate = [
                        (1,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_DOCUMENTS) % this_object,    "documents",        _Conf.BASE_DOCUMENT_URL+ "docadd.py?rel_id=%(key_id)s" % locals()),
                        (2,  _Conf.MODULES_CALENDAR,      REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_CALENDAR) % this_object,       "calendar",         _Conf.BASE_CALENDAR_URL+"addevent.py?rel_id=%(key_id)s" % locals()),
                        (3,  _Conf.MODULES_TODOS,         REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_TODOS) % this_object,        "tasks",            _Conf.BASE_TODO_URL+"todoadd.py?rel_id=%(key_id)s" % locals()),
                        (4,  _Conf.MODULES_TODOS,         REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_NOTES) % this_object,    "notes",            _Conf.BASE_TODO_URL+"notes.py/add?menu=%(menu_name)s&obj_id=%(key_id)s" % locals()),
                        (5,  _Conf.MODULES_WORKFLOWS,     REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_WORKFLOWS) % this_object,    "workflows",        _Conf.BASE_WORKFLOWS_URL+"workflowadd.py?rel_id=%(key_id)s" % locals()),
                        (6,  _Conf.MODULES_CLIENTS,       REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_CLIENTS) % this_object,       "clients",          _Conf.BASE_CLIENT_URL+"clientadd.py?rel_id=%(key_id)s" % locals()),
                        (7,  _Conf.MODULES_CONTACTS,      REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_CONTACTS) % this_object,     "contacts",         _Conf.BASE_CONTACT_URL+"contactadd.py?rel_id=%(key_id)s" % locals()),
                        (8, _Conf.MODULES_OPPORTUNITIES,  REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_OPPORTUNITIES) % this_object,   "opportunities",    _Conf.BASE_OPPORTUNITIES_URL+"oppadd.py?rel_id=%(key_id)s" % locals()),
                        (9, _Conf.MODULES_PRODUCTS,       REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_PRODUCTS) % this_object,      "products",         _Conf.BASE_PRODUCTS_URL+"addproduct.py?rel_id=%(key_id)s" % locals()),
                ]
                relation = u"""\
    <TR class="ra_menu_item_tr" onmouseover="rhl('addrel');hide_menu2();window.clearTimeout(time_out_id3);show_my_menu_add_rel();" onmouseout="rul('addrel');window.clearTimeout(time_out_id3);time_out_id3=window.setTimeout('hide_menu3()', 500);">
      <TD id="addrelc" style="border-top: 1px solid #8A867A;" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sstartmenu_add.gif" width="16" height="16" border="0" alt=""></TD>
      <TD id="addreld" class="ra_menu_item_td" style="border-top: 1px solid #8A867A;" nowrap>%(tls_m_addto)s</TD>
    </TR>""" % locals()
                for item in types_relate:
                    if access_str[item[1]]=="1":
                        id = item[0]
                        title = item[2]
                        img = item[3]
                        exe = item[4]
                        returl = urllib.quote(REQUEST.mod_req.uri)+urllib.quote(REQUEST.get_formstring(['sel_id','rnd','o','rel_id1', '_delete', 'delete', 'add', 'edit', '_add', '_edit']))
    #docframe.py?doc_url=" + urllib.quote(_Conf.BASE_DOCUMENT_URL + 'folder.py?parent_id=%(item_id)d' % item
                        url = "%(exe)s&returl=%(returl)s" % locals()
                        if item[1]==_Conf.MODULES_DOCUMENTS:
                            url = _Conf.BASE_DOCUMENT_URL+"docframe.py?doc_url=%s" % urllib.quote(url)
                        add_rel.append(u"""\
    <TR class="ra_menu_item_tr" onmouseover="rhrl('sm%(id)s');" onmouseout="rurl('sm%(id)s');" onclick="rpll('%(url)s');">
      <TD id="sm%(id)sx" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)srightmenu_%(img)s.gif" width="16" height="16" border="0" alt=""></TD>
      <TD id="sm%(id)sy" nowrap class="ra_menu_item_td">%(title)s</TD>
    </TR>""" % locals())
                relations = "\n".join(add_rel)
                if relations:
                    relations = u"""
    <TABLE border="0" cellpadding="2" cellspacing="0" bgcolor="#F6F6F6" style="border: 1px solid #8A867A; spacing-left: 1px; spacing-right: 1px;">
    %(relations)s
    </TABLE>""" % locals()

        res = []
        for item in types_menus:
            if access_str[item[1]]=="1":
                id = item[0]
                title = item[2]
                img = item[3]
                path = item[4]
                exe = item[5]
                res.append(u"""\
    <TR class="ra_menu_item_tr" onmouseover="rhl('sm%(id)s');" onmouseout="rul('sm%(id)s');" onclick="rpll('%(path)s%(exe)s');">
      <TD id="sm%(id)sc" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)srightmenu_%(img)s.gif" width="16" height="16" border="0" alt=""></TD>
      <TD id="sm%(id)sd" nowrap class="ra_menu_item_td">%(title)s</TD>
    </TR>""" % locals())
        result = "\n".join(res)

        addres = []
        for item in types_add:
            if access_str[item[1]]=="1":
                id = item[0]
                title = item[2]
                img = item[3]
                path = item[4]
                exe = item[5]
                addres.append(u"""\
    <TR class="ra_menu_item_tr" onmouseover="rhal('sm%(id)s');" onmouseout="rual('sm%(id)s');" onclick="rpll('%(path)s%(exe)s');">
      <TD id="sm%(id)st" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)srightmenu_%(img)s.gif" width="16" height="16" border="0" alt=""></TD>
      <TD id="sm%(id)su" nowrap class="ra_menu_item_td">%(title)s</TD>
    </TR>""" % locals())
        result_add = "\n".join(addres)

        menu_put.append(u"""\
    <script type="text/javascript">function rhl(id){  el_1 = document.getElementById(id+"c");  el_2 = document.getElementById(id+"d");  el_1.style.backgroundColor="#C1D2EE";  el_2.style.backgroundColor="#C1D2EE";} function rul(id){  el_1 = document.getElementById(id+"c");  el_2 = document.getElementById(id+"d");  el_1.style.backgroundColor="#EFEDDE";  el_2.style.backgroundColor="#F6F6F6";} function rpll(exe){    top.topcontents.document.location=exe; }
    function rhal(id){  el_1 = document.getElementById(id+"t");  el_2 = document.getElementById(id+"u");  el_1.style.backgroundColor="#C1D2EE";  el_2.style.backgroundColor="#C1D2EE";} function rual(id){  el_1 = document.getElementById(id+"t");  el_2 = document.getElementById(id+"u");  el_1.style.backgroundColor="#EFEDDE";  el_2.style.backgroundColor="#F6F6F6";}
    function rhrl(id){  el_1 = document.getElementById(id+"x");  el_2 = document.getElementById(id+"y");  el_1.style.backgroundColor="#C1D2EE";  el_2.style.backgroundColor="#C1D2EE";} function rurl(id){  el_1 = document.getElementById(id+"x");  el_2 = document.getElementById(id+"y");  el_1.style.backgroundColor="#EFEDDE";  el_2.style.backgroundColor="#F6F6F6";}
    </script>
    <div id="cont_menu" style="visibility: hidden; position: absolute; z-index:9876;" onMouseOut="window.clearTimeout(time_out_id);time_out_id=window.setTimeout('hide_menu()', 500);" onMouseOver="window.clearTimeout(time_out_id);">
    <TABLE width="125" border="0" cellpadding="2" cellspacing="0" bgcolor="#F6F6F6" style="border: 1px solid #8A867A; spacing-left: 1px; spacing-right: 1px;">
    %(result)s
    <TR class="ra_menu_item_tr" onmouseover="rhl('add');hide_menu3();show_my_menu_add();" onmouseout="rul('add');window.clearTimeout(time_out_id2);time_out_id2=window.setTimeout('hide_menu2()', 500);">
      <TD id="addc" style="border-top: 1px solid #8A867A;" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sstartmenu_add.gif" width="16" height="16" border="0" alt=""></TD>
      <TD id="addd" class="ra_menu_item_td" style="border-top: 1px solid #8A867A;" nowrap>%(tls_m_add)s</TD>
    </TR>
    %(relation)s
    <TR class="ra_menu_item_tr" onmouseover="rhl('closemenu');" onmouseout="rul('closemenu');" onclick="contextDisabled=true; hide_menu();">
      <TD id="closemenuc" style="border-top: 1px solid #8A867A;" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sspacer.gif" width="16" height="16" border="0" alt=""></TD>
      <TD id="closemenud" class="ra_menu_item_td" style="border-top: 1px solid #8A867A;" nowrap>%(tls_menu_disable)s</TD>
    </TR>
    </TABLE>
    </div>
    <div id="cont_menu_add" style="visibility: hidden; position: absolute; z-index:9876;" onMouseOut="window.clearTimeout(time_out_id2);time_out_id2=window.setTimeout('hide_menu2()', 500);window.clearTimeout(time_out_id);time_out_id=window.setTimeout('hide_menu()', 500);" onMouseOver="window.clearTimeout(time_out_id2);window.clearTimeout(time_out_id);">
    <TABLE border="0" cellpadding="2" cellspacing="0" bgcolor="#F6F6F6" style="border: 1px solid #8A867A; spacing-left: 1px; spacing-right: 1px;">
    %(result_add)s
    </TABLE>
    </div>
    <div id="cont_menu_add_rel" style="visibility: hidden; position: absolute; z-index:9876;" onMouseOut="window.clearTimeout(time_out_id3);time_out_id3=window.setTimeout('hide_menu3()', 500);window.clearTimeout(time_out_id);time_out_id=window.setTimeout('hide_menu()', 500);" onMouseOver="window.clearTimeout(time_out_id3);window.clearTimeout(time_out_id);">
    <TABLE border="0" cellpadding="2" cellspacing="0" bgcolor="#F6F6F6" style="border: 1px solid #8A867A; spacing-left: 1px; spacing-right: 1px;">
    %(relations)s
    </TABLE>
    </div>
    """ % locals())

    ns['menu_out'] = "\n".join(menu_put)

    return u"""\
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
<HEAD>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <TITLE>%(app_name)s</TITLE>
    <LINK rel="stylesheet" href="%(BASE_WEB_URL)sconflux.css">
    <LINK REL="SHORTCUT ICON" HREF="%(BASE_URL)sfavicon.ico">
    <script type="text/javascript">function show_bl(){ bl_win = window.open("","buddy_window","width=200,height=250,toolbar=0,directories=0,menubar=0,status=0,location=0,scrollbars=yes,resizable=no"); if(bl_win.location.href && bl_win.location.href=="about:blank") { myhref = '%(BASE_MESSENGER_URL)sbuddy_list.py'; bl_win.location.href=myhref; bl_win.focus(); } } </script>
    %(extra_headers)s %(script)s
</HEAD>
<BODY %(extra_body)s>
%(menu_out)s
""" % ns

def html_header_popup(REQUEST, extra_headers="", extra_body="onLoad='window.focus();'"):
    ns = {}
    ns['BASE_URL'] = _Conf.BASE_URL
    ns['BASE_WEB_URL'] = _Conf.BASE_WEB_URL
    ns['extra_headers'] = extra_headers
    ns['extra_body'] = extra_body
    ns['app_name'] = _Conf.APP_NAME
    return u"""\
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
<HEAD>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <TITLE>%(app_name)s</TITLE>
  <LINK rel="stylesheet" href="%(BASE_WEB_URL)sconflux.css">
  <LINK REL="SHORTCUT ICON" HREF="%(BASE_URL)sfavicon.ico">
  %(extra_headers)s
</HEAD>
<BODY %(extra_body)s>
""" % ns

def html_footer(REQUEST):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_URL = _Conf.BASE_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    tls_logoff = REQUEST.TLS('tls_logoff')
    try:
        interface = REQUEST.get_setting('interface_type')
    except:
        interface = "0"
    start_menu = []
    res = []
    output = []

    types_menus = [ (1,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('type_Documents')),
                    (2,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('type_Folders')),
                    (3,  _Conf.MODULES_CALENDAR,      REQUEST.TLS('type_Events')),
                    (4,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_Todos')),
                    (5,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_UserNotes')),
                    (6,  _Conf.MODULES_WORKFLOWS,     REQUEST.TLS('type_Workflows')),
                    (7,  _Conf.MODULES_DISCUSSION,    REQUEST.TLS('type_Discussions')),
                    (8,  _Conf.MODULES_CLIENTS,       REQUEST.TLS('type_Client')),
                    (9,  _Conf.MODULES_CONTACTS,      REQUEST.TLS('type_Contacts')),
                    (10, _Conf.MODULES_OPPORTUNITIES, REQUEST.TLS('type_Opportunity')),
                    (11, _Conf.MODULES_PRODUCTS,      REQUEST.TLS('type_Product')),
                    (12, _Conf.MODULES_EMAIL,         REQUEST.TLS('type_e-mails')),
    ]

    types_menus2 = [(1,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('type_Documents'),    "documents",        _Conf.BASE_DOCUMENT_URL,        "docframe.py"),
                    (2,  _Conf.MODULES_CALENDAR,      REQUEST.TLS('topmenu_calendar'),       "calendar",         _Conf.BASE_CALENDAR_URL,        "day.py"),
                    (3,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_Todos'),        "tasks",            _Conf.BASE_TODO_URL,            "todoindex.py"),
                    (4,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_UserNotes'),    "notes",            _Conf.BASE_TODO_URL,            "notes.py"),
                    (5,  _Conf.MODULES_WORKFLOWS,     REQUEST.TLS('type_Workflows'),    "workflows",        _Conf.BASE_WORKFLOWS_URL,       "workflowindex.py"),
                    (6,  _Conf.MODULES_DISCUSSION,    REQUEST.TLS('type_Discussions'),  "discussions",      _Conf.BASE_DISCUSSION_URL,      "discindex.py"),
                    (7,  _Conf.MODULES_CLIENTS,       REQUEST.TLS('type_Client'),       "clients",          _Conf.BASE_CLIENT_URL,          "clients.py"),
                    (8,  _Conf.MODULES_CONTACTS,      REQUEST.TLS('type_Contacts'),     "contacts",         _Conf.BASE_CONTACT_URL,         "contactindex.py?only_mine=1"),
                    (9, _Conf.MODULES_OPPORTUNITIES, REQUEST.TLS('type_Opportunity'),   "opportunities",    _Conf.BASE_OPPORTUNITIES_URL,   "opportunities.py"),
                    (10, _Conf.MODULES_PRODUCTS,      REQUEST.TLS('type_Product'),      "products",         _Conf.BASE_PRODUCTS_URL,        "products.py"),
    ]
    access_str = _Utils.get_module_access(REQUEST)
    
    try:
        logo = REQUEST.get_setting('organization_logo_small')
    except:
        logo = ""
    if logo:
        logo_str = """<IMG src="%smyinfo.py/pic3" width="103" border=0 alt="">""" % _Conf.BASE_ADMIN_URL
    else:
        logo_str = """<IMG src="%(BASE_WEB_URL)sicons/startmenu_conflux.gif" width="103" height="25" border=0 alt="">""" % locals()

    if interface and interface=="1":
        for item in types_menus2:
            if access_str[item[1]]=="1":
                id = item[0]
                title = item[2]
                img = item[3]
                path = item[4]
                exe = item[5]
                res.append(u"""
<TR class="start_menu_item_tr" onmouseover="hl('sm%(id)s');" onmouseout="ul('sm%(id)s');" onclick="pll('%(path)s%(exe)s');">
  <TD id="sm%(id)sa" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sstartmenu_%(img)s.gif" width="20" height="20" border="0" alt=""></TD>
  <TD id="sm%(id)sb" nowrap class="start_menu_item_td">%(title)s</TD>
</TR>""" % locals())
        result = "\n".join(res)
        output.append(u"""
<script type="text/javascript">function hl(id){  el_1 = document.getElementById(id+"a");  el_2 = document.getElementById(id+"b");  el_1.style.backgroundColor="#C1D2EE";  el_2.style.backgroundColor="#C1D2EE";} function ul(id){  el_1 = document.getElementById(id+"a");  el_2 = document.getElementById(id+"b");  el_1.style.backgroundColor="#EFEDDE";  el_2.style.backgroundColor="#F6F6F6";} function pll(exe){    top.topcontents.document.location=exe; }</script>
<DIV id="start_menu" style="position: absolute; left: 1px; bottom: 0px; z-index=3; visibility: hidden">
<TABLE border="0" cellpadding="4" cellspacing="0" bgcolor="#F6F6F6" style="border: 1px solid #8A867A; spacing-left: 1px; spacing-right: 1px;">
<TR bgcolor="#F6F6F6">
  <TD colspan="2" align="center">%(logo_str)s</TD>
</TR>
%(result)s
<TR class="start_menu_item_tr" onmouseover="hl('logout');" onmouseout="ul('logout');" onclick="top.document.location='%(BASE_URL)slogout.py';">
  <TD id="logouta" style="border-top: 1px solid #8A867A;" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sstartmenu_logout.gif" width="20" height="20" border="0" alt=""></TD>
  <TD id="logoutb" class="start_menu_item_td" style="border-top: 1px solid #8A867A;" nowrap>%(tls_logoff)s</TD>
</TR>
</TABLE></DIV>""" % locals())
    start_menu = "\n".join(output)

    search_contents = []
    index = 0
    for row in types_menus:
        if access_str[row[1]]=="1":
            search_contents.append(u"""      <OPTION value="%d">%s</OPTION>""" % (row[0], row[2]))
        index = index + 1
    search_contents = " ".join(search_contents)

    tls_quicksearch = REQUEST.TLS('tls_quicksearch')
    tls_type = REQUEST.TLS('tls_type')
    tls_search = REQUEST.TLS('tls_search')
    tls_0 = REQUEST.TLS('tls_all')
    tls_recentsearches = REQUEST.TLS('tls_recentsearches')

    try:
        saved_list = REQUEST.get_setting('quick_searches')
    except:
        saved_list = []
    recent_searches = ""
    count = 0
    if saved_list:
        saved_list.reverse()
        recent_searches = u"""<TR>  <TD colspan="2" class="pad3"><B>%(tls_recentsearches)s:</B> """ % locals()
    for item in saved_list:
        count = count + 1
        recent_searches = recent_searches + """ <a href="#" class="whitelink" onclick="document.forms['quicksearchform'].search_keyword.value='%s';document.forms['quicksearchform'].submit()">%s</a>"""%(item.decode('UTF8').replace("'", "\\'").replace('"','&quot;'), _Utils.shorten_string(item.decode('UTF8'), 12))
    if(count):
        recent_searches = recent_searches + u"""</TD></TR>"""
    
    return u"""<SCRIPT TYPE="text/javascript">function show_search() { search_div = document.getElementById('d7765'); if(search_div.style.visibility=='visible') { search_div.style.visibility='hidden'; search_div.style.display='none'; } else { search_div.style.visibility='visible'; search_div.style.display='block'; } }</SCRIPT>
<DIV id="d7765" style="position: absolute; z-index: 5; top: 23px; left: 500px; display: none; visibility: hidden;"><FORM method="GET" name="quicksearchform" action="%(BASE_GENERAL_URL)squicksearch.py" target="topcontents"><TABLE width="200" border="0" cellpadding="0" cellspacing="0" bgcolor="#70BF55" style="border-left: 1px solid black;border-right: 1px solid black; border-bottom: 1px solid black; color: white;"><TR bgcolor="#2BA10B">  <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="200" height="1" border="0" alt=""></TD></TR><TR bgcolor="#2BA10B">  <TD colspan="2" class="pad4"><b>%(tls_quicksearch)s</b></TD></TR><TR>  <TD class="pad3">%(tls_type)s:</TD>  <TD class="pad3">    <SELECT name="search_type">      <OPTION SELECTED value="0">%(tls_0)s</OPTION>%(search_contents)s    </SELECT>  </TD></TR><TR>  <TD colspan="2" class="pad3"><INPUT class="textfield1" type="text" size="12" name="search_keyword">&nbsp;<INPUT class="input2" type="submit" value="%(tls_search)s"></TD></TR>%(recent_searches)s</TABLE></FORM></DIV><script type="text/javascript">var myWidth = 0, myHeight = 0; if( typeof( window.innerWidth ) == 'number' ) { myWidth = window.innerWidth; myHeight = window.innerHeight; } else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) { myWidth = document.documentElement.clientWidth; myHeight = document.documentElement.clientHeight; } else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) { myWidth = document.body.clientWidth; myHeight = document.body.clientHeight; } if(myWidth && myWidth>222) { pos = myWidth - 222; search_div = document.getElementById('d7765'); pos = pos+"px"; search_div.style.left = pos; }</script>%(start_menu)s
</BODY>
</HTML>
""" % locals()

def window_script(name="open_window", target="popup_window", height=200, width=320, toolbar=0, menubar=0, status=0, location=0, scrollbars='yes', resizable='no'):
    return u"""<SCRIPT language="javascript" type="text/javascript">function %(name)s(uri) {  window.open(uri,"%(target)s","width=%(width)d,height=%(height)d,toolbar=%(toolbar)d,directories=0,menubar=%(menubar)d,status=%(status)d,location=%(location)d,scrollbars=%(scrollbars)s,resizable=%(resizable)s"); }</SCRIPT>""" % locals()

def html_footer2(REQUEST):
    try:
        interface = REQUEST.get_setting('interface_type')
    except:
        interface = "0"
    start_menu = []
    res = []
    output = []
    tls_logoff = REQUEST.TLS('tls_logoff')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_URL = _Conf.BASE_URL
    try:
        logo = REQUEST.get_setting('organization_logo_small')
    except:
        logo = ""
    if logo:
        logo_str = """<IMG src="%smyinfo.py/pic3" width="103" border=0 alt="">""" % _Conf.BASE_ADMIN_URL
    else:
        logo_str = """<IMG src="%sicons/startmenu_conflux.gif" width="103" height="25" border=0 alt="">""" % _Conf.BASE_WEB_URL

    types_menus2 = [(1,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('type_Documents'),    "documents",        _Conf.BASE_DOCUMENT_URL,        "docframe.py"),
                    (2,  _Conf.MODULES_CALENDAR,      REQUEST.TLS('topmenu_calendar'),       "calendar",         _Conf.BASE_CALENDAR_URL,        "day.py"),
                    (3,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_Todos'),        "tasks",            _Conf.BASE_TODO_URL,            "todoindex.py"),
                    (4,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_UserNotes'),    "notes",            _Conf.BASE_TODO_URL,            "notes.py"),
                    (5,  _Conf.MODULES_WORKFLOWS,     REQUEST.TLS('type_Workflows'),    "workflows",        _Conf.BASE_WORKFLOWS_URL,       "workflowindex.py"),
                    (6,  _Conf.MODULES_DISCUSSION,    REQUEST.TLS('type_Discussions'),  "discussions",      _Conf.BASE_DISCUSSION_URL,      "discindex.py"),
                    (7,  _Conf.MODULES_CLIENTS,       REQUEST.TLS('type_Client'),       "clients",          _Conf.BASE_CLIENT_URL,          "clients.py"),
                    (8,  _Conf.MODULES_CONTACTS,      REQUEST.TLS('type_Contacts'),     "contacts",         _Conf.BASE_CONTACT_URL,         "contactindex.py?only_mine=1"),
                    (9, _Conf.MODULES_OPPORTUNITIES, REQUEST.TLS('type_Opportunity'),   "opportunities",    _Conf.BASE_OPPORTUNITIES_URL,   "opportunities.py"),
                    (10, _Conf.MODULES_PRODUCTS,      REQUEST.TLS('type_Product'),      "products",         _Conf.BASE_PRODUCTS_URL,        "products.py"),
    ]
    access_str = _Utils.get_module_access(REQUEST)
    

    if interface and interface=="1":
        for item in types_menus2:
            if access_str[item[1]]=="1":
                id = item[0]
                title = item[2]
                img = item[3]
                path = item[4]
                exe = item[5]
                res.append(u"""
<TR class="start_menu_item_tr" onmouseover="hl('sm%(id)s');" onmouseout="ul('sm%(id)s');" onclick="pll('%(path)s%(exe)s');">
  <TD id="sm%(id)sa" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sstartmenu_%(img)s.gif" width="20" height="20" border="0" alt=""></TD>
  <TD id="sm%(id)sb" nowrap class="start_menu_item_td">%(title)s</TD>
</TR>""" % locals())
        result = "\n".join(res)
        output.append(u"""
<script type="text/javascript">
function hl(id)
{
  el_1 = document.getElementById(id+"a");
  el_2 = document.getElementById(id+"b");
  el_1.style.backgroundColor="#C1D2EE";
  el_2.style.backgroundColor="#C1D2EE";
}
function ul(id)
{
  el_1 = document.getElementById(id+"a");
  el_2 = document.getElementById(id+"b");
  el_1.style.backgroundColor="#EFEDDE";
  el_2.style.backgroundColor="#F6F6F6";
}
function pll(exe)
{
  top.topcontents.document.location=exe;
}
</script>
<DIV id="start_menu" style="position: absolute; left: 1px; bottom: 0px; z-index=3; visibility: hidden">
<TABLE border="0" cellpadding="4" cellspacing="0" bgcolor="#F6F6F6" style="border: 1px solid #8A867A; spacing-left: 1px; spacing-right: 1px;">
<TR bgcolor="#F6F6F6">
  <TD colspan="2" align="center">%(logo_str)s</TD>
</TR>
%(result)s
<TR class="start_menu_item_tr" onmouseover="hl('logout');" onmouseout="ul('logout');" onclick="top.document.location='%(BASE_URL)slogout.py';">
  <TD id="logouta" style="border-top: 1px solid #8A867A;" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sstartmenu_logout.gif" width="20" height="20" border="0" alt=""></TD>
  <TD id="logoutb" class="start_menu_item_td" style="border-top: 1px solid #8A867A;" nowrap>%(tls_logoff)s</TD>
</TR>
</TABLE>
</DIV>""" % locals())
    start_menu = "\n".join(output)
    return u"""\
%(start_menu)s
</BODY>
</HTML>
""" % locals()

def html_footer3(REQUEST):
    return """
</BODY>
</HTML>
"""

def top_menu(REQUEST):
    ns = {}
    ns['BASE_URL'] = _Conf.BASE_URL
    ns['BASE_WEB_URL'] = _Conf.BASE_WEB_URL
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['user_full_name'] = REQUEST.USER.get_name()

    menustring = u"""\
<TR>
  <TD colspan="2">
    <TABLE border="0" width="180" cellpadding="0" cellspacing="0" class="topmenu_menu" onmouseover="this.style.backgroundColor='#91E600';" onmouseout="this.style.backgroundColor='#7BC300';" onclick="parent.topcontents.location='%(current_menu_link)s';">
    <TR>
     <TD width="178" colspan="3"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=178 height=7 border=0 alt=""></TD>
     <TD width="2" style="background-image: url('%(BASE_WEB_URL)sicons/logoright3.gif')"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=2 height=1 border=0 alt=""></TD>
    </TR>
    <TR>
     <TD width="13"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=13 height=1 border=0 alt=""></TD>
     <TD width="158" class="a_menubar">%(current_menu_name)s</TD>
     <TD width="7"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=7 height=1 border=0 alt=""></TD>
     <TD width="2" style="background-image: url('%(BASE_WEB_URL)sicons/logoright3.gif')"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=2 height=1 border=0 alt=""></TD>
    </TR>
    <TR>
     <TD width="178" colspan="3"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=178 height=7 border=0 alt=""></TD>
     <TD width="2" style="background-image: url('%(BASE_WEB_URL)sicons/logoright3.gif')"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=2 height=1 border=0 alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
"""
    menudivider = """\
<TR>
 <TD class="spacer" width="100%%" style="background-image: url('%(BASE_ICON_URL)smenusep.gif')"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=178 height=2 border=0 alt=""></TD>
 <TD class="spacer"  style="background-image: url('%(BASE_ICON_URL)slogoright3.gif')"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
</TR>"""
    menubar = []
    access_str = _Utils.get_module_access(REQUEST)
    index = 0
    for menuitem in _Conf.MENU:
        if(access_str[menuitem[2]]=="1" or REQUEST.USER.get_id() == _Conf.SUPERUSER) and menuitem[_Conf.MENU_ENABLED]:
            ns['current_menu_name'] = REQUEST.TLS(menuitem[_Conf.MENU_NAME])
            ns['current_menu_link'] = menuitem[_Conf.MENU_LINK]
            menubar.append(menustring % ns)
            menubar.append(menudivider % {'BASE_ICON_URL':_Conf.BASE_ICON_URL})
        index += 1
    ns['menubar'] = "\n".join(menubar)
    try:
        logo = REQUEST.get_setting('organization_logo')
    except:
        logo = ""
    if logo:
        ns['logo_str'] = """<IMG src="%smyinfo.py/pic2" width=178 border=0 alt="">""" % _Conf.BASE_ADMIN_URL
    else:
        ns['logo_str'] = """<IMG src="%(BASE_WEB_URL)sicons/logovaike.jpg" width=178 height=58 border=0 alt="">""" % ns

    ns['app_name'] = _Conf.APP_NAME
    return u"""\
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
<HEAD>
  <TITLE>%(app_name)s</TITLE>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <LINK rel="stylesheet" href="%(BASE_WEB_URL)sconflux.css">
  <LINK REL="SHORTCUT ICON" HREF="%(BASE_URL)sfavicon.ico">
</HEAD>
<BODY class="topmenu_menu3" background="%(BASE_WEB_URL)sicons/menubg.gif">
<SCRIPT type="text/javascript">
function disabletext(e) { return false; }
function reEnable() { return true; }
document.onselectstart=new Function ("return false")
if (window.sidebar){ document.onmousedown=disabletext; document.onclick=reEnable; }
</script>
<TABLE width="180" border="0" cellpadding="0" cellspacing="0" style="background-image: url('%(BASE_WEB_URL)sicons/treetopbg2.gif');">
<TR>
 <TD><img src="%(BASE_WEB_URL)sicons/spacer.gif" width="8" height="26" border=0 alt=""></TD>
 <TD><IMG src="%(BASE_WEB_URL)sicons/userinfo.gif" width="6" height="9" border=0 alt=""></TD>
 <TD><img src="%(BASE_WEB_URL)sicons/spacer.gif" width="4" height="26" border=0 alt=""></TD>
 <TD width="100%%" nowrap class="topmenu_link">%(user_full_name)s</TD>
 <TD style="background-image: url('%(BASE_WEB_URL)sicons/logoe1.gif')"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=2 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE border=0 cellpadding=0 cellspacing=0 class="topmenu_menu3">
<TR>
 <TD class="topmenu_logo">%(logo_str)s</TD>
 <TD class="spacer"  style="background-image: url('%(BASE_WEB_URL)sicons/logoright.gif')"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=2 height=1 border=0 alt=""></TD>
</TR>
<TR>
 <TD class="topmenu_bar"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=178 height=4 border=0 alt=""></TD>
 <TD class="spacer"  style="background-image: url('%(BASE_WEB_URL)sicons/logoright3.gif')"><IMG src="%(BASE_WEB_URL)sicons/spacer.gif" width=2 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE border=0 cellpadding=0 cellspacing=0 class="topmenu_menu3">
%(menubar)s
<TR>
 <TD class="topmenu_menu3">&nbsp;</TD>
 <TD class="spacer"  style="background-image: url('%(BASE_ICON_URL)slogoright3.gif')"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
</TR>
<TR>
 <TD class="topmenu_menu3"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=178 height=10 border=0 alt=""></TD>
 <TD class="spacer"  style="background-image: url('%(BASE_ICON_URL)slogoright3.gif')"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</BODY>
</HTML>
""" % ns

def start_menu(REQUEST):
    ns = {}
    ns['BASE_URL'] = _Conf.BASE_URL
    ns['BASE_WEB_URL'] = _Conf.BASE_WEB_URL
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['BASE_EMAIL_URL'] = _Conf.BASE_EMAIL_URL
    ns['BASE_ADMIN_URL'] = _Conf.BASE_ADMIN_URL
    ns['user_full_name'] = REQUEST.USER.get_name()
    ns['tls_programs'] = REQUEST.TLS('tls_programs')
    ns['tls_desktop'] = REQUEST.TLS('topmenu_desktop')
    ns['tls_email'] = REQUEST.TLS('topmenu_email')
    ns['tls_settings'] = REQUEST.TLS('compmenu_admin_settings')
    ns['email_url'] = "efolder1.py"
    ns['app_name'] = _Conf.APP_NAME
    return u"""\
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
<HEAD>
  <TITLE>%(app_name)s</TITLE>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <LINK rel="stylesheet" href="%(BASE_WEB_URL)sconflux.css">
  <LINK REL="SHORTCUT ICON" HREF="%(BASE_URL)sfavicon.ico">
  <script type="text/javascript">
  function show_start()
  {
    e = parent.topcontents.document.getElementById('start_menu');
    if(!e && parent.topcontents.frametree)
    {
      e = parent.topcontents.frametree.document.getElementById('start_menu');
    }
    else if(!e && parent.topcontents.mail_contents)
    {
      e = parent.topcontents.mail_contents.document.getElementById('start_menu');
    }
    else if(!e && parent.topcontents.framebody)
    {
      e = parent.topcontents.framebody.frametree.document.getElementById('start_menu');
    }
    if(e.style.visibility=='hidden')
    {
       e.style.visibility='visible';
    }
    else
    {
       e.style.visibility='hidden';
    }
  }
  </script>
</HEAD>
<BODY>
<script type="text/javascript" language="JavaScript1.2">
function disabletext(e) { return false; }
function reEnable() { return true; }
document.onselectstart=new Function ("return false")
if (window.sidebar){ document.onmousedown=disabletext; document.onclick=reEnable; }
</script>
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0" bgcolor="#7BC300" class="start_menu">
<TR>
  <TD width="100%%" colspan="11" bgcolor="#619C02"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="24" border="0" alt=""></TD>
  <TD nowrap>
    <TABLE cellspacing="0" class="start_menu_table" onmouseover="this.className='start_menu_table2';" onmouseout="this.className='start_menu_table';" onclick="show_start();">
    <TR>
      <TD class="start_menu_td"><img src="%(BASE_ICON_URL)sstartmenu_programs.gif" width="16" height="16" border="0" alt=""></TD>
      <TD class="start_menu_td">%(tls_programs)s</TD>
    </TR>
    </TABLE>
  </TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
  <TD nowrap>
    <TABLE cellspacing="0" class="start_menu_table" onmouseover="this.className='start_menu_table2';" onmouseout="this.className='start_menu_table';" onclick="parent.topcontents.document.location='%(BASE_URL)sfrontpage.py'">
    <TR>
      <TD class="start_menu_td"><img src="%(BASE_ICON_URL)sstartmenu_desktop.gif" width="16" height="16" border="0" alt=""></TD>
      <TD class="start_menu_td">%(tls_desktop)s</TD>
    </TR>
    </TABLE>
  </TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
  <TD nowrap>
    <TABLE cellspacing="0" class="start_menu_table" onmouseover="this.className='start_menu_table2';" onmouseout="this.className='start_menu_table';" onclick="parent.topcontents.document.location='%(BASE_EMAIL_URL)s%(email_url)s'">
    <TR>
      <TD class="start_menu_td"><img src="%(BASE_ICON_URL)sstartmenu_email.gif" width="16" height="16" border="0" alt=""></TD>
      <TD class="start_menu_td" nowrap>%(tls_email)s</TD>
    </TR>
    </TABLE>
  </TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
  <TD>
    <TABLE cellspacing="0" class="start_menu_table" onmouseover="this.className='start_menu_table2';" onmouseout="this.className='start_menu_table';" onclick="parent.topcontents.document.location='%(BASE_ADMIN_URL)ssettings.py'">
    <TR>
      <TD class="start_menu_td"><img src="%(BASE_ICON_URL)sstartmenu_admin.gif" width="16" height="16" border="0" alt=""></TD>
      <TD class="start_menu_td">%(tls_settings)s</TD>
    </TR>
    </TABLE>
  </TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
  <TD width="100%%" align="right">%(user_full_name)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
</TR>
</TABLE>
</BODY>
</HTML>
""" % ns

def frametree_script(REQUEST):
    return u"""
<script type="text/javascript">
function show_frametree()
{
  el1 = document.getElementById('1213');
  el2 = parent.document.getElementById('1212');
  if(el2.cols=='0,*')
    el1.style.display='block';
}
</script>
    """

def FULL_BAR(START_BAR, NAV_BAR, END_BAR):
    return u"""
<TABLE class="td_normal_noborder">
<TR>
  <TD><img src="%sspacer.gif" width="150" height="6" border="0" alt=""</TD>
  <TD><img src="%sspacer.gif" width="50" height="6" border="0" alt=""</TD>
  <TD><img src="%sspacer.gif" width="150" height="6" border="0" alt=""</TD>
</TR>
<TR valign="top">
  <TD width="1%%" nowrap align="left">&nbsp;&nbsp;%s&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD width="98%%" align="left">%s</TD>
  <TD width="1%%" nowrap align="right">&nbsp;&nbsp;&nbsp;&nbsp;%s&nbsp;&nbsp;</TD>
</TR>
</TABLE>""" % (_Conf.BASE_ICON_URL,_Conf.BASE_ICON_URL,_Conf.BASE_ICON_URL,START_BAR, NAV_BAR, END_BAR)

def FULL_BAR2(START_BAR, NAV_BAR, END_BAR):
    return u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="3" bgcolor="#7BA5BD"><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD><img src="%sspacer.gif" width="100" height="6" border="0" alt=""</TD>
  <TD><img src="%sspacer.gif" width="50" height="6" border="0" alt=""</TD>
  <TD><img src="%sspacer.gif" width="100" height="6" border="0" alt=""</TD>
</TR>
<TR valign="top">
  <TD nowrap align="left">&nbsp;&nbsp;%s&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD width="100%%" align="left">%s</TD>
  <TD nowrap align="right">&nbsp;&nbsp;&nbsp;&nbsp;%s&nbsp;&nbsp;</TD>
</TR>
</TABLE>""" % (_Conf.BASE_ICON_URL,_Conf.BASE_ICON_URL,_Conf.BASE_ICON_URL,_Conf.BASE_ICON_URL,START_BAR, NAV_BAR, END_BAR)

def FULL_BAR3(START_BAR, NAV_BAR, END_BAR):
    return u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR valign="top" style="padding-top: 1px;">
  <TD nowrap align="left">&nbsp;&nbsp;%s&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD width="100%%" align="left">%s</TD>
  <TD nowrap align="right">&nbsp;&nbsp;&nbsp;&nbsp;%s&nbsp;&nbsp;</TD>
</TR>
</TABLE>""" % (START_BAR, NAV_BAR, END_BAR)


def standard_redirect(REQUEST, url, time):
    return u"""<SCRIPT type="text/JavaScript">function ffredirect(){ document.location="%(url)s";} setTimeout("ffredirect()",%(time)s*1000);</SCRIPT>""" % locals()

def standard_objname(REQUEST, name, title, type):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    return u"""
      <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
        <TD><img src="%(BASE_ICON_URL)stitle_%(type)s.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
        <TD nowrap width="100%%"><span class="t3">%(name)s: %(title)s</span></TD>
      </TR>
      <TR>
        <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="5" border=0 alt=""></TD>
      </TR>
      </TABLE>""" % locals()

def standard_objname_link(REQUEST, name, title, type, link):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    return u"""
      <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
        <TD><img src="%(BASE_ICON_URL)stitle_%(type)s.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
        <TD nowrap width="100%%"><span class="t3">%(name)s: <a class="l3" href="%(link)s">%(title)s</A></span></TD>
      </TR>
      <TR>
        <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="5" border=0 alt=""></TD>
      </TR>
      </TABLE>""" % locals()