import _Organization
import _RootObject
import _InitTypes
import _Access
import _Conf
import _Utils

import standard_html

import MultiForm

MY_MENU_ID = 3

QUERY = """\
SELECT
 ar.right_id,
 ug.group_id,
 ug.group_org_id,
 ug.group_name,
-- ugo.organization_name as group_org_name
 i.item_name as group_org_name
FROM
 user_groups ug
LEFT JOIN access_rights ar ON ug.group_id=ar.group_id AND ( ar.item_id IS NULL OR ar.item_id=%(organization_id)s )
-- LEFT JOIN organizations ugo ON ug.group_org_id=ugo.organization_id
LEFT JOIN items i ON ug.group_org_id=i.item_id
%(right_param)s
-- ORDER BY ugo.organization_name
ORDER BY i.item_name
"""

QUERY_GROUPS = """\
SELECT
 ar.right_id,
 ug.group_id,
 ug.group_org_id,
 ug.group_name,
-- ugo.organization_name as group_org_name
 i.item_name as group_org_name
FROM
 user_groups ug
LEFT JOIN access_rights ar ON ug.group_id=ar.group_id AND ( ar.item_id IS NULL OR ar.item_id=%(organization_id)s )
-- LEFT JOIN organizations ugo ON ug.group_org_id=ugo.organization_id
LEFT JOIN items i ON ug.group_org_id=i.item_id
WHERE ug.top_org_id=%(top_org_id)d
-- ORDER BY ugo.organization_name
ORDER BY i.item_name
"""

UPDATE_QUERY = """\
UPDATE
 access_rights
SET
 right_id=%(right_id)d
WHERE
 group_id=%(group_id)d AND
 item_id=%(organization_id)d"""

INSERT_QUERY = """\
INSERT INTO
 access_rights
(item_id, treepos, group_id, right_id)
SELECT
 i.item_id,
 i.treepos,
 %(group_id)d,
 %(right_id)d
FROM
 items i
WHERE
 i.item_id=%(organization_id)d"""

DELETE_QUERY = """\
DELETE FROM
 access_rights
WHERE
 group_id=%(group_id)d AND
 item_id=%(organization_id)d"""

def index(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    tls_accesstree = REQUEST.TLS('compmenu_admin_access')
    tls_modules = REQUEST.TLS('tls_enabled_modules')
    tls_permissions = REQUEST.TLS('admin_permissions')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    if REQUEST.form.has_key('organization_id'):
        org_id = int(REQUEST.form['organization_id'].value)
        org = _RootObject.dispatch_item(REQUEST, org_id)
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')


    active = 0
    if REQUEST.form.has_key('modules') and REQUEST.form['modules'].value=='1' and org.get_parent_id() == _Conf.ROOTOBJECT and REQUEST.USER.get_id() == _Conf.SUPERUSER:
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_ADMIN_URL)saccesslist.py?organization_id=%(org_id)d&modules=1">%(tls_modules)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    elif org.get_parent_id() == _Conf.ROOTOBJECT and REQUEST.USER.get_id() == _Conf.SUPERUSER:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_ADMIN_URL)saccesslist.py?organization_id=%(org_id)d&modules=1">%(tls_modules)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u""
    if REQUEST.form.has_key('show') and REQUEST.form['show'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_ADMIN_URL)saccesslist.py?organization_id=%(org_id)d&show=1">%(tls_permissions)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_ADMIN_URL)saccesslist.py?organization_id=%(org_id)d&show=1">%(tls_permissions)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_ADMIN_URL)saccesslist.py?organization_id=%(org_id)d">%(tls_accesstree)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_ADMIN_URL)saccesslist.py?organization_id=%(org_id)d">%(tls_accesstree)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()

    output.append(u"""
      <BR>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    if REQUEST.form.has_key('save_menu'):
        menu_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                menu_ids.append(int(key[4:]))
        i = 0
        j = 0
        menu_size = _Conf.MODULES_TOTAL_COUNT + 1
        menu_str = ""
        while(i<menu_size):
            try:
              if (menu_ids[j] == i):
                  menu_str += "1"
                  j = j + 1
              else:
                  menu_str += "0"
            except:
              menu_str +="0"
            i = i + 1
        REQUEST._settings.set_setting_org_any(REQUEST, org_id, 'module_access', menu_str)

    if not REQUEST.form.has_key('modules') and not REQUEST.form.has_key('show'):
        if REQUEST.form.has_key('save_rights'):
            multiform = MultiForm.MultiForm(REQUEST)
            for formrow in multiform.get_rows():
                if formrow['oldvalue'] == formrow['newvalue']:
                    continue
                ns = {'organization_id':org_id, 'group_id':int(formrow['group_id']), 'right_id':int(formrow['newvalue'])}

                tmp = _Organization.Organization(REQUEST, _InitTypes.INIT_TYPE_ID, int(org_id))
                if REQUEST.USER.get_id() not in [_Conf.SUPERUSER, tmp.get_top_parent().get('superuser_id')]:
                    continue
                    
                if int(formrow['is_inherited']) and ns['right_id'] <> 0:
                    Q = INSERT_QUERY % ns
                elif ns['right_id'] == 0:
                    Q = DELETE_QUERY % ns
                elif int(formrow['oldvalue']) == 0:
                    Q = INSERT_QUERY % ns
                else:
                    Q = UPDATE_QUERY % ns
                REQUEST.db.execute(Q.encode('UTF8'))

        output.append(u"""\
<FORM action="accesslist.py" method="POST">
<INPUT type="hidden" name="organization_id" value="%d">
<TABLE border=0 cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1"><img src="%sspacer.gif" width="5" height="20" border="0" alt=""></TD>
  <TD class="td_listing1"><b>%s:</B> %s</TD>
  <TD class="td_listing1">&nbsp;</TD>
</TR>""" % (org_id, _Conf.BASE_ICON_URL, REQUEST.TLS('admin_organization'), org.get_name()))


        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_ORGANIZATION])
        if right_param:
            right_param = """WHERE %s""" % right_param
        REQUEST.db.execute((QUERY % {'organization_id':org_id, 'right_param':right_param}).encode('UTF8'))
        dbresult = REQUEST.db.dictfetchall()
        if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
            REQUEST.db.execute((QUERY_GROUPS % {'organization_id':org_id, 'top_org_id':REQUEST.USER.get_person(REQUEST).get_top_parent().get_id()}).encode('UTF8'))
            dbresult = dbresult + REQUEST.db.dictfetchall()
        index = 0
        for row in dbresult:
            ns = {}
            ns['ro'] = ""
            if row['group_org_id'] and  REQUEST.USER.get_id() not in [_Conf.SUPERUSER, _Organization.Organization(REQUEST, _InitTypes.INIT_TYPE_ID, int(org_id)).get_top_parent().get('superuser_id')]:
                ns['ro'] = 'readonly disabled'
            ns['class_type'] = index % 2
            ns['index'] = index
            index += 1

            ns['read_selected'] = ""
            ns['write_selected'] = ""
            ns['manage_selected'] = ""

            ns['group_id'] = row['group_id']

            ns['is_inherited'] = 0

            if row['right_id'] == _Access.ACCESS_READ:
                ns['read_selected'] = " SELECTED"
                ns['true_right_id'] = _Access.ACCESS_READ
            elif row['right_id'] == _Access.ACCESS_WRITE:
                ns['write_selected'] = "SELECTED"
                ns['true_right_id'] = _Access.ACCESS_WRITE
            elif row['right_id'] == _Access.ACCESS_MANAGE:
                ns['manage_selected'] = "SELECTED"
                ns['true_right_id'] = _Access.ACCESS_MANAGE
            elif row['right_id'] == 0:
                ns['true_right_id'] = 0
            else:
                right_id = _Access.get_item_right_group(REQUEST, org_id, row['group_id'])
                if right_id == _Access.ACCESS_READ:
                    ns['is_inherited'] = 1
                    ns['true_right_id'] = _Access.ACCESS_READ
                    ns['read_selected'] = " SELECTED"
                elif right_id == _Access.ACCESS_WRITE:
                    ns['is_inherited'] = 1
                    ns['true_right_id'] = _Access.ACCESS_WRITE
                    ns['write_selected'] = "SELECTED"
                elif right_id == _Access.ACCESS_MANAGE:
                    ns['is_inherited'] = 1
                    ns['true_right_id'] = _Access.ACCESS_MANAGE
                    ns['manage_selected'] = "SELECTED"
                elif row['right_id'] == 0:
                    ns['is_inherited'] = 1
                    ns['true_right_id'] = 0
                else:
                    ns['true_right_id'] = 0
            if row['group_org_name'] is None:
                ns['group_org_name'] = row['group_name'].decode('UTF8')
            else:
                ns['group_org_name'] = row['group_org_name'].decode('UTF8')
            ns['tls_read'] = REQUEST.TLS('admin_read')
            ns['tls_write'] = REQUEST.TLS('admin_write')
            ns['tls_manage'] = REQUEST.TLS('admin_manage')
            ns['admin_hasaccess'] = REQUEST.TLS('admin_hasaccess')
            ns['admin_right'] = REQUEST.TLS('admin_right')
            ns['admin_right_end'] = REQUEST.TLS('admin_right_end')
            ns['to'] = org.get_name()
            output.append(u"""\
<INPUT type="hidden" name="form_%(index)03d_oldvalue" value="%(true_right_id)d">
<INPUT type="hidden" name="form_%(index)03d_is_inherited" value="%(is_inherited)d">
<INPUT type="hidden" name="form_%(index)03d_group_id" value="%(group_id)d">
<TR>
  <TD class="td_listing%(class_type)d">&nbsp;</TD>
  <TD class="td_listing%(class_type)d" nowrap>%(group_org_name)s %(admin_hasaccess)s</TD>
  <TD class="td_listing%(class_type)d" nowrap>
     <SELECT name="form_%(index)03d_newvalue" %(ro)s>
         <OPTION value="0">
         <OPTION value="1"%(read_selected)s>%(tls_read)s
         <OPTION value="2"%(write_selected)s>%(tls_write)s
         <OPTION value="3"%(manage_selected)s>%(tls_manage)s
     </SELECT>
     %(admin_right)s %(to)s%(admin_right_end)s
  </TD>
</TR>""" % ns)
        if not ns['ro']:
            output.append(u"""<TR><TD class="td_listing0" colspan="3"><INPUT type="submit" class="input2" name="save_rights" value="%s"></TD></TR>""" % REQUEST.TLS('tls_save'))
        output.append(u"""</TABLE></FORM>""")
    
    # MODULES
    
    if (org.get_parent_id() == _Conf.ROOTOBJECT and REQUEST.USER.get_id() == _Conf.SUPERUSER and REQUEST.form.has_key('modules')):
            ns = {}
            BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
            BASE_ICON_URL = _Conf.BASE_ICON_URL
            tls_enabled_modules = REQUEST.TLS('tls_enabled_modules')
            tls_select_all = REQUEST.TLS('tls_select_all')
            access_str = _Utils.get_module_access_org(REQUEST, org_id)

            output.append(u"""\
        <SCRIPT type="text/javascript">
        <!--
        function select_all()
        {
            for(var x=0;x<document.forms['menu_form'].elements.length;x++)
            {
               var e = document.forms['menu_form'].elements[x];
               if ((e.name != 'all') && (e.type=='checkbox'))
               {
                 e.checked = document.forms['menu_form'].all.checked;
               }
            }
        }
        //-->
        </SCRIPT>
        <FORM method="post" name="menu_form" action="%(BASE_ADMIN_URL)saccesslist.py">
        <input type="hidden" name="organization_id" value="%(org_id)s">
        <input type="hidden" name="modules" value="1">
        <TABLE border=0 width="400" cellpadding="0" cellspacing="0">
        <TR>
          <TD class="td_listing1"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="20" border="0" alt=""></TD>
          <TD class="td_listing1b">%(tls_enabled_modules)s</TD>
          <TD class="td_listing1b"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="15" border="0" alt=""></TD>
        </TR>
        <TR>
          <TD class="td_listing0"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="15" border="0" alt=""></TD>
          <TD align="right" class="td_listing0"> %(tls_select_all)s</TD>
          <TD class="td_listing0"><INPUT type="checkbox" name="all" onclick="select_all();"></TD>
        </TR>""" % (locals()))

            ns['index'] = 0
            for i in range(_Conf.MODULES_TOTAL_COUNT):
                mi = None
                for menuitem in _Conf.MENU:
                    if menuitem[2] == i:
                        mi = menuitem
                        break
                if not mi or not mi[_Conf.MENU_ENABLED]:
                    ns['index'] += 1
                    continue
                if(access_str[menuitem[2]]=="1"):
                    ns['selected']="checked"
                else:
                    ns['selected']=""
                ns['td_class'] = ns['index'] % 2
                ns['current_menu_name'] = REQUEST.TLS(menuitem[_Conf.MENU_NAME])
                ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
                output.append(u"""\
        <TR>
          <TD class="td_listing%(td_class)s"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="15" border="0" alt=""></TD>
          <TD class="td_listing%(td_class)s">%(current_menu_name)s</TD>
          <TD class="td_listing%(td_class)s"><INPUT type="checkbox" %(selected)s name="sel_%(index)s"></TD>
        </TR>
        """ % ns)
                ns['index'] += 1
            output.append(u"""\
        <TR>
          <TD colspan="3" class="td_listing0"><INPUT type="submit" class="input2" name="save_menu" value="%s"></TD>
        </TR>
        </TABLE>
        </FORM>""" %(REQUEST.TLS('tls_save')))
    if REQUEST.form.has_key('show') and REQUEST.form['show'].value=='1':
        BASE_ICON_URL = _Conf.BASE_ICON_URL
        tls_org = REQUEST.TLS('admin_organization')
        org_name = org.get('item_name')
        org.load_group()
        group_id = org.get('group_id')
        SQL = """SELECT item_id, item_name from items i where item_type_id=%d AND item_id<>%s""" % (_InitTypes.ITEM_TYPE_ORGANIZATION, _Conf.ROOTOBJECT)
        REQUEST.db.execute(SQL.encode('UTF8'))
        dbres = REQUEST.db.dictfetchall()
        manage_out = ""
        write_out = ""
        read_out = ""
        none_out = ""
        for row in dbres:
            right = _Access.get_item_right_group(REQUEST, row['item_id'], group_id)
            if right==_Access.ACCESS_MANAGE:
                right2 = _Access.get_item_right(REQUEST, row['item_id'], REQUEST.USER.get_id())
                if right2:
                    manage_out = manage_out + "<LI>" + row['item_name'].decode('UTF8') + "\n"
            elif right==_Access.ACCESS_WRITE:
                right2 = _Access.get_item_right(REQUEST, row['item_id'], REQUEST.USER.get_id())
                if right2:
                   write_out = write_out + "<LI>" + row['item_name'].decode('UTF8') + "\n"
            elif right==_Access.ACCESS_READ:
                right2 = _Access.get_item_right(REQUEST, row['item_id'], REQUEST.USER.get_id())
                if right2:
                    read_out = read_out + "<LI>" + row['item_name'].decode('UTF8') + "\n"
            else:
                right2 = _Access.get_item_right(REQUEST, row['item_id'], REQUEST.USER.get_id())
                if right2:
                    none_out = none_out + "<LI>" + row['item_name'].decode('UTF8') + "\n"


        tls_manageto = REQUEST.TLS('admin_manage_to')
        tls_writeto = REQUEST.TLS('admin_write_to')
        tls_readto = REQUEST.TLS('admin_read_to')
        tls_noto = REQUEST.TLS('admin_no_to')
        tls_haspermissions = REQUEST.TLS('admin_haspermissions')
        output.append(u"""
<TABLE border=0 width="400" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="20" border="0" alt=""></TD>
  <TD class="td_listing1b" width="100%%">%(tls_org)s: %(org_name)s %(tls_haspermissions)s:</TD>
  <TD class="td_listing1b"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="15" border="0" alt=""></TD>
</TR>
</TABLE>
<BR>
<DT>
  <DD><b>%(tls_manageto)s:</b>
    <UL>
      %(manage_out)s
    </UL>
  <DD><b>%(tls_writeto)s:</b>
    <UL>
      %(write_out)s
    </UL>
  <DD><b>%(tls_readto)s:</b>
    <UL>
      %(read_out)s
    </UL>
  <DD><b>%(tls_noto)s:</b>
    <UL>
      %(none_out)s
    </UL>
</DT>
<br>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
