import _Conf

from Menus import get_admin_menu
import standard_html

MY_MENU_ID = 4

def index(REQUEST):
    if REQUEST.form.has_key('_save') or REQUEST.form.has_key('_save.x'):
        return save_choice(REQUEST)

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_choices = REQUEST.TLS('admin_choices')
    tls_choice = REQUEST.TLS('admin_choice')
    tls_save = REQUEST.TLS('tls_save')
    tls_edit = REQUEST.TLS('tls_edit')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    SQL = "SELECT setting_key FROM settings WHERE is_configurable=1 ORDER by setting_key ASC"
    REQUEST.db.execute(SQL)
    choice_names = map(lambda x: x['setting_key'].decode('UTF8'), REQUEST.db.dictfetchall())

    choice_select = u"""<SELECT class="input6" name="selected_choice">\n%s\n</SELECT>""" % "\n".join(map(lambda x: u"""<OPTION %s value="%s">%s""" % ((REQUEST.form.has_key('selected_choice') and x==REQUEST.form['selected_choice'].value and "SELECTED") or "", x,x), choice_names))

    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        form_title = REQUEST.TLS('admin_choices_systemwide')
        edit_root = 1
    else:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() == top_parent.get('superuser_id'):
            form_title = u"%s %s" % (REQUEST.TLS('admin_choices_org'), top_parent.get_name())
            edit_root = 0
        else:
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if (REQUEST.form.has_key('_select') or REQUEST.form.has_key('_select.x')) and REQUEST.form.has_key('selected_choice') and REQUEST.form['selected_choice'].value:
        choice_name = REQUEST.form['selected_choice'].value.decode('UTF8')
        found = 0
        if edit_root:
            choice_value = REQUEST._settings.get_settings_top(REQUEST)
            for choice in choice_value:
                if choice['setting_key'] == choice_name:
                    found = 1
                    choice_value = choice['value']
                    break
        else:
            choice_value = REQUEST._settings.get_settings_org(REQUEST)
            for choice in choice_value:
                if choice['setting_key'] == choice_name:
                    found = 1
                    choice_value = choice['value']
                    break
            if not found:
                choice_value = REQUEST._settings.get_settings_top(REQUEST)
                for choice in choice_value:
                    if choice['setting_key'] == choice_name:
                        found = 1
                        choice_value = choice['value']
                        break
        if not found:
            raise RuntimeError, REQUEST.TLS('admin_choices_notfound')
        if isinstance(choice_value, list) or choice_name in ['cal_activities','cal_priorities', 'todo_categories','todo_statuses','contact_categories','todo_priorities', 'doc_categories']:
            choice_value = "\n".join(choice_value)
            is_list = 1
        else:
            is_list = 0

        edit_form = u"""\
<INPUT type="hidden" name="is_list" value="%(is_list)d">
<INPUT type="hidden" name="choice_name" value="%(choice_name)s">
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1">%(tls_choice)s: %(choice_name)s
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0"><TEXTAREA class="textarea1" name="choice_contents" cols="40" rows="8">%(choice_value)s</TEXTAREA></TD>
 </TR>
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1"><INPUT class="input2" type="submit" name="_save" value="%(tls_save)s"></TD>
 </TR>
""" % locals()
    else:
        edit_form = u""

    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    output.append(u"""\
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_choices.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_choices)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM action="%(BASE_ADMIN_URL)schoices.py" method="POST">
 <TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1" width="100%%">%(form_title)s</TD>
 </TR>
 <TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0">%(choice_select)s&nbsp;<INPUT class="input2" type="submit" name="_select" value="%(tls_edit)s"></TD>
 </TR>
%(edit_form)s
</TABLE>
</FORM>
""" % locals())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def save_choice(REQUEST):
    if not REQUEST.form.has_key('choice_name') or not REQUEST.form.has_key('choice_contents') or not REQUEST.form['choice_name'].value or not REQUEST.form['choice_contents'].value:
       if not (REQUEST.form.has_key('choice_name') and (REQUEST.form['choice_name'].value=='currency_prefix' or REQUEST.form['choice_name'].value=='currency_suffix')):
           raise RuntimeError, REQUEST.TLS('admin_choices_empty')

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_ADMIN_URL+"choices.py"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        edit_root = 1
    else:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() == top_parent.get('superuser_id'):
            edit_root = 0
        else:
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    choice_name = REQUEST.form['choice_name'].value.decode('UTF8')
    choice_contents = REQUEST.form['choice_contents'].value.decode('UTF8').replace(u'\r\n',u'\n')
    if REQUEST.form.has_key('is_list') and REQUEST.form['is_list'].value:
        is_list = int(REQUEST.form['is_list'].value)
    else:
        is_list = 0

    if is_list == 0 and choice_contents.find('\n'):
        choice_contents = choice_contents.split('\n')[0]
    if is_list == 1:
        choice_contents = filter(None, map(lambda x: x.strip(), choice_contents.split('\n')))
    else:
        choice_contents = choice_contents.strip()


    if edit_root:
        REQUEST._settings.set_setting_top(REQUEST, choice_name, choice_contents)
    else:
        REQUEST._settings.set_setting_org(REQUEST, choice_name, choice_contents)

    output.append(REQUEST.TLS('admin_choices_updated') % choice_name)

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

