"""

Default admin page.

$Id$
"""

from mod_python import apache
import _Conf
from Menus import get_admin_menu
import standard_html, _UserGroups

import _Access, _InitTypes, _Exceptions, _Utils

MY_MENU_ID = 6

def index(REQUEST):
    top_org_id = None
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        top_org_id = top_parent.get_id()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    QUERY = """SELECT
 count(*) as count_all
FROM
 user_groups ug
LEFT JOIN organizations t ON ug.top_org_id = t.organization_id
WHERE ug.group_org_id is null
"""
    if top_org_id is not None:
        QUERY += """ AND ug.top_org_id=%d""" % top_org_id
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sgroups.py%sqs=" % (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sgroups.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sgroups.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    if top_org_id is not None:
        q2 = """ AND ug.top_org_id=%d""" % top_org_id
    else:
        q2 = ""
    QUERY = """SELECT
 ug.*,
 t.organization_name as top_name
FROM
 user_groups ug
LEFT JOIN organizations t ON ug.top_org_id = t.organization_id
WHERE ug.group_org_id is null%s LIMIT %d OFFSET %d""" % (q2, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    tls_edit = REQUEST.TLS('admin_edit')
    tls_del = REQUEST.TLS('admin_delete')
    tls_search = REQUEST.TLS('tls_search')
    tls_add = REQUEST.TLS('tls_add')
    tls_email = REQUEST.TLS('tls_email')
    tls_groups = REQUEST.TLS('compmenu_admin_group')
    tls_groupname = REQUEST.TLS('tls_groupname')
    tls_users = REQUEST.TLS('compmenu_admin_user')
    tls_toplevel = REQUEST.TLS('admin_toplevel')

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_groups)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" width="40%%" nowrap>%(tls_groupname)s</TD>
  <TD class="td_listing1b" width="45%%" nowrap>%(tls_toplevel)s</TD>
  <TD class="td_listing1b" width="15%%" nowrap align="center">%(tls_users)s</TD>
  <TD class="td_listing1b" width="25"   nowrap>%(tls_del)s</TD>
</TR>""" % locals())

    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_ADMIN_URL'] = _Conf.BASE_ADMIN_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        item['group_name'] = (item['group_name'] and item['group_name'].decode('UTF8')) or ''
        item['top_name'] = (item['top_name'] and item['top_name'].decode('UTF8')) or ''

        item['tls_edit'] = tls_edit
        item['tls_sureq'] = REQUEST.TLS('admin_sureq')
        item['tls_delete'] = REQUEST.TLS('tls_delete')
        REQUEST.db.execute("""SELECT count(*) FROM access_groups WHERE group_id=%d""" % item['group_id'])
        item['children'] = REQUEST.db.fetchone()[0]
        output.append(u"""<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d"><A class="blacklink" href="%(BASE_ADMIN_URL)sgroups.py/group_edit_form?group_id=%(group_id)d">%(group_name)s</A></TD>
  <TD class="td_listing%(class_type)d">%(top_name)s</TD>
  <TD class="td_listing%(class_type)d" align="center">%(children)d</TD>
  <TD class="td_listing%(class_type)d" style="text-align: center"><A onclick="return confirm('%(tls_sureq)s?');" href="%(BASE_ADMIN_URL)sgroups.py/group_delete?group_id=%(group_id)d"><IMG src="%(BASE_ICON_URL)sdelete.gif" alt="%(tls_delete)s"></A></TD>
</TR>""" % item)
    output.append(u"</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)

    item = {}
    item['BASE_ADMIN_URL'] = _Conf.BASE_ADMIN_URL
    item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    item['tls_add'] = tls_add
    item['tls_search'] = tls_search
    output.append(u"""
    <BR>
    <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
      <TR>
        <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
        <TD class="td_listing_noborder" width="100%%"><FORM action="%(BASE_ADMIN_URL)sgroups.py" method="GET"><INPUT class="input2" type="submit" value="%(tls_add)s" name="do_add" onclick="this.form.action='%(BASE_ADMIN_URL)sgroups.py/add'"></FORM></TD>
      </TR>
    </TABLE>""" % item)
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def add(REQUEST):
    top_org_id = None
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        top_org_id = top_parent.get_id()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_newgroup = REQUEST.TLS('cal_newgroup')
    tls_groupname = REQUEST.TLS('tls_groupname')
    tls_save = REQUEST.TLS('tls_save')
    tls_toplevel = REQUEST.TLS('admin_toplevel')
    tls_choose = REQUEST.TLS('email_choose')
    output.append(u"""
<SCRIPT type="text/JavaScript">
<!--
  function check_values()
  {
    if (!document.addform.group_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_6.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_newgroup)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="post" action="%(BASE_ADMIN_URL)sgroups.py/save" onsubmit="return check_values();">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_groupname)s:</TD>
    <TD class="td_listing1ve"><INPUT type="text" class="textfield1" name="group_name" size=20 maxlength=20></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())

    if top_org_id is None:
        REQUEST.db.execute("""SELECT organization_id, organization_name FROM items i, organizations o WHERE
i.item_id=o.organization_id AND i.parent_id=%d AND i.item_id<>%d""" % (_Conf.ROOTOBJECT, _Conf.ROOTOBJECT))
        orgs = REQUEST.db.fetchall()
        sel = ["""<SELECT name="top_org_id">\n<option value="">%(tls_choose)s""" % locals()]
        for org in orgs:
            sel.append("""<option value="%d">%s""" % (org[0], _Utils.html_quote(org[1].decode('UTF8'))))
        sel.append("""</select>""")
        sel = "\n".join(sel)
        output.append(u"""
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0ke" nowrap>%(tls_toplevel)s:</TD>
    <TD class="td_listing0ve">%(sel)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())
    else:
        output.append(u"""<INPUT TYPE="hidden" name="top_org_id" value="%d">""" % top_org_id)
    output.append(u"""
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD colspan=3  class="td_listing_noborder"><input type="submit" name="_add" class="input2" value="%(tls_save)s"></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)


def save(REQUEST):
    top_org_id = None
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        top_org_id = top_parent.get_id()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if REQUEST.form.has_key('_add'):
        if top_org_id is not None and REQUEST.form.has_key('top_org_id') and int(REQUEST.form['top_org_id'].value) <> top_org_id:
            raise RuntimeError, REQUEST.TLS('admin_notsuper')
    
        if not REQUEST.form.has_key('group_name') or \
           not REQUEST.form.has_key('top_org_id') or \
           not REQUEST.form['group_name'].value.decode('UTF8').strip() or \
           not REQUEST.form['top_org_id'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')

        group_name = _Utils.sql_quote(REQUEST.form['group_name'].value.decode('UTF8').strip())
        top_org_id = int(REQUEST.form['top_org_id'].value.decode('UTF8').strip())
        SQL = u"""INSERT INTO
 user_groups (
 group_name,
 top_org_id )
VALUES (
 %(group_name)s,
 %(top_org_id)d )""" % locals()
        REQUEST.db.execute(SQL.encode('UTF8'))

    REQUEST.mod_req.headers_out["Location"] = """%sgroups.py""" % _Conf.BASE_ADMIN_URL
    return apache.HTTP_MOVED_TEMPORARILY

def group_edit_form(REQUEST):
    top_org_id = None
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        top_org_id = top_parent.get_id()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')
    if REQUEST.form.has_key('organization_id') and REQUEST.form['organization_id'].value and int(REQUEST.form['organization_id'].value):
        organization_id = int(REQUEST.form['organization_id'].value)
    else:
        organization_id = ""
    if not REQUEST.form.has_key('group_id') or not REQUEST.form['group_id'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    group = _UserGroups.UserGroup(REQUEST, int(REQUEST.form['group_id'].value.decode('UTF8').strip()))
    group.load_persons()
    if top_org_id is not None and group.data['top_org_id'] <> top_org_id:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if REQUEST.form.has_key('action') and REQUEST.form['action'].value.decode('UTF8') == u'del':
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'del_':
                del_ids.append(int(key[4:]))
        for del_id in del_ids:
            group.del_person(int(del_id))

    if REQUEST.form.has_key('action') and REQUEST.form['action'].value.decode('UTF8') == u'add':
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))
        for del_id in del_ids:
            group.add_person(int(del_id))

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    group_name = _Utils.html_quote(group.data['group_name'].decode('UTF8'))
    group_id = group.data['group_id']
    tls_choose = REQUEST.TLS('email_choose')
    tls_remove_sel = REQUEST.TLS('tls_remove_sel')
    tls_add_sel = REQUEST.TLS('tls_add_sel')
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL

    in_group = []
    if group.persons:
        in_group.append(u"""
<FORM name="addform" method="POST" action="%(BASE_ADMIN_URL)sgroups.py/group_edit_form">
<input type="hidden" name="group_id" value="%(group_id)s">
<input type="hidden" name="action" value="del">
<input type="hidden" name="organization_id" value="%(organization_id)s">
""" % locals())
    for per in (group.persons or []):
        for key in ['first_name','last_name','username']:
            per[key] = per[key].decode('UTF8')
        in_group.append(u"""
<TR>
 <TD nowrap class="td_listing_noborder">%(first_name)s %(last_name)s (%(username)s)</TD>
 <TD nowrap><input type="checkbox" name="del_%(person_id)s" value="1"></TD>
</TR>
""" % per)
    if in_group:
        in_group.append("""
<TR>
 <TD class="td_listing_noborder" colspan="2"><input type="submit" value="%(tls_remove_sel)s" class="input6"></TD>
</TR>
</FORM>""" % locals())
    in_group = "\n".join(in_group)
    
    if top_org_id is None:
        SQL = u"""SELECT organization_id, organization_name FROM items i, organizations o WHERE
i.item_id=o.organization_id AND i.item_id<>%d ORDER BY treepos""" % _Conf.ROOTOBJECT
    else:
        SQL = u"""SELECT organization_id, organization_name FROM items i, organizations o WHERE
i.item_id=o.organization_id AND
i.item_id<>%d AND
i.treepos >= %s and i.treepos < (%s || B'1')
ORDER BY treepos""" % (_Conf.ROOTOBJECT, _Utils.sql_cast_bit(REQUEST, top_parent.get('treepos')), _Utils.sql_cast_bit(REQUEST, top_parent.get('treepos')))
    REQUEST.db.execute(SQL.encode('UTF8'))
    orgs = REQUEST.db.fetchall()
    sel = ["""<SELECT name="organization_id" onchange="change_url();">\n<option value="">%(tls_choose)s""" % locals()]
    for org in orgs:
        if REQUEST.form.has_key('organization_id') and REQUEST.form['organization_id'].value and int(REQUEST.form['organization_id'].value) == org[0]:
            sel.append("""<option value="%d" selected>%s""" % (org[0], _Utils.html_quote(org[1].decode('UTF8'))))
        else:
            sel.append("""<option value="%d">%s""" % (org[0], _Utils.html_quote(org[1].decode('UTF8'))))
    sel.append("""</select>""")
    sel = "\n".join(sel)

    out_group = []
    if REQUEST.form.has_key('organization_id') and REQUEST.form['organization_id'].value:
        org_id = int(REQUEST.form['organization_id'].value)
        SQL = u"""SELECT p.person_id, p.first_name, p.last_name, p.username FROM  persons p, items i WHERE  i.item_id=p.person_id and  i.parent_id=%d and p.is_deleted=0""" % org_id
        REQUEST.db.execute(SQL.encode('UTF8'))
        pers = REQUEST.db.fetchall()
        gr_pers = map(lambda x:x['person_id'], group.persons)
        is_set = 0
        for per in pers:
            if per[0] not in gr_pers:
                if not is_set:
                  out_group.append(u"""
<FORM name="addform" method="POST" action="%(BASE_ADMIN_URL)sgroups.py/group_edit_form">
<input type="hidden" name="group_id" value="%(group_id)s">
<input type="hidden" name="action" value="add">
<input type="hidden" name="organization_id" value="%(organization_id)s">
""" % locals())
                  is_set = 1
                person_id = per[0]
                first_name = per[1].decode('UTF8')
                last_name = per[2].decode('UTF8')
                username = per[3].decode('UTF8')
                out_group.append(u"""
<TR>
 <TD class="td_listing_noborder" nowrap>%(first_name)s %(last_name)s (%(username)s)</TD>
 <TD nowrap><input type="checkbox" name="sel_%(person_id)s" value="1"></TD>
</TR>""" % locals())
    if out_group:
        out_group.append("""
<TR>
 <TD class="td_listing_noborder" colspan="2"><input type="submit" value="%(tls_add_sel)s" class="input6"></TD>
</TR>
</FORM>""" % locals())
    out_group = "\n".join(out_group)

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_groups = REQUEST.TLS('compmenu_admin_group')
    tls_groupname = REQUEST.TLS('tls_groupname')
    tls_members = REQUEST.TLS('tls_members')
    tls_org = REQUEST.TLS('admin_organization')
    output.append(u"""
<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!--
function change_url()
{
    if (document.group_form.organization_id.selectedIndex == 0)
        return;
    else
        document.group_form.submit();
}
// -->   
</script>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_groups)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="group_form" method=post action="%(BASE_ADMIN_URL)sgroups.py/group_edit_form"><input type="hidden" name="group_id" value="%(group_id)s">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_groupname)s: %(group_name)s</TD>
  <TD class="td_listing1" nowrap><img src="%(BASE_ICON_URL)sspacer.gif" width=50 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_org)s: %(sel)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</FORM>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0b" nowrap>%(tls_members)s:</TD>
  <TD class="td_listing0" nowrap>&nbsp;</TD>
  <TD class="td_listing0b" nowrap>%(tls_members)s:</TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap valign="top">
    <TABLE valign="top">
      %(in_group)s
    </TABLE>
  </TD>
  <TD class="td_listing0" nowrap>&nbsp;</TD>
  <TD class="td_listing0" nowrap  valign="top">
    <TABLE valign="top">
      %(out_group)s
    </TABLE>
  </TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def group_delete(REQUEST):
    top_org_id = None
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        top_org_id = top_parent.get_id()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    SQL = "SELECT * FROM user_groups WHERE group_id=%d" % int(REQUEST.form['group_id'].value)
    REQUEST.db.execute(SQL)
    res = REQUEST.db.dictfetchone()

    if top_org_id is not None and res['top_org_id'] <> top_org_id:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')
    
    SQL = """DELETE FROM user_groups WHERE group_id=%d""" % int(REQUEST.form['group_id'].value)
    REQUEST.db.execute(SQL)

    REQUEST.mod_req.headers_out["Location"] = """%sgroups.py""" % _Conf.BASE_ADMIN_URL
    return apache.HTTP_MOVED_TEMPORARILY

