import _Conf, _Utils, _Access, _InitTypes, _RootObject

from Menus import get_admin_menu
import standard_html
from mod_python import apache

MY_MENU_ID = 8

def index(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_pit = REQUEST.TLS('admin_pit')
    tls_search = REQUEST.TLS('tls_search')
    tls_name = REQUEST.TLS('tls_name')
    tls_editor = REQUEST.TLS('log_mod_by')
    tls_owner = REQUEST.TLS('client_owner')
    tls_time = REQUEST.TLS('log_mod_time')
    tls_lastitems = REQUEST.TLS('admin_lastitems')
    tls_itemid = REQUEST.TLS('log_item_id')
    tls_itemname = REQUEST.TLS('log_item_name')
    type_Folders = REQUEST.TLS('type_Folders')
    type_Documents = REQUEST.TLS('type_Documents')
    type_Events = REQUEST.TLS('type_Events')
    type_Todos = REQUEST.TLS('type_Todos')
    type_Workflows = REQUEST.TLS('type_Workflows')
    type_Client = REQUEST.TLS('type_Client')
    type_Contacts = REQUEST.TLS('type_Contacts')
    type_Opportunity = REQUEST.TLS('type_Opportunity')
    type_Product = REQUEST.TLS('type_Product')
    ITEM_TYPE_FOLDER = _InitTypes.ITEM_TYPE_FOLDER
    ITEM_TYPE_DOCUMENT = _InitTypes.ITEM_TYPE_DOCUMENT
    ITEM_TYPE_EVENT = _InitTypes.ITEM_TYPE_EVENT
    ITEM_TYPE_TODO = _InitTypes.ITEM_TYPE_TODO
    ITEM_TYPE_WORKFLOW = _InitTypes.ITEM_TYPE_WORKFLOW
    ITEM_TYPE_CLIENT = _InitTypes.ITEM_TYPE_CLIENT
    ITEM_TYPE_CONTACT = _InitTypes.ITEM_TYPE_CONTACT
    ITEM_TYPE_OPPORTUNITY = _InitTypes.ITEM_TYPE_OPPORTUNITY
    ITEM_TYPE_PRODUCT = _InitTypes.ITEM_TYPE_PRODUCT

    fol_out = u""
    doc_out = u""
    eve_out = u""
    tas_out = u""
    wor_out = u""
    cli_out = u""
    con_out = u""
    opp_out = u""
    pro_out = u""

    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, folders f, items i2, items i3 WHERE f.folder_id = i.item_id AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id %s ORDER BY i.edit_time desc LIMIT 5"""
    fol_out = create_batch(REQUEST, SQL, "ITEM_TYPE_FOLDER") % locals()
    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, documents d, items i2, items i3 WHERE d.document_id = i.item_id AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id AND (d.document_id IS NOT NULL and d.final_version_id IS NULL) %s ORDER BY i.edit_time desc LIMIT 5"""
    doc_out = create_batch(REQUEST, SQL, "ITEM_TYPE_DOCUMENT") % locals()
    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, events d, items i2, items i3 WHERE d.event_id = i.item_id AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id %s ORDER BY i.edit_time desc LIMIT 5"""
    eve_out = create_batch(REQUEST, SQL, "ITEM_TYPE_EVENT") % locals()
    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, todos d, items i2, items i3 WHERE d.todo_id = i.item_id AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id %s ORDER BY i.edit_time desc LIMIT 5"""
    tas_out = create_batch(REQUEST, SQL, "ITEM_TYPE_TODO") % locals()
    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, workflows d, items i2, items i3 WHERE d.workflow_id = i.item_id AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id %s ORDER BY i.edit_time desc LIMIT 5"""
    wor_out = create_batch(REQUEST, SQL, "ITEM_TYPE_WORKFLOW") % locals()
    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, clients d, items i2, items i3 WHERE d.client_id = i.item_id AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id %s ORDER BY i.edit_time desc LIMIT 5"""
    cli_out = create_batch(REQUEST, SQL, "ITEM_TYPE_CLIENT") % locals()
    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, contacts d, items i2, items i3 WHERE d.contact_id = i.item_id AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id %s ORDER BY i.edit_time desc LIMIT 5"""
    con_out = create_batch(REQUEST, SQL, "ITEM_TYPE_CONTACT") % locals()
    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, opportunities d, items i2, items i3 WHERE d.opp_id = i.item_id AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id %s ORDER BY i.edit_time desc LIMIT 5"""
    opp_out = create_batch(REQUEST, SQL, "ITEM_TYPE_OPPORTUNITY") % locals()
    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, products d, items i2, items i3 WHERE d.product_id = i.item_id AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id %s ORDER BY i.edit_time desc LIMIT 5"""
    pro_out = create_batch(REQUEST, SQL, "ITEM_TYPE_PRODUCT") % locals()

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_pit)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" action="%(BASE_ADMIN_URL)spoint-in-time.py/search">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap width="10%%">%(tls_itemid)s:</TD>
  <TD class="td_listing1b" nowrap width="10%%"><input type="text" class="textfield1" size="5" name="item_id"></TD>
  <TD class="td_listing1b" nowrap width="10%%">%(tls_itemname)s:</TD>
  <TD class="td_listing1b" nowrap width="10%%"><input type="text" class="textfield1" size="20" name="item_name"></TD>
  <TD class="td_listing1b" nowrap width="10%%"><input type="submit" class="input2" value="%(tls_search)s" ></TD>
  <TD class="td_listing1b" nowrap width="50%%">&nbsp;</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0b" nowrap colspan="5">%(tls_lastitems)s</TD>
  <TD class="td_listing0b" nowrap>&nbsp;</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap colspan="6"><a class="blackboldlink" href="%(BASE_ADMIN_URL)spoint-in-time.py/show_list?item_type_id=%(ITEM_TYPE_FOLDER)s">%(type_Folders)s:</a></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap colspan="6" valign="top">%(fol_out)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap colspan="6"><a class="blackboldlink" href="%(BASE_ADMIN_URL)spoint-in-time.py/show_list?item_type_id=%(ITEM_TYPE_DOCUMENT)s">%(type_Documents)s:</a></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap colspan="6" valign="top">%(doc_out)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap colspan="6"><a class="blackboldlink" href="%(BASE_ADMIN_URL)spoint-in-time.py/show_list?item_type_id=%(ITEM_TYPE_EVENT)s">%(type_Events)s:</a></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap colspan="6" valign="top">%(eve_out)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap colspan="6"><a class="blackboldlink" href="%(BASE_ADMIN_URL)spoint-in-time.py/show_list?item_type_id=%(ITEM_TYPE_TODO)s">%(type_Todos)s:</a></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap colspan="6" valign="top">%(tas_out)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap colspan="6"><a class="blackboldlink" href="%(BASE_ADMIN_URL)spoint-in-time.py/show_list?item_type_id=%(ITEM_TYPE_WORKFLOW)s">%(type_Workflows)s:</a></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap colspan="6" valign="top">%(wor_out)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap colspan="6"><a class="blackboldlink" href="%(BASE_ADMIN_URL)spoint-in-time.py/show_list?item_type_id=%(ITEM_TYPE_CLIENT)s">%(type_Client)s:</a></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap colspan="6" valign="top">%(cli_out)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap colspan="6"><a class="blackboldlink" href="%(BASE_ADMIN_URL)spoint-in-time.py/show_list?item_type_id=%(ITEM_TYPE_CONTACT)s">%(type_Contacts)s:</a></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap colspan="6" valign="top">%(con_out)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap colspan="6"><a class="blackboldlink" href="%(BASE_ADMIN_URL)spoint-in-time.py/show_list?item_type_id=%(ITEM_TYPE_OPPORTUNITY)s">%(type_Opportunity)s:</a></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap colspan="6" valign="top">%(opp_out)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap colspan="6"><a class="blackboldlink" href="%(BASE_ADMIN_URL)spoint-in-time.py/show_list?item_type_id=%(ITEM_TYPE_PRODUCT)s">%(type_Product)s:</a></TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap colspan="6" valign="top">%(pro_out)s</TD>
</TR>
</TABLE>
</FORM>
<BR>
""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def create_batch(REQUEST, SQL, item_type, style_class="td_listing0b"):
    try:
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_WRITE, [eval('_InitTypes.%s' % item_type)])
    except:
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_WRITE, [item_type])
    if right_param:
        right_param = " AND %s" % right_param
    SQL = SQL % (right_param)
    REQUEST.db.execute(SQL.encode('utf8'))
    dbresult = REQUEST.db.dictfetchall()
    if dbresult:
        out = u"""<TABLE border=0 cellpadding="0" cellspacing="0" width="100%%%%">\n<TR>\n  <TD width="25%%%%" class="%s">%%(tls_name)s</TD>\n  <TD width="25%%%%" class="%s">%%(tls_owner)s</TD>\n  <TD width="25%%%%" class="%s">%%(tls_editor)s</TD>\n  <TD width="25%%%%" class="%s">%%(tls_time)s</TD>\n</TR>""" % (style_class,style_class,style_class,style_class,)
        for row in dbresult:
            out = out + u"""<TR>\n  <TD class="td_listing_noborder"><a href="%spoint-in-time.py/show_item?item_id=%s">%s</a></TD>\n  <TD class="td_listing_noborder">%s</TD>\n  <TD class="td_listing_noborder">%s</TD>\n  <TD class="td_listing_noborder">%s</TD>\n</TR>""" % (_Conf.BASE_ADMIN_URL, row['item_id'], _Utils.html_quote_show(_Utils.shorten_string(row['item_name'].decode('UTF8'), 30)), row['creator_name'].decode('UTF8'), row['editor_name'].decode('UTF8'), REQUEST.iso2userdatetime(REQUEST, row['edit_time']))
        out = out + u"</TABLE>"
    else:
        out = u"""<TABLE border=0 cellpadding="0" cellspacing="0" width="100%%%%">\n<TR>\n <TD width="100%%%%" class="td_listing_noborder">%s</TD>\n</TR></TABLE>""" % REQUEST.TLS('tls_norecords')
    return out

def show_item(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')
    if not (REQUEST.form.has_key('item_id') and REQUEST.form['item_id'].value):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    if REQUEST.form.has_key('_recover') and REQUEST.form.has_key('b_id') and REQUEST.form['b_id'].value:
        item = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['item_id'].value))
        item.log_undo(int(REQUEST.form['b_id'].value))
        item.save()
        output.append(u"&nbsp;&nbsp;%s<BR>" % REQUEST.TLS('admin_recovered'))

    item = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['item_id'].value))
    item_name = _Utils.html_quote_show(item.get('item_name'))
    item_id = item.get_id()

    b_id = 0
    if REQUEST.form.has_key('batch_id') and REQUEST.form['batch_id'].value and not REQUEST.form.has_key('_recover'):
        item.log_undo(int(REQUEST.form['batch_id'].value))
        b_id = int(REQUEST.form['batch_id'].value)
    item_data = item.object_fields.keys() + ['item_id','parent_id','editor_id','editor_ip','edit_time']

    SQL = """SELECT distinct i.batch_id, i.change_time FROM item_log i WHERE i.item_id=%d  AND (i.log_flags & %d) = 0 order by i.batch_id desc""" % (item_id, _RootObject.LOG_DELETE)
    REQUEST.db.execute(SQL)
    dbres = REQUEST.db.dictfetchall()
    
    sel_out = u"""<SELECT name="batch_id">"""
    is_sel = 0
    for row in dbres:
        if row['batch_id']==b_id or (not b_id and not is_sel):
            sel_out = sel_out + u"""<OPTION value="%s" SELECTED>%s</OPTION>""" % (row['batch_id'], REQUEST.iso2userdatetime(REQUEST, row['change_time']))
            is_sel = 1
        else:
            sel_out = sel_out + u"""<OPTION value="%s">%s</OPTION>""" % (row['batch_id'], REQUEST.iso2userdatetime(REQUEST, row['change_time']))
    sel_out = sel_out + u"""</SELECT>"""


    tls_data = REQUEST.TLS('admin_data')
    tls_object = REQUEST.TLS('tls_object')
    tls_show = REQUEST.TLS('tls_show')
    tls_recover = REQUEST.TLS('admin_recover')
    tls_confirm = REQUEST.TLS('admin_rec_confirm')
    tls_on_time = REQUEST.TLS('admin_on_time')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_data)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM method="POST" action="%(BASE_ADMIN_URL)spoint-in-time.py/show_item">
<INPUT type="hidden" name="item_id" value="%(item_id)s">
<INPUT type="hidden" name="b_id" value="%(b_id)s">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap colspan="2"><b>%(tls_object)s:</b> %(item_name)s <b>%(tls_on_time)s:</b> %(sel_out)s <input type="submit" class="input2" value="%(tls_show)s"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())
    item_data.sort()
    for key in item_data:
        val = _Utils.html_quote_show(item.get(key))
        output.append(u"""
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0b" nowrap>%(key)s:</TD>
    <TD class="td_listing0" val>%(val)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())
    if b_id:
        output.append(u"""
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="2" nowrap><input type="submit" name="_recover" class="input6" value="%(tls_recover)s" onclick="return confirm('%(tls_confirm)s');"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())
    output.append(u"""</TABLE></FORM><BR>""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def show_list(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    tls_name = REQUEST.TLS('tls_name')
    tls_editor = REQUEST.TLS('log_mod_by')
    tls_owner = REQUEST.TLS('client_owner')
    tls_time = REQUEST.TLS('log_mod_time')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    item_type = int(REQUEST.form['item_type_id'].value)
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_WRITE, [item_type])
    if right_param:
        right_param = " AND %s" % right_param
    QUERY = """SELECT count(*) as count_all FROM items i WHERE i.item_type_id=%(item_type)d %(right_param)s""" % locals()
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%spoint-in-time.py/show_list%sqs=" % (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%spoint-in-time.py/show_list%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        else:
            START_BAR = """<img src="%sspacer.gif" width="100" height="1" border="0" alt="">""" % BASE_ICON_URL
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%spoint-in-time.py/show_list%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        else:
            END_BAR = """<img src="%sspacer.gif" width="100" height="1" border="0" alt="">""" % BASE_ICON_URL
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    SQL = """SELECT i.*, i2.item_name as editor_name, i3.item_name as creator_name FROM items i, items i2, items i3 WHERE i.item_type_id=%d AND i2.item_id=i.editor_id AND i3.item_id=i.creator_id %%s ORDER BY i.edit_time desc LIMIT %d OFFSET %d""" % (item_type, REQUEST.batch_size, REQUEST.qs)
    
    out = create_batch(REQUEST, SQL, item_type, "td_listing1b") % locals()
    SQL = "SELECT item_type_name from item_types where item_type_id = %d" % item_type
    REQUEST.db.execute(SQL)
    type_name = REQUEST.TLS("type_" + REQUEST.db.fetchone()[0])

    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(type_name)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD width="100%%">%(out)s</TD>
</TR>
<TR>
</TABLE>
%(FULL_BAR)s""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def search(REQUEST):
    forbidden_list = (_InitTypes.ITEM_TYPE_EFOLDER, _InitTypes.ITEM_TYPE_EMAIL, _InitTypes.ITEM_TYPE_EACCOUNT, _InitTypes.ITEM_TYPE_DISCCATEGORY, _InitTypes.ITEM_TYPE_RESOURCE, _InitTypes.ITEM_TYPE_BOOKMARK, _InitTypes.ITEM_TYPE_EFILTER, _InitTypes.ITEM_TYPE_QUOTA, _InitTypes.ITEM_TYPE_CONTACTGROUP)
    if not ((REQUEST.form.has_key('item_id') and REQUEST.form['item_id'].value.strip()) or (REQUEST.form.has_key('item_name') and REQUEST.form['item_name'].value.strip())):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    if REQUEST.form.has_key('item_id') and REQUEST.form['item_id'].value.strip():
        item_id = int(REQUEST.form['item_id'].value.strip())
        REQUEST.db.execute("select count(*) from items where item_id=%d and i.item_type_id not in %s" % (item_name, forbidden_list))
        count = REQUEST.db.fetchone()
        if count and count[0]:
            REQUEST.mod_req.headers_out["Location"] = "%spoint-in-time.py/show_item?item_id=%s" % (_Conf.BASE_ADMIN_URL, item_id)
            return apache.HTTP_MOVED_TEMPORARILY
        else:
            raise RuntimeError, REQUEST.TLS('admin_notfound')
    else:
        item_name = REQUEST.form['item_name'].value
        REQUEST.db.execute("select i.item_id, i.item_name, i2.item_type_name, i.edit_time, i3.item_name from items i, item_types i2, items i3 where lower(i.item_name) like '%%%s%%' and i.item_type_id=i2.item_type_id and i.item_type_id not in %s and i.creator_id=i3.item_id order by i.edit_time desc" % (item_name, forbidden_list))
        res = REQUEST.db.fetchall()
        if len(res)==1:
            REQUEST.mod_req.headers_out["Location"] = "%spoint-in-time.py/show_item?item_id=%s" % (_Conf.BASE_ADMIN_URL, res[0][0])
            return apache.HTTP_MOVED_TEMPORARILY
        else:
            BASE_ICON_URL = _Conf.BASE_ICON_URL
            BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
            tls_search = REQUEST.TLS('tls_search')
            tls_name = REQUEST.TLS('tls_name')
            tls_type = REQUEST.TLS('tls_type')
            tls_time = REQUEST.TLS('log_mod_time')
            tls_editor = REQUEST.TLS('log_mod_by')
            output = []
            output.append(standard_html.html_header(REQUEST))
            output.append(get_admin_menu(REQUEST, MY_MENU_ID))
            output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_search.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_search)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_name)s:</TD>
  <TD class="td_listing1b" nowrap>%(tls_type)s:</TD>
  <TD class="td_listing1b" nowrap>%(tls_editor)s:</TD>
  <TD class="td_listing1b" nowrap width="100%%">%(tls_time)s:</TD>

</TR>""" % locals())
            for row in res:
                item_id = row[0]
                item_name = _Utils.html_quote_show(_Utils.shorten_string(row[1].decode('UTF8'), 25))
                type_name = REQUEST.TLS('type_' + row[2])
                type_time = REQUEST.iso2userdatetime(REQUEST, row[3])
                type_deleter = row[4].decode('UTF8')
                output.append(u"""
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap><a href="%(BASE_ADMIN_URL)spoint-in-time.py/show_item?item_id=%(item_id)s">%(item_name)s</A></TD>
  <TD class="td_listing0" nowrap>%(type_name)s</TD>
  <TD class="td_listing0" nowrap>%(type_deleter)s</TD>
  <TD class="td_listing0" nowrap width="100%%">%(type_time)s</TD>
</TR>
""" % locals())
            output.append("</TABLE><BR>")
            output.append(standard_html.html_footer(REQUEST))
            return "\n".join(output)