import _Conf

from mod_python import apache

from Menus import get_admin_menu
import standard_html, _Person, _InitTypes, _Utils, _RootObject, _Quota

MY_MENU_ID = 7

def index(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    tls_organization = REQUEST.TLS('admin_organization')
    tls_orgadmin = REQUEST.TLS('admin_orgadmin')
    tls_assign = REQUEST.TLS('admin_assign')
    tls_asp = REQUEST.TLS('compmenu_admin_toplevel')
    tls_usedspace = REQUEST.TLS('tls_usedspace')
    tls_remove = REQUEST.TLS('tls_remove')
    tls_soft = REQUEST.TLS('quota_soft')
    tls_hard = REQUEST.TLS('quota_hard')
    tls_quota = REQUEST.TLS('quota_quota')
    tls_topusercount = REQUEST.TLS('tls_topusercount')
    tls_topuserlimit = REQUEST.TLS('tls_topuserlimit')

    SQL = "SELECT o.*, i.* FROM organizations o, items i WHERE o.organization_id=i.item_id AND i.parent_id=%d AND i.item_id <> %d ORDER BY lower(i.item_name) ASC" % (_Conf.ROOTOBJECT, _Conf.ROOTOBJECT)
    REQUEST.db.execute(SQL)

    dbresult = REQUEST.db.dictfetchall()
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_asp)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b">%(tls_organization)s</TD>
  <TD class="td_listing1b">%(tls_orgadmin)s</TD>
  <TD class="td_listing1b">%(tls_topusercount)s</TD>
  <TD class="td_listing1b">%(tls_topuserlimit)s</TD>
  <TD class="td_listing1b">%(tls_soft)s</TD>
  <TD class="td_listing1b">%(tls_hard)s</TD>
  <TD class="td_listing1b">%(tls_usedspace)s</TD>
</TR>""" % locals())

    ndx = 0
    for result in dbresult:
        ndx = ndx + 1
        orgid = result['item_id']
        org = _RootObject.dispatch_item(REQUEST, orgid)
        orgname = """<a href="%stoplevel.py/edit?organization_id=%s">%s</a>""" % (BASE_ADMIN_URL, orgid, org.get_name())
        if result['superuser_id'] is not None:
            orgsuper = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, result['superuser_id']).get_name()
        else:
            orgsuper = 'N/A'
        quota = org.get_quota()
        if quota:
            quota_soft = _Utils.str_size(quota.get('quota_soft_size')*1024)
            quota_hard = _Utils.str_size(quota.get('quota_hard_size')*1024)
            used_quota = _Utils.str_size(quota.get('quota_used'))
            remlink = u"""&nbsp;<A href="%(BASE_ADMIN_URL)stoplevel.py/del_quota?organization_id=%(orgid)d">%(tls_remove)s</A>""" % locals()
        else:
            quota_soft = "N/A"
            quota_hard = "N/A"
            SQL = """SELECT sum(item_size) FROM items WHERE treepos >= %s AND treepos < B'%s1'""" % (_Utils.sql_cast_bit(REQUEST, result['treepos']), _Utils.sql_quote_simple(result['treepos']))
            REQUEST.db.execute(SQL)
            used_quota = _Utils.str_size(REQUEST.db.fetchone()[0])
            remlink = u""
        SQL = """SELECT count(*) FROM items i, persons p WHERE i.item_type_id=%d AND i.item_id=p.person_id AND p.is_deleted=0 AND i.treepos >= %s AND i.treepos < B'%s1'""" % (_InitTypes.ITEM_TYPE_PERSON, _Utils.sql_cast_bit(REQUEST, result['treepos']), _Utils.sql_quote_simple(result['treepos']))
        REQUEST.db.execute(SQL)
        current_persons = REQUEST.db.fetchone()[0]
        try:
            userlimit = str(REQUEST._settings.get_setting_org_any(REQUEST, orgid, "userlimit_%s" % orgid) or "N/A")
        except:
            userlimit = "N/A"
        if (ndx%2)==0:
            td_class = "td_listing1"
        else:
            td_class = "td_listing0"

        output.append(u"""
<TR>
  <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD class="%(td_class)s">%(orgname)s</TD>
  <TD class="%(td_class)s">%(orgsuper)s</TD>
  <TD class="%(td_class)s">%(current_persons)s</TD>
  <TD class="%(td_class)s">%(userlimit)s</TD>
  <TD class="%(td_class)s">%(quota_soft)s</TD>
  <TD class="%(td_class)s">%(quota_hard)s</TD>
  <TD class="%(td_class)s">%(used_quota)s</TD>
</TR>
""" % locals())

    output.append(u"""</TABLE>""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if not REQUEST.form.has_key('organization_id') or not REQUEST.form['organization_id'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    orgid = int(REQUEST.form['organization_id'].value)
    tls_organization = REQUEST.TLS('admin_organization')
    tls_orgadmin = REQUEST.TLS('admin_orgadmin')
    tls_asp = REQUEST.TLS('compmenu_admin_toplevel')
    tls_save = REQUEST.TLS('tls_save')
    tls_soft = REQUEST.TLS('quota_soft')
    tls_hard = REQUEST.TLS('quota_hard')
    tls_assign = REQUEST.TLS('admin_assign')
    tls_topuserlimit = REQUEST.TLS('tls_topuserlimit')


    org = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['organization_id'].value))
    orgid = org.get_id()
    orgname = org.get_name()

    SQL = "SELECT p.*, i.* FROM persons p, items i WHERE p.person_id=i.item_id AND i.parent_id=%d" % int(REQUEST.form['organization_id'].value)
    REQUEST.db.execute(SQL)
    tls_persons = u"""<SELECT class="textfield1" name="person_id">\n%s\n</SELECT>""" % "\n".join(map(lambda x: u"""<OPTION value="%d">%s""" % (x['person_id'], x['item_name'].decode('UTF8')), REQUEST.db.dictfetchall()))

    if org.get('superuser_id') is not None:
        orgsuper = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, org.get('superuser_id')).get_name()
    else:
        orgsuper = 'N/A'

    quota = org.get_quota()
    if quota:
        quota_soft = quota.get('quota_soft_size')
        quota_hard = quota.get('quota_hard_size')
    else:
        quota_soft = 0
        quota_hard = 0

    try:
        userlimit = REQUEST._settings.get_setting_org_any(REQUEST, orgid, "userlimit_%s" % orgid)
    except:
        userlimit = 0



    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_asp)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM action="%(BASE_ADMIN_URL)stoplevel.py/save" method="post">
<INPUT type="hidden" name="organization_id" value="%(orgid)s">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1"  nowrap>%(tls_organization)s:</TD>
  <TD class="td_listing1b" width="100%%">%(orgname)s</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap>%(tls_orgadmin)s:</TD>
  <TD class="td_listing0b">%(orgsuper)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1" nowrap>%(tls_assign)s:</TD>
  <TD class="td_listing1b">%(tls_persons)s</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap>%(tls_soft)s:</TD>
  <TD class="td_listing0b"><INPUT class="textfield1" type="text" size="10" maxsize="10" name="quota_soft_size" value="%(quota_soft)d"> KB</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1" nowrap>%(tls_hard)s:</TD>
  <TD class="td_listing1b"><INPUT class="textfield1" type="text" size="10" maxsize="10" name="quota_hard_size" value="%(quota_hard)d"> KB</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap>%(tls_topuserlimit)s:</TD>
  <TD class="td_listing0b"><INPUT class="textfield1" type="text" size="10" maxsize="10" name="userlimit" value="%(userlimit)d"></TD>
</TR>
<TR>
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="td_listing1" colspan="2"><INPUT type="submit" class="input2" name="_save" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


def save(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if not REQUEST.form.has_key('organization_id') or not REQUEST.form['organization_id'].value.decode('UTF8').strip() or \
       not REQUEST.form.has_key('userlimit') or not REQUEST.form['userlimit'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    SQL = "UPDATE organizations SET superuser_id=%d WHERE organization_id=%d" % (int(REQUEST.form['person_id'].value), int(REQUEST.form['organization_id'].value))
    REQUEST.db.execute(SQL)


    org = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['organization_id'].value))
    quota = org.get_quota()
    if (not REQUEST.form.has_key('quota_soft_size') or not int(REQUEST.form['quota_soft_size'].value.decode('UTF8').strip())) and (not REQUEST.form.has_key('quota_hard_size') or not int(REQUEST.form['quota_hard_size'].value.decode('UTF8').strip())):
      if quota:
          quota.delete()
    else:
      if not quota:
          quota = _Quota.Quota(REQUEST, _InitTypes.INIT_TYPE_NEW)
          quota.set('parent_id', org.get_id())
          SQL = """SELECT sum(item_size) FROM items WHERE treepos >= %s AND treepos < B'%s1'""" % (_Utils.sql_cast_bit(REQUEST, org.get('treepos')), _Utils.sql_quote_simple(org.get('treepos')))
          REQUEST.db.execute(SQL.encode('UTF8'))
          used_quota = REQUEST.db.fetchone()[0] or 0
          quota.set('quota_used', used_quota)
      quota.set('quota_soft_size', int(REQUEST.form['quota_soft_size'].value.decode('UTF8').strip()))
      quota.set('quota_hard_size', int(REQUEST.form['quota_hard_size'].value.decode('UTF8').strip()))
      if quota.get('quota_soft_size') > quota.get('quota_hard_size'):
          raise RuntimeError, REQUEST.TLS('quota_soft_gt_hard')
      quota.save()


    org = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['organization_id'].value))
    REQUEST._settings.set_setting_org_any(REQUEST, org.get_id(), "userlimit_%s" % org.get_id(), int(REQUEST.form['userlimit'].value))

    REQUEST.mod_req.headers_out["Location"] = """%stoplevel.py""" % _Conf.BASE_ADMIN_URL
    return apache.HTTP_MOVED_TEMPORARILY  



def save_quota(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if not REQUEST.form.has_key('organization_id') or not REQUEST.form['organization_id'].value.decode('UTF8').strip() or \
       not REQUEST.form.has_key('quota_soft_size') or not REQUEST.form['quota_soft_size'].value.decode('UTF8').strip() or \
       not REQUEST.form.has_key('quota_hard_size') or not REQUEST.form['quota_hard_size'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    org = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['organization_id'].value))
    quota = org.get_quota()
    if not quota:
        quota = _Quota.Quota(REQUEST, _InitTypes.INIT_TYPE_NEW)
        quota.set('parent_id', org.get_id())
        SQL = """SELECT sum(item_size) FROM items WHERE treepos >= %s AND treepos < B'%s1'""" % (_Utils.sql_cast_bit(REQUEST, org.get('treepos')), _Utils.sql_quote_simple(org.get('treepos')))
        REQUEST.db.execute(SQL.encode('UTF8'))
        used_quota = REQUEST.db.fetchone()[0] or 0
        quota.set('quota_used', used_quota)
    quota.set('quota_soft_size', int(REQUEST.form['quota_soft_size'].value.decode('UTF8').strip()))
    quota.set('quota_hard_size', int(REQUEST.form['quota_hard_size'].value.decode('UTF8').strip()))
    if quota.get('quota_soft_size') > quota.get('quota_hard_size'):
        raise RuntimeError, REQUEST.TLS('quota_soft_gt_hard')
    quota.save()

    REQUEST.mod_req.headers_out["Location"] = """%stoplevel.py""" % _Conf.BASE_ADMIN_URL
    return apache.HTTP_MOVED_TEMPORARILY  

def del_quota(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if not REQUEST.form.has_key('organization_id') or not REQUEST.form['organization_id'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    org = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['organization_id'].value))
    quota = org.get_quota()
    if quota:
        quota.delete()

    REQUEST.mod_req.headers_out["Location"] = """%stoplevel.py""" % _Conf.BASE_ADMIN_URL
    return apache.HTTP_MOVED_TEMPORARILY  