import time, mx.DateTime

import mx.DateTime
import _Conf, _Exceptions, _Utils, _InitTypes, _Access, _Event, relations, _RootObject
from Menus import get_calendar_menu
from mod_python import apache
import standard_html
import _calendar
import _Resource
import urllib

MY_MENU_ID=2

def get_colour_class(REQUEST, event, show_resources, sel_resources = {}):
    try:
        show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        show_groups = None
   
# week_my     = my event
# week_rel    = related event
# week_notrel = others event
# week_res    = resource related event
# week_group  = group event
    if event.has_key('related_groups') and event['related_groups'] <> '{}':
        return "week_group"
    sel_resources = _Resource.get_event_resource_ids(REQUEST, event.get('event_id'))
    if show_resources:
        for i in show_resources:
            if i in sel_resources:
                return "week_res"
    event_related = _Utils.sql_parse_array(REQUEST, event.get('related_persons'))
    if REQUEST.USER.get_id() != event.get('creator_id'):
        if REQUEST.USER.get_id() not in event_related:
            return "week_notrel"
        else:
            return "week_rel"
    else:
        return "week_my"

def index(REQUEST):
    output = []
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    buttons = {'week_my':'1', 'week_rel':'2', 'week_notrel':'3', 'week_res':'4', 'week_group':'5'}
    if REQUEST.form.has_key('show_users_list'):
        loc = u"%sday.py/users_list" % (_Conf.BASE_CALENDAR_URL)
        REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
        return apache.HTTP_MOVED_TEMPORARILY

    if REQUEST.form.has_key('show_users'):
        REQUEST.del_setting('cal_show_users')
        REQUEST.del_setting('cal_show_resources')
        REQUEST.del_setting('cal_show_groups')

    formstring = REQUEST.get_formstring(['qs', 'show_users'])
    returl = urllib.quote("%smonth.py%s" % (BASE_CALENDAR_URL, formstring))

    tls_resources = REQUEST.TLS('tls_resources')
    REQUEST.db.execute("""SELECT r.resource_id, r.resource_name FROM items i, resources r WHERE r.resource_id=i.item_id""".encode('UTF8'))
    resos = REQUEST.db.dictfetchall()
    resources = {}
    for row in resos:
        resources[row['resource_id']]=row['resource_name']


    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = None
    try:
        show_resources = REQUEST.get_setting('cal_show_resources')
    except:
        show_resources = None
    try:
        show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        show_groups = None

    if show_groups:
        dic = {}
        REQUEST.db.execute("""SELECT members from calendar_groups where group_id in (%s)""" % ",".join(map(str, show_groups)))
        group_members = map(lambda x:_Utils.sql_parse_array(REQUEST, x[0]), REQUEST.db.fetchall())
        for gr in group_members:
            for member in gr:
                dic[member]=1
        group_members = dic.keys()
        if show_users:
            show_users+=group_members
        else:
            show_users=group_members

    output.append(standard_html.html_header(REQUEST))
    output.append(get_calendar_menu(REQUEST,MY_MENU_ID))
    output.append(standard_html.window_script(height=670,width=550))

    output.append(u"""\
<DIV id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></DIV>
<SCRIPT type="text/javascript" src="%soverlib.js"><!-- overLIB (c) Erik Bosrup --></SCRIPT>
<TABLE cellpadding=0 cellspacing=0 style="width: 99%%; border: none"><TR valign="top"><TD><img src="%sspacer.gif" width=25 height=1 border=0 alt=""></TD><TD width="100%%">""" % (_Conf.BASE_WEB_URL, _Conf.BASE_ICON_URL))


    if REQUEST.form.has_key('date'):
        try:
            year, month, day = map(int, REQUEST.form['date'].value.decode('UTF8').split('-'))
        except:
            raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        data = _calendar.MonthHandler(REQUEST, year, month, day, show_users, show_resources)
    else:
        data = _calendar.MonthHandler(REQUEST, show_users=show_users, show_resources=show_resources)

    data.load(REQUEST)

    ###
    # Main contents
    ###
    month_name = "%s %d" % (REQUEST.TLS('month_%d' % data.month), data.year)
    if data.month == 1: previous_month = '%04d-%02d-01' % (data.year - 1, 12)
    else: previous_month = '%04d-%02d-01' % (data.year, data.month-1)
    if data.month == 12: next_month = '%04d-%02d-01' % (data.year + 1, 1)
    else: next_month = '%04d-%02d-01' % (data.year, data.month+1)
    tls_nextmonth = REQUEST.TLS('cal_nextmonth')
    tls_lastmonth = REQUEST.TLS('cal_lastmonth')
    output.append(u"""
<TABLE width="100%%" border="0" cellpadding="0" cellspacing="0">
<TR style="height: 40px;">
  <TD colspan="7">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD width="50%%" align="right"><A href="%(BASE_CALENDAR_URL)smonth.py?date=%(previous_month)s"><IMG title="%(tls_lastmonth)s" src="%(BASE_ICON_URL)sarr1.gif" width="11" height="16" border="0" alt=""></A></TD>
      <TD nowrap align="center" style="font-weight: bold; font-size: 16px;">&nbsp;&nbsp;%(month_name)s&nbsp;&nbsp;</TD>
      <TD width="50%%" align="left"><A href="%(BASE_CALENDAR_URL)smonth.py?date=%(next_month)s"><IMG title="%(tls_nextmonth)s" src="%(BASE_ICON_URL)sarr2.gif" width="11" height="16" border="0" alt=""></A></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
<TR style="height: 25px;">""" % locals())
    for i in range(7):
        day = data.events_calendar[0][i]
        output.append(u"""<TD bgcolor="#FFFFFF" width="13%%" align="center" style="font-weight: bold; font-size: 15px; line-height: 25px;">%s</TD>"""% REQUEST.TLS("cal_short_"+str(i+1)))
    output.append(u"""</TR>
<TR>
  <TD bgcolor="#CCCCCC" colspan="7"><IMG src="%sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % _Conf.BASE_ICON_URL)

    event_ids = {}
    output.append(u"""</TR>""")
    for week in data.events_calendar:
        for ndx in range(7):
            for eventtime in week[ndx].events:
                for event in eventtime[2]:
                    event_ids[event['event_id']] = 1
    event_ids = event_ids.keys()

    sel_resources = _Resource.get_list_event_resource_ids(REQUEST, event_ids)

    for week in data.events_calendar:
        output.append(u"""<TR style="height: 60px;" bgcolor="#FFFFFF">""")
        for ndx in range(7):
            day = week[ndx]
            if day.month <> data.month: # Prev or next month
                daycolour = "#BBBBBB"
            elif ndx in [5,6]: # Weekend
                daycolour = "#DD0000"
            else: # this month workdays
                daycolour = "#676767"
            if ndx == 0:
                bord_style = """border-left: 1px solid #CCCCCC; border-right: 1px solid #CCCCCC; border-bottom: 1px solid #CCCCCC;"""
            else:
                bord_style = """border-right: 1px solid #CCCCCC; border-bottom: 1px solid #CCCCCC;"""

            kuupaev = mx.DateTime.DateTime(day.year, day.month, day.day)
            output.append(u"""\
<TD valign="top" style="%s cursor: pointer; cursor: hand;" onmouseover="this.style.backgroundColor='#F0F5FB';" onmouseout="this.style.backgroundColor='#FFFFFF';" onclick="window.location='addevent.py?year=%d&amp;month=%d&amp;day=%d&amp;hour=7&amp;returl=%s';">
  <TABLE border=0 height="100%%" cellpadding=0 cellspacing=0 width="100%%" valign="top">
  <TR valign="top" height="1%%">
    <TD height="1%%" align="right" style="padding: 3px; color: %s; font-weight:bold; font-size: 13px;">%s</TD>
  </TR>
  <TR valign="top">
    <TD class="calendar_monthtd0" valign="top">""" % (bord_style, day.year, day.month, day.day, returl, daycolour, kuupaev.day))
            day_events = []
            for eventtime in day.events:
                if eventtime[2]:
                    day_events += eventtime[2]
            for event in day_events:
                if event['real_start_stamp'] and event['real_end_stamp']:
                    if event['real_start_stamp'].year <> event['real_end_stamp'].year or \
                       event['real_start_stamp'].month <> event['real_end_stamp'].month or \
                       event['real_start_stamp'].day <> event['real_end_stamp'].day:
                        timestr = u"<B>%s:</B> %s <B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.iso2userdatetime(REQUEST, event['real_start_stamp'], is_utc=0), REQUEST.TLS('cal_end'), REQUEST.iso2userdatetime(REQUEST, event['real_end_stamp'], is_utc=0))
                    else:
                        timestr = u"<B>%s:</B> %s <B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.iso2usertime(REQUEST, event['real_start_stamp'], is_utc=0), REQUEST.TLS('cal_end'), REQUEST.iso2usertime(REQUEST, event['real_end_stamp'], is_utc=0))
                elif event['real_start_stamp']:
                    if event['real_start_stamp'].year <> event['start_stamp'].year or \
                       event['real_start_stamp'].month <> event['start_stamp'].month or \
                       event['real_start_stamp'].day <> event['start_stamp'].day:
                        timestr = u"<B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.USER.iso2userdatetime(REQUEST, event['start_stamp'], is_utc=0))
                    else:
                        timestr = u"<B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.USER.iso2usertime(REQUEST, event['start_stamp'], is_utc=0))
                else:
                    timestr = ""
                reminder = event.get('remind_type')
                d_name = event['event_name'].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace("<", "").replace(">", "")
                if event['description'] is None or not event['description']: description = ""
                else:
                    description = u"""<B>%s:</B> %s""" % (REQUEST.TLS('tls_description'), _Utils.newline2br(event['description'].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace("<", "").replace(">", "")))
                if event['creator_id'] <> REQUEST.USER.get_id():
                    description += u'<br><B>%s:</B> %s' % (REQUEST.TLS('tls_creator'), event['creator_name'].decode('UTF8'))
                tls_title = REQUEST.TLS('tls_title')
                tls_desc = REQUEST.TLS('tls_description')

                persons_out = []
                event_related = _Utils.sql_parse_array(REQUEST, event.get('related_persons'))
                event_relgroups = _Utils.sql_parse_array(REQUEST, event.get('related_groups'))
                if event_related:
                    REQUEST.su_by_id(_Conf.SUPERUSER)
                    for person_id in event_related:
                        try:
                            rel_per = _RootObject.dispatch_item(REQUEST, person_id)
                            persons_out.append(rel_per.get_name())
                        except _Exceptions.RootObjectError:
                            rel_per = ""
                            raise
                    REQUEST.unsu()
                    related_persons = ", ".join(persons_out)
                else:
                    related_persons = ""
                persons_out = u""
                if related_persons:
                    tls_invpersons = REQUEST.TLS('cal_invitedpersons')
                    persons_out = u"""<BR><B>%(tls_invpersons)s:</b> %(related_persons)s""" % locals()

                REQUEST.db.execute("""SELECT group_id, group_name from calendar_groups where parent_id=%d""" % (event.get('creator_id')))
                related_groups = REQUEST.db.dictfetchall()
                relcount = len(related_groups)
                group_tmp = []
                for group_id in related_groups:
                    if group_id['group_id'] in event_relgroups:
                        group_tmp.append("""%s""" % group_id['group_name'].decode('UTF8'))
                related_groups = ", ".join(group_tmp)
                groups_out = u""
                if related_groups:
                    tls_invgroups = REQUEST.TLS('cal_invitedgroups')
                    groups_out = u"""<BR><B>%(tls_invgroups)s:</b> %(related_groups)s""" % locals()

                relation_ids = relations.get_relations_by_id(REQUEST, event['event_id'])

                contact_out = ""
                for rel in relation_ids:
                    if rel['left_type_id']==_InitTypes.ITEM_TYPE_CONTACT or rel['right_type_id']==_InitTypes.ITEM_TYPE_CONTACT:
                        if int(rel['left_item_id'])==event['event_id']:
                            contact_out = contact_out + rel['right_item_name'].decode('UTF8') + ", "
                        else:
                            contact_out = contact_out + rel['left_item_name'].decode('UTF8') + ", "
                if contact_out:
                    contact_out = contact_out[0:-2]
                tls_invcontacts = REQUEST.TLS('cal_invitedcontacts')
                if contact_out:
                    contact_out = u"""<BR><B>%(tls_invcontacts)s:</b> %(contact_out)s""" % locals()

                sel_resources = _Resource.get_event_resources(REQUEST, event['event_id'])
                sel_resources_ids = map(lambda x: x.get_id(), sel_resources)
                sel_resources = ""
                for id in sel_resources_ids:
                    sel_resources += resources[id] + ", "
                if sel_resources:
                    sel_resources = sel_resources[0:-2].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace("<", "").replace(">", "")
                    res_out = u"""<BR><B>%(tls_resources)s:</b> %(sel_resources)s""" % locals()
                else:
                    res_out = ""
                overdivstr = u"""\
<B>%(tls_title)s:</B> %(d_name)s<BR>\
%(timestr)s<BR>\
%(description)s\
%(persons_out)s\
%(groups_out)s\
%(contact_out)s\
%(res_out)s""" % locals()
                
                eventclass = get_colour_class(REQUEST, event, show_resources,sel_resources)
                event_id = event['event_id']
                event_desc = _Utils.html_quote(_Utils.shorten_string(event['event_name'].decode('UTF8').replace('&quot;','"'), 20))
                output.append(u"""<A class="%(eventclass)s" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)d&amp;returl=%(returl)s" onmouseover="return overlib('%(overdivstr)s', TEXTSIZE, '11px');" onmouseout="return nd();">%(event_desc)s</A><BR>""" % locals())
            output.append(u"""</TD></TR></TABLE></TD>""")
        output.append(u"""</TR>""")
    output.append(u"""</TABLE></TD>""")

    output.append(_calendar.mini_calendar(REQUEST, data, "month.py", "day.py"))
    output.append(u"</TR></TABLE>")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
