from mod_python import apache
import standard_html
import urllib
import _Conf, _Utils, Menus, _InitTypes, custom_fields

MY_MENU_ID = 6

ITEM_TYPE_ID = _InitTypes.ITEM_TYPE_CONTACT

def index(REQUEST):
    top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')
    TOPORG_ID = top_parent.get_id()
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))
    output.append(custom_fields.get_listing(REQUEST, ITEM_TYPE_ID, TOPORG_ID, "contacts", urllib.quote(_Conf.BASE_CONTACT_URL+"contact_fields.py")))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)



def edit_field(REQUEST):
    top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')
    if not REQUEST.form.has_key('field_id') or not REQUEST.form['field_id'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    field_id = int(REQUEST.form['field_id'].value.strip())
    toporg_id = top_parent.get_id()
    SQL = """select toporg_id, field_name from custom_fields where field_id=%d""" % field_id
    REQUEST.db.execute(SQL)
    res = REQUEST.db.fetchall()
    if len(res)<1:
        raise RuntimeError, "INVALID field_id"
    elif res[0][0]<>toporg_id:
        raise RuntimeError, REQUEST.TLS('rootobj_noupdateaccess')
    field_name = _Utils.html_quote_edit(res[0][1].decode('UTF8'))
    output = []
    returl = ""
    obj_id = ""
    if REQUEST.form.has_key('returl'):
      returl = REQUEST.form['returl'].value
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('menu'):
      menu = REQUEST.form['menu'].value
      if menu=="contacts":
        output.append(Menus.get_contact_menu(REQUEST, 6))
      elif menu=="clients":
        output.append(Menus.get_clients_menu(REQUEST, 4))
      elif menu=="documents":
        output.append(Menus.get_document_menu(REQUEST, 4))
      elif menu=="products":
        output.append(Menus.get_products_menu(REQUEST, 3))
      elif menu=="opp":
        output.append(Menus.get_opportunities_menu(REQUEST, 7))


    tls_save = REQUEST.TLS('tls_save')
    tls_delete = REQUEST.TLS('tls_delete')
    tls_confirm = REQUEST.TLS('tls_confirm_del')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_fieldname = REQUEST.TLS('custom_fieldname')
    tls_edit = REQUEST.TLS('custom_editfield')
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD

    output.append("""\
<SCRIPT type="text/JavaScript">
<!--
  function check_values()
  {
    if(!document.forms.addform.field_name.value||document.forms.addform.field_name.value=='')
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_CONTACT_URL)scontact_fields.py/edit_save" onsubmit="return check_values();">
<input type="hidden" name="returl" value="%(returl)s">
<input type="hidden" name="field_id" value="%(field_id)s">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_edit)s</span></TD>
    <TD width="100%%">&nbsp;</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1" style="border-top: 1px solid #CCCCCC" nowrap>%(tls_fieldname)s%(REQ_FIELD)s</TD>
  <TD class="td_listing1" style="border-top: 1px solid #CCCCCC"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1"><INPUT type="text" class="textfield4" name="field_name" value="%(field_name)s"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing_noborder" colspan="3"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2">&nbsp;<INPUT type="submit" class="input2" name="_delete" value="%(tls_delete)s" onClick="return confirm('%(tls_confirm)s');"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
    
    
def add_field(REQUEST):
    top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')
    if not REQUEST.form.has_key('item_type_id') or not REQUEST.form['item_type_id'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    item_type_id = REQUEST.form['item_type_id'].value.strip()
    output = []
    returl = ""
    obj_id = ""
    if REQUEST.form.has_key('returl'):
      returl = REQUEST.form['returl'].value
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('menu'):
      menu = REQUEST.form['menu'].value
      if menu=="contacts":
        output.append(Menus.get_contact_menu(REQUEST, 6))
      elif menu=="clients":
        output.append(Menus.get_clients_menu(REQUEST, 4))
      elif menu=="documents":
        output.append(Menus.get_document_menu(REQUEST, 4))
      elif menu=="products":
        output.append(Menus.get_products_menu(REQUEST, 3))
      elif menu=="opp":
        output.append(Menus.get_opportunities_menu(REQUEST, 7))


    tls_save = REQUEST.TLS('tls_save')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_fieldname = REQUEST.TLS('custom_fieldname')
    tls_add = REQUEST.TLS('custom_addfield')
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD
    
    output.append("""\
<SCRIPT type="text/JavaScript">
<!--
  function check_values()
  {
    if(!document.forms.addform.field_name.value||document.forms.addform.field_name.value=='')
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_CONTACT_URL)scontact_fields.py/add_save" onsubmit="return check_values();">
<input type="hidden" name="returl" value="%(returl)s">
<input type="hidden" name="item_type_id" value="%(item_type_id)s">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_add)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1" nowrap>%(tls_fieldname)s%(REQ_FIELD)s</TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1"><INPUT type="text" class="textfield4" name="field_name" value=""></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing_noborder" width="100%%" colspan="5"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
</TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def add_save(REQUEST):
    top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')
    if not REQUEST.form.has_key('item_type_id') or not REQUEST.form['item_type_id'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    item_type_id = int(REQUEST.form['item_type_id'].value.strip())
    if not REQUEST.form.has_key('field_name') or not REQUEST.form['field_name'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    field_name = REQUEST.form['field_name'].value.decode('UTF8').strip()
    toporg_id = top_parent.get_id()
    SEL_SQL = u"""select field_id from custom_fields where toporg_id=%d and item_type_id=%d and lower(field_name)=%s""" % (toporg_id, item_type_id, _Utils.sql_quote(field_name.lower()))
    REQUEST.db.execute(SEL_SQL.encode('UTF8'))
    res = REQUEST.db.fetchall()
    if res:
        raise RuntimeError, "FIELD ALREADY EXISTS" #FIXME
    SEL_SQL = """select max(priority) from custom_fields where toporg_id=%d and item_type_id=%d""" % (toporg_id, item_type_id)
    REQUEST.db.execute(SEL_SQL)
    priority = int(REQUEST.db.fetchall()[0][0] or 0)+1
    INS_SQL = u"""INSERT INTO custom_fields (toporg_id, item_type_id, field_name, priority, type, size) VALUES (%d, %d, %s, %d, 1, 0)""" % (toporg_id, item_type_id, _Utils.sql_quote(field_name), priority)
    REQUEST.db.execute(INS_SQL.encode('UTF8'))
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
        REQUEST.mod_req.headers_out["Location"] = "%sfrontpage.py" % _Conf.BASE_URL
    return apache.HTTP_MOVED_TEMPORARILY

def edit_save(REQUEST):
    top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')
    if not REQUEST.form.has_key('field_id') or not REQUEST.form['field_id'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    field_id = int(REQUEST.form['field_id'].value.strip())
    if not REQUEST.form.has_key('field_name') or not REQUEST.form['field_name'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    field_name = REQUEST.form['field_name'].value.decode('UTF8').strip()
    toporg_id = top_parent.get_id()
    if REQUEST.form.has_key('_delete'):
        SEL_SQL = """SELECT priority, item_type_id from custom_fields where toporg_id=%d and field_id=%d""" % (toporg_id, field_id)
        REQUEST.db.execute(SEL_SQL)
        priority, item_type_id = REQUEST.db.fetchone()
        DEL_SQL = """DELETE from custom_fields where toporg_id=%d and field_id=%d""" % (toporg_id, field_id)
        REQUEST.db.execute(DEL_SQL)
        REQUEST.db.execute("""UPDATE custom_fields set priority=priority-1 where toporg_id=%d and item_type_id=%d and priority>%d""" % (toporg_id, item_type_id, priority))
    else:
        UPD_SQL = u"""UPDATE custom_fields set field_name=%s where toporg_id=%d and field_id=%d""" % (_Utils.sql_quote(field_name), toporg_id, field_id)
        REQUEST.db.execute(UPD_SQL.encode('UTF8'))
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
        REQUEST.mod_req.headers_out["Location"] = "%sfrontpage.py" % _Conf.BASE_URL
    return apache.HTTP_MOVED_TEMPORARILY

def swap(REQUEST):
    top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')
    if not REQUEST.form.has_key('item_type_id') or not REQUEST.form['item_type_id'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    item_type_id = int(REQUEST.form['item_type_id'].value.strip())
    if not REQUEST.form.has_key('old_pri') or not REQUEST.form['old_pri'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    old_priority = int(REQUEST.form['old_pri'].value.strip())
    if not REQUEST.form.has_key('new_pri') or not REQUEST.form['new_pri'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    new_priority = int(REQUEST.form['new_pri'].value.strip())
    toporg_id = top_parent.get_id()

    # swap
    if old_priority>new_priority:
        condition = "and priority >=%d and priority <=%d" % (new_priority, old_priority)
        order = "priority desc,field_id asc"
        action = 1
    else:
        condition = "and priority >=%d and priority <=%d" % (old_priority, new_priority)
        order = "priority asc,field_id asc"
        action = 0
    SQL = """SELECT field_id, priority FROM custom_fields where toporg_id=%d and item_type_id=%d %s order by %s""" % (toporg_id, item_type_id, condition, order)
    REQUEST.db.execute(SQL)
    res = REQUEST.db.fetchall()
    for row in res:
        if row[1]==old_priority:
            do_priority = new_priority
        else:
            if action==1:
                do_priority = row[1] + 1
            else:
                do_priority = row[1] - 1
        SQL = """UPDATE custom_fields set priority=%d WHERE field_id=%d""" % (do_priority, row[0])
        REQUEST.db.execute(SQL)

    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
        REQUEST.mod_req.headers_out["Location"] = "%sfrontpage.py" % _Conf.BASE_URL
    return apache.HTTP_MOVED_TEMPORARILY