"""

Default discussions page.

$Id: discindex.py,v 1.9 2004/02/15 13:10:56 incxcvs Exp $
"""

import _Conf, _RootObject
from Menus import get_discussion_menu
import standard_html

import _Access, _InitTypes, _Discussion

MY_MENU_ID=0

import SQLTree, _InitTypes, _Conf, Menus, _Utils


def frametree(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    a = SQLTree.SQLTree(REQUEST, "disctree2")
    a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION])
    a.set_param('tree_url', _Conf.BASE_DISCUSSION_URL + 'disctree.py/frametree')
    a.set_param('target_url', _Conf.BASE_DISCUSSION_URL + 'discindex.py')
    a.set_param('target', 'framecontents')
    a.set_param('js', """<A href="javascript:void(0);" onClick="window.opener.document.forms.addform.parent_id.value=%(item_id)d; window.opener.document.forms.addform.parent_name.value='%(item_name)s'; window.close();\">""")
    a.maketree()

    output.append(a.getTree())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_discussion_menu(REQUEST, MY_MENU_ID))

    if REQUEST.form.has_key('parent_id'):
        parent_id = int(REQUEST.form['parent_id'].value)
    else:
        try:
            parent_id = int(REQUEST.get_setting('activediscFolder'))
        except:
            parent_id = REQUEST.USER.get_parent_id(REQUEST)

    try:
        active_folder = _RootObject.dispatch_item(REQUEST, parent_id)
    except:
        active_folder = _RootObject.dispatch_item(REQUEST, REQUEST.USER.get_parent_id(REQUEST))
    if active_folder.get('item_type_id') <> _InitTypes.ITEM_TYPE_DISCCATEGORY:
        REQUEST.db.execute("""SELECT i.item_id FROM disccategories d, items i WHERE i.item_id=d.disccategory_id AND i.parent_id=%d ORDER BY item_id LIMIT 1""" % active_folder.get_id())
        dbresult = REQUEST.db.dictfetchone()
        if not dbresult:
            output.append(REQUEST.TLS('disc_wrongparent'))
            output.append(standard_html.html_footer(REQUEST))
            return '\n'.join(output)
        else:
            parent_id = dbresult['item_id']
            active_folder = _RootObject.dispatch_item(REQUEST, parent_id)
    REQUEST.set_setting('activediscFolder',parent_id)

    if REQUEST.form.has_key('_delete') or REQUEST.form.has_key('_delete.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            disc_obj = _Discussion.Discussion(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            disc_obj.delete()

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_DISCUSSION])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT d.*, i.parent_id, i.creator_id, i.create_time, i.edit_time, p.item_name AS author, (select coalesce(max(c.create_time), i.create_time) FROM items c WHERE c.parent_id=i.item_id) AS last_post FROM discussions d, items i, items p WHERE d.discussion_id=i.item_id AND i.creator_id=p.item_id AND i.parent_id=%d%s ORDER BY last_post DESC""" % (parent_id, right_param)

    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    children = {}
    if dbresult:
        QUERY = u"""SELECT parent_id, count(*) AS count_children FROM items WHERE parent_id in (%s) GROUP BY parent_id""" % ",".join(map(lambda x: str(x['discussion_id']), dbresult))
        REQUEST.db.execute(QUERY.encode('UTF8'))
        for child in REQUEST.db.dictfetchall():
            children[child['parent_id']] = child['count_children']

    count_all = len(dbresult)
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sdiscindex.py%sqs=" % (_Conf.BASE_DISCUSSION_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sdiscindex.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_DISCUSSION_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sdiscindex.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_DISCUSSION_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    dbresult = dbresult[REQUEST.qs:REQUEST.qs+REQUEST.batch_size]

    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    active_folder_path = active_folder.get_virtual_path()
    tls_discs = REQUEST.TLS('tls_discussions')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_creator = REQUEST.TLS('tls_creator')
    tls_replies = REQUEST.TLS('disc_replies')
    tls_updated = REQUEST.TLS('disc_updated')
    tls_deletesel = REQUEST.TLS('tls_deletesel')
    email_confirm_del = REQUEST.TLS('email_confirm_del')
    tree_bar = _Discussion.tree_bar(REQUEST)
    output.append("""
<FORM method="POST" action="%(BASE_DISCUSSION_URL)sdiscindex.py">
%(tree_bar)s
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE border=0 cellpadding=0 cellspacing=1 width="100%%" bgcolor="#7BA5BD">
    <TR>
      <TD class="td_listing2b" width="5%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=15 border=0 alt=""></TD>
      <TD class="td_listing2b" width="100%%"  align="center">%(tls_subject)s</TD>
      <TD class="td_listing2b" nowrap align="center">%(tls_replies)s</TD>
      <TD class="td_listing2b" nowrap align="center">%(tls_creator)s</TD>
      <TD class="td_listing2b" nowrap align="center">%(tls_updated)s</TD>
    </TR>""" % locals())

    index = 0
    can_delete = 0
    last_parent = -1
    for item in dbresult:
        item['class_type'] = index % 2
        item['parent_id'] = parent_id
        index += 1
        item['BASE_DISCUSSION_URL'] = _Conf.BASE_DISCUSSION_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['disc_subject'] = _Utils.html_quote(item['disc_subject'].decode('UTF8'))
        item['author'] = item['author'].decode('UTF8')
        item['urllink'] = u"""%(BASE_DISCUSSION_URL)sdiscread.py?parent_id=%(parent_id)s&discussion_id=%(discussion_id)d""" % item
        if children.has_key(item['discussion_id']):
            item['replies'] = "%d" % children[item['discussion_id']]
        else:
            item['replies'] = "0"
        item['updated'] = REQUEST.iso2userdatetime(REQUEST, item['last_post'])
        if REQUEST.USER.get_id() == _Conf.SUPERUSER or REQUEST.USER.get_id() == REQUEST.USER.get_parent(REQUEST).get_top_parent().get('superuser_id'):
            can_delete = 1
            item['checkbox'] = """<INPUT type="checkbox" name="sel_%(discussion_id)d">""" % item
        else:
            item['checkbox'] = ""
        output.append(u"""
<TR>
  <TD class="td_listingd%(class_type)d" nowrap style="text-align: center"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=19 border=0 alt="">%(checkbox)s</TD>
  <TD class="td_listingd%(class_type)d"><A href="%(urllink)s" class="blackboldlink2">%(disc_subject)s</A></TD>
  <TD class="td_listingd%(class_type)d" nowrap align="center">%(replies)s</TD>
  <TD class="td_listingd%(class_type)d" nowrap>%(author)s</TD>
  <TD class="td_listingd%(class_type)d" nowrap>%(updated)s</TD>
</TR>""" % item)

    if FULL_BAR:
        output.append(u"""
                        <TR>
                          <TD colspan="5" class="td_listing0">%s</TD>
                        </TR>""" % (FULL_BAR))
    class_type = index % 2
    output.append(u"</TABLE>")
    if can_delete:
        output.append(u"""
    <BR>
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
    <TR class="tr_listing0">
      <TD><INPUT type="submit" class="input2" name="_delete" value="%(tls_deletesel)s" onClick="return confirm('%(email_confirm_del)s');"></TD>
    </TR>
    </TABLE>""" % locals())
    output.append(u"""
  </TD>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % (locals()))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)
