import os, stat, mimetypes, cStringIO
from mod_python import apache
import mx.DateTime

import _Conf, standard_html, _Document, _InitTypes, _RootObject, Menus, _Utils, custom_fields, _mail
import email.Header

def index(REQUEST):
    # The "or" part is a IE hack since it doesn't submit the submit image button itself but x and y coordinates
    if REQUEST.form.has_key('submit_copy') or REQUEST.form.has_key('submit_copy.x'):
        return copy_files(REQUEST)
    elif REQUEST.form.has_key('submit_delete') or REQUEST.form.has_key('submit_delete.x'):
        return delete_files(REQUEST)
    elif REQUEST.form.has_key('submit_rename') or REQUEST.form.has_key('submit_rename.x'):
        return rename_files(REQUEST)
    elif REQUEST.form.has_key('submit_cut') or REQUEST.form.has_key('submit_cut.x'):
        return cut_files(REQUEST)
    elif REQUEST.form.has_key('submit_paste') or REQUEST.form.has_key('submit_paste.x'):
        return paste_files(REQUEST)
    elif REQUEST.form.has_key('_editcontents') or REQUEST.form.has_key('_editcontents.x'):
        return edit_contents(REQUEST)
    elif REQUEST.form.has_key('_editmeta') or REQUEST.form.has_key('_editmeta.x'):
        return edit_meta(REQUEST)
    elif REQUEST.form.has_key('_editversion') or REQUEST.form.has_key('_editversion.x'):
        return edit_version(REQUEST)
    elif REQUEST.form.has_key('_lock'):
        return lock_doc_show(REQUEST)
    elif REQUEST.form.has_key('_unlock'):
        return unlock_doc(REQUEST)
    elif REQUEST.form.has_key('_delversion'):
        return delete_versions(REQUEST)
    elif REQUEST.form.has_key('_setversion'):
        return restore_version(REQUEST)
    else:
        raise RuntimeError, REQUEST.TLS('doc_nosuchdocop')

def copy_files(REQUEST):
    output = []
    try:
        parent_id = int(REQUEST.getCookie('activeFolder'))
    except:
        parent_id = REQUEST.USER.get_parent_id(REQUEST)
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_DOCUMENT_URL+"folder.py?parent_id="+str(parent_id)
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))

    copy_ids = []
    for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
            copy_ids.append(key[4:])

    if not copy_ids:
        REQUEST.delCookie("doc_cut_ids")
        REQUEST.delCookie("doc_copy_ids")
        raise RuntimeError, REQUEST.TLS('doc_nothing_selected')

    REQUEST.delCookie("doc_cut_ids")
    REQUEST.setCookie("doc_copy_ids", ",".join(copy_ids))

    output.append(REQUEST.TLS('doc_copy_marked'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def paste_files(REQUEST):
    output = []
    try:
        parent_id = int(REQUEST.getCookie('activeFolder'))
    except:
        parent_id = REQUEST.USER.get_parent_id(REQUEST)
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_DOCUMENT_URL+"folder.py?parent_id="+str(parent_id)
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))

    cut = 0 # if 0, then copy, else cut

    new_parent_id = int(REQUEST.getCookie('activeFolder'))

    try:
        ids = REQUEST.getCookie("doc_cut_ids")
        cut = 1
    except:
        try:
            ids = REQUEST.getCookie("doc_copy_ids")
            cut = 0
        except:
            raise RuntimeError, REQUEST.TLS('doc_nothing_selected')

    if not ids:
        REQUEST.delCookie("doc_cut_ids")
        REQUEST.delCookie("doc_copy_ids")
        raise RuntimeError, REQUEST.TLS('doc_nothing_selected')

    REQUEST.delCookie("doc_cut_ids")
    REQUEST.delCookie("doc_copy_ids")

    ids = map(int, ids.split(","))
    if cut:
        for id in ids:
            item = _RootObject.dispatch_item(REQUEST, id)
            if item.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT and item.get('final_version_id'):
                id = item.get('final_version_id')
                item = _RootObject.dispatch_item(REQUEST, id)
            item.set('parent_id', new_parent_id)
            item.save()
            REQUEST.db.commit() # FIXME but we need this to insure FS integrity
            if item.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT:
                _mail.email_notify(REQUEST, item, 1)
                REQUEST.db.execute("""SELECT document_id FROM documents WHERE final_version_id=%d""" % item.get_id())
                res = REQUEST.db.fetchall() or []
                for row in res:
                    item_v = _RootObject.dispatch_item(REQUEST, row[0])
                    item_v.set('parent_id', new_parent_id)
                    item_v.save()
                    REQUEST.db.commit() # FIXME but we need this to insure FS integrity
            output.append(REQUEST.TLS('doc_item_moved') % _Utils.html_quote(item.get_name()))
    else:
        for id in ids:
            item = _RootObject.dispatch_item(REQUEST, id)
            if item.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT and item.get('final_version_id'):
                id = item.get('final_version_id')
                item = _RootObject.dispatch_item(REQUEST, id)
            new_id = item.copyto(new_parent_id)
            if item.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT:
                item = _RootObject.dispatch_item(REQUEST, new_id)
                _mail.email_notify(REQUEST, item, 1)
            output.append(REQUEST.TLS('doc_item_copied') % _Utils.html_quote(item.get_name()))

    output.append(u"""\
<SCRIPT LANGUAGE="JavaScript">
<!--
function change_url()
{
   parent.frametree.location.href='%sdoctree.py?timestamp=%s';
}
change_url();
// -->
</script>
""" % (_Conf.BASE_DOCUMENT_URL, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def cut_files(REQUEST):
    output = []
    try:
        parent_id = int(REQUEST.getCookie('activeFolder'))
    except:
        parent_id = REQUEST.USER.get_parent_id(REQUEST)
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_DOCUMENT_URL+"folder.py?parent_id="+str(parent_id)
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))
    
    cut_ids = []
    for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
            cut_ids.append(key[4:])

    if not cut_ids:
        REQUEST.delCookie("doc_cut_ids")
        REQUEST.delCookie("doc_copy_ids")
        raise RuntimeError, REQUEST.TLS('doc_nothing_selected')

    REQUEST.delCookie("doc_copy_ids")
    REQUEST.setCookie("doc_cut_ids", ",".join(cut_ids))

    output.append(REQUEST.TLS('doc_cut_marked'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def delete_files(REQUEST):
    output = []
    try:
        parent_id = int(REQUEST.getCookie('activeFolder'))
    except:
        parent_id = REQUEST.USER.get_parent_id(REQUEST)

    del_ids = []
    for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
            del_ids.append(int(key[4:]))

    if not del_ids:
        raise RuntimeError, REQUEST.TLS('doc_nothing_selected')

    if parent_id in del_ids:
        parent_id = REQUEST.USER.get_parent_id(REQUEST)

    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_DOCUMENT_URL+"folder.py?parent_id="+str(parent_id)
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))

    for id in del_ids:
        obj = _RootObject.dispatch_item(REQUEST, id)
        if obj.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT and obj.get('final_version_id'):
            id = obj.get('final_version_id')
            obj = _RootObject.dispatch_item(REQUEST, id)
        output.append(REQUEST.TLS('doc_item_deleted') % obj.get_name())
        obj.delete()

    output.append(u"""\
<SCRIPT LANGUAGE="JavaScript">
<!--
function change_url()
{
   parent.frametree.location.href='%sdoctree.py?timestamp=%s';
}
change_url();
// -->
</script>
""" % (_Conf.BASE_DOCUMENT_URL, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def rename_files(REQUEST):
    output = []

    if REQUEST.form.has_key('final_rename') and REQUEST.form.has_key('item_id'):
        try:
            parent_id = int(REQUEST.getCookie('activeFolder'))
        except:
            parent_id = REQUEST.USER.get_parent_id(REQUEST)
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_DOCUMENT_URL+"folder.py?parent_id="+str(parent_id)
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(Menus.get_document_menu(REQUEST))

        if not REQUEST.form.has_key('newname') or not REQUEST.form['newname'].value.decode('UTF8').strip(): # FIXME or REQUEST.form['newname'].value.decode('UTF8').strip().find('/') <> -1:
            raise RuntimeError, REQUEST.TLS('docinvalidrename')

        item = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['item_id'].value))
        if item.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT and item.get('final_version_id'):
            id = item.get('final_version_id')
            item = _RootObject.dispatch_item(REQUEST, id)
        old_path = item.get_path()
        if item.item_type_id == _InitTypes.ITEM_TYPE_DOCUMENT:
            item.set('title', REQUEST.form['newname'].value.decode('UTF8'))
        elif item.item_type_id == _InitTypes.ITEM_TYPE_FOLDER:
            item.set('folder_name', REQUEST.form['newname'].value.decode('UTF8'))
        else:
            raise RuntimeError, REQUEST.TLS('doc_rename_wrongtype')
        if item.item_type_id == _InitTypes.ITEM_TYPE_FOLDER:
            new_path = item.get_path()
            if old_path == new_path:
                raise RuntimeError, REQUEST.TLS('doc_rename_nochange')
            else:
                if os.path.exists(new_path.encode('UTF8')):
                    raise RuntimeError, REQUEST.TLS('doc_rename_exists')
        item.save()
        output.append(REQUEST.TLS('doc_item_renamed'))
    else:
        extra_headers = standard_html.frametree_script(REQUEST)
        extra_body = u""" onload="show_frametree();\""""
        output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
        output.append(Menus.get_document_menu(REQUEST))
        item_id = None
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                item_id = int(key[4:])
                break

        if item_id is None:
            raise RuntimeError, REQUEST.TLS('doc_nothing_selected')
        item = _RootObject.dispatch_item(REQUEST, item_id)
        if item.item_type_id not in [_InitTypes.ITEM_TYPE_DOCUMENT,_InitTypes.ITEM_TYPE_FOLDER]:
            raise RuntimeError, REQUEST.TLS('doc_rename_wrongtype')
        if item.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT and item.get('final_version_id'):
            item_id = item.get('final_version_id')
            item = _RootObject.dispatch_item(REQUEST, item_id)

        BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
        newname = _Utils.html_quote_edit(item.get_name())
        rename_tls = REQUEST.TLS('doc_rename')
        tls_save = REQUEST.TLS('tls_save')
        newname_tls = REQUEST.TLS('doc_rename_newname')
        tls_missing_input = REQUEST.TLS('tls_missing_input')
        REQ_FIELD = _Conf.REQ_FIELD
        BASE_ICON_URL = _Conf.BASE_ICON_URL
        tls_object = REQUEST.TLS('log_document_id')
        object_name = newname
        output.append("""\
<SCRIPT language="javascript">
<!--
  function check_values()
  {
    if (!document.addform.newname.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(rename_tls)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_DOCUMENT_URL)sdocops.py/rename_files" onsubmit="return check_values();">
<INPUT type="hidden" name="final_rename" value="">
<INPUT type="hidden" name="item_id" value="%(item_id)d">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(newname_tls)s:</TD>
    <TD class="td_listing1" width="100%%"><INPUT type="text" class="textfield1" size=35 name="newname" value="%(newname)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=23 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2"><INPUT type="submit" class="input6" name="_save" value="%(tls_save)s"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def file(REQUEST):
    if not REQUEST.form.has_key('document_id'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    try:
        doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
    except:
        raise RuntimeError, REQUEST.TLS('doc_file_notfound')
    if doc.get('final_version_id') and not REQUEST.form.has_key('give_old'):
        id = doc.get('final_version_id')
        doc = _RootObject.dispatch_item(REQUEST, id)

    filepath = doc.get_path()
    filesize = os.stat(filepath.encode('UTF8'))[stat.ST_SIZE]
    filefp = open(filepath.encode('UTF8'),'rb')
    if REQUEST.browser == 'IE':
        try:
            fn = doc.get('filename').encode(_Conf.FALLBACK_ENCODING)
        except:
            fn = doc.get('filename').encode('UTF8')
    else:
         fn = str(email.Header.Header(doc.get('filename')))
    del REQUEST.mod_req.headers_out["Pragma"]
    REQUEST.mod_req.headers_out["Content-Length"] = str(filesize)
    REQUEST.mod_req.headers_out["Content-Disposition"] = "attachment; filename=%s" % fn
#    REQUEST.mod_req.headers_out["Content-Disposition"] = "inline; filename=%s" % fn
    mimetype, encoding = mimetypes.guess_type(doc.get_name())
    REQUEST.mod_req.content_type = mimetype or "application/binary"

    if _Conf.IS_MP_27:
        REQUEST.mod_req.send_http_header()

    if REQUEST.mod_req.method == "HEAD":
        REQUEST.mod_req.write("")
        return apache.OK
    reqwrite = REQUEST.mod_req.write
    fpread = filefp.read
    data = fpread(_Document.BLOCK_SIZE)
    while data:
        reqwrite(data)
        data = fpread(_Document.BLOCK_SIZE)
    filefp.close()
    return apache.OK

def edit_meta_save(REQUEST):
    if not REQUEST.form.has_key('document_id') or not REQUEST.form['document_id'].value:
        raise RuntimeError, REQUEST.TLS('doc_noid')

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
    if doc.get('final_version_id'):
        id = doc.get('final_version_id')
        doc = _RootObject.dispatch_item(REQUEST, id)
    if REQUEST.form.has_key('title') and REQUEST.form['title'].value:
        doc.set('title', REQUEST.form['title'].value.decode('UTF8'))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if REQUEST.form.has_key('author') and REQUEST.form['author'].value:
        doc.set('author', REQUEST.form['author'].value.decode('UTF8'))
    else:
        doc.set('author', None)
    if REQUEST.form.has_key('comments') and REQUEST.form['comments'].value:
        doc.set('comments', REQUEST.form['comments'].value.decode('UTF8'))
    else:
        doc.set('comments', None)
    if REQUEST.form.has_key('description') and REQUEST.form['description'].value:
        doc.set('description', REQUEST.form['description'].value.decode('UTF8'))
    else:
        doc.set('description', None)
    if REQUEST.form.has_key('parent_id') and REQUEST.form['parent_id'].value:
        doc.set('parent_id', int(REQUEST.form['parent_id'].value.decode('UTF8')))

    if REQUEST.form.has_key('doc_category') and REQUEST.form['doc_category'].value:
        doc.set('doc_category', REQUEST.form['doc_category'].value.decode('UTF8'))
    doc.save()
    custom_fields.save_custom_vals(REQUEST, doc.get_id())
    if REQUEST.form.has_key('parent_id') and REQUEST.form['parent_id'].value:
        REQUEST.db.commit() # FIXME but we need this to insure FS integrity
        REQUEST.db.execute("""SELECT document_id FROM documents WHERE final_version_id=%d""" % doc.get_id())
        res = REQUEST.db.fetchall() or []
        for row in res:
            item_v = _RootObject.dispatch_item(REQUEST, row[0])
            item_v.set('parent_id', doc.get_parent_id())
            item_v.save()
            REQUEST.db.commit() # FIXME but we need this to insure FS integrity

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_GENERAL_URL+"info.py?item_id="+str(doc.get_id())
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))
    output.append(REQUEST.TLS('doc_metadatasaved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_meta(REQUEST):
    output = []
    extra_headers = standard_html.frametree_script(REQUEST)
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST))
    output.append(standard_html.window_script(height=300,width=300))

    if not REQUEST.form.has_key('document_id') or not REQUEST.form['document_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
    if doc.get('final_version_id'):
        item_id = doc.get('final_version_id')
        doc = _RootObject.dispatch_item(REQUEST, item_id)

    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    my_parent_id = doc.get_parent_id()
    my_parent_name = _Utils.html_quote_edit(doc.get_parent().get_virtual_path())
    edit_file_meta_tls = REQUEST.TLS("doc_editfilemeta")
    title_tls = REQUEST.TLS("tls_title")
    author_tls = REQUEST.TLS("doc_author")
    folder_tls = REQUEST.TLS("doc_folder")
    desc_tls = REQUEST.TLS("tls_description")
    comments_tls = REQUEST.TLS("tls_comments")
    tls_save = REQUEST.TLS('tls_save')
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')

    my_id = doc.get_id()
    doc_title = _Utils.html_quote_edit(doc.get('title'))
    doc_author = _Utils.html_quote_edit(doc.get('author') or '')
    doc_comments = _Utils.html_quote(doc.get('comments') or '')
    doc_description = _Utils.html_quote(doc.get('description') or '')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_category = REQUEST.TLS('tls_category')
    category = doc.get('doc_category')
    categories = _Utils.make_setting_selection(REQUEST, None, 'doc_category', 'doc_categories', None, 0, category)
    tls_object = REQUEST.TLS('log_document_id')
    object_name = doc_title
    c_fields = custom_fields.get_object_edit_fields(REQUEST, doc, 0)
    output.append("""\
<SCRIPT language="javascript">
<!--
  function check_values()
  {
    if (!document.addform.title.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_4.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(edit_file_meta_tls)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_DOCUMENT_URL)sdocops.py/edit_meta_save" onsubmit="return check_values();">
<INPUT type="hidden" name="parent_id" value="%(my_parent_id)d">
<INPUT type="hidden" name="document_id" value="%(my_id)d">
<TR class="tr_listing1">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="100" height="1" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="100" height="1" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke">%(REQ_FIELD)s%(title_tls)s:</TD>
  <TD class="td_listing1" colspan=4><INPUT  size=35 class="textfield1" type="text" name="title" value="%(doc_title)s"></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke">%(tls_category)s:</TD>
  <TD class="td_listing0" colspan=4>%(categories)s</TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke">%(author_tls)s:</TD>
  <TD class="td_listing1" colspan=4><INPUT  size=35 class="textfield1" type="text" name="author" value="%(doc_author)s"></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke">%(folder_tls)s:</TD>
  <TD class="td_listing0" colspan=4><INPUT size=35 type="text"  class="textfield1" name="parent_name" value="%(my_parent_name)s" disabled>&nbsp;&nbsp;<A target="popup_window" href="%(BASE_DOCUMENT_URL)sdoctree.py/frametree" onClick="open_window('about:blank');"><IMG src="%(BASE_ICON_URL)sfld.gif" border="0"></A></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1b" colspan="5">%(desc_tls)s<BR><TEXTAREA class="textarea4" name="description" rows="10" cols="60">%(doc_description)s</TEXTAREA></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0b" colspan="5">%(comments_tls)s<BR><TEXTAREA class="textarea4" name="comments" rows="10" cols="60">%(doc_comments)s</TEXTAREA></TD>
</TR>
%(c_fields)s
<TR class="tr_listing1">
  <TD colspan="5" class="td_listing1"><INPUT type="submit" class="input6" name="_save" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_contents_save(REQUEST):
    if not REQUEST.form.has_key('document_id') or not REQUEST.form['document_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    if REQUEST.form.has_key('_save') or REQUEST.form.has_key('_save.x'):
        doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
        if doc.get('final_version_id'):
            item_id = doc.get('final_version_id')
            doc = _RootObject.dispatch_item(REQUEST, item_id)
        if REQUEST.form.has_key('doc_contents') and REQUEST.form['doc_contents'].value:
            fp = cStringIO.StringIO(REQUEST.form['doc_contents'].value) # No decode, file has to be utf8
        else:
            fp = cStringIO.StringIO('')
        fp.seek(0)
        doc.set('filepointer', fp)
        doc.save()
        fp.close()

        output = []
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_GENERAL_URL+"info.py?item_id="+str(doc.get_id())
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(Menus.get_document_menu(REQUEST))
        output.append(REQUEST.TLS('doc_contentssaved'))
        output.append(standard_html.html_footer(REQUEST))
        return "\n".join(output)
    elif REQUEST.form.has_key('_savever') or REQUEST.form.has_key('_savever.x'):
        doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
        if doc.get('final_version_id'):
            item_id = doc.get('final_version_id')
            doc = _RootObject.dispatch_item(REQUEST, item_id)
        if REQUEST.form.has_key('doc_contents') and REQUEST.form['doc_contents'].value:
            fp = cStringIO.StringIO(REQUEST.form['doc_contents'].value) # No decode, file has to be utf8
        else:
            fp = cStringIO.StringIO('')
        fp.seek(0)

        newdoc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_NEW)
        for key in ['filename','title','description','comments','author','mime_major','mime_minor','parent_id']:
            newdoc.set(key, doc.get(key))
        doc.set('filename', "%d_%s" % (doc.get_id(), doc.get('filename')))
        doc.save()
        newdoc.set('filepointer', fp)
        newdoc.save()

        # update versions
        REQUEST.db.execute("""UPDATE documents SET final_version_id=%d WHERE final_version_id=%d OR document_id=%d""" % (newdoc.get_id(), doc.get_id(), doc.get_id()))
        # update relations
        REQUEST.db.execute("""UPDATE item_rels SET left_item_id=%d WHERE left_item_id=%d""" % (newdoc.get_id(), doc.get_id()))
        REQUEST.db.execute("""UPDATE item_rels SET right_item_id=%d WHERE right_item_id=%d""" % (newdoc.get_id(), doc.get_id()))
        # update notes
        REQUEST.db.execute("""UPDATE items SET parent_id=%d WHERE parent_id=%d""" % (newdoc.get_id(), doc.get_id()))

        output = []
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_GENERAL_URL+"info.py?item_id="+str(newdoc.get_id())
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(Menus.get_document_menu(REQUEST))
        output.append(REQUEST.TLS('doc_newversaved'))
        output.append(standard_html.html_footer(REQUEST))
        return "\n".join(output)


def edit_contents(REQUEST):
    output = []
    extra_headers = standard_html.frametree_script(REQUEST)
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST))

    if not REQUEST.form.has_key('document_id') or not REQUEST.form['document_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
    if doc.get('final_version_id'):
        item_id = doc.get('final_version_id')
        doc = _RootObject.dispatch_item(REQUEST, item_id)

    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    edit_file_meta_tls = REQUEST.TLS("doc_editfilecontents")
    title_tls = REQUEST.TLS("tls_title")

    my_id = doc.get_id()
    doc_title = _Utils.html_quote_edit(doc.get('title'))
    try:
        filepath = doc.get_path()
        if os.stat(filepath.encode('UTF8'))[stat.ST_SIZE] > 1048576:
            raise RuntimeError, REQUEST.TLS('doc_toolarge')
        filefp = open(filepath.encode('UTF8'),'rb')
        doc_contents = filefp.read() or ''
        filefp.close()
    except:
        doc_contents = ''

    try:
        doc_contents = doc_contents.decode(_Conf.ENCODING)
    except:
        doc_contents = doc_contents.decode(_Conf.FALLBACK_ENCODING)
    doc_contents = _Utils.html_quote(doc_contents)
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_contents = REQUEST.TLS('tls_contents')
    tls_save = REQUEST.TLS('tls_save')
    tls_asnewver = REQUEST.TLS('doc_saveasnewversion')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_object = REQUEST.TLS('log_document_id')
    object_name = doc_title

    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, doc.get('item_type_id')))
    output.append(u"""\
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="editform" method="POST" action="%(BASE_DOCUMENT_URL)sdocops.py/edit_contents_save">
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(title_tls)s:</TD>
  <TD class="td_listing1" width="100%%">%(doc_title)s</TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0b" colspan="2">%(tls_contents)s<BR><TEXTAREA class="textarea" cols=100 rows=25 name="doc_contents">%(doc_contents)s</TEXTAREA></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=23 border=0 alt=""></TD>
  <TD class="td_listing1" colspan="2"><INPUT type="submit" class="input6" name="_save" value="%(tls_save)s">&nbsp;<INPUT type="submit" class="input6" name="_savever" value="%(tls_asnewver)s"></TD>
</TR>
</TABLE>
<INPUT type="hidden" name="document_id" value="%(my_id)d">
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_version(REQUEST):
    if not REQUEST.form.has_key('document_id') or not REQUEST.form['document_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
    if doc.get('final_version_id'):
        item_id = doc.get('final_version_id')
        doc = _RootObject.dispatch_item(REQUEST, item_id)
    my_id = doc.get_id()

    output = []
    extra_headers = standard_html.frametree_script(REQUEST)
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST))

    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    add_file_tls = REQUEST.TLS("doc_loadnewversion")
    file_tls = REQUEST.TLS("doc_file")
    tls_save = REQUEST.TLS("tls_save")
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    REQ_FIELD = _Conf.REQ_FIELD
    tls_object = REQUEST.TLS('log_document_id')
    object_name = _Utils.html_quote_show(doc.get('item_name'))
    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, doc.get('item_type_id')))
    output.append("""\
<SCRIPT language="javascript">
<!--
  function check_values()
  {
    if (!document.addform.filepointer.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(add_file_tls)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_DOCUMENT_URL)sdocops.py/edit_version_save" ENCTYPE="multipart/form-data" onsubmit="return check_values();">
<INPUT type="hidden" name="document_id" value="%(my_id)d">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(file_tls)s:</TD>
    <TD class="td_listing1" width="100%%"><INPUT size=35 class="textfield1" type="file" name="filepointer"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=23 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2" ><INPUT type="submit" class="input6" name="_save" value="%(tls_save)s"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_version_save(REQUEST):
    if not REQUEST.form.has_key('document_id') or not REQUEST.form['document_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
    if doc.get('final_version_id'):
        item_id = doc.get('final_version_id')
        doc = _RootObject.dispatch_item(REQUEST, item_id)

    newdoc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_NEW)
    for key in ['filename','title','description','comments','author','mime_major','mime_minor','parent_id']:
        newdoc.set(key, doc.get(key))
    doc.set('filename', "%d_%s" % (doc.get_id(), doc.get('filename')))
    doc.save()
    newdoc.save()
    _mail.email_notify(REQUEST, newdoc, 2)

    REQUEST.db.execute("""UPDATE documents SET final_version_id=%d WHERE final_version_id=%d OR document_id=%d""" % (newdoc.get_id(), doc.get_id(), doc.get_id()))
    REQUEST.db.execute("""UPDATE item_rels SET left_item_id=%d WHERE left_item_id=%d""" % (newdoc.get_id(), doc.get_id()))
    REQUEST.db.execute("""UPDATE item_rels SET right_item_id=%d WHERE right_item_id=%d""" % (newdoc.get_id(), doc.get_id()))
    REQUEST.db.execute("""UPDATE items set parent_id=%d where parent_id=%s""" % (newdoc.get_id(), doc.get_id()))


    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_GENERAL_URL+"info.py?versions=1&item_id="+str(newdoc.get_id())
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))
    output.append(REQUEST.TLS('doc_newversaved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def lock_doc_show(REQUEST):
    if not REQUEST.form.has_key('document_id') or not REQUEST.form['document_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    timecheck_js = REQUEST.timecheck_js()
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_lock = REQUEST.TLS('doc_lock')
    tls_document = REQUEST.TLS('tls_document')
    tls_currdate = REQUEST.TLS('tls_currdate')
    tls_currtime = REQUEST.TLS('tls_time')
    tls_lockuntil = REQUEST.TLS('doc_lockuntil')

    now = _Utils.utc_now_mx()
    start_stamp = mx.DateTime.DateTime(now.year, now.month, now.day, now.hour, now.minute)
    end_stamp = mx.DateTime.DateTime(now.year, now.month, now.day, now.hour, now.minute) + mx.DateTime.DateTimeDelta(0, 0, 30)
    start_stamp_d, start_stamp_t = REQUEST.iso2userdatetime(REQUEST, start_stamp).split(' ')
    end_stamp_d, end_stamp_t = REQUEST.iso2userdatetime(REQUEST, end_stamp).split(' ')

    document_id = int(REQUEST.form['document_id'].value)
    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
    if doc.get('final_version_id'):
        document_id = doc.get('final_version_id')
        doc = _RootObject.dispatch_item(REQUEST, document_id)
    doc_name = _Utils.html_quote_show(doc.get('item_name'))
    output = []
    extra_headers = standard_html.frametree_script(REQUEST)
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST))
    tls_object = REQUEST.TLS('log_document_id')
    object_name = doc_name
    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, doc.get('item_type_id')))
    output.append("""\
<SCRIPT type="text/javascript">
<!--
%(datecheck_js)s
%(timecheck_js)s
  function check_values()
  {
    if (!document.addform.due_date.value || !document.addform.due_time.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(tls_lock)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_DOCUMENT_URL)sdocops.py/lock_doc" onsubmit="return check_values();">
<INPUT type="hidden" name="document_id" value="%(document_id)d">
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_document)s:</TD>
  <TD class="td_listing1ve" nowrap>%(doc_name)s</TD>
  <TD class="td_listing1" colspan="2" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_currdate)s:</TD>
  <TD class="td_listing0" nowrap>%(start_stamp_d)s</TD>
  <TD class="td_listing0ke" nowrap>%(tls_currtime)s:</TD>
  <TD class="td_listing0" nowrap width="100%%">%(start_stamp_t)s</TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_lockuntil)s:</TD>
  <TD class="td_listing1" nowrap><INPUT size="10" type="text" class="textfield1" name="due_date" value="%(end_stamp_d)s" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">
  </TD>
  <TD class="td_listing1ke" nowrap>%(tls_currtime)s:</TD>
  <TD class="td_listing1" nowrap width="100%%"><INPUT size="5" type="text" class="textfield1" name="due_time" value="%(end_stamp_t)s" onblur="if (timecheck_js(this.value) != true) { if (!timecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=timecheck_js(this.value); }">
  </TD>
</TR>
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="4"><INPUT type="submit" class="input6" name="_save" value="%(tls_lock)s"></TD>
</TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def lock_doc(REQUEST):
    if not REQUEST.form.has_key('document_id') or not REQUEST.form['document_id'].value or not REQUEST.form.has_key('due_date') or not REQUEST.form['due_date'].value or not REQUEST.form.has_key('due_time') or not REQUEST.form['due_time'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
    if doc.get('final_version_id'):
        item_id = doc.get('final_version_id')
        doc = _RootObject.dispatch_item(REQUEST, item_id)
    doc.lock(REQUEST.form['due_date'].value, REQUEST.form['due_time'].value)
    doc.save()
    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_GENERAL_URL+"info.py?item_id="+str(doc.get_id())
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))
    output.append(REQUEST.TLS('doc_islocked'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def unlock_doc(REQUEST):
    if not REQUEST.form.has_key('document_id') or not REQUEST.form['document_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['document_id'].value))
    if doc.get('final_version_id'):
        item_id = doc.get('final_version_id')
        doc = _RootObject.dispatch_item(REQUEST, item_id)
    doc.unlock()
    doc.save()
    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_GENERAL_URL+"info.py?item_id="+str(doc.get_id())
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))
    output.append(REQUEST.TLS('doc_isunlocked'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def delete_versions(REQUEST):
    output = []

    del_ids = []
    for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
            del_ids.append(int(key[4:]))

    if not del_ids:
        raise RuntimeError, REQUEST.TLS('doc_nothing_selected')
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_GENERAL_URL+"info.py?versions=1&item_id="+str(REQUEST.form['document_id'].value)
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))

    for id in del_ids:
        obj = _RootObject.dispatch_item(REQUEST, id)
        output.append(REQUEST.TLS('doc_item_deleted') % obj.get_name())
        obj.delete()
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def restore_version(REQUEST):
    sel_ids = []
    for key in REQUEST.form.keys():
        if key[:4] == 'sel_':
            sel_ids.append(int(key[4:]))

    if not sel_ids or len(sel_ids) <> 1:
        raise RuntimeError, REQUEST.TLS('doc_nothing_selected')

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, sel_ids[0])
    primarydoc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, doc.get('final_version_id'))

    newdoc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_NEW)
    for key in ['title','description','comments','author','mime_major','mime_minor','parent_id']:
        newdoc.set(key, doc.get(key))
    newdoc.set('filename', primarydoc.get('filename'))

    primarydoc.set('filename', "%d_%s" % (primarydoc.get_id(), primarydoc.get('filename')))
    primarydoc.save()
    fp = open(doc.get_path(),'rb')
    newdoc.set('filepointer', fp)
    newdoc.save()
    if not fp.closed:
        fp.close()

    # update versions
    REQUEST.db.execute("""UPDATE documents SET final_version_id=%d WHERE final_version_id=%d OR document_id=%d""" % (newdoc.get_id(), primarydoc.get_id(), primarydoc.get_id()))
    # update relations
    REQUEST.db.execute("""UPDATE item_rels SET left_item_id=%d WHERE left_item_id=%d""" % (newdoc.get_id(), primarydoc.get_id()))
    REQUEST.db.execute("""UPDATE item_rels SET right_item_id=%d WHERE right_item_id=%d""" % (newdoc.get_id(), primarydoc.get_id()))
    # update notes
    REQUEST.db.execute("""UPDATE items SET parent_id=%d WHERE parent_id=%d""" % (newdoc.get_id(), primarydoc.get_id()))

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_GENERAL_URL+"info.py?versions=1&item_id="+str(newdoc.get_id())
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST))
    output.append(REQUEST.TLS('doc_newversaved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
