"""
The front page.
$Id: frontpage.py,v 1.7 2003/12/30 00:20:00 incxcvs Exp $
"""

import mx.DateTime
import standard_html, _Access, _InitTypes, _Email, _Efolder, _Conf, Menus, _Utils
import time, calendar
import _calendar

MY_MENU_ID=0

def index(REQUEST):
    now = _Utils.utc2local_mx(REQUEST, _Utils.utc_now_mx())
    daystart = mx.DateTime.DateTime(now.year, now.month, now.day)
    dayend = mx.DateTime.DateTime(now.year, now.month, now.day, 23, 59, 59)

    output = []
    output2 = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))
    BASE_URL = _Conf.BASE_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_WORKFLOWS_URL = _Conf.BASE_WORKFLOWS_URL
    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    tls_topmenu_calendar = REQUEST.TLS('topmenu_calendar')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_discussions = REQUEST.TLS('tls_discussions')
    tls_add = REQUEST.TLS('tls_add')
    tls_search = REQUEST.TLS('tls_search')
    tls_dayname = REQUEST.TLS(_Conf.WEEK_DAYS[daystart.day_of_week])
    month_name = "%d. %s %d" % (daystart.day, REQUEST.TLS('month_%d' % daystart.month), daystart.year)
    tls_greeting = REQUEST.TLS('tls_greeting') % REQUEST.USER.get_name().split(" ")[0]
    tls_schedule = REQUEST.TLS('tls_schedule')
    tls_tasks = REQUEST.TLS('todo_mytasks')
    tls_messages = REQUEST.TLS('tls_mymessages')
    tls_notes = REQUEST.TLS('tls_mynotes')
    tls_newevent = REQUEST.TLS('tls_newevent')
    tls_newtask = REQUEST.TLS('tls_newtask')
    tls_newnote = REQUEST.TLS('tls_newnote')
    tls_newmail = REQUEST.TLS('tls_newemail')
    tls_noevents = REQUEST.TLS('tls_noevents')
    tls_workflows = REQUEST.TLS('type_Workflows')
    tls_noworkflows = REQUEST.TLS('tls_noworkflows')
    note_divs = ""
    
    # Todos
    todo_output = ""
    todo_s = []
    
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_TODO])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.db.version < 740:
        SQL = u"""SELECT t.* FROM todos t, items i WHERE t.todo_id=i.item_id AND percent_complete < 100 AND t.due_time is not NULL AND t.due_time <= '%s'::timestamptz AND (i.creator_id=%d OR t.related_persons @ '{%d}'::int[]) %s """ % (dayend, REQUEST.USER.get_id(), REQUEST.USER.get_id(), right_param)
    else:
        SQL = u"""SELECT t.* FROM todos t, items i WHERE t.todo_id=i.item_id AND percent_complete < 100 AND t.due_time is not NULL AND t.due_time <= '%s'::timestamptz AND (i.creator_id=%d OR %d=ANY(t.related_persons)) %s""" % (dayend, REQUEST.USER.get_id(), REQUEST.USER.get_id(), right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    today_todos = []
    old_todos = []
    for todo in dbresult:
        if todo['due_time'] < daystart:
            old_todos.append(todo)
        else:
            today_todos.append(todo)
    del dbresult
    shown = 0
    if old_todos:
        shown = 1
        for todo in old_todos:
            todo_s.append(u"""    <TR>\n      <TD style="padding: 3px" colspan="2"><A class="blacklink" href="%stodoedit.py?todo_id=%d">%s</A></TD>\n      <TD><IMG src="%sspacer.gif" width="5" height="1" border="0" alt=""></TD>\n    </TR>""" % (_Conf.BASE_TODO_URL, todo['todo_id'], _Utils.html_quote(todo['title'].decode('UTF8')), _Conf.BASE_ICON_URL))
    if today_todos:
        shown = 1
        for todo in today_todos:
            todo_s.append(u"""    <TR>\n      <TD style="padding: 3px" colspan="2"><A class="blacklink" href="%stodoedit.py?todo_id=%d">%s</A></TD>\n      <TD><IMG src="%sspacer.gif" width="5" height="1" border="0" alt=""></TD>\n    </TR>""" % (_Conf.BASE_TODO_URL, todo['todo_id'], _Utils.html_quote(todo['title'].decode('UTF8')), _Conf.BASE_ICON_URL))
    if not shown:
        todo_s.append(u"""    <TR>\n      <TD style="padding: 3px" colspan="2">%s</TD>\n      <TD><IMG src="%sspacer.gif" width="5" height="1" border="0" alt=""></TD>\n    </TR>""" % (REQUEST.TLS('front_notodos'), _Conf.BASE_ICON_URL))
    todo_s = "\n".join(todo_s)

    todo_output = u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR valign="top">
  <TD style="padding: 10px"><IMG src="%(BASE_ICON_URL)sstartmenu_tasks.gif" width="20" height="20" border="0" alt=""></TD>
  <TD width="100%%">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD width="100%%" style="padding: 5px"><IMG src="%(BASE_ICON_URL)sfbtn.gif" width="12" height="12" border="0" alt="" style="position:relative;top:2px;">&nbsp;&nbsp;<a class="hdr2" href="%(BASE_TODO_URL)stodoindex.py">%(tls_tasks)s</a></TD>
      <TD nowrap><input type="button" class="input7" onclick="document.location='%(BASE_TODO_URL)stodoadd.py'" value="%(tls_newtask)s">&nbsp;&nbsp;&nbsp;</TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
      <TD colspan="2" width="100%%" bgcolor="#000000"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
%(todo_s)s
    </TABLE>
  </TD>
</TR>
</TABLE>""" % locals()

    # Calendar

    BASE_ICON_URL = _Conf.BASE_ICON_URL

    calendar_output = ""
    calendar_s = []

    data = _calendar.DayHandler(REQUEST, show_users= None)
    data.load(REQUEST)
    day = data.active_week[0]
    today = REQUEST.TLS(_Conf.WEEK_DAYS[calendar.weekday(day.year, day.month, day.day)])

    todaydt=_Utils.utc_now_mx()
    tomorrowdt=todaydt + mx.DateTime.DateTimeDelta(1)
    data2 = _calendar.DayHandler(REQUEST, tomorrowdt.year, tomorrowdt.month, tomorrowdt.day, show_users= None)
    data2.load(REQUEST)
    day2 = data2.active_week[0]
    tomorrow = REQUEST.TLS(_Conf.WEEK_DAYS[calendar.weekday(day2.year, day2.month, day2.day)])
    day_output2 = []
    for i in range(len(data.active_week[0].events)):
        for day in data.active_week:
            for event in day.events[i][2]:
                event['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
                event['BASE_CALENDAR_URL'] = _Conf.BASE_CALENDAR_URL
                event['start_time'] = REQUEST.iso2usertime(REQUEST, event['real_start_stamp'], is_utc=0)
                event['end_time'] = REQUEST.iso2usertime(REQUEST, event['real_end_stamp'], is_utc=0)
                event['event_name']=_Utils.html_quote(event['event_name'].decode('UTF8'))
                calendar_s.append(u"""<TR><TD colspan="2" style="padding: 3px;"><a class="blacklink" target="topcontents" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)d">%(start_time)s-%(end_time)s %(event_name)s</a></TD><TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD></TR>""" % event)
    calendar_s = "\n".join(calendar_s)
    if not calendar_s:
        calendar_s = """<TR><TD style="padding: 3px" colspan="2">%(tls_noevents)s</TD><TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD></TR>""" % locals()
    
    calendar_output = u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR valign="top">
  <TD style="padding: 10px"><IMG src="%(BASE_ICON_URL)sstartmenu_calendar.gif" width="20" height="20" border="0" alt=""></TD>
  <TD width="100%%">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD width="100%%" style="padding: 5px"><IMG src="%(BASE_ICON_URL)sfbtn.gif" width="12" height="12" border="0" alt="" style="position:relative;top:2px;">&nbsp;&nbsp;<a class="hdr2" href="%(BASE_CALENDAR_URL)sday.py">%(tls_schedule)s</a></TD>
      <TD nowrap><input type="button" class="input7" value="%(tls_newevent)s" onclick="document.location='%(BASE_CALENDAR_URL)saddevent.py'">&nbsp;&nbsp;&nbsp;</TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
      <TD colspan="2" width="100%%" bgcolor="#000000"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    %(calendar_s)s
    </TABLE>
  </TD>
</TR>
</TABLE>""" % locals()
    
    
    # Notes
    
    note_output = ""
    note_s = []
    
    REQUEST.db.execute("""SELECT u.note_id, note_message, edit_time, note_color FROM items i, usernotes u WHERE u.note_id=i.item_id AND i.parent_id=%d AND i.is_private=true order by edit_time desc limit 3""" % (REQUEST.USER.get_id()))
    dbres = REQUEST.db.dictfetchall()
    note_msg = ""
    if dbres and dbres[0]:
        for row in dbres:
            dt = REQUEST.iso2userdate(_Utils.utc2local_mx(REQUEST, row['edit_time']))
            note_s.append("""<TR><TD colspan="2" style="padding: 3px;" class="note_date">(%s) <A class="blacklink" style="style="cursor: pointer; cursor: hand;" href="%snotes.py/edit?note_id=%s" onmouseover="show_note(this, 'note_%s');" onmouseout="hide_note('note_%s');">%s</A></TD><TD><IMG src="%sspacer.gif" width="5" height="1" border="0" alt=""></TD></TR>""" % (dt, _Conf.BASE_TODO_URL, row['note_id'], row['note_id'], row['note_id'], _Utils.html_quote_show(_Utils.shorten_string(row['note_message'].decode('UTF8'), 35)), _Conf.BASE_ICON_URL))
            note_divs = note_divs + table_output(REQUEST, row)
    else:
        note_s.append("""<TR><TD colspan="2" style="padding: 3px;">%s</TD><TD><IMG src="%sspacer.gif" width="5" height="1" border="0" alt=""></TD></TR>""" % (REQUEST.TLS('note_none'), _Conf.BASE_ICON_URL))
    note_s = "\n".join(note_s)

    note_output = u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR valign="top">
  <TD style="padding: 10px"><IMG src="%(BASE_ICON_URL)sstartmenu_notes.gif" width="20" height="20" border="0" alt=""></TD>
  <TD width="100%%">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD width="100%%" style="padding: 5px"><IMG src="%(BASE_ICON_URL)sfbtn.gif" width="12" height="12" border="0" alt="" style="position:relative;top:2px;">&nbsp;&nbsp;<a class="hdr2" href="%(BASE_TODO_URL)snotes.py">%(tls_notes)s</A></TD>
      <TD nowrap><input type="button" class="input7" onclick="document.location='%(BASE_TODO_URL)snotes.py/add'" value="%(tls_newnote)s">&nbsp;&nbsp;&nbsp;</TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
      <TD colspan="2" width="100%%" bgcolor="#000000"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
%(note_s)s
    </TABLE>
  </TD>
</TR>
</TABLE>""" % locals()


    # Emails
    email_output = ""
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_INBOX))
    result = REQUEST.db.dictfetchone()
    if result:
        INBOX_ID = result['efolder_id']
        SQL = u"""SELECT  (SELECT count(email_id) FROM emails e, items i WHERE e.email_id=i.item_id AND i.parent_id=%d) AS count_all,  (SELECT count(*) FROM emails e, items i WHERE e.email_id=i.item_id AND i.parent_id=%d AND (e.email_flags & %d) = 0) AS count_unread """ % (INBOX_ID, INBOX_ID, _Email.EMAIL_READ)
        REQUEST.db.execute(SQL.encode('UTF8'))
        dbresult = REQUEST.db.dictfetchone()
        email_str = u"""%s""" % (REQUEST.TLS('front_mail') % (dbresult['count_all'] or 0, dbresult['count_unread'] or 0))
    else:
        email_str = u"""%s""" % (REQUEST.TLS('front_noaccount'))

    email_output = u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR valign="top">
  <TD style="padding: 10px"><IMG src="%(BASE_ICON_URL)sstartmenu_email2.gif" width="20" height="20" border="0" alt=""></TD>
  <TD width="100%%">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD width="100%%" style="padding: 5px"><IMG src="%(BASE_ICON_URL)sfbtn.gif" width="12" height="12" border="0" alt="" style="position:relative;top:2px;">&nbsp;&nbsp;<a class="hdr2" href="%(BASE_EMAIL_URL)sefolder1.py">%(tls_messages)s</a></TD>
      <TD nowrap><input type="button" class="input7" onclick="document.location='%(BASE_EMAIL_URL)scompose.py'" value="%(tls_newmail)s">&nbsp;&nbsp;&nbsp;</TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
      <TD colspan="2" width="100%%" bgcolor="#000000"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
        <TD colspan="2" style="padding: 3px;">%(email_str)s</TD>
        <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
</TABLE>""" % locals()

    # Workflows
    wf_str = u""
    wf_output = u""
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_WORKFLOW])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.db.version < 740:
        users_limit = """\n  AND (i.creator_id = %d OR w.related_persons @ '{%d}'::int[])""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
    else:
        users_limit = """\n  AND (i.creator_id = %d OR %d=ANY(w.related_persons))""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
    QUERY = u"""SELECT w.* FROM workflows w, items i WHERE w.workflow_id=i.item_id  AND w.percent_complete<100  %s%s ORDER BY w.workflow_due_time LIMIT 5""" % (users_limit, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    if dbresult:
        for wf in dbresult:
            wf_str = wf_str + u"""<A class="blacklink" href="%sworkflowedit.py?workflow_id=%d">%s</A><BR>""" % (_Conf.BASE_WORKFLOWS_URL, wf['workflow_id'], _Utils.html_quote(wf['workflow_title'].decode('UTF8')))
    else:
        wf_str = tls_noworkflows
    wf_output = u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR valign="top">
  <TD style="padding: 10px"><IMG src="%(BASE_ICON_URL)stitle_16.gif" width="20" height="20" border="0" alt=""></TD>
  <TD width="100%%">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD width="100%%" style="padding: 5px"><IMG src="%(BASE_ICON_URL)sfbtn.gif" width="12" height="12" border="0" alt="" style="position:relative;top:2px;">&nbsp;&nbsp;<a class="hdr2" href="%(BASE_WORKFLOWS_URL)sworkflowindex.py">%(tls_workflows)s</a></TD>
      <TD nowrap>&nbsp;&nbsp;&nbsp;</TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
      <TD colspan="2" width="100%%" bgcolor="#000000"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
        <TD colspan="2" style="padding: 3px;">%(wf_str)s</TD>
        <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
</TABLE>""" % locals()


    # Discussions
    disc_output = u""
    disc_str = u""
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_DISCCATEGORY])
    if right_param:
        right_param = " AND " + right_param
    SQL = u"""SELECT item_id FROM items i WHERE item_type_id=%d%s""" % (_InitTypes.ITEM_TYPE_DISCCATEGORY, right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    parents = REQUEST.db.dictfetchall()
    if parents:
        parents = u"(%s)" % ",".join(map(lambda x: str(x['item_id']), parents))
        SQL = u"""\
SELECT
 d.discussion_id,
 d.disc_subject,
 (SELECT count(*) FROM discussions x, items y WHERE x.discussion_id=y.item_id AND y.parent_id=d.discussion_id) AS count_answers
FROM
 discussions d,
 items i
WHERE
 d.discussion_id=i.item_id AND
 i.parent_id in %s
ORDER BY i.create_time DESC LIMIT 5""" % parents
        REQUEST.db.execute(SQL.encode('UTF8'))
        dbresult = REQUEST.db.dictfetchall()
    else:
        dbresult = None
    if dbresult:
        for disc in dbresult:
            disc_str = disc_str + u"""<A class="blacklink" href="%sdiscread.py?discussion_id=%d">%s</A> <span style="color: #A50000;">(%s)</span><BR>""" % (_Conf.BASE_DISCUSSION_URL, disc['discussion_id'], _Utils.html_quote(disc['disc_subject'].decode('UTF8')), disc['count_answers'])
    else:
        disc_str = REQUEST.TLS('front_nodiscs')
    disc_output = u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR valign="top">
  <TD style="padding: 10px"><IMG src="%(BASE_ICON_URL)stitle_0.gif" width="20" height="20" border="0" alt=""></TD>
  <TD width="100%%">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD width="100%%" style="padding: 5px"><IMG src="%(BASE_ICON_URL)sfbtn.gif" width="12" height="12" border="0" alt="" style="position:relative;top:2px;">&nbsp;&nbsp;<a class="hdr2" href="%(BASE_DISCUSSION_URL)sdiscindex.py">%(tls_discussions)s</a></TD>
      <TD nowrap>&nbsp;&nbsp;&nbsp;</TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
      <TD colspan="2" width="100%%" bgcolor="#000000"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
        <TD colspan="2" style="padding: 3px;">%(disc_str)s</TD>
        <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
</TABLE>""" % locals()


    # CRM info
    now = _Utils.utc_now_mx()
    begin = "%04d-%02d-%02d" % (now.year, now.month, now.day)
    now = now + 2
    end2 = "%04d-%02d-%02d" % (now.year, now.month, now.day)
    now = now + 4
    end = "%04d-%02d-%02d" % (now.year, now.month, now.day)
    crm_output = u""

    
    REQUEST.db.execute("""SELECT o.opp_id, i.item_name, o.close_date from items i, opportunities o where i.item_id=o.opp_id and i.creator_id=%d AND ((o.close_date<='%s' AND o.opp_stage>0 AND o.opp_stage<100) OR (o.close_date between '%s' AND '%s'))""" % (REQUEST.USER.get_id(), begin, begin, end))
    dbres1 = REQUEST.db.dictfetchall()
    if dbres1:
        BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
        tls_opp_my = REQUEST.TLS('opp_my')
        tls_opp_others = REQUEST.TLS('opp_others')
        out1 = " "
        out2 = " "
        if dbres1:
            for row in dbres1:
                out1 = out1 + u"""<span class="note_date">(%s)</span>&nbsp;&nbsp;<A class="blacklink" href="%soppedit.py?opp_id=%s">%s</a><BR>""" % (REQUEST.iso2userdate(row['close_date']), _Conf.BASE_OPPORTUNITIES_URL, row['opp_id'], row['item_name'].decode('UTF8'))
        else:
            out1 = out1 + REQUEST.TLS('tls_norecords')
        crm_output = u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR valign="top">
  <TD style="padding: 10px"><IMG src="%(BASE_ICON_URL)stitle_19.gif" width="20" height="20" border="0" alt=""></TD>
  <TD width="100%%">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD width="100%%" style="padding: 5px"><IMG src="%(BASE_ICON_URL)sfbtn.gif" width="12" height="12" brder="0" alt="" style="position:relative;top:2px;">&nbsp;&nbsp;<a class="hdr2" href="%(BASE_OPPORTUNITIES_URL)sopportunities.py">%(tls_opp_my)s</a></TD>
      <TD nowrap>&nbsp;&nbsp;&nbsp;</TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
      <TD colspan="2" width="100%%" bgcolor="#000000"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
        <TD colspan="2" style="padding: 3px;">%(out1)s</TD>
        <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
</TABLE>""" % locals()

    # Annoucements
    
    tls_frontpagemanagemessage = REQUEST.TLS('frontpage_managemessage');
    body_str = ""
    try:
         body = REQUEST.get_setting('frontpage_contents')
    except:
         body = ""
    if body and body.strip().lower()<>'<br>':
        body_output = u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR valign="top">
  <TD style="padding: 10px"><IMG src="%(BASE_ICON_URL)sstartmenu_discussions.gif" width="20" height="20" border="0" alt=""></TD>
  <TD width="100%%">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
    <TR>
      <TD width="100%%" class="hdr2" style="padding: 5px"><IMG src="%(BASE_ICON_URL)sfbtn.gif" width="12" height="12" border="0" alt="" style="position:relative;top:2px;">&nbsp;&nbsp;%(tls_frontpagemanagemessage)s</TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
      <TD width="100%%" bgcolor="#000000"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    <TR>
      <TD style="padding: 3px;">%(body)s</TD>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="5" height="1" border="0" alt=""></TD>
    </TR>
    </TABLE>
  </TD>
</TR>
</TABLE>""" % locals()
        body_str = u"""
<TR valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD width="100%%" colspan="3" style="padding-right: 10px">%(body_output)s</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>""" % locals()


    if crm_output:
        crm_str = u"""
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="25" alt=""></TD>
    <TD width="50%%" style="padding-right: 10px">&nbsp;</TD>
    <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD width="50%%" style="padding-left: 10px">&nbsp;</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>
<TR valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD width="100%%" style="padding-right: 10px" colspan="3">%(crm_output)s</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="25" alt=""></TD>
    <TD width="50%%" style="padding-right: 10px">&nbsp;</TD>
    <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD width="50%%" style="padding-left: 10px">&nbsp;</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>""" % locals()

    else:
        crm_str = u"""
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="25" alt=""></TD>
    <TD width="50%%" style="padding-right: 10px">&nbsp;</TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD width="50%%" style="padding-left: 10px">&nbsp;</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>""" % locals()


#### START

    output.append(u"""
<script type="text/javascript">
function DL_GetElementLeft(eElement){ var nLeftPos = eElement.offsetLeft; var eParElement = eElement.offsetParent; while (eParElement != null) { nLeftPos += eParElement.offsetLeft; eParElement = eParElement.offsetParent; } return nLeftPos; }
function DL_GetElementTop(eElement){ var nTopPos = eElement.offsetTop; var eParElement = eElement.offsetParent; while (eParElement != null) { nTopPos += eParElement.offsetTop; eParElement = eParElement.offsetParent; } return nTopPos; }
function show_note(note, note_id)
{
  el = document.getElementById(note_id);
  pos_top = DL_GetElementTop(note)+18;
  pos_left = DL_GetElementLeft(note);
  el.style.top = pos_top+'px';
  el.style.left = pos_left+'px';
  el.style.visibility='visible';
}
function hide_note(note_id)
{
  el = document.getElementById(note_id);
  el.style.visibility='hidden';
}
</script>
%(note_divs)s
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD style="padding: 15px;" class="hdr">%(tls_greeting)s</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD style="padding: 15px;" class="hdr" align="right">%(tls_dayname)s, %(month_name)s</TD>
    <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
</TR>
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD colspan="6" width="100%%" bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD colspan="7" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="10" alt=""></TD>
</TR>
<TR valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD width="50%%" style="padding-right: 10px">%(calendar_output)s</TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD width="50%%" style="padding-left: 10px">%(todo_output)s</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="25" alt=""></TD>
    <TD width="50%%" style="padding-right: 10px">&nbsp;</TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD width="50%%" style="padding-left: 10px">&nbsp;</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>
<TR valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD width="50%%" style="padding-right: 10px">%(note_output)s</TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD width="50%%" style="padding-left: 10px">%(email_output)s</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="25" alt=""></TD>
    <TD width="50%%" style="padding-right: 10px">&nbsp;</TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD width="50%%" style="padding-left: 10px">&nbsp;</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>
<TR valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD width="50%%" style="padding-right: 10px">%(wf_output)s</TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD width="50%%" style="padding-left: 10px">%(disc_output)s</TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD bgcolor="#000000"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="1" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="10" height="1" alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" border="0" width="15" height="1" alt=""></TD>
</TR>
%(crm_str)s
%(body_str)s
</TABLE>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)


def table_output(REQUEST, item):
    output=[]
    item['BASE_TODO_URL'] = _Conf.BASE_TODO_URL
    item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    item['note_message'] = _Utils.newline2br(_Utils.html_quote_show(item['note_message'].decode("UTF8"))).replace("  ", " &nbsp;")
    item['date'] = REQUEST.iso2userdatetime(REQUEST, item['edit_time'])
    
    corners = {'#C4AFE8':'1','#3F97E1':'2','#70BF55':'3'}
    fontcols = {'#C4AFE8':'#5D3DC0','#3F97E1':'#CBFFFF','#70BF55':'#F0FFF0'}
    bgcols = {'#C4AFE8':'#492CA1','#3F97E1':'#0068C6','#70BF55':'#2BA10B'}
    colours = ["#70BF55", "#3F97E1", "#C4AFE8"]
    item['bgcolor'] = colours[item['note_color']]
    item['bgcolor2'] = bgcols[item['bgcolor']]
    item['corner'] = corners[item['bgcolor']]
    item['f_col'] = fontcols[item['bgcolor']]
    item['tls_edit'] = REQUEST.TLS('tls_edit')
    item['tls_del'] = REQUEST.TLS('email_short_del')
    
    output.append(u"""
<div id="note_%(note_id)s" style="width: 250px; visibility: hidden; position: absolute; z-index: 4;">
<TABLE width="100%%" border=0 cellpadding=0 cellspacing=0>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s21.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD style="color: #FFFFFF; font-weight: bold; padding: 4px;" bgcolor="%(bgcolor2)s" width="100%%" nowrap><b>%(date)s</b></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s22.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s8.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD align="left" bgcolor="%(bgcolor)s" style="color: %(f_col)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s6.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s8.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD height="100%%" class="note_td" align="left" bgcolor="%(bgcolor)s" style="color: %(f_col)s">%(note_message)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s6.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sn%(corner)s3.gif" width="7" height="7" border="0" alt=""></TD>
  <TD width="100%%" style="background-image: url('%(BASE_ICON_URL)sn%(corner)s7.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sn%(corner)s4.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
</div>""" % item)
    return "\n".join(output)
