import _Conf, standard_html, _RootObject, _InitTypes, _Utils, Menus, _Access, mimetypes, _Exceptions, _Log
import _Person, _Usernote
import relations, urllib, custom_fields
MY_MENU_ID = 0

def index(REQUEST):
    output = []
    extra_headers = standard_html.frametree_script(REQUEST)
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))
    if not REQUEST.form.has_key('item_id') or not REQUEST.form['item_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_noitemid')

    item = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['item_id'].value))
    if item.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT and item.get('final_version_id') and not REQUEST.form.has_key('give_old'):
        id = item.get('final_version_id')
        item = _RootObject.dispatch_item(REQUEST, id)

    try:
        parent_id = int(REQUEST.getCookie('activeFolder'))
    except:
        parent_id = REQUEST.USER.get_parent_id(REQUEST)
    active_folder = _RootObject.dispatch_item(REQUEST, parent_id)
    virtual_path = []
    REQUEST.su_by_id(_Conf.SUPERUSER)
    parent_obj = item.get_parent()
    while parent_obj.get_id() <> _Conf.ROOTOBJECT:
        REQUEST.unsu()
        can_read = parent_obj.canRead()
        REQUEST.su_by_id(_Conf.SUPERUSER)
        if can_read:
            virtual_path.append(u"""<A class="apath" href="%sfolder.py?parent_id=%d">%s</A>""" % (_Conf.BASE_DOCUMENT_URL, parent_obj.get_id(), _Utils.html_quote(parent_obj.get_name())))
        else:
            virtual_path.append(u"""%s""" % _Utils.html_quote(parent_obj.get_name()))
        parent_obj = parent_obj.get_parent()
    REQUEST.unsu()
    virtual_path.reverse()
    virtual_path = u"/%s" % "/".join(virtual_path)

    output.append(u"""<DIV class="path">&nbsp;&nbsp;%s:&nbsp;%s/%s</DIV>""" % (REQUEST.TLS('tls_path'), virtual_path, _Utils.html_quote(item.get('title') or item.get('folder_name') or item.get('organization_name'))))

    # We already know that user has rights to this specific
    # object, so all related items (even if usually unreadable)
    # shown in dispatchers should be given access to.
    # REQUEST.su_by_id(_Conf.SUPERUSER)

    if item.item_type_id == _InitTypes.ITEM_TYPE_PERSON:
        output.append("""Info dispatcher for persons not implemented yet.""")
    elif item.item_type_id == _InitTypes.ITEM_TYPE_ORGANIZATION:
        output.append(organization_info(REQUEST, item))
    elif item.item_type_id == _InitTypes.ITEM_TYPE_FOLDER:
        output.append(folder_info(REQUEST, item))
    elif item.item_type_id == _InitTypes.ITEM_TYPE_DOCUMENT:
        output.append(document_info(REQUEST, item))
    elif item.item_type_id == _InitTypes.ITEM_TYPE_EVENT:
        output.append("""Info dispatcher for events not implemented yet.""")
    else:
        output.append("""Info dispatcher for UNKNOWN TYPE not implemented yet.""")

    # End su session
    # REQUEST.unsu()

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def document_info(REQUEST, doc):

    if REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    elif REQUEST.form.has_key('versions'):
        return versions_contents(REQUEST, doc)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, doc.get_id())

    ns = {'BASE_DOCUMENT_URL':_Conf.BASE_DOCUMENT_URL}
    ns['document_id'] = doc.get_id()
    REQUEST.su_by_id(_Conf.SUPERUSER)
    try:
        ns['creator'] = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, doc.get('creator_id')).get_name()
    except:
        ns['creator'] = u"N/A"
    try:
        ns['editor'] = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, doc.get('editor_id')).get_name()
    except:
        ns['editor'] = u"N/A"
    REQUEST.unsu()
    ns['create_time'] = REQUEST.iso2userdatetime(REQUEST, doc.get('create_time'))
    ns['edit_time'] = REQUEST.iso2userdatetime(REQUEST, doc.get('edit_time'))
    ns['title'] = _Utils.html_quote_show(doc.get('title')) or '&nbsp;'
    ns['filename'] = _Utils.html_quote_show(doc.get('filename')) or '&nbsp;'
    ns['description'] = _Utils.html_quote_show(doc.get('description')) or '&nbsp;'
    ns['comments'] = _Utils.html_quote_show(doc.get('comments')) or '&nbsp;'
    ns['author'] = _Utils.html_quote_show(doc.get('author')) or '&nbsp;'
    ns['doc_category'] = doc.get('doc_category') or '&nbsp;'
    ns['tls_category'] = REQUEST.TLS('tls_category')
    ns['tls_lock'] = REQUEST.TLS('doc_lock')
    ns['tls_unlock'] = REQUEST.TLS('doc_unlock')
    if _Access.get_item_right(REQUEST, doc.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE and not doc.get('final_version_id'):
        ns['edit_meta'] = u"""<INPUT class="input6" type="submit" name="_editmeta" value=" %s ">&nbsp;""" % REQUEST.TLS('doc_editfilemeta')
        ns['edit_version'] = ""u"""<INPUT class="input6" type="submit" name="_editversion" value=" %s ">&nbsp;""" % REQUEST.TLS('doc_loadnewversion')
        if doc.get('locker_id') is None:
            ns['lock'] = u"""<INPUT class="input6" type="submit" name="_lock" value="%(tls_lock)s">&nbsp;""" % ns
        elif doc.get('locker_id') is not None and (doc.get('locker_id')==REQUEST.USER.get_id() or _Access.get_item_right(REQUEST, doc.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_MANAGE or REQUEST.USER.get_id() == _Conf.SUPERUSER):
            ns['lock'] = u"""<INPUT class="input6" type="submit" name="_unlock" value="%(tls_unlock)s">&nbsp;""" % ns
        else:
            ns['lock'] = u""
        mimetype = mimetypes.guess_type(doc.get('filename'))[0]
        if mimetype and mimetype.split('/')[0] == 'text':
            ns['edit_contents'] = u"""<INPUT class="input6" type="submit" name="_editcontents" value=" %s ">&nbsp;""" % REQUEST.TLS('doc_editfilecontents')
        else:
            ns['edit_contents'] = u""
    else:
        ns['edit_meta'] = u""
        ns['edit_version'] = u""
        ns['edit_contents'] = u""
        ns['lock'] = u""
    ns['tls_filename'] = REQUEST.TLS('doc_filename')
    ns['tls_info'] = REQUEST.TLS('info')
    ns['item_size'] = _Utils.str_size(doc.get('item_size'))
    ns['tls_title'] = REQUEST.TLS('tls_title')
    ns['tls_author'] = REQUEST.TLS('tls_author')
    ns['tls_creator'] = REQUEST.TLS('tls_creator')
    ns['tls_createtime'] = REQUEST.TLS('tls_createtime')
    ns['tls_editor'] = REQUEST.TLS('tls_editor')
    ns['tls_edittime'] = REQUEST.TLS('tls_edittime')
    ns['tls_size'] = REQUEST.TLS('size')
    ns['tls_comments'] = REQUEST.TLS('tls_comments')
    ns['tls_description'] = REQUEST.TLS('tls_description')
    ns['tls_islock_show'] = REQUEST.TLS('doc_islock_show')
    ns['tls_lockedby'] = REQUEST.TLS('doc_lockedby')
    ns['tls_lockeduntil'] = REQUEST.TLS('doc_lockeduntil')
    ns['tls_currdate'] = REQUEST.TLS('tls_currdate')
    ns['tls_time'] = REQUEST.TLS('tls_time')
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['menu'] = menu_output(REQUEST, doc)
    ns['locked_out'] = u""
    today = _Utils.utc_now_mx()
    ns['currtime'] = "%s" % (REQUEST.iso2userdatetime(REQUEST, today))
    if doc.get('locker_id') is not None:
        REQUEST.su_by_id(_Conf.SUPERUSER)
        person = _RootObject.dispatch_item(REQUEST, doc.get('locker_id'))
        ns['locker_name'] = person.get('item_name')
        REQUEST.unsu()
        ns['lock_due'] = REQUEST.iso2userdatetime(REQUEST, doc.get('lock_due'))
        ns['locked_out'] = u"""
<TR>
  <TD class="td_listing1b" colspan="5">%(tls_islock_show)s</TD>
</TR>
<TR valign="top">
  <TD class="td_listing0b" valign="top">%(tls_lockedby)s:</TD>
  <TD class="td_listing0"  valign="top" colspan="4">%(locker_name)s</TD>
</TR>
<TR valign="top">
  <TD class="td_listing1b" valign="top">%(tls_lockeduntil)s:</TD>
  <TD class="td_listing1"  valign="top" colspan="4">%(lock_due)s</TD>
</TR>
<TR valign="top">
  <TD class="td_listing0b" valign="top">%(tls_currdate)s, %(tls_time)s:</TD>
  <TD class="td_listing0"  valign="top" colspan="4">%(currtime)s</TD>
</TR>
""" % ns

    ns['c_fields'] = custom_fields.get_object_show_fields(REQUEST, doc, 1)
    return u"""\
<FORM action="%(BASE_DOCUMENT_URL)sdocops.py" method="POST">
<INPUT type="hidden" name="document_id" value="%(document_id)d">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1kv" nowrap>%(tls_title)s:</TD>
  <TD class="td_listing1vv" nowrap>%(title)s</TD>
  <TD class="td_listing1kv" nowrap>%(tls_filename)s:</TD>
  <TD class="td_listing1vv" nowrap>%(filename)s</TD>
  <TD class="td_listing1vv" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0kv" nowrap>%(tls_author)s:</TD>
  <TD class="td_listing0vv" nowrap>%(author)s</TD>
  <TD class="td_listing0kv" nowrap>%(tls_creator)s:</TD>
  <TD class="td_listing0vv" nowrap>%(creator)s</TD>
  <TD class="td_listing0vv"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1kv" nowrap>%(tls_createtime)s:</TD>
  <TD class="td_listing1vv" nowrap>%(create_time)s</TD>
  <TD class="td_listing1kv" nowrap>%(tls_category)s:</TD>
  <TD class="td_listing1vv" nowrap>%(doc_category)s</TD>
  <TD class="td_listing1vv"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0kv" nowrap>%(tls_edittime)s:</TD>
  <TD class="td_listing0vv" nowrap>%(edit_time)s</TD>
  <TD class="td_listing0kv" nowrap>%(tls_editor)s:</TD>
  <TD class="td_listing0vv" nowrap>%(editor)s</TD>
  <TD class="td_listing0vv"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1kv">%(tls_size)s:</TD>
  <TD class="td_listing1vv" colspan="4">%(item_size)s</TD>
</TR>
<TR valign="top">
  <TD class="td_listing0kv" valign="top">%(tls_description)s:</TD>
  <TD class="td_listing0vv"  valign="top" colspan="4">%(description)s</TD>
</TR>
<TR valign="top">
  <TD class="td_listing1kv" valign="top">%(tls_comments)s:</TD>
  <TD class="td_listing1vv"  valign="top" colspan="4">%(comments)s</TD>
</TR>
%(c_fields)s
%(locked_out)s
<TR>
  <TD width="100%%" colspan="5" class="td_listing0">%(edit_meta)s%(edit_version)s</TD>
</TR>
<TR>
  <TD width="100%%" colspan="5" class="td_listing0">%(lock)s%(edit_contents)s</TD>
</TR>
<TR>
  <TD width="100%%" colspan="5" class="td_listing0">&nbsp;</TD>
</TR>
</FORM>
</TABLE>""" % ns

def organization_info(REQUEST, org):
    ns = {}
    REQUEST.su_by_id(_Conf.SUPERUSER)
    ns['creator'] = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, org.get('creator_id')).get_name()
    ns['create_time'] = REQUEST.iso2userdatetime(REQUEST, org.get('create_time'))
    ns['editor'] = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, org.get('editor_id')).get_name()
    ns['edit_time'] = REQUEST.iso2userdatetime(REQUEST, org.get('edit_time'))
    REQUEST.unsu()
    ns['organization_name'] = org.get('organization_name')
    if org.get('address') and org.get('zipcode') and org.get('city'):
        ns['address'] = "%s, %s, %s" % (org.get('address'), org.get('zipcode'), org.get('city'))
    elif org.get('address') and org.get('zipcode'):
        ns['address'] = "%s, %s" % (org.get('address'), org.get('zipcode'))
    elif org.get('address') and org.get('city'):
        ns['address'] = "%s, %s" % (org.get('address'), org.get('city'))
    elif org.get('zipcode') and org.get('city'):
        ns['address'] = "%s, %s" % (org.get('zipcode'), org.get('city'))
    elif org.get('city'):
        ns['address'] = org.get('city')
    elif org.get('address'):
        ns['address'] = org.get('address')
    else:
        ns['address'] = '&nbsp;'
    if org.get('state') and org.get('country'):
        ns['statecountry'] = "%s, %s" % (org.get('state'), org.get('country'))
    elif org.get('country'):
        ns['statecountry'] = org.get('country')
    elif org.get('state'):
        ns['statecountry'] = org.get('state')
    else:
        ns['statecountry'] = '&nbsp;'
    ns['telephone'] = org.get('telephone') or '&nbsp;'
    ns['fax'] = org.get('fax') or '&nbsp;'
    ns['website'] = org.get('website') or '&nbsp;'
    ns['email'] = org.get('email') or '&nbsp;'
    if org.get_parent_id():
        parent = org.get_parent()
        ns['toplevel'] = """\
<TR>
  <TD class="td_listing1"><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan="2" class="td_listing1b">%s:</TD>
  <TD colspan="2" class="td_listing1">%s</TD>
</TR>""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('info_suborg'), parent.get('organization_name'))
        del parent
    else:
        ns['toplevel'] = ""
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['tls_org_name'] = REQUEST.TLS('admin_orgname')
    ns['tls_info'] = REQUEST.TLS('info')
    ns['tls_address'] = REQUEST.TLS('contact_address')
    ns['tls_state'] = REQUEST.TLS('contact_state')
    ns['tls_tel'] = REQUEST.TLS('contact_tele')
    ns['tls_phone_fax'] = REQUEST.TLS('tls_phone_fax')
    ns['tls_website'] = REQUEST.TLS('tls_website')
    ns['tls_email'] = REQUEST.TLS('tls_email')
    ns['tls_creator'] = REQUEST.TLS('tls_creator')
    ns['tls_createtime'] = REQUEST.TLS('tls_createtime')
    ns['tls_editor'] = REQUEST.TLS('tls_editor')
    ns['tls_edittime'] = REQUEST.TLS('tls_edittime')
    return """\
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_organization.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(tls_info)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan="2" class="td_listing1b" nowrap>%(tls_org_name)s:</TD>
  <TD colspan="2" width="80%%" class="td_listing1b">%(organization_name)s</TD>
</TR>
%(toplevel)s
<TR>
  <TD class="td_listing0b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan="2" class="td_listing0b">%(tls_address)s:</TD>
  <TD colspan="2" class="td_listing0b">%(tls_state)s:</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan="2" class="td_listing1">%(address)s</TD>
  <TD colspan="2" class="td_listing1">%(statecountry)s</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0b">%(tls_tel)s:</TD>
  <TD class="td_listing0">%(telephone)s</TD>
  <TD class="td_listing0b">%(tls_phone_fax)s:</TD>
  <TD class="td_listing0">%(fax)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan="2" class="td_listing1b">%(tls_website)s:</TD>
  <TD colspan="2" class="td_listing1b">%(tls_email)s:</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan="2" class="td_listing0">%(website)s</TD>
  <TD colspan="2" class="td_listing0">%(email)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" colspan="2">%(tls_creator)s:</TD>
  <TD class="td_listing1" colspan="2">%(creator)s</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0b" colspan="2">%(tls_createtime)s:</TD>
  <TD class="td_listing0" colspan="2">%(create_time)s</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" colspan="2">%(tls_editor)s:</TD>
  <TD class="td_listing1" colspan="2">%(editor)s</TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0b" colspan="2">%(tls_edittime)s:</TD>
  <TD class="td_listing0" colspan="2">%(edit_time)s</TD>
</TR>
</TABLE>
""" % ns

def folder_info(REQUEST, folder):
    if REQUEST.form.has_key('_editmeta'):
        return folder_meta(REQUEST, folder)
    elif REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, folder.get_id())
    ns = {}
    ns['full_path'] = _Utils.html_quote_show(folder.get_virtual_path())
    REQUEST.su_by_id(_Conf.SUPERUSER)
    try:
        ns['creator'] = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, folder.get('creator_id')).get_name()
    except:
        ns['creator'] = u"N/A"
    try:
        ns['editor'] = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, folder.get('editor_id')).get_name()
    except:
        ns['editor'] = u"N/A"
    REQUEST.unsu()
    ns['create_time'] = REQUEST.iso2userdatetime(REQUEST, folder.get('create_time'))
    ns['edit_time'] = REQUEST.iso2userdatetime(REQUEST, folder.get('edit_time'))
    ns['comments'] = _Utils.html_quote_show(folder.get('comments') or '')
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['tls_creator'] = REQUEST.TLS('tls_creator')
    ns['tls_createtime'] = REQUEST.TLS('tls_createtime')
    ns['tls_editor'] = REQUEST.TLS('tls_editor')
    ns['tls_edittime'] = REQUEST.TLS('tls_edittime')
    ns['tls_comments'] = REQUEST.TLS('tls_comments')
    ns['tls_info'] = REQUEST.TLS('info')
    if _Access.get_item_right(REQUEST, folder.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        ns['edit_meta'] = u"""\
<TR>
  <TD colspan="5" class="td_listing1"><FORM method="post" action="%sinfo.py"><INPUT type="hidden" name="item_id" value="%s"><INPUT class="input6" type="submit" name="_editmeta" value=" %s "></FORM></TD>
</TR>""" % (_Conf.BASE_GENERAL_URL, folder.get('item_id'), REQUEST.TLS('doc_editfilemeta'))
    else:
        ns['edit_meta'] = u""
    ns['menu'] = menu_output(REQUEST, folder)
    return """\
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1ke" nowrap>%(tls_creator)s:</TD>
  <TD class="td_listing1"  nowrap>%(creator)s</TD>
  <TD class="td_listing1ke" nowrap>%(tls_createtime)s:</TD>
  <TD class="td_listing1"  nowrap>%(create_time)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing0ke">%(tls_editor)s:</TD>
  <TD class="td_listing0">%(editor)s</TD>
  <TD class="td_listing0ke">%(tls_edittime)s:</TD>
  <TD class="td_listing0">%(edit_time)s</TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1b" colspan="5">%(tls_comments)s</TD>
</TR>
<TR>
  <TD class="td_listing0"  colspan="5">%(comments)s</TD>
</TR>
%(edit_meta)s
</TABLE>
""" % ns

def folder_meta(REQUEST, folder):
    ns = {}
    ns['full_path'] = _Utils.html_quote_show(folder.get_virtual_path())
    ns['comments'] = _Utils.html_quote(folder.get('comments')) or '&nbsp;'
    ns['tls_comments'] = REQUEST.TLS('tls_comments')
    ns['tls_name'] = REQUEST.TLS('tls_name')
    ns['folder_name'] = _Utils.html_quote_show(folder.get('item_name'))
    ns['tls_save'] = REQUEST.TLS('tls_save')
    ns['item_id'] = folder.get('item_id')
    ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    ns['BASE_GENERAL_URL'] = _Conf.BASE_GENERAL_URL
    ns['tls_info'] = REQUEST.TLS('info')
    return u"""\
<FORM method="post" action="%(BASE_GENERAL_URL)sinfo.py/save_folder">
<INPUT type="hidden" name="item_id" value="%(item_id)s">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD width="100%%"><span class="t3">%(tls_info)s</span></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=20 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1ke" nowrap>%(tls_name)s:</TD>
  <TD class="td_listing1" width="100%%">%(folder_name)s</TD>
</TR>
<TR>
  <TD class="td_listing0b" nowrap>%(tls_comments)s:</TD>
  <TD class="td_listing0"><textarea name="_comments" rows="20" cols="80" class="textarea1">%(comments)s</textarea></TD>
</TR>
<TR>
  <TD class="td_listing1b" colspan="2"><INPUT type="submit" class="input6" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>""" % ns

def save_folder(REQUEST):
    if not REQUEST.form.has_key('item_id') or not REQUEST.form['item_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_noitemid')
    fcomments = _Utils.newline2br(REQUEST.form['_comments'].value.decode('UTF8').strip())
    folder = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['item_id'].value))
    folder.set('comments', fcomments)
    folder.save()
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))
    output.append(folder_info(REQUEST, folder))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST, obj):
    output=[]
    doc_id = obj.get_id()
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL

    tls_info = REQUEST.TLS('contact_info')
    tls_relations = REQUEST.TLS('tls_relations')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_notes = REQUEST.TLS('compmenu_todo_notes')
    tls_contacts = REQUEST.TLS('topmenu_contacts')
    tls_log = REQUEST.TLS('log_log')
    tls_versions = REQUEST.TLS('tls_versions')
    relations_count = relations.relations_count(REQUEST, obj)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT count(*) FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s""" % (doc_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    note_count = REQUEST.db.fetchone()[0]

    active = 0
    if REQUEST.form.has_key('rel') and REQUEST.form['rel'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('note') and REQUEST.form['note'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('log') and REQUEST.form['log'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if obj.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT:
        if REQUEST.form.has_key('versions') and REQUEST.form['versions'].value=='1':
          active = 1
          el5 = u"""
              <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
              <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s&versions=1">%(tls_versions)s</a>&nbsp;&nbsp;&nbsp;</TD>
              <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
        else:
          el5 = u"""
              <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
              <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s&versions=1">%(tls_versions)s</a>&nbsp;&nbsp;&nbsp;</TD>
              <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
        el5 = u""
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()


    if obj.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT:
        tls_object = REQUEST.TLS('log_document_id')
    else:
        tls_object = REQUEST.TLS('log_folder_id')
    object_name =  _Utils.html_quote_show(obj.get('item_name'))
    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, obj.get('item_type_id')))
    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el5)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)




def show_log(REQUEST, obj_id):
    doc_id = obj_id
    obj = _RootObject.dispatch_item(REQUEST, obj_id)
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    output = []
    menu = menu_output(REQUEST, obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    output.append(_Log.standard_log_output(REQUEST, obj_id))
    return "\n".join(output)

def relations_contents(REQUEST):
    if not REQUEST.form.has_key('item_id') or not REQUEST.form['item_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['item_id'].value)
    obj = _RootObject.dispatch_item(REQUEST, obj_id)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    menu = menu_output(REQUEST, obj)
    output = []
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    relation_output = relations.show_relations(REQUEST, obj)
    output.append(relation_output)
    return "\n".join(output)

def notes_contents(REQUEST):
    if not REQUEST.form.has_key('item_id') or not REQUEST.form['item_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['item_id'].value)
    obj = _RootObject.dispatch_item(REQUEST, obj_id)
    output = []
    menu = menu_output(REQUEST, obj)
    menu = u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals()
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    returl = "%(BASE_GENERAL_URL)sinfo.py?item_id=%(obj_id)s&note=1" % locals()
    returl = urllib.quote(returl)
    if obj.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT:
        show_menu = "documents"
    else:
        show_menu = "folders"
    output.append(_Usernote.note_out(REQUEST, obj, obj_id, returl, menu, show_menu))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def versions_contents(REQUEST, doc):
    document_id = doc.get_id()
    if doc.get('final_version_id'):
        menu = menu_output(REQUEST, doc)
        return menu
    else:
        REQUEST.su_by_id(_Conf.SUPERUSER)
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_DOCUMENT])
        if right_param:
            right_param = " AND %s" % right_param
        SQL = u"""SELECT d.document_id FROM items i, documents d WHERE d.document_id=i.item_id AND d.final_version_id=%d%s ORDER BY create_time DESC""" % (doc.get_id(), right_param)
        REQUEST.db.execute(SQL.encode('UTF8'))
        versions = REQUEST.db.dictfetchall()
        version_output = []

        try:
            creator_name = _RootObject.dispatch_item(REQUEST, doc.get('creator_id')).get_name()
        except _Exceptions.RootObjectError:
            creator_name = u"N/A"
        REQUEST.unsu()
        BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
        BASE_ICON_URL = _Conf.BASE_ICON_URL
        BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
        doc_id = doc.get_id()
        doc_name = _Utils.html_quote_show(doc.get('title'))
        doc_size = _Utils.str_size(doc.get('item_size'))
        doc_time = REQUEST.iso2userdatetime(REQUEST, doc.get('create_time'))
        version_output.append(u"""\
  <TR>
    <TD class="td_listing0"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0"><A class="td_listing" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)d"><B>%(doc_id)d</B></A></TD>
    <TD class="td_listing0"><A class="td_listing" href="%(BASE_DOCUMENT_URL)sdocops.py/file?document_id=%(doc_id)d"><B>%(doc_name)s</B></A></TD>
    <TD class="td_listing0"><B>%(doc_size)s</B></TD>
    <TD class="td_listing0"><B>%(creator_name)s</B></TD>
    <TD class="td_listing0"><B>%(doc_time)s</B></TD>
    <TD class="td_listing0"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  </TR>""" % locals())

        n = 0
        for version in versions:
            REQUEST.su_by_id(_Conf.SUPERUSER)
            ver = _RootObject.dispatch_item(REQUEST, version['document_id'])
            try:
                creator_name = _RootObject.dispatch_item(REQUEST, ver.get('creator_id')).get_name()
            except _Exceptions.RootObjectError:
                creator_name = u"N/A"
            REQUEST.unsu()
            if(n % 2 == 1):
                cl = "td_listing0"
            else:
                cl = "td_listing1"
            doc_id = ver.get_id()
            doc_name = _Utils.html_quote_show(ver.get('title'))
            doc_size = _Utils.str_size(ver.get('item_size'))
            doc_time = REQUEST.iso2userdatetime(REQUEST, ver.get('create_time'))

            version_output.append(u"""\
  <TR>
    <TD class="td_listing0"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0"><A class="td_listing" href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(doc_id)d&give_old=1">%(doc_id)d</A></TD>
    <TD class="td_listing0"><A class="td_listing" href="%(BASE_DOCUMENT_URL)sdocops.py/file?document_id=%(doc_id)d&give_old=1">%(doc_name)s</A></TD>
    <TD class="td_listing0">%(doc_size)s</TD>
    <TD class="td_listing0">%(creator_name)s</TD>
    <TD class="td_listing0">%(doc_time)s</TD>
    <TD class="td_listing0"><input type="checkbox" name="sel_%(doc_id)s"></TD>
  </TR>""" % locals())
            n = n + 1
        vers_output = "\n".join(version_output)
        tls_versions = REQUEST.TLS('tls_versions')
        tls_title = REQUEST.TLS('tls_title')
        tls_size = REQUEST.TLS('size')
        tls_creator = REQUEST.TLS('tls_creator')
        tls_createtime = REQUEST.TLS('tls_createtime')
        BASE_ICON_URL = _Conf.BASE_ICON_URL
        menu = menu_output(REQUEST, doc)
        output = []
        output.append(u""" %(menu)s""" % locals())
        output.append(u"""\
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<FORM action="%(BASE_DOCUMENT_URL)sdocops.py" method="POST">
<input type="hidden" name="document_id" value="%(document_id)s">
  <TR>
   <TD class="td_listing1b"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
   <TD class="td_listing1b">ID</TD>
   <TD class="td_listing1b">%(tls_title)s</TD>
   <TD class="td_listing1b">%(tls_size)s</TD>
   <TD class="td_listing1b">%(tls_creator)s</TD>
   <TD class="td_listing1b">%(tls_createtime)s</TD>
   <TD class="td_listing1"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  </TR>
%(vers_output)s
""" % locals())
        tls_new_vers = REQUEST.TLS('doc_loadnewversion')
        tls_del_vers = REQUEST.TLS('doc_delversion')
        tls_prim_vers = REQUEST.TLS('doc_primeversion')
        del_out = ""
        pri_out = ""
        if _Access.get_item_right(REQUEST, doc.get_id(), REQUEST.USER.get_id()) > _Access.ACCESS_WRITE:
            pri_out = u"""<INPUT class="input6" type="submit" name="_setversion" value=" %s ">&nbsp;""" % REQUEST.TLS('doc_primeversion')
            del_out = u"""<INPUT class="input6" type="submit" name="_delversion" value=" %s " onClick="return confirm('%s');">""" % (REQUEST.TLS('doc_delversion'), REQUEST.TLS('tls_confirm_del'))

        output.append(u"""
<TR>
  <TD class="td_listing0"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="2"><INPUT class="input6" type="submit" name="_editversion" value=" %(tls_new_vers)s "></TD>
  <TD class="td_listing0" colspan="3" align="right">%(pri_out)s%(del_out)s</TD>
  <TD class="td_listing0"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>
  """ % locals())
        return "\n".join(output)

def tree_set(REQUEST):
    if not REQUEST.form.has_key("treename"):
        return " "
    treename = REQUEST.form['treename'].value.decode('UTF8')
    try: treeval = REQUEST.get_setting('tree_'+treename)
    except: treeval = []
    if REQUEST.form.has_key("open_paths"):
        path_id = int(REQUEST.form["open_paths"].value)
        REQUEST.su_by_id(_Conf.SUPERUSER)
        pathobj = _RootObject.dispatch_item(REQUEST, path_id)
        REQUEST.unsu()
        path = pathobj.get('treepos')
        if path in treeval: # Close branch
            treeval.remove(path)
            close_paths = treeval[:]
            for close_path in close_paths:
                if path == close_path[:len(path)]:
                    treeval.remove(close_path)
        else: # Open branch
            treeval.append(path)
        REQUEST.set_setting('tree_'+treename, treeval)
    return " "

