"""
Popup calendar

Requester MUST set date_result before opening window.
"""

import mx.DateTime, calendar

import _Conf, standard_html, _Utils

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append("""\
<SCRIPT LANGUAGE="JavaScript">
<!--
function return_value(val)
{
    window.opener.date_result.value=val;
    window.close();
}
// -->
</SCRIPT>""")

    real_today = _Utils.utc_now_mx()

    if REQUEST.form.has_key('date'):
        try:
            year, month, day = map(int, REQUEST.form['date'].value.split('-'))
        except:
            raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        today = mx.DateTime.Date(year, month, day)
    else:
        today = _Utils.utc_now_mx()

    if today.month == 1:
        previous_month = '%04d-%02d-01' % (today.year - 1, 12)
    else:
        previous_month = '%04d-%02d-01' % (today.year, today.month-1)
    if today.month == 12:
        next_month = '%04d-%02d-01' % (today.year + 1, 1)
    else:
        next_month = '%04d-%02d-01' % (today.year, today.month+1)
    next_year = '%04d-%02d-01' % (today.year + 1, today.month)
    previous_year = '%04d-%02d-01' % (today.year - 1, today.month)
    month_name = "%s %d" % (REQUEST.TLS('month_%d' % today.month), today.year)
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    tls_nextmonth = REQUEST.TLS('cal_nextmonth')
    tls_nextyear = REQUEST.TLS('cal_nextyear')
    tls_lastyear = REQUEST.TLS('cal_lastyear')
    tls_lastmonth = REQUEST.TLS('cal_lastmonth')
    tls_1 = REQUEST.TLS('cal_short_1')
    tls_2 = REQUEST.TLS('cal_short_2')
    tls_3 = REQUEST.TLS('cal_short_3')
    tls_4 = REQUEST.TLS('cal_short_4')
    tls_5 = REQUEST.TLS('cal_short_5')
    tls_6 = REQUEST.TLS('cal_short_6')
    tls_7 = REQUEST.TLS('cal_short_7')
    output.append(u"""\
<TABLE cellpadding=3 width="170" cellspacing=0 border=0 bgcolor="#FFFFFF" style="border: solid 1px #AAAAAA">
  <TR bgcolor="#609700">
    <TD><A href="%(BASE_GENERAL_URL)spopupcal.py?date=%(previous_year)s" style=" color: black;font-size: 8pt;font-weight: bold;" title="%(tls_lastyear)s">-</A></TD>
    <TD colspan="5" style="text-align: center; font-weight: bold; font-size: 7pt"><A href="%(BASE_GENERAL_URL)spopupcal.py?date=%(previous_month)s" style=" color: black;font-size: 8pt;" title="%(tls_lastmonth)s">&laquo;</A> %(month_name)s <A href="%(BASE_GENERAL_URL)spopupcal.py?date=%(next_month)s"  style=" color: black;font-size: 8pt;" title="%(tls_nextmonth)s">&raquo;</A></TD>
    <TD><A href="%(BASE_GENERAL_URL)spopupcal.py?date=%(next_year)s"  style=" color: black;font-size: 8pt;font-weight: bold;" title="%(tls_nextyear)s">+</A></TD>
  </TR>
  <TR bgcolor="#7BC300">
    <TD style="text-align: center; font-weight: bold; font-size: 8pt">%(tls_1)s</TD>
    <TD style="text-align: center; font-weight: bold; font-size: 8pt">%(tls_2)s</TD>
    <TD style="text-align: center; font-weight: bold; font-size: 8pt">%(tls_3)s</TD>
    <TD style="text-align: center; font-weight: bold; font-size: 8pt">%(tls_4)s</TD>
    <TD style="text-align: center; font-weight: bold; font-size: 8pt">%(tls_5)s</TD>
    <TD style="text-align: center; font-weight: bold; font-size: 8pt; color: white">%(tls_6)s</TD>
    <TD style="text-align: center; font-weight: bold; font-size: 8pt; color: white">%(tls_7)s</TD>
  </TR>
""" % locals())

    cal = calendar.monthcalendar(today.year, today.month)
    for week in cal:
        output.append(u"""<TR bgcolor="#FFFFFF">""")
        for i in range(7):
            day = week[i]
            if today.year == real_today.year and today.month == real_today.month and day == real_today.day:
                bs = ' background-color: #B2F63D;'
            else:
                bs = ''
            if day == 0:
                output.append(u"""<TD>&nbsp;</TD>""" )
            elif i == 5 or i == 6:
                thisday = mx.DateTime.Date(today.year, today.month, day)
                output.append(u"""<TD style="text-align: center; font-size: 7pt;%s"><A style=" color: red;" href="javascript:void(0);" onClick="return_value('%s');">%d</A></TD>""" % (bs, REQUEST.iso2userdate(thisday), day))
            else:
                thisday = mx.DateTime.Date(today.year, today.month, day)
                output.append(u"""<TD style="text-align: center; font-size: 7pt;%s"><A style=" color: black;" href="javascript:void(0);" onClick="return_value('%s');">%d</A></TD>""" % (bs, REQUEST.iso2userdate(thisday), day))
        output.append(u"""  </TR>""")
    output.append(u"""</TABLE>""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
