import standard_html

import _Access, _InitTypes, _Conf, _Utils

def index(REQUEST):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    tls_done = REQUEST.TLS('todo_done')
    tls_search = REQUEST.TLS('tls_search')
    tls_name = REQUEST.TLS('clients_name')
    tls_field = REQUEST.TLS('clients_area')
    tls_owner = REQUEST.TLS('client_owner')

    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
window.moveTo(0,0);

function replace_vals(ret_val, ret_name)
{
    window.opener.top.frames['topcontents'].document.forms.addform.client_id.value=ret_val; 
    window.opener.top.frames['topcontents'].document.forms.addform.client_name.value=ret_name; 
}
// -->
</SCRIPT>
""" % locals())

    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    word = ""
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CLIENT])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.form.has_key('_word') and REQUEST.form['_word'].value.strip():
      word = _Utils.sql_quote_simple(REQUEST.form['_word'].value.decode('UTF8').strip().lower())
    QUERY = """SELECT count(*) FROM clients c, items i WHERE c.client_id=i.item_id %s AND (lower(c.e_mail) like '%%%s%%' or lower(c.client_name) like '%%%s%%' or lower(c.client_nr) like '%%%s%%')""" % (right_param, word, word, word)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sclient_pop.py%sqs=" % (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sclient_pop.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sclient_pop.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_OPPORTUNITIES_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    if REQUEST.form.has_key('_word') and REQUEST.form['_word'].value.strip():
      word = _Utils.sql_quote_simple(REQUEST.form['_word'].value.decode('UTF8').strip().lower())
    SQL = """SELECT c.*, i.*, i2.item_name as creator_name FROM clients c, items i, items i2 WHERE c.client_id=i.item_id and i.creator_id=i2.item_id %s AND (lower(c.e_mail) like '%%%s%%' or lower(c.client_name) like '%%%s%%' or lower(c.client_nr) like '%%%s%%') ORDER BY client_name LIMIT %d OFFSET %d""" % (right_param, word, word, word, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    output.append(u"""
<TABLE border="0" width="100%%" cellpadding=0 cellspacing=0>
  <TR>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD class="td_listing0" colspan="3" width="100%%" align="center"><form method="POST" action="%(BASE_OPPORTUNITIES_URL)sclient_pop.py"><input name="_word" type="text" class="textfield1" value="%(word)s"> <input name="_search" class="input6" type="submit" value="%(tls_search)s"></FORM></TD>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="15" border=0 alt=""></TD>
    <TD class="td_listing1b">%(tls_name)s:</TD>
    <TD class="td_listing1b">%(tls_field)s:</TD>
    <TD class="td_listing1b">%(tls_owner)s:</TD>
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>
""" %locals())
    index = 0
    for result in dbresult:
        if(index % 2 == 0):
            td_class='td_listing0'
        else:
            td_class='td_listing1'
        index = index + 1
        ns = {}
        ns['person_name'] = _Utils.html_quote(result['client_name'].decode('UTF8'))
        ns['person_name_js'] = _Utils.html_quote_show(result['client_name'].decode('UTF8')).replace("'", r"\'").replace('"', '&quot;')
        ns['td_class'] = td_class
        ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        ns['person_email'] = result['e_mail'].decode('UTF8')
        ns['person_id'] = result['client_id']
        ns['field'] = result['client_field'].decode('UTF8') or "&nbsp;"
        ns['owner'] = result['creator_name'].decode('UTF8')
        output.append(u"""
  <TR>
    <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="15" border=0 alt=""></TD>
    <TD class="%(td_class)s"><A class="blueboldlink" href="javascript:void(0);" onClick="replace_vals('%(person_id)s', '%(person_name_js)s');window.close()";>%(person_name)s&nbsp;</A></TD>
    <TD class="%(td_class)s">%(field)s</TD>
    <TD class="%(td_class)s">%(owner)s</TD>
    <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>""" % ns)
    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
