import standard_html
import _InitTypes, _Conf, _Utils, Menus, _Log

import _Opportunity, _Client, _RootObject, _Access, _Usernote, _Person, custom_fields
import relations
import mx.DateTime
import urllib
from mod_python import apache

MY_MENU_ID = -1

def index(REQUEST):
    if not REQUEST.form.has_key('opp_id') or not REQUEST.form['opp_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    opp_id = REQUEST.form['opp_id'].value
    if REQUEST.form.has_key('_edit'):
        return edit_contents(REQUEST)
    elif REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, REQUEST.form['opp_id'].value)
    elif REQUEST.form.has_key('_delete'):
        obj = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['opp_id'].value))
        obj.delete()
        REQUEST.mod_req.headers_out["Location"] = "%sopportunities.py" % (_Conf.BASE_OPPORTUNITIES_URL)
        return apache.HTTP_MOVED_TEMPORARILY
    
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_opportunities_menu(REQUEST, MY_MENU_ID))

    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    BASE_CLIENT_URL = _Conf.BASE_CLIENT_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD

    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""

    opp_obj = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['opp_id'].value))
    opp_id = opp_obj.get_id()
    if REQUEST.form.has_key('product_id') and REQUEST.form['product_id'].value and REQUEST.form.has_key('_save'):
        product_id = int(REQUEST.form['product_id'].value)
        REQUEST.db.execute("""DELETE FROM opp_products WHERE opp_id=%(opp_id)d AND product_id=%(product_id)d""" % locals())
        try:
          amount = float(REQUEST.form['amount'].value)
        except:
          raise RuntimeError, "%s %s" % (REQUEST.TLS('opp_bad_amount'), REQUEST.form['amount'].value)
        try:
          price = float(REQUEST.form['price'].value)
        except:
          raise RuntimeError, "%s %s" % (REQUEST.TLS('opp_bad_price'), REQUEST.form['price'].value)
        opp_obj.add_product(product_id, amount, price, REQUEST.form['key_requirement'].value.decode('UTF8'))
        REQUEST.db.execute("""SELECT price, amount from opp_products WHERE opp_id=%(opp_id)d""" % locals())
        res = REQUEST.db.fetchall()
        sum = 0.0
        for row in res:
            sum = sum + row[0]*row[1]
        opp_obj.set('amount', sum)
        opp_obj.save()
    elif REQUEST.form.has_key('prod_id') and REQUEST.form['prod_id'].value and REQUEST.form.has_key('_del'):
        product_id = int(REQUEST.form['prod_id'].value)
        REQUEST.db.execute("""DELETE FROM opp_products WHERE opp_id=%(opp_id)d AND product_id=%(product_id)d""" % locals())
        REQUEST.db.execute("""SELECT price, amount from opp_products WHERE opp_id=%(opp_id)d""" % locals())
        res = REQUEST.db.fetchall()
        sum = 0.0
        for row in res:
            sum = sum + row[0]*row[1]
        opp_obj.set('amount', sum)
        opp_obj.save()
    opp_name = _Utils.html_quote(opp_obj.get('opp_name'))
    creator_id = opp_obj.get('creator_id')
    client_id = opp_obj.get('client_id')
    if client_id:
      client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(client_id))
      client_name = _Utils.html_quote_show(client_obj.get('client_name'))
      client_name = u"""<a href="%(BASE_CLIENT_URL)sclientedit.py?client_id=%(client_id)s">%(client_name)s</a>""" % locals()
    else:
      client_name = "&nbsp;"
    close_date = REQUEST.iso2userdate(opp_obj.get('close_date'))
    REQUEST.su_by_id(_Conf.SUPERUSER)
    owner = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, creator_id)
    creator_id = owner.get('item_name')
    REQUEST.unsu()

    user_lang=REQUEST.get_setting("user_language")
    clist = "_Conf.stages_" + user_lang
    stages = eval(clist)
    opp_stage = str(opp_obj.get('opp_stage'))
    stage_name = stages[opp_stage]
    if opp_stage:
      opp_stage = str(opp_stage) + "%"
    opp_type = (opp_obj.get('client_type') or "&nbsp;")
    lead_source = (opp_obj.get('lead_source') or "&nbsp;")
    if opp_obj.get('amount'):
        amount = (c_pre + str(opp_obj.get('amount') and "%.2f" % opp_obj.get('amount')) + c_suf) or ''
    else:
        amount = ''
    next_step = _Utils.html_quote(opp_obj.get('opp_next_stage')) or "&nbsp;"
    opp_lost = _Utils.html_quote_show(opp_obj.get('opp_lost')) or ""
    description = _Utils.newline2br(_Utils.html_quote(opp_obj.get('description'))) or "&nbsp;"
    req_descr = _Utils.newline2br(_Utils.html_quote(opp_obj.get('req_descr'))) or "&nbsp;"



    
    tls_opportunities = REQUEST.TLS('topmenu_opportunities')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_name = REQUEST.TLS('tls_name')
    tls_type = REQUEST.TLS('clients_type')
    tls_client = REQUEST.TLS('opp_client')
    tls_owner = REQUEST.TLS('client_owner')
    tls_nextstep = REQUEST.TLS('opp_nextstep')
    tls_stage = REQUEST.TLS('opp_stage')
    tls_probability = REQUEST.TLS('opp_probability')
    tls_closedate = REQUEST.TLS('opp_date')
    tls_amount = REQUEST.TLS('opp_amount')
    tls_lead = REQUEST.TLS('opp_source')
    tls_description = REQUEST.TLS('tls_description')
    tls_req = REQUEST.TLS('opp_req_desc')
    tls_lost_reason = REQUEST.TLS('opp_lost_reason')
    tls_edit = REQUEST.TLS('tls_edit')
    tls_delete = REQUEST.TLS('tls_delete')
    tls_confirm_del = REQUEST.TLS('tls_confirm_del')
    tls_del_short = REQUEST.TLS('email_short_del')
    tls_save = REQUEST.TLS('tls_save')
    tls_group = REQUEST.TLS('tls_group')
    tls_unit = REQUEST.TLS('prod_unit')
    tls_price = REQUEST.TLS('prod_price')
    tls_discount = REQUEST.TLS('prod_discount')
    tls_amnt = REQUEST.TLS('prod_amount')
    tls_key_req = REQUEST.TLS('prod_key_req')
    tls_action = REQUEST.TLS('email_action')
    tls_products = REQUEST.TLS('topmenu_products')
    tls_add_product = REQUEST.TLS('prod_add')
    tls_opp_lost = REQUEST.TLS('opp_lost_reason')
    datecheck_js = REQUEST.datecheck_js(REQUEST)

    if opp_lost:
      opp_lost = u"""
  <TR class="tr_listing1" valign="top">
    <TD class="td_listing1b" colspan="2">%(tls_opp_lost)s:</TD>
    <TD class="td_listing1" colspan="2">%(opp_lost)s</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>""" % locals()
    c_fields = custom_fields.get_object_show_fields(REQUEST, opp_obj, 0)
    menu = menu_output(REQUEST, opp_obj)
    output.append(standard_html.window_script(height=500,width=500))
    output.append("""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="editform" method="POST" action="%(BASE_OPPORTUNITIES_URL)soppedit.py">
<INPUT type="hidden" name="opp_id" value="%(opp_id)s">
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=100 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=150 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=100 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=150 height=1 border=0 alt=""></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1kv" nowrap>%(tls_name)s:</TD>
    <TD class="td_listing1vv"  nowrap>%(opp_name)s</TD>
    <TD class="td_listing1kv" nowrap>%(tls_owner)s:</TD>
    <TD class="td_listing1vv"  nowrap>%(creator_id)s</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0kv" nowrap>%(tls_client)s:</TD>
    <TD class="td_listing0vv"  nowrap>%(client_name)s&nbsp;</TD>
    <TD class="td_listing0kv" nowrap>%(tls_closedate)s:</TD>
    <TD class="td_listing0vv"  nowrap>%(close_date)s&nbsp;</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1kv" nowrap>%(tls_stage)s:</TD>
    <TD class="td_listing1vv"  nowrap>%(stage_name)s&nbsp;</TD>
    <TD class="td_listing1kv" nowrap>%(tls_probability)s:</TD>
    <TD class="td_listing1vv"  nowrap>%(opp_stage)s&nbsp;</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0kv" nowrap>%(tls_type)s:</TD>
    <TD class="td_listing0vv"  nowrap>%(opp_type)s&nbsp;</TD>
    <TD class="td_listing0kv" nowrap>%(tls_lead)s:</TD>
    <TD class="td_listing0vv"  nowrap>%(lead_source)s&nbsp;</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1kv" nowrap>%(tls_amount)s:</TD>
    <TD class="td_listing1vv"  nowrap>%(amount)s&nbsp;</TD>
    <TD class="td_listing1kv" nowrap>%(tls_nextstep)s:</TD>
    <TD class="td_listing1vv"  nowrap>%(next_step)s&nbsp;</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0" valign="top">
    <TD class="td_listing0kv">%(tls_description)s:</TD>
    <TD class="td_listing0vv">%(description)s</TD>
    <TD class="td_listing0kv">%(tls_req)s:</TD>
    <TD class="td_listing0vv">%(req_descr)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
%(opp_lost)s""" % locals())
    if _Access.get_item_right(REQUEST, opp_obj.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        output.append(u"""
%(c_fields)s
  <TR class="tr_listing0">
    <TD class="td_listing0" colspan="2"><INPUT type="submit" name="_edit" value="%(tls_edit)s" class="input2"></TD>
    <TD class="td_listing0" colspan="2" align="right"><INPUT type="submit" name="_delete" value="%(tls_delete)s" onclick="return confirm('%(tls_confirm_del)s');" class="input2">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    else:
        output.append(u"""
</TABLE>
</FORM>"""%locals())
    output.append(u"""
<br>
<br>
<SCRIPT TYPE="text/javascript">
function calc(numb)
{
  if(numb=="1")
  {
    base_price_obj = document.forms['prodform'].base_price;
    base_price = base_price_obj.value;
    price_obj = document.forms['prodform'].price;
    price = price_obj.value;
    chk = price.match(/^\d+$/);
    if(chk)
    {
      discount = Math.round((1-price/base_price)*100);
      document.forms['prodform'].discount.value=discount;
    }
  }
  else
  {
    base_price_obj = document.forms['prodform'].base_price;
    base_price = base_price_obj.value;
    disc_obj = document.forms['prodform'].discount;
    disc = disc_obj.value;
    chk = disc.match(/^\d+$/);
    if(chk)
    {
      if(disc>0)
        price = Math.round(base_price*(1-disc/100));
      else
        price = base_price;
      document.forms['prodform'].price.value=price;
    }
  }
}
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
  <TD nowrap><span class="t3">%(tls_products)s</span></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=100 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=100 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=60 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=60 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=60 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=60 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=80 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=60 height=1 border=0 alt=""></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b">%(tls_name)s</TD>
  <TD class="td_listing1b">%(tls_group)s</TD>
  <TD class="td_listing1b">%(tls_unit)s</TD>
  <TD class="td_listing1b">%(tls_price)s</TD>
  <TD class="td_listing1b" nowrap>%(tls_discount)s %%</TD>
  <TD class="td_listing1b">%(tls_amnt)s</TD>
  <TD class="td_listing1b" nowrap>%(tls_key_req)s</TD>
  <TD class="td_listing1b">%(tls_action)s</TD>
  <TD class="td_listing1b" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())

    REQUEST.db.execute("""SELECT o.*, p.* FROM opp_products o, products p WHERE o.opp_id=%(opp_id)d and o.product_id=p.product_id order by product_name""" % locals())
    dbres = REQUEST.db.dictfetchall()
    index = 0
    for row in dbres:
        if index%2==0:
          cla = "0"
        else:
          cla = "1"
        index += 1
        if REQUEST.form.has_key('prod_id') and int(REQUEST.form['prod_id'].value)== row['product_id']:
            product_id = int(row['product_id'])
            product_name = _Utils.html_quote(row['product_name'].decode('UTF8')) or "&nbsp;"
            product_group = _Utils.html_quote(row['product_group'].decode('UTF8')) or "&nbsp;"
            product_unit = _Utils.html_quote(row['product_unit'].decode('UTF8')) or ""
            price = (float(row['price'] and "%.2f" % row['price'] or 0)) or ""
            amount = int(row['amount']) or ""
            base_price = (float(row['product_price'] and "%.2f" % row['product_price'] or 0)) or ""
            if not isinstance(price, str) and not isinstance(base_price, str):
                discount = int(round((1-price/base_price)*100))
            else:
                discount = ""
            price = (row['price'] and "%.2f" % row['price']) or ""

            key_requirement = _Utils.make_setting_selection(REQUEST, None, 'key_requirement', 'opportunity_key_requirement', is_multiple=0, selected=row['key_requirement'], style="textfield4")
            output.append(u"""
<FORM method="post" action="%(BASE_OPPORTUNITIES_URL)soppedit.py" name="prodform">
<input type="hidden" name="opp_id" value="%(opp_id)s">
<input type="hidden" name="product_id" value="%(product_id)s">
<input type="hidden" name="base_price" value="%(base_price)s">
<TR class="tr_listing%(cla)s">
  <TD class="td_listing%(cla)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(cla)s">%(product_name)s</TD>
  <TD class="td_listing%(cla)s">%(product_group)s</TD>
  <TD class="td_listing%(cla)s">%(product_unit)s</TD>
  <TD class="td_listing%(cla)s" nowrap>%(c_pre)s <input type="text" class="textfield1" size="5" name="price" onchange="calc('1');" value="%(price)s"> %(c_suf)s</TD>
  <TD class="td_listing%(cla)s"><input type="text" class="textfield1" size="2" name="discount" onchange="calc('2');" value="%(discount)s"> %%</TD>
  <TD class="td_listing%(cla)s"><input type="text" class="textfield1" size="3" name="amount" value="%(amount)s"></TD>
  <TD class="td_listing%(cla)s" nowrap>%(key_requirement)s</TD>
  <TD class="td_listing%(cla)s" nowrap align="center"><input type="submit" class="input6" value="%(tls_save)s" name="_save"></TD>
  <TD class="td_listing%(cla)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</FORM>""" % locals())
        else:
            product_id = int(row['product_id'])
            product_name = _Utils.html_quote_show(row['product_name'].decode('UTF8')) or "&nbsp;"
            product_group = _Utils.html_quote_show(row['product_group'].decode('UTF8')) or "&nbsp;"
            product_unit = _Utils.html_quote_show(row['product_unit'].decode('UTF8')) or "&nbsp;"
            amount = int(row['amount']) or "&nbsp;"
            price = (float(row['price'] and "%.2f" % row['price'])) or "&nbsp;"
            base_price = (float(row['product_price'] and "%.2f" % row['product_price'] or 0)) or "&nbsp;"
            if not isinstance(price, str) and not isinstance(base_price, str):
                discount = str(int(round((1-price/base_price)*100))) + "%"
            else:
                discount = "&nbsp;"
            price = (c_pre + str(row['price'] and "%.2f" % row['price']) + c_suf) or ""
            key_requirement = _Utils.html_quote_show(row['key_requirement'].decode('UTF8')) or "&nbsp;"
            if _Access.get_item_right(REQUEST, int(opp_id), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
                actrow = u"""<a href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s&prod_id=%(product_id)s&edit=1">%(tls_edit)s</A> | <a href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s&prod_id=%(product_id)s&_del=1">%(tls_del_short)s</A>""" % locals()
            else:
                actrow = u"&nbsp;"
            output.append(u"""
<TR class="tr_listing%(cla)s">
  <TD class="td_listing%(cla)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(cla)s">%(product_name)s</TD>
  <TD class="td_listing%(cla)s">%(product_group)s</TD>
  <TD class="td_listing%(cla)s">%(product_unit)s</TD>
  <TD class="td_listing%(cla)s">%(price)s</TD>
  <TD class="td_listing%(cla)s">%(discount)s</TD>
  <TD class="td_listing%(cla)s">%(amount)s</TD>
  <TD class="td_listing%(cla)s" nowrap>%(key_requirement)s</TD>
  <TD class="td_listing%(cla)s" nowrap align="center">%(actrow)s</TD>
  <TD class="td_listing%(cla)s" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
""" % locals())
    if not REQUEST.form.has_key('edit'):
      if _Access.get_item_right(REQUEST, int(opp_id), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
          output.append(u"""
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="8"><input type="button" class="input6" value="%(tls_add_product)s" onclick="open_window('%(BASE_OPPORTUNITIES_URL)sprod_pop.py?opp_id=%(opp_id)s')"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
      else:
          output.append(u"""
<TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="8">&nbsp;</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    
    output.append(u"</TABLE><BR>")
    output.append(_Log.status_log_output(REQUEST, opp_id))
    output.append("<BR>")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_contents(REQUEST):
    if not REQUEST.form.has_key('opp_id') or not REQUEST.form['opp_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    opp_id = REQUEST.form['opp_id'].value
    
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(Menus.get_opportunities_menu(REQUEST, MY_MENU_ID))

    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD

    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""

    opp_obj = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['opp_id'].value))
    opp_id = opp_obj.get_id()
    opp_name = _Utils.html_quote(opp_obj.get('opp_name'))
    creator_id = opp_obj.get('creator_id')

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT p.* FROM persons p, items i WHERE p.person_id=i.item_id %s ORDER BY p.first_name, p.last_name""" % (right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    creator_name = u"""<SELECT name="creator_name">"""
    for row in dbres:
        if row['person_id'] == creator_id:
          sel = " SELECTED"
        else:
          sel = ""
        creator_name += """<option value="%s"%s>%s %s</option>""" % (row['person_id'], sel, row['first_name'].decode('UTF8'), row['last_name'].decode('UTF8'))
    creator_name += u"""</SELECT>"""

    client_id = opp_obj.get('client_id')
    if client_id:
      client_obj = _Client.Client(REQUEST, _InitTypes.INIT_TYPE_ID, int(client_id))
      client_name = _Utils.html_quote(client_obj.get('client_name'))
    else:
      client_name = "&nbsp;"
    close_date = REQUEST.iso2userdate(opp_obj.get('close_date'))

    user_lang=REQUEST.get_setting("user_language")
    clist = "_Conf.stages_" + user_lang
    stages = eval(clist)
    opp_stage = str(opp_obj.get('opp_stage'))
    stage_name = stages[opp_stage]

    def kala(a,b):
      if a=='':
        return -1
      elif b=='':
        return 1
      elif int(a)==0:
        return 1
      elif int(b)==0:
        return -1
      elif int(a)>int(b):
        return 1
      else:
        return -1

    user_lang=REQUEST.get_setting("user_language")
    clist = "_Conf.stages_" + user_lang
    stages = eval(clist)
    stage = u"""<select name="opp_stage" onchange="prob(this.value)" class="textfield4">"""
    keys = stages.keys()
    keys.sort(kala)
    for key in keys:
      if key==opp_stage:
          stage = stage + u"""<option value="%s" SELECTED>%s</option>""" % (key, stages[key])
      else:
          stage = stage + u"""<option value="%s">%s</option>""" % (key, stages[key])
    stage = stage + u"""</select>"""

    opp_type = opp_obj.get('client_type') or ""
    lead_source = opp_obj.get('lead_source') or ""
    opp_lost = opp_obj.get('opp_lost') or ""

    client_type = _Utils.make_setting_selection(REQUEST, None, 'client_type', 'opportunity_client_type', is_multiple=0, selected=opp_type, style="textfield4")
    lead_source = _Utils.make_setting_selection(REQUEST, None, 'lead_source', 'opportunity_lead_source', is_multiple=0, selected=lead_source, style="textfield4")
    lost_reason = _Utils.make_setting_selection(REQUEST, None, 'opp_lost', 'opportunity_lost_reason', is_multiple=0, selected=opp_lost, style="textfield4")

    
    amount = (opp_obj.get('amount') and "%.2f" % opp_obj.get('amount')) or ""
    next_step = _Utils.html_quote_edit(opp_obj.get('opp_next_stage') or "")
    description = _Utils.html_quote(opp_obj.get('description') or "")
    req_descr = _Utils.html_quote(opp_obj.get('req_descr') or "")


    
    tls_opportunities = REQUEST.TLS('topmenu_opportunities')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_name = REQUEST.TLS('tls_name')
    tls_type = REQUEST.TLS('clients_type')
    tls_client = REQUEST.TLS('opp_client')
    tls_owner = REQUEST.TLS('client_owner')
    tls_nextstep = REQUEST.TLS('opp_nextstep')
    tls_stage = REQUEST.TLS('opp_stage')
    tls_probability = REQUEST.TLS('opp_probability')
    tls_closedate = REQUEST.TLS('opp_date')
    tls_amount = REQUEST.TLS('opp_amount')
    tls_lead = REQUEST.TLS('opp_source')
    tls_description = REQUEST.TLS('tls_description')
    tls_req = REQUEST.TLS('opp_req_desc')
    tls_lost_reason = REQUEST.TLS('opp_lost_reason')
    tls_edit = REQUEST.TLS('tls_edit')
    tls_save = REQUEST.TLS('tls_save')
    tls_choose = REQUEST.TLS('email_choose')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    
    vis = " none;"
    if opp_lost or opp_stage=="0":
        vis = " block;"

    menu = menu_output(REQUEST, opp_obj)
    output.append(standard_html.window_script(height=500,width=500))
    c_fields = custom_fields.get_object_edit_fields(REQUEST, opp_obj, 0)

    output.append(u"""
<SCRIPT type="text/JavaScript">
<!--
function check_values()
{
  if (!document.addform.opp_name.value||!document.addform.creator_name.value||!document.addform.client_id.value||!document.addform.close_date.value||document.addform.opp_stage.value=="")
  {
    alert("%(tls_missing_input)s");
    return false;
  }
  return true;
}
function prob(val)
{
  el1 = document.getElementById('91');
  if(val=="0")
  {
    el1.style.display='block';
  }
  else
  {
    el1.style.display='none';
  }
  document.forms['addform'].probability.value=val;
}
function cal_popup(url, fieldname)
{
    window.date_result = document.addform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
%(datecheck_js)s
// -->
</SCRIPT>
<FORM name="addform" method="POST" action="%(BASE_OPPORTUNITIES_URL)soppedit.py/edit" onsubmit="return check_values();">
<input type="hidden" name="opp_id" value="%(opp_id)s">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
  %(menu)s
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="opp_name" value="%(opp_name)s"></TD>
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_owner)s:</TD>
  <TD class="td_listing1ve">%(creator_name)s</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(REQ_FIELD)s%(tls_client)s:</TD>
  <TD class="td_listing0ve"><INPUT type="hidden" name="client_id" value="%(client_id)s"><INPUT type="text" class="textfield1" size="15" readonly name="client_name" value="%(client_name)s"> <input type="button" class="input6" value="%(tls_choose)s" onclick="open_window('%(BASE_OPPORTUNITIES_URL)sclient_pop.py')"></TD>
  <TD class="td_listing0ke">%(REQ_FIELD)s%(tls_closedate)s:</TD>
  <TD class="td_listing0ve"><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="close_date" id="close_date" value="%(close_date)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('close_date', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_stage)s:</TD>
  <TD class="td_listing1ve">%(stage)s</TD>
  <TD class="td_listing1ke">%(tls_probability)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4_readonly" size=2 name="probability" value="%(opp_stage)s">%%</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_type)s:</TD>
  <TD class="td_listing0ve">%(client_type)s</TD>
  <TD class="td_listing0ke">%(tls_lead)s:</TD>
  <TD class="td_listing0ve">%(lead_source)s</TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(tls_amount)s:</TD>
  <TD class="td_listing1ve" nowrap>%(c_pre)s <INPUT type="text" class="textfield4" name="amount" value="%(amount)s"> %(c_suf)s</TD>
  <TD class="td_listing1ke">%(tls_nextstep)s:</TD>
  <TD class="td_listing1ve"><INPUT type="text" class="textfield4" name="opp_next_stage" value="%(next_step)s"></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0" valign="top">
  <TD class="td_listing0b" colspan="2">%(tls_description)s<BR><TEXTAREA class="textarea5" name="description" rows="8" cols="40">%(description)s</TEXTAREA></TD>
  <TD class="td_listing0b" colspan="2">%(tls_req)s<BR><TEXTAREA class="textarea5" name="req_descr" rows="8" cols="40">%(req_descr)s</TEXTAREA></TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD colspan="5">
  <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0" style="display: %(vis)s" id="91">
    <TR class="tr_listing1">
      <TD class="td_listing1ke" nowrap>%(tls_lost_reason)s:</TD>
      <TD class="td_listing1ve" nowrap>%(lost_reason)s</TD>
      <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    </TR>
  </TABLE>
  </TD>
</TR>
%(c_fields)s
<TR class="tr_listing0">
  <TD class="td_listing_noborder" colspan="4"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)


def edit(REQUEST):
    if not REQUEST.form.has_key('opp_id') or not REQUEST.form['opp_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')


    opp_obj = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['opp_id'].value))

    if not (REQUEST.form.has_key('opp_name') and REQUEST.form['opp_name'].value.decode('UTF8').strip() and REQUEST.form.has_key('creator_name') and REQUEST.form['creator_name'].value.decode('UTF8').strip() and REQUEST.form.has_key('client_id') and REQUEST.form['client_id'].value.decode('UTF8').strip() and REQUEST.form.has_key('close_date') and REQUEST.form['close_date'].value.decode('UTF8').strip()):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    opp_obj.load_req()
    opp_obj.set('amount', float(REQUEST.form['amount'].value.strip() or 0))
    opp_obj.set('close_date', REQUEST.user2isodate(REQUEST, REQUEST.form['close_date'].value))
    opp_obj.__itemdata__['creator_id'] =  int(REQUEST.form['creator_name'].value)
    opp_obj.save()
    custom_fields.save_custom_vals(REQUEST, opp_obj.get_id())

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = _Conf.BASE_OPPORTUNITIES_URL + 'oppedit.py?opp_id=%s' % opp_obj.get_id()
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_opportunities_menu(REQUEST, MY_MENU_ID))
    output.append(REQUEST.TLS('opp_saved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def relations_contents(REQUEST):
    if not REQUEST.form.has_key('opp_id') or not REQUEST.form['opp_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    opp_id = REQUEST.form['opp_id'].value
    opp_obj = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['opp_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_opportunities_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, opp_obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    relation_output = relations.show_relations(REQUEST, opp_obj)
    output.append(relation_output)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def notes_contents(REQUEST):
    if not REQUEST.form.has_key('opp_id') or not REQUEST.form['opp_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['opp_id'].value)
    obj = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['opp_id'].value))
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_opportunities_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    menu = u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals()
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    returl = "%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(obj_id)s&note=1" % locals()
    returl = urllib.quote(returl)
    show_menu = "opp"
    output.append(_Usernote.note_out(REQUEST, obj, obj_id, returl, menu, show_menu))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST, opp_obj):
    if not REQUEST.form.has_key('opp_id') or not REQUEST.form['opp_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output=[]
    opp_id = int(REQUEST.form['opp_id'].value)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL

    tls_viewclient = REQUEST.TLS('clients_view')
    tls_info = REQUEST.TLS('contact_info')
    tls_relations = REQUEST.TLS('tls_relations')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_notes = REQUEST.TLS('compmenu_todo_notes')
    tls_log = REQUEST.TLS('log_log')
    relations_count = relations.relations_count(REQUEST, opp_obj)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT count(*) FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s""" % (opp_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    note_count = REQUEST.db.fetchone()[0]

    active = 0
    if REQUEST.form.has_key('rel') and REQUEST.form['rel']=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('note') and REQUEST.form['note']=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('log') and REQUEST.form['log'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()


    tls_object = REQUEST.TLS('opp_long')
    object_name = _Utils.html_quote_show(opp_obj.get('item_name'))
    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, opp_obj.get('item_type_id')))
    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)

def show_log(REQUEST, obj_id):
    obj = _Opportunity.Opportunity(REQUEST, _InitTypes.INIT_TYPE_ID, int(obj_id))
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_opportunities_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    output.append(_Log.standard_log_output(REQUEST, obj_id))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
