MY_MENU_ID=0

import _Conf, standard_html
from Menus import get_opportunities_menu
import _Opportunity, _InitTypes, _Utils, _Access

def index(REQUEST):
    output = []
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_OPPORTUNITIES_URL = _Conf.BASE_OPPORTUNITIES_URL
    tls_overview = REQUEST.TLS('tls_overview')
    tls_top = REQUEST.TLS('opp_top')
    tls_reptop = REQUEST.TLS('opp_rep_top')
    tls_amount = REQUEST.TLS('opp_amount')
    tls_owner = REQUEST.TLS('client_owner')
    output.append(standard_html.html_header(REQUEST))
    output.append(get_opportunities_menu(REQUEST, MY_MENU_ID))
    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_19.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_overview)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="100%%">&nbsp;</TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())
    
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_OPPORTUNITY])
    if right_param:
        right_param = " AND " + right_param
    
    # TOP OPPS
    
    SQL = """SELECT o.*, i2.item_name as creator_name from opportunities o, items i, items i2 WHERE o.opp_id=i.item_id and i.creator_id=i2.item_id AND o.opp_stage>0 AND o.opp_stage<100 and amount IS NOT NULL %s ORDER BY amount desc LIMIT 5""" % right_param
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    if dbres:
        
        top_amount = dbres[0]['amount']
        output.append(u"""
<BR>
<TABLE border="0" cellpadding="0" cellspacing="0" align="center">
<TR>
  <TD colspan="2" style="font-weight: bold; font-size: 16px; text-align: center">%(tls_top)s</TD>
</TR>
<TR>
  <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="10" border="0" alt=""></TD>
</TR>
""" % locals())
        for row in dbres:
            if not row['amount']:
                continue
            opp_length = row['amount']/top_amount*200
            opp_height = 8
            opp_name = row['opp_name'].decode('UTF8')
            opp_amount = (c_pre + str(row['amount'] and "%.2f" % row['amount']) + c_suf) or ''
            opp_owner = row['creator_name'].decode('UTF8')
            title = "%s: %s, %s: %s" % (tls_owner, opp_owner, tls_amount, opp_amount)
            opp_id = row['opp_id']
            output.append(u"""
<TR>
  <TD class="td_listing0_noborder" style="text-align:right;font-weight: bold;"><a href="%(BASE_OPPORTUNITIES_URL)soppedit.py?opp_id=%(opp_id)s" class="blackboldlink">%(opp_name)s</a></TD>
  <TD class="td_listing0_noborder" nowrap><img title="%(title)s" src="%(BASE_ICON_URL)sred_bg1.png" width="%(opp_length)s" height="%(opp_height)s" border="0" alt="" style="border: 1px solid #D62F29">&nbsp;&nbsp;%(opp_amount)s</TD>
</TR>
<TR>
  <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="5" border="0" alt=""></TD>
</TR>""" % locals())
        output.append(u"""</TABLE><BR>""")
    
    # TOP PPL
    
    SQL = """SELECT i2.item_name, coalesce(sum(amount),0) as sold FROM opportunities o, items i, items i2 WHERE o.opp_stage>0 and o.opp_stage<100 and o.opp_id = i.item_id and i.creator_id = i2.item_id %s GROUP BY i2.item_name order by sold desc """ % (right_param)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    if dbres:
        top_amount = dbres[0]['sold']
        output.append(u"""
<BR>
<BR>
<TABLE border="0" cellpadding="0" cellspacing="0" align="center">
<TR>
  <TD colspan="2" style="font-weight: bold; font-size: 16px; text-align: center">%(tls_reptop)s</TD>
</TR>
<TR>
  <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="10" border="0" alt=""></TD>
</TR>
""" % locals())
        for row in dbres:
            if not row['sold']:
                continue
            opp_length = row['sold']/top_amount*200
            opp_height = 8
            opp_amount = (c_pre + str(row['sold'] and "%.2f" % row['sold']) + c_suf) or ''
            opp_owner = row['item_name'].decode('UTF8')
            output.append(u"""
<TR>
  <TD class="td_listing0_noborder" style="text-align:right;font-weight: bold;">%(opp_owner)s</a></TD>
  <TD class="td_listing0_noborder" nowrap><img title="%(opp_amount)s" src="%(BASE_ICON_URL)sred_bg1.png" width="%(opp_length)s" height="%(opp_height)s" border="0" alt="" style="border: 1px solid #D62F29">&nbsp;&nbsp;%(opp_amount)s</TD>
</TR>
<TR>
  <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="5" border="0" alt=""></TD>
</TR>""" % locals())
        output.append(u"""</TABLE>""")
    
    
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)