MY_MENU_ID=1

from mod_python import apache

import _Conf, standard_html
from Menus import get_products_menu
import _Product, _InitTypes, _Utils, urllib, relations, custom_fields

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))
    
    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_addproduct = REQUEST.TLS('prod_add')
    tls_name = REQUEST.TLS('prod_name')
    tls_group = REQUEST.TLS('prod_group')
    tls_unit = REQUEST.TLS('prod_unit')
    tls_price = REQUEST.TLS('prod_price')
    tls_description = REQUEST.TLS('tls_description')
    tls_save = REQUEST.TLS('tls_save')
    product_group = _Utils.make_setting_selection(REQUEST, None, 'product_group', 'product_groups', is_multiple=0, selected="", style="textfield4")
    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""

    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      returl = REQUEST.form['returl'].value
    else:
      returl = ""
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = REQUEST.form['rel_id'].value
    else:
      rel_id = ""

    c_fields = custom_fields.get_object_search_fields(REQUEST, REQUEST.USER.get_parent(REQUEST).get_top_parent().get_id(), _InitTypes.ITEM_TYPE_PRODUCT, 1)
    output.append(u"""
<SCRIPT type="text/JavaScript">
<!--
  function check_values()
  {
    if (!document.addform.product_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_0.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_addproduct)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_PRODUCTS_URL)saddproduct.py/add" onsubmit="return check_values();">
<INPUT type="hidden" name="returl" value="%(returl)s">
<INPUT type="hidden" name="rel_id" value="%(rel_id)s">
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
  <TD class="td_listing1ve" nowrap><INPUT type="text" class="textfield4" name="product_name" value=""></TD>
  <TD class="td_listing1ke" nowrap>%(tls_group)s:</TD>
  <TD class="td_listing1ve" nowrap>&nbsp;&nbsp;&nbsp;%(product_group)s&nbsp;</TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_unit)s:</TD>
  <TD class="td_listing0ve" nowrap><INPUT type="text" class="textfield4" name="product_unit" value=""></TD>
  <TD class="td_listing0ke" nowrap>%(tls_price)s:</TD>
  <TD class="td_listing0ve" nowrap>%(c_pre)s&nbsp;<INPUT type="text" class="textfield4" name="product_price" value="">&nbsp;%(c_suf)s</TD>
  <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1" valign="top">
  <TD class="td_listing1b" colspan="4">%(tls_description)s<BR><TEXTAREA class="textarea1" name="description" rows="8" cols="40"></TEXTAREA></TD>
  <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
%(c_fields)s
<TR class="tr_listing0">
  <TD class="td_listing_noborder" colspan="4"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def add(REQUEST):
    output = []
    if REQUEST.form.has_key('product_name') and REQUEST.form['product_name'].value.decode('UTF8').strip():
        product = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_REQ)
        product.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
        product.save()
        custom_fields.save_custom_vals(REQUEST, product.get_id())
        product_id = product.get_id()
        output.append(standard_html.html_header(REQUEST))
        output.append(get_products_menu(REQUEST, MY_MENU_ID))
        output.append(REQUEST.TLS('product_saved'))
        if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
          rel_id = int(REQUEST.form['rel_id'].value)
          relations.add_relation(REQUEST, rel_id, product_id)
        if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
            REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
            return apache.HTTP_MOVED_TEMPORARILY
        else:
            ref_url = REQUEST.SERVER_URL+_Conf.BASE_PRODUCTS_URL+"editproduct.py?product_id="+str(product_id)
            output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
