MY_MENU_ID=-1

import _Conf, standard_html
from Menus import get_products_menu
import _Product, _InitTypes, _Utils, relations, _Access, _Log, _Usernote, relations, calendar, urllib, custom_fields
import mx.DateTime

def index(REQUEST):
    if not REQUEST.form.has_key('product_id') or not REQUEST.form['product_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))
    
    if REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, REQUEST.form['product_id'].value)
    elif REQUEST.form.has_key('reports'):
        return show_reports(REQUEST)
    
    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_editproduct = REQUEST.TLS('prod_edit')
    tls_name = REQUEST.TLS('prod_name')
    tls_group = REQUEST.TLS('prod_group')
    tls_unit = REQUEST.TLS('prod_unit')
    tls_price = REQUEST.TLS('prod_price')
    tls_description = REQUEST.TLS('tls_description')
    tls_save = REQUEST.TLS('tls_save')
    product_obj = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['product_id'].value))
    product_id = product_obj.get_id()

    product_name = _Utils.html_quote(product_obj.get('product_name'))
    product_group = _Utils.html_quote(product_obj.get('product_group') or '')
    product_unit = _Utils.html_quote(product_obj.get('product_unit') or '')
    product_price = (product_obj.get('product_price') and "%.2f" % product_obj.get('product_price')) or ''
    description = _Utils.html_quote(product_obj.get('description') or '')
    product_group = _Utils.make_setting_selection(REQUEST, None, 'product_group', 'product_groups', is_multiple=0, selected=product_group, style="textfield4")

    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""
    menu = menu_output(REQUEST, product_obj)
    c_fields = custom_fields.get_object_edit_fields(REQUEST, product_obj, 1)
    output.append(u"""
<SCRIPT type="text/JavaScript">
<!--
  function check_values()
  {
    if (!document.addform.product_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR class="tr_listing0">
    <TD>%(menu)s</TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_PRODUCTS_URL)seditproduct.py/edit" onsubmit="return check_values();">
<input type="hidden" name="product_id" value="%(product_id)s">
<TR class="tr_listing1">
  <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_name)s:</TD>
  <TD class="td_listing1ve" nowrap><INPUT type="text" class="textfield4" name="product_name" value="%(product_name)s"></TD>
  <TD class="td_listing1ke" nowrap>%(tls_group)s:</TD>
  <TD class="td_listing1ve" nowrap>&nbsp;&nbsp;%(product_group)s&nbsp;</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0ke" nowrap>%(tls_unit)s:</TD>
  <TD class="td_listing0ve" nowrap><INPUT type="text" class="textfield4" name="product_unit" value="%(product_unit)s"></TD>
  <TD class="td_listing0ke" nowrap>%(tls_price)s:</TD>
  <TD class="td_listing0ve" nowrap>%(c_pre)s&nbsp;<INPUT type="text" class="textfield4" name="product_price" value="%(product_price)s">&nbsp;%(c_suf)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1" valign="top">
  <TD class="td_listing1b" colspan="4">%(tls_description)s<BR><TEXTAREA class="textarea1" name="description" rows="8" cols="40">%(description)s</TEXTAREA></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
%(c_fields)s
<TR class="tr_listing0">
  <TD class="td_listing_noborder" colspan="4"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def edit(REQUEST):
    if not REQUEST.form.has_key('product_id') or not REQUEST.form['product_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))

    product_obj = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['product_id'].value))

    if not REQUEST.form.has_key('product_name') or not REQUEST.form['product_name'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    product_obj.load_req()
    product_obj.save()
    custom_fields.save_custom_vals(REQUEST, product_obj.get_id())

    ref_url = REQUEST.SERVER_URL+_Conf.BASE_PRODUCTS_URL+"editproduct.py?product_id="+str(product_obj.get_id())
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(REQUEST.TLS('product_saved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def relations_contents(REQUEST):
    if not REQUEST.form.has_key('product_id') or not REQUEST.form['product_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['product_id'].value)
    obj = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_ID, obj_id)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    relation_output = relations.show_relations(REQUEST, obj)
    output.append(relation_output)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def notes_contents(REQUEST):
    if not REQUEST.form.has_key('product_id') or not REQUEST.form['product_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['product_id'].value)
    obj = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_ID, obj_id)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    menu = u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals()
    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL
    returl = "%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(obj_id)s&note=1" % locals()
    returl = urllib.quote(returl)
    show_menu = "products"
    output.append(_Usernote.note_out(REQUEST, obj, obj_id, returl, menu, show_menu))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def show_log(REQUEST, obj_id):
    obj = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_ID, int(obj_id))
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    output.append(_Log.standard_log_output(REQUEST, obj_id))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST, product_obj):
    if not REQUEST.form.has_key('product_id') or not REQUEST.form['product_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output=[]
    product_id = int(REQUEST.form['product_id'].value)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL

    tls_info = REQUEST.TLS('prod_edit')
    tls_relations = REQUEST.TLS('tls_relations')
    tls_notes = REQUEST.TLS('compmenu_todo_notes')
    tls_log = REQUEST.TLS('log_log')
    tls_reports = REQUEST.TLS('rep_reports')
    relations_count = relations.relations_count(REQUEST, product_obj)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT count(*) FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s""" % (product_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    note_count = REQUEST.db.fetchone()[0]
    SQL = """SELECT count(*) FROM item_rels ir, items i, items i2, contacts c WHERE ((i.item_id=ir.left_item_id AND i2.item_id=ir.right_item_id AND ir.left_item_id = %d AND i2.item_type_id = %d) OR (i.item_id=ir.right_item_id AND i2.item_id=ir.left_item_id AND ir.right_item_id = %d AND i2.item_type_id = %d)) AND i2.item_id=c.contact_id""" % (product_id, _InitTypes.ITEM_TYPE_CONTACT, product_id, _InitTypes.ITEM_TYPE_CONTACT)
    REQUEST.db.execute(SQL)
    contact_count = REQUEST.db.fetchone()[0]

    active = 0
    if REQUEST.form.has_key('rel') and REQUEST.form['rel'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('note') and REQUEST.form['note'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('log') and REQUEST.form['log'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if (REQUEST.form.has_key('reports') and REQUEST.form['reports'].value=='1') or REQUEST.form.has_key('start_day'):
      active = 1
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s&reports=1">%(tls_reports)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s&reports=1">%(tls_reports)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_PRODUCTS_URL)seditproduct.py?product_id=%(product_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()

    tls_object = REQUEST.TLS('log_product_id')
    object_name = _Utils.html_quote_show(product_obj.get('item_name'))
    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, product_obj.get('item_type_id')))
    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el5)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)

def show_reports(REQUEST):
    product_id = int(REQUEST.form['product_id'].value)
    obj = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_ID, product_id)
    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    today = _Utils.utc2local_mx(REQUEST, _Utils.utc_now_mx())
    day = today.day
    month = today.month
    year = today.year
    
    tls_salesstat = REQUEST.TLS('rep_prod_income')
    tls_dt1 = REQUEST.TLS('rep_thismonth')
    tls_dt2 = REQUEST.TLS('rep_lastmonth')
    tls_dt3 = REQUEST.TLS('rep_fromlastmonth')
    tls_dt4 = REQUEST.TLS('rep_q1')
    tls_dt5 = REQUEST.TLS('rep_q2')
    tls_dt6 = REQUEST.TLS('rep_q3')
    tls_dt7 = REQUEST.TLS('rep_q4')
    tls_dt8 = REQUEST.TLS('rep_thisyear')
    tls_dt9 = REQUEST.TLS('rep_lastyear')
    tls_start = REQUEST.TLS('rep_periodstart')
    tls_end = REQUEST.TLS('rep_periodend')
    tls_short = REQUEST.TLS('rep_shortformat')
    tls_long = REQUEST.TLS('rep_longformat')
    tls_show = REQUEST.TLS('rep_showreport')
    
    day_cont = ""
    i=1
    while(i<32):
        if i==day:
            day_cont += u"""<option value="%s" selected>%s</option>""" % (i,i)
        else:
            day_cont += u"""<option value="%s">%s</option>""" % (i,i)
        i += 1
    begin_day = u"""<select name="start_day">%s</select>""" % day_cont
    end_day = u"""<select name="end_day">%s</select>""" % day_cont
    
    month_cont = u""
    i=1
    while(i<13):
        if i==month:
            month_cont += """<option value="%s" selected>%s</option>""" % (i,REQUEST.TLS('month_%d' % i))
        else:
            month_cont += """<option value="%s">%s</option>""" % (i,REQUEST.TLS('month_%d' % i))
        i += 1
    begin_month = """<select name="start_month">%s</select>""" % month_cont
    end_month = u"""<select name="end_month">%s</select>""" % month_cont
    
    year_cont = u""
    i=year-3
    while(i<=year+1):
        if i==year:
            year_cont += """<option value="%s" selected>%s</option>""" % (i,i)
        else:
            year_cont += """<option value="%s">%s</option>""" % (i,i)
        i += 1
    begin_year = """<select name="start_year">%s</select>""" % year_cont
    end_year = u"""<select name="end_year">%s</select>""" % year_cont

    dt1 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,month,year,day,month,year)
    if month==1:
        lastday = calendar.monthrange(year-1, 12)[1]
        dt2 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,12,year-1,lastday,12,year-1)
    else:
        lastday = calendar.monthrange(year, month-1)[1]
        dt2 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,month-1,year,lastday,month-1,year)
    if month==1:
        dt3 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,12,year-1,day,month,year)
    else:
        dt3 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,month-1,year,day,month,year)
    dt4 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,1,year,31,3,year)
    dt5 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,4,year,30,6,year)
    dt6 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,7,year,30,9,year)
    dt7 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,10,year,31,12,year)
    dt8 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,1,year,day,month,year)
    dt9 = """show_r(%s,%s,%s,%s,%s,%s)""" % (1,1,year-1,31,12,year-1)
    str1 = """<a class="blueboldlink" href="#" onclick="%(dt1)s;">%(tls_dt1)s</a>""" % locals()
    str2 = """<a class="blueboldlink" href="#" onclick="%(dt2)s;">%(tls_dt2)s</a>""" % locals()
    str3 = """<a class="blueboldlink" href="#" onclick="%(dt3)s;">%(tls_dt3)s</a>""" % locals()
    str4 = """<a class="blueboldlink" href="#" onclick="%(dt4)s;">%(tls_dt4)s</a> |""" % locals()
    if month>3:
        str5 = """<a class="blueboldlink" href="#" onclick="%(dt5)s;">%(tls_dt5)s</a> |""" % locals()
    else:
        str5 = ""
    if month>6:
        str6 = """<a class="blueboldlink" href="#" onclick="%(dt6)s;">%(tls_dt6)s</a> |""" % locals()
    else:
        str6 = ""
    if month>9:
        str7 = """<a class="blueboldlink" href="#" onclick="%(dt7)s;">%(tls_dt7)s</a> |""" % locals()
    else:
        str7 = ""
    str8 = """<a class="blueboldlink" href="#" onclick="%(dt8)s;">%(tls_dt8)s</a>""" % locals()
    str9 = """<a class="blueboldlink" href="#" onclick="%(dt9)s;">%(tls_dt9)s</a>""" % locals()
    output.append(u"""
<script type="text/javascript">
function show_r(sd, sm, sy, ed, em, ey)
{
  document.forms[0]['start_day'].value   = sd;
  document.forms[0]['start_month'].value = sm;
  document.forms[0]['start_year'].value  = sy;
  document.forms[0]['end_day'].value   = ed;
  document.forms[0]['end_month'].value = em;
  document.forms[0]['end_year'].value  = ey;
  document.forms[0].submit();
}
</script>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<FORM name="editform" method="POST" action="%(BASE_PRODUCTS_URL)seditproduct.py/report">
<INPUT type="hidden" name="product_id" value="%(product_id)s">
  <TR class="tr_listing1">
    <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b" colspan="2" width="100%%">%(tls_salesstat)s:</TD>
  </TR>
  <TR class="tr_listing0">
    <TD colspan="3"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder" colspan="2" width="100%%" align="center">%(str1)s | %(str2)s | %(str3)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder" colspan="2" width="100%%" align="center">%(str4)s %(str5)s %(str6)s %(str7)s %(str8)s | %(str9)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder" width="40%%" width="40%%" style="text-align: right; font-weight: bold;">%(tls_start)s:</TD>
    <TD class="td_listing_noborder" align="left" width="60%%" nowrap>%(begin_day)s %(begin_month)s %(begin_year)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder" width="40%%" width="40%%" style="text-align: right; font-weight: bold;">%(tls_end)s:</TD>
    <TD class="td_listing_noborder" align="left" width="60%%" nowrap>%(end_day)s %(end_month)s %(end_year)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder" width="40%%" style="text-align: right; font-weight: bold;">&nbsp;</TD>
    <TD class="td_listing_noborder" align="left" width="60%%" nowrap><input type="radio" name="type" value="1" checked>&nbsp;%(tls_short)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing_noborder" width="40%%" style="text-align: right; font-weight: bold;">&nbsp;</TD>
    <TD class="td_listing_noborder" width="60%%" nowrap><input type="radio" name="type" value="2">&nbsp;%(tls_long)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=40 border=0 alt=""></TD>
    <TD class="td_listing_noborder" colspan="2" width="100%%" align="center"><input name="_report" type="submit" class="input6" value="%(tls_show)s"></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def report(REQUEST):
    if not (REQUEST.form.has_key('start_day') and REQUEST.form.has_key('end_day') and REQUEST.form.has_key('start_month') and REQUEST.form.has_key('end_month') and REQUEST.form.has_key('start_year') and REQUEST.form.has_key('end_year') and REQUEST.form['start_day'].value and REQUEST.form['start_month'].value and REQUEST.form['start_year'].value and REQUEST.form['end_day'].value and REQUEST.form['end_month'].value and REQUEST.form['end_year'].value):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    start_date = mx.DateTime.DateTime(int(REQUEST.form['start_year'].value), int(REQUEST.form['start_month'].value), int(REQUEST.form['start_day'].value))
    end_date = mx.DateTime.DateTime(int(REQUEST.form['end_year'].value), int(REQUEST.form['end_month'].value), int(REQUEST.form['end_day'].value))
    product_obj = _Product.Product(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['product_id'].value))
    product_name = product_obj.get('item_name')
    product_id = product_obj.get_id()
    if REQUEST.form.has_key('type') and REQUEST.form['type'].value=="2":
      type=2
    else:
      type=1
    if type==1:
        SQL = """
SELECT
 coalesce(sum(case when opp_stage=100 then op.amount*op.price else 0 end),0) as sold,
 coalesce(sum(case when opp_stage=0 then op.amount*op.price else 0 end),0) as lost,
 coalesce(sum(case when opp_stage>0 and opp_stage<100 then op.amount*op.price else 0 end),0) as pending
FROM
 opportunities o,
 opp_products op
WHERE
 o.opp_id = op.opp_id and o.close_date between '%s' and '%s' and op.product_id=%d""" % (start_date.strftime('%Y-%m-%d'), end_date.strftime('%Y-%m-%d'), product_id)
        REQUEST.db.execute(SQL)
        dbres = REQUEST.db.fetchone()
        deals_sold = dbres[0]
        deals_lost = dbres[1]
        deals_pending = dbres[2]
    else:
        SQL = """
SELECT
 c.client_name,
 coalesce(sum(case when opp_stage=100 then op.amount*op.price else 0 end),0) as sold,
 coalesce(sum(case when opp_stage=0 then op.amount*op.price else 0 end),0) as lost,
 coalesce(sum(case when opp_stage>0 and opp_stage<100 then op.amount*op.price else 0 end),0) as pending
FROM
 opportunities o,
 opp_products op,
 clients c
WHERE
 o.opp_id = op.opp_id and o.close_date between '%s' and '%s' and op.product_id=%d and o.client_id = c.client_id
 GROUP BY c.client_name order by client_name""" % (start_date.strftime('%Y-%m-%d'), end_date.strftime('%Y-%m-%d'), product_id)
        REQUEST.db.execute(SQL)
        dbres = REQUEST.db.fetchall()


    try:    c_pre = REQUEST.get_setting('currency_prefix')[0]
    except: c_pre = ""
    try:    c_suf = REQUEST.get_setting('currency_suffix')[0]
    except: c_suf = ""
    
    BASE_PRODUCTS_URL = _Conf.BASE_PRODUCTS_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_products_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, product_obj)
    datestr = "%s-%s" % (REQUEST.iso2userdate(start_date), REQUEST.iso2userdate(end_date))
    tls_product = REQUEST.TLS('log_product_id')
    tls_stat_during = REQUEST.TLS('rep_stat_period') % datestr
    tls_won = REQUEST.TLS('rep_won')
    tls_lost = REQUEST.TLS('rep_lost')
    tls_pending = REQUEST.TLS('rep_pending')
    tls_total = REQUEST.TLS('rep_total')
    tls_client = REQUEST.TLS('opp_client')
    if type==1:
        out_str = u"""
      <TABLE border=0 cellpadding=0 cellspacing=1 bgcolor="#FFFFFF" style="border: 1px solid #EBEBEB">
        <TR>
          <TD class="td_listing1b" nowrap>%(tls_won)s</TD>
          <TD class="td_listing1b" nowrap>%(tls_lost)s</TD>
          <TD class="td_listing1b" nowrap>%(tls_pending)s</TD>
        </TR>
        <TR>
          <TD class="td_listing0b" nowrap>%(c_pre)s%(deals_sold)d%(c_suf)s</TD>
          <TD class="td_listing0b" nowrap>%(c_pre)s%(deals_lost)d%(c_suf)s</TD>
          <TD class="td_listing0b" nowrap>%(c_pre)s%(deals_pending)d%(c_suf)s</TD>
        </TR>
      </TABLE>""" % locals()
    else:
        out_str = u"""
      <TABLE border=0 cellpadding=0 cellspacing=1 bgcolor="#FFFFFF" style="border: 1px solid #EBEBEB">
        <TR>
          <TD class="td_listing1b" nowrap>%(tls_client)s</TD>
          <TD class="td_listing1b" nowrap>%(tls_won)s</TD>
          <TD class="td_listing1b" nowrap>%(tls_lost)s</TD>
          <TD class="td_listing1b" nowrap>%(tls_pending)s</TD>
        </TR>""" % locals()
        sum1 = sum2 = sum3 = 0
        for row in dbres:
            cli = _Utils.html_quote_show(row[0].decode('UTF8'))
            won = row[1]
            lost = row[2]
            pending = row[3]
            sum1 = sum1 + row[1]
            sum2 = sum2 + row[2]
            sum3 = sum3 + row[3]
            out_str += u"""
        <TR>
          <TD class="td_listing0b" nowrap>%(cli)s</TD>
          <TD class="td_listing0b" nowrap>%(c_pre)s%(won)d%(c_suf)s</TD>
          <TD class="td_listing0b" nowrap>%(c_pre)s%(lost)d%(c_suf)s</TD>
          <TD class="td_listing0b" nowrap>%(c_pre)s%(pending)d%(c_suf)s</TD>
        </TR>""" % locals()
        out_str += u"""
        <TR>
          <TD class="td_listing1b" nowrap>%(tls_total)s</TD>
          <TD class="td_listing1b" nowrap>%(c_pre)s%(sum1)d%(c_suf)s</TD>
          <TD class="td_listing1b" nowrap>%(c_pre)s%(sum2)d%(c_suf)s</TD>
          <TD class="td_listing1b" nowrap>%(c_pre)s%(sum3)d%(c_suf)s</TD>
        </TR>
      </TABLE>""" % locals()
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR class="tr_listing0">
  <TD>%(menu)s</TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" colspan="2" width="100%%">%(tls_product)s: %(product_name)s</TD>
</TR>
<TR>
  <TD colspan="3"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing_noborder" align="center" style="font-weight: bold;">%(tls_stat_during)s</TD>
  <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="3"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD>%(out_str)s</TD>
  <TD class="td_listing_noborder" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="3"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)