import os
import mx.DateTime

import standard_html
import _InitTypes, _Conf, _Utils, Menus, _Access, _Exceptions, _Workflow
import _Todo, _RootObject, _Usernote, _Log, _mail
import relations
import urllib

MY_MENU_ID = -1

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" title="win2k-1" />' % _Conf.BASE_WEB_URL))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))

    BASE_URL = _Conf.BASE_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL

    if not REQUEST.form.has_key('todo_id'):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
        returl = REQUEST.form['returl'].value
    else:
        returl = ""

    if REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, REQUEST.form['todo_id'].value)

    todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['todo_id'].value))
    todo_id = todo.get_id()
    todo_title = _Utils.html_quote_edit(todo.get('title'))
    todo_description = _Utils.html_quote(todo.get('description') or "")
    if todo.get('creator_id') <> REQUEST.USER.get_id():
        todo_is_private = u""
    elif todo.get('is_private'):
        todo_is_private = u"""
  <TR>
    <TD class="td_listing0ke">%s:</TD>
    <TD class="td_listing0ve"><INPUT type="checkbox" name="todo_is_private" CHECKED></TD>
    <TD class="td_listing0" width="100%%"><img src="%sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % (REQUEST.TLS('tls_private'), BASE_ICON_URL)
    else:
        todo_is_private = u"""
  <TR>
    <TD class="td_listing0ke">%s:</TD>
    <TD class="td_listing0ve"><INPUT type="checkbox" name="todo_is_private"></TD>
    <TD class="td_listing0" width="100%%"><img src="%sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % (REQUEST.TLS('tls_private'), BASE_ICON_URL)
    if todo.get('related_persons'):
        todo_related = _Utils.sql_parse_array(REQUEST, todo.get('related_persons'))
    else:
        todo_related = []
    if todo.get('seen_persons'):
        todo_seen = _Utils.sql_parse_array(REQUEST, todo.get('seen_persons'))
    else:
        todo_seen = []
    if todo.get('accepted_persons'):
        todo_accepted = _Utils.sql_parse_array(REQUEST, todo.get('accepted_persons'))
    else:
        todo_accepted = []
    if todo.get('rejected_persons'):
        todo_rejected = _Utils.sql_parse_array(REQUEST, todo.get('rejected_persons'))
    else:
        todo_rejected = []
    if REQUEST.USER.get_id() in (todo_related + [todo.get('creator_id')]) and REQUEST.USER.get_id() not in todo_seen and REQUEST.USER.get_id()<>todo.get('creator_id'):
        if REQUEST.db.version < 740:
            REQUEST.db.execute("""UPDATE todos SET seen_persons = seen_persons + '{%d}'::int[] WHERE todo_id=%d""" % (REQUEST.USER.get_id(), todo_id))
        else:
            REQUEST.db.execute("""UPDATE todos SET seen_persons = seen_persons || '{%d}'::int[] WHERE todo_id=%d""" % (REQUEST.USER.get_id(), todo_id))
        todo_seen += [REQUEST.USER.get_id()]
    if todo.get('start_time') is not None:
        todo_start_time = REQUEST.iso2userdate(todo.get('start_time'))
    else:
        todo_start_time = ""
    if todo.get('due_time') is not None:
        days_left = todo.get('due_time') 
        now = _Utils.utc2local_mx(REQUEST,_Utils.utc_now_mx())
        now = mx.DateTime.Date(now.year, now.month, now.day)
        days_left = days_left - now
        if days_left.days >1:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_1') % days_left.days
        elif days_left.days == 1:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_2')
        elif days_left.days  == 0:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_3')
        elif days_left.days  == -1:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_4')
        else:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_5') % abs(days_left.days)
        del days_left
        todo_due_time = REQUEST.iso2userdate(todo.get('due_time'))
    else:
        days_left_str = ""
        todo_due_time = ""
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute((u"""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id AND p.is_deleted=0 %s""" % right_param).encode('UTF8'))
    related_persons = REQUEST.db.dictfetchall()
    related_persons = filter(None, map(lambda x: (_Access.get_item_right(REQUEST, REQUEST.USER.get_parent_id(REQUEST), x['person_id']) > _Access.ACCESS_NONE and x) or None, related_persons))
    persons_out = ["""<SELECT class="textfield1" name="related_persons" multiple size="5">"""]
    for person in related_persons:
        if person['person_id'] in todo_related:
            persons_out.append(u"""<OPTION value="%d" SELECTED>%s""" % (person['person_id'], person['item_name'].decode('UTF8')))
        else:
            persons_out.append(u"""<OPTION value="%d">%s""" % (person['person_id'], person['item_name'].decode('UTF8')))
    persons_out.append("""</SELECT>""")
    related_persons = "\n".join(persons_out)
    del persons_out
    seen_out = []
    for person_id in todo_seen:
        REQUEST.su_by_id(_Conf.SUPERUSER)
        ok = 1
        try:
            p = _RootObject.dispatch_item(REQUEST, person_id)
        except _Exceptions.RootObjectError:  # We can have this fail, since it usually means a deleted user.
            ok = 0                           # Prolly should ensure with foreign keys that this does not happen, but with
                                             # intarrays and such it's a problem.
        REQUEST.unsu()
        if ok:
            seen_out.append(u"""%s %s.""" % (p.get_name(), REQUEST.TLS('todo_hasseen')))
    seen_out = "<BR>\n".join(seen_out)
    if seen_out:
        seen_out = u"""
  <TR>
    <TD class="td_listing0" colspan="2">%(seen_out)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals()


    accepted_out = []
    for person_id in todo_accepted:
        REQUEST.su_by_id(_Conf.SUPERUSER)
        ok = 1
        try:
            p = _RootObject.dispatch_item(REQUEST, person_id)
        except _Exceptions.RootObjectError:  # We can have this fail, since it usually means a deleted user.
            ok = 0                           # Prolly should ensure with foreign keys that this does not happen, but with
                                             # intarrays and such it's a problem.
        REQUEST.unsu()
        if ok:
            accepted_out.append("""%s %s.""" % (p.get_name(), REQUEST.TLS('todo_hasaccepted')))
    accepted_out = "<BR>\n".join(accepted_out)
    if accepted_out:
        accepted_out = u"""
  <TR>
    <TD class="td_listing0" colspan="2">%(accepted_out)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals()

    rejected_out = []
    for person_id in todo_rejected:
        REQUEST.su_by_id(_Conf.SUPERUSER)
        ok = 1
        try:
            p = _RootObject.dispatch_item(REQUEST, person_id)
        except _Exceptions.RootObjectError:  # We can have this fail, since it usually means a deleted user.
            ok = 0                           # Prolly should ensure with foreign keys that this does not happen, but with
                                             # intarrays and such it's a problem.
        REQUEST.unsu()
        if ok:
            rejected_out.append("""%s %s.""" % (p.get_name(), REQUEST.TLS('todo_hasrejected')))
    rejected_out = "<BR>\n".join(rejected_out)
    if rejected_out:
        rejected_out = u"""
  <TR>
    <TD class="td_listing0" colspan="2">%(rejected_out)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals()


    priorities = _Utils.make_setting_selection(REQUEST, todo, 'priority', 'todo_priorities')

    complete_percent = ["""<SELECT name="percent_complete">"""]
    for i in [0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100]:
        if i == todo.get('percent_complete'):
            complete_percent.append("""<OPTION value="%d" SELECTED>%d%%""" % (i, i))
        else:
            complete_percent.append("""<OPTION value="%d">%d%%""" % (i, i))
    complete_percent.append("""</SELECT>""")
    complete_percent = "\n".join(complete_percent)

    if REQUEST.USER.get_id() == todo.get('creator_id'):
        delete = """&nbsp;<INPUT type="submit" class="input2" name="_delete" value="%s" onClick="return confirm('%s');">""" % (REQUEST.TLS('tls_delete'), REQUEST.TLS('email_confirm_del'))
    else:
        delete = ""
    
    workflow_has_preceeding_tasks = 0
    if todo.get('workflow_id') is not None:
        REQUEST.su_by_id(_Conf.SUPERUSER)
        workflow_obj = _RootObject.dispatch_item(REQUEST, todo.get('workflow_id'))
        REQUEST.unsu()
        if workflow_obj.get('workflow_flags') & _Workflow.WORKFLOW_SERIAL:
            SQL = """SELECT count(*) from todos t where t.workflow_id=%d and t.percent_complete<100 and t.workflow_sequence_id<%d""" % (todo.get('workflow_id'), todo.get('workflow_sequence_id'))
            REQUEST.db.execute(SQL)
            res = REQUEST.db.fetchone()[0]
            if res:
                workflow_has_preceeding_tasks = 1

    if workflow_has_preceeding_tasks:
        save_button = ""
        saven_button = ""
        accept_button = ""
        reject_button = ""
    else:
        save_button = """<INPUT type="submit" class="input6" name="_save" value="%s">""" % REQUEST.TLS('tls_save')
        saven_button = """&nbsp;<INPUT type="submit" class="input6" name="_notify" value="%s">""" % REQUEST.TLS('tls_save_notify')
        if REQUEST.USER.get_id()<>todo.get('creator_id') and REQUEST.USER.get_id() in todo_related and REQUEST.USER.get_id() not in todo_accepted and REQUEST.USER.get_id() not in todo_rejected:
            accept_button = """&nbsp;<INPUT type="submit" name="_accept" class="input6" value="%s">""" % REQUEST.TLS('todo_accept')
            save_button = ""
            saven_button = ""
        else:
            accept_button = ""
        if REQUEST.USER.get_id()<>todo.get('creator_id') and REQUEST.USER.get_id() in todo_related and REQUEST.USER.get_id() not in todo_accepted and REQUEST.USER.get_id() not in todo_rejected:
            reject_button = """&nbsp;<INPUT type="submit" name="_reject" class="input6" value="%s">""" % REQUEST.TLS('todo_reject')
            save_button = ""
            saven_button = ""
        else:
            reject_button = ""

    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_edittodo = REQUEST.TLS('todo_edittodo')
    tls_save = REQUEST.TLS('tls_save')
    tls_title = REQUEST.TLS('tls_title')
    tls_pri = REQUEST.TLS('tls_priority')
    tls_start = REQUEST.TLS('todo_starttime')
    tls_due = REQUEST.TLS('todo_duetime')
    tls_related = REQUEST.TLS('tls_responsible_per')
    tls_desc = REQUEST.TLS('tls_description')
    tls_percent = REQUEST.TLS('todo_percentcomplete')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    menu = menu_output(REQUEST, todo)

    BASE_WEB_URL = _Conf. BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append("""\
<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.editform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
  function check_values()
  {
    if (!document.editform.title.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
%(datecheck_js)s
// -->
</SCRIPT>
<FORM name="editform" method="POST" action="%(BASE_TODO_URL)stodoedit.py/edit" onsubmit="return check_values();">
<INPUT type="hidden" name="todo_id" value="%(todo_id)d">
<INPUT type="hidden" name="returl" value="%(returl)s">
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<TR>
  <TD>
  %(menu)s
  </TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_title)s:</TD>
    <TD class="td_listing1ve"><INPUT class="textfield3" size="50" type="text" name="title" value="%(todo_title)s"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke">%(tls_pri)s:</TD>
    <TD class="td_listing0ve">%(priorities)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke">%(tls_start)s:</TD>
    <TD class="td_listing1ve"><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="start_time" id="start_time" value="%(todo_start_time)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR style="vertical-align: top">
    <TD class="td_listing0ke">%(tls_due)s:</TD>
    <TD class="td_listing0ve"><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="due_time" id="due_time" value="%(todo_due_time)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('due_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A>%(days_left_str)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR style="vertical-align: top">
    <TD class="td_listing1ke">%(tls_related)s:</TD>
    <TD class="td_listing1ve">%(related_persons)s</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
%(seen_out)s
%(accepted_out)s
%(rejected_out)s
%(todo_is_private)s
  <TR>
    <TD class="td_listing0b" colspan="2">%(tls_desc)s<BR><TEXTAREA class="textarea1" name="description" rows="3" cols="20">%(todo_description)s</TEXTAREA></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke">%(tls_percent)s:</TD>
    <TD class="td_listing1ve">%(complete_percent)s</TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())
    if _Access.get_item_right(REQUEST, todo.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        output.append("""
  <TR class="tr_listing0">
    <TD class="td_listing_noborder" colspan="2">%(save_button)s%(saven_button)s%(accept_button)s%(reject_button)s%(delete)s</TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>""" % locals())
    output.append(u"""
</TABLE>
</FORM>
<BR>
""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit(REQUEST):
    if not REQUEST.form.has_key('todo_id'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output = []
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        output.append(standard_html.html_header(REQUEST,"""<SCRIPT type="text/javascript">document.location.href='%s';</SCRIPT>"""% urllib.unquote(REQUEST.form['returl'].value)))
    else:
        output.append(standard_html.html_header(REQUEST, """"<SCRIPT type="text/javascript">document.location.href='%stodoindex.py';</SCRIPT>"""%_Conf.BASE_TODO_URL))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
    if REQUEST.form.has_key('_delete') or REQUEST.form.has_key('_delete.x'):
        todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['todo_id'].value))
        _mail.send_invitation_update(REQUEST, todo, 4)
        todo.delete()
        output.append(REQUEST.TLS('todo_deleted'))
    else:
        todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['todo_id'].value))
        if REQUEST.form.has_key('_accept'):
            todo.set('accepted_persons', _Utils.sql_parse_array(REQUEST, todo.get('accepted_persons')) + [REQUEST.USER.get_id()])
        if REQUEST.form.has_key('_reject'):
            todo.set('rejected_persons', _Utils.sql_parse_array(REQUEST, todo.get('rejected_persons')) + [REQUEST.USER.get_id()])
        if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')
        todo.set('title', REQUEST.form['title'].value)
        todo.set('description', REQUEST.form['description'].value)
        todo.set('priority', REQUEST.form['priority'].value)
        todo.set('percent_complete', int(REQUEST.form['percent_complete'].value))
        if todo.get('creator_id') == REQUEST.USER.get_id():
            if REQUEST.form.has_key('todo_is_private'):
                todo.set('is_private', 1)
            else:
                todo.set('is_private', 0)
        if REQUEST.form['start_time'].value:
            try: todo.set('start_time', REQUEST.user2isodate(REQUEST, REQUEST.form['start_time'].value))
            except ValueError:
                raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        else:
            todo.set('start_time', None)
        if REQUEST.form['due_time'].value:
            try: todo.set('due_time', REQUEST.user2isodate(REQUEST, REQUEST.form['due_time'].value))
            except ValueError:
                raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        else:
             todo.set('due_time', None)
        if REQUEST.form.has_key('related_persons'):
            try:
                todo.set('related_persons', [int(REQUEST.form['related_persons'].value)])
            except AttributeError:
                todo.set('related_persons', REQUEST.form['related_persons'])
        else:
            todo.set('related_persons', [])
        todo.save()
        todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['todo_id'].value))
        if REQUEST.form.has_key('_notify'):
            _mail.send_invitation_update(REQUEST, todo, 3)
        output.append(REQUEST.TLS('todo_saved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


def relations_contents(REQUEST):
    if not REQUEST.form.has_key('todo_id') or not REQUEST.form['todo_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    todo_id = REQUEST.form['todo_id'].value
    obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['todo_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    relation_output = relations.show_relations(REQUEST, obj)
    output.append(relation_output)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def notes_contents(REQUEST):
    if not REQUEST.form.has_key('todo_id') or not REQUEST.form['todo_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['todo_id'].value)
    obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, obj_id)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    menu = u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals()
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    returl = "%(BASE_TODO_URL)stodoedit.py?todo_id=%(obj_id)s&note=1" % locals()
    returl = urllib.quote(returl)
    show_menu = "todo"
    output.append(_Usernote.note_out(REQUEST, obj, obj_id, returl, menu, show_menu))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST, obj):
    if not REQUEST.form.has_key('todo_id') or not REQUEST.form['todo_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output=[]
    todo_id = int(REQUEST.form['todo_id'].value)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_TODO_URL = _Conf.BASE_TODO_URL

    tls_info = REQUEST.TLS('contact_info')
    tls_relations = REQUEST.TLS('tls_relations')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_notes = REQUEST.TLS('compmenu_todo_notes')
    tls_contacts = REQUEST.TLS('topmenu_contacts')
    tls_log = REQUEST.TLS('log_log')
    relations_count = relations.relations_count(REQUEST, obj)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT count(*) FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s""" % (todo_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    note_count = REQUEST.db.fetchone()[0]

    active = 0
    if REQUEST.form.has_key('rel') and REQUEST.form['rel'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('note') and REQUEST.form['note'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('log') and REQUEST.form['log'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()


    tls_object = REQUEST.TLS('log_todo_id')
    tls_object2 = REQUEST.TLS('log_workflow_id')
    object_name = _Utils.html_quote_show(obj.get('item_name'))
    wf_id =  obj.get('workflow_id')
    if wf_id:
        try:
            wf = _RootObject.dispatch_item(REQUEST, wf_id)
            output.append(standard_html.standard_objname_link(REQUEST, tls_object2, wf.get('item_name'), wf.get('item_type_id'), _Conf.BASE_WORKFLOWS_URL+"workflowedit.py?workflow_id=%d" % wf.get_id()))
        except:
            raise
    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, obj.get('item_type_id')))
    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)


def show_log(REQUEST, obj_id):
    obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(obj_id))
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    output.append(_Log.standard_log_output(REQUEST, obj_id))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
