import mx.DateTime
from mod_python import apache

import _Conf
from Menus import get_workflows_menu
import standard_html
import MultiForm, _Workflow, _Todo, Menus, _Utils, urllib, relations

import _Access, _InitTypes

MY_MENU_ID=3

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(get_workflows_menu(REQUEST, MY_MENU_ID))
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      returl = REQUEST.form['returl'].value
    else:
      returl = ""
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = REQUEST.form['rel_id'].value
    else:
      rel_id = ""
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute(("""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id AND p.is_deleted=0 %s""" % (right_param)).encode('UTF8'))
    related_persons = REQUEST.db.dictfetchall()
    related_persons = filter(None, map(lambda x: (_Access.get_item_right(REQUEST, REQUEST.USER.get_parent_id(REQUEST), x['person_id']) > _Access.ACCESS_NONE and x) or None, related_persons))

    datecheck_js = REQUEST.datecheck_js(REQUEST)

    start_offset = 0
    end_offset = 0
    if REQUEST.form.has_key('wf_id') and REQUEST.form['wf_id'].value:
        wf_id = int(REQUEST.form['wf_id'].value)
        wf = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, wf_id)
        old_start = wf.get('workflow_start_time')
        old_due   = wf.get('workflow_due_time')
        if REQUEST.form.has_key('start_time'):
            new_start = mx.DateTime.Date(*map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['start_time'].value).split('-')))
            start_offset = new_start - old_start
        if REQUEST.form.has_key('due_time'):
            new_due = mx.DateTime.Date(*map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['due_time'].value).split('-')))
            end_offset = new_due - old_due

    BASE_WORKFLOWS_URL = _Conf.BASE_WORKFLOWS_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_addworkflow = REQUEST.TLS('tls_addworkflow')
    tls_title = REQUEST.TLS('tls_title')
    tls_save = REQUEST.TLS('tls_save')
    tls_start = REQUEST.TLS('todo_starttime')
    tls_due = REQUEST.TLS('todo_duetime')
    tls_related = REQUEST.TLS('tls_related')
    tls_responsible = REQUEST.TLS('tls_responsible_per')
    tls_desc = REQUEST.TLS('tls_description')
    tls_task = REQUEST.TLS('tls_todo')
    tls_add_rows = REQUEST.TLS('tls_add_rows')
    tls_serial = REQUEST.TLS('tls_serial')
    tls_send_initial = REQUEST.TLS('tls_send_initial')
    tls_send_final = REQUEST.TLS('tls_send_final')
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    
    # read in form variables
    if REQUEST.form.has_key('title'):
        form_title = REQUEST.form['title'].value.decode('UTF8')
    else:
        form_title = ''
    if REQUEST.form.has_key('due_time'):
        form_due_time = REQUEST.form['due_time'].value.decode('UTF8')
    else:
        form_due_time = ''
    if REQUEST.form.has_key('start_time'):
        form_start_time = REQUEST.form['start_time'].value.decode('UTF8')
    else:
        form_start_time = ''
    if REQUEST.form.has_key('is_serial'):
        is_serial = " CHECKED"
    else:
        is_serial = ""
    if REQUEST.form.has_key('email_start'):
        email_start = " CHECKED"
    else:
        email_start = ""
    if REQUEST.form.has_key('email_done'):
        email_done = " CHECKED"
    else:
        email_done = ""

    # Related persons!
    if REQUEST.form.has_key('related_persons'):
        rel_ids = REQUEST.form['related_persons']
        if isinstance(rel_ids, list):
            rel_ids = map(int, rel_ids)
        else:
            rel_ids = [int(rel_ids.value)]
        related_persons_str = u"""<SELECT name="related_persons" multiple size="4">\n%s</SELECT>""" % "\n".join(map(lambda x: """<OPTION value="%d" %s>%s""" % (x['person_id'], (x['person_id'] in rel_ids and " SELECTED") or "", x['item_name'].decode('UTF8')), related_persons))
    else:
        related_persons_str = u"""<SELECT name="related_persons" multiple size="4">\n%s</SELECT>""" % "\n".join(map(lambda x: """<OPTION value="%d">%s""" % (x['person_id'], x['item_name'].decode('UTF8')), related_persons))
    if REQUEST.form.has_key('description'):
        form_description = REQUEST.form['description'].value.decode('UTF8')
    else:
        form_description = ''
    multiform = MultiForm.MultiForm(REQUEST)

    num_rows = len(multiform.rows.keys())
    if REQUEST.form.has_key('_addrows') and REQUEST.form['_addrows'].value and REQUEST.form.has_key('num_rows'):
        num_rows += int(REQUEST.form['num_rows'].value)
    if not num_rows:
        num_rows = 3
    existing_rows = len(multiform.rows.keys())

    n = 0
    tasks = []
    while(n<num_rows):
        if(n%2) == 0:
            td_class = 0
        else:
            td_class = 1
        task_num = n+1
        if n < existing_rows:
            task_title = multiform.rows[n]['title']
            task_due = multiform.rows[n]['due']
            task_start = multiform.rows[n]['start']
            if task_start and start_offset:
                task_start = REQUEST.iso2userdate(mx.DateTime.Date(*map(int, (REQUEST.user2isodate(REQUEST, task_start).split('-')))) + start_offset)
            if task_due and end_offset:
                task_due = REQUEST.iso2userdate(mx.DateTime.Date(*map(int, (REQUEST.user2isodate(REQUEST, task_due).split('-')))) + end_offset)
            task_desc = _Utils.html_quote_edit(multiform.rows[n]['desc'])
            try:
                rel_ids = multiform.rows[n]['related']
                if isinstance(rel_ids, list):
                    rel_ids = map(int, rel_ids)
                else:
                    rel_ids = [int(rel_ids)]
                task_related = "\n".join(map(lambda x: x['person_id'] in rel_ids and ("""<OPTION value="%d" SELECTED>%s""" % (x['person_id'], ((len(x['item_name'].decode('UTF8')) <= 10 and x['item_name'].decode('UTF8')) or x['item_name'].decode('UTF8')[:10] + '..'))) or "", related_persons))
            except:
                task_related = "<OPTION>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
            tasks.append(u"""\
  <TR>
    <TD class="td_listing%(td_class)s" colspan="5">
      <TABLE border=0 cellpadding="0" cellspacing="0">
        <TR valign="top">
          <TD rowspan="2" nowrap class="td_listing%(td_class)sbb">%(tls_title)s<br><input type="text" name="form_%(n)d_title" class="textfield2" value="%(task_title)s"></TD>
          <TD nowrap class="td_listing%(td_class)sbb">%(tls_start)s<br><input size="10" name="form_%(n)d_start" id="form_%(n)d_start" type="text" value="%(task_start)s" class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('form_%(n)d_start', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
          <TD rowspan="2" nowrap class="td_listing%(td_class)sbb" valign="top">%(tls_responsible)s<br><div id="%(n)d"><SELECT size="3" multiple name="form_%(n)d_related">%(task_related)s</SELECT>&nbsp;<A href="javascript:void(0);" OnClick="rel_popup('%(BASE_GENERAL_URL)spopuprel.py?ret=form_%(n)d_related&amp;num=%(n)d', 'form_%(n)d_related');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" align="top" style="position: relative; top: 2px;"></A></DIV></TD>
          <TD rowspan="2"  nowrap class="td_listing%(td_class)sbb">%(tls_desc)s<br><textarea name="form_%(n)d_desc" class="textarea4" cols="50" rows="4">%(task_desc)s</textarea></TD>
          <TD rowspan="2" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
        <TR valign="top">
          <TD nowrap class="td_listing%(td_class)sbb">%(tls_due)s<br><input size="10" name="form_%(n)d_due" id="form_%(n)d_due" type="text" value="%(task_due)s" class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('form_%(n)d_due', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>""" % locals())
        else:
            tasks.append(u"""\
  <TR>
    <TD class="td_listing%(td_class)s" colspan="5">
      <TABLE border=0 cellpadding="0" cellspacing="0">
        <TR valign="top">
          <TD rowspan="2" nowrap class="td_listing%(td_class)sbb">%(tls_title)s<br><input type="text" name="form_%(n)d_title" class="textfield2"></TD>
          <TD nowrap class="td_listing%(td_class)sbb">%(tls_start)s<br><input size="10" name="form_%(n)d_start" id="form_%(n)d_start" type="text" class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('form_%(n)d_start', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
          <TD rowspan="2"  nowrap class="td_listing%(td_class)sbb" valign="top">%(tls_responsible)s<br><div id="%(n)d"><SELECT size="3" multiple name="form_%(n)d_related"><OPTION>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</SELECT>&nbsp;<A href="javascript:void(0);" OnClick="rel_popup('%(BASE_GENERAL_URL)spopuprel.py?ret=form_%(n)d_related&amp;num=%(n)d', 'form_%(n)d_related');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" align="top" style="position: relative; top: 2px;"></A></DIV></TD>
          <TD rowspan="2"  nowrap class="td_listing%(td_class)sbb">%(tls_desc)s<br><textarea name="form_%(n)d_desc" class="textarea4" cols="50" rows="4"></textarea></TD>
          <TD rowspan="2"  width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
        <TR valign="top">
          <TD nowrap class="td_listing%(td_class)sbb">%(tls_due)s<br><input size="10" name="form_%(n)d_due" id="form_%(n)d_due" type="text" class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('form_%(n)d_due', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>""" % locals())
        n+=1
    alltasks = "\n".join(tasks)

    output.append(u"""\
<SCRIPT type="text/JavaScript">
<!--
function check_values()
{
  if (!document.addform.title.value||!document.addform.start_time.value||!document.addform.due_time.value)
  {
    alert("%(tls_missing_input)s");
    return false;
  }
  return true;
}
%(datecheck_js)s

function rel_popup(url)
{
    window.open(url,'popuprel','width=750,height=170,scrollbars=no');
}
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_WORKFLOWS_URL)sworkflowadd.py/save" onsubmit="return check_values();">
<INPUT type="hidden" name="returl" value="%(returl)s">
<INPUT type="hidden" name="rel_id" value="%(rel_id)s">
<INPUT type="hidden" name="_addrows" value="">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_16.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_addworkflow)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=150 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=50 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=150 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=50 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_title)s:</TD>
    <TD class="td_listing1" nowrap colspan="3"><INPUT class="textfield3"  type="text" name="title" size="50" value="%(form_title)s"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke" nowrap>%(REQ_FIELD)s%(tls_start)s:</TD>
    <TD class="td_listing0" nowrap colspan="3"><INPUT size="10" class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="start_time"  id="start_time" value="%(form_start_time)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke" nowrap>%(REQ_FIELD)s%(tls_due)s:</TD>
    <TD class="td_listing1" nowrap colspan="3"><INPUT size="10" class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="due_time" id="due_time" value="%(form_due_time)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('due_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke" nowrap>%(tls_related)s:</TD>
    <TD class="td_listing0" nowrap colspan="3">%(related_persons_str)s</TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1b" colspan="5">%(tls_desc)s<BR><TEXTAREA class="textarea4" name="description" rows="10" cols="80">%(form_description)s</TEXTAREA></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke">%(tls_serial)s:</TD>
    <TD class="td_listing0" colspan="3"><INPUT type="checkbox" name="is_serial"%(is_serial)s></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke">%(tls_send_initial)s:</TD>
    <TD class="td_listing1"><INPUT type="checkbox" name="email_start"%(email_start)s></TD>
    <TD class="td_listing1ke">%(tls_send_final)s:</TD>
    <TD class="td_listing1"><INPUT type="checkbox" name="email_done"%(email_done)s></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
%(alltasks)s
  <TR>
    <TD class="td_listing_noborder" colspan="5"><INPUT type="submit" class="input2" name="_save" value="%(tls_save)s">&nbsp;&nbsp;&nbsp;&nbsp;<INPUT type="button" class="input2" name="_addrowsbtn" value="%(tls_add_rows)s" onClick="document.addform._addrows.value='1'; document.addform.action='%(BASE_WORKFLOWS_URL)sworkflowadd.py'; document.addform.submit();">&nbsp;&nbsp;&nbsp;<SELECT name="num_rows"><option value="0">&nbsp;<option value="1">1<option value="3">3<option value="5">5</select></TD>
  </TR>
</TABLE>
</FORM>
<BR>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def save(REQUEST):
    multiform = MultiForm.MultiForm(REQUEST)
    if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if not REQUEST.form.has_key('start_time') or not REQUEST.form['start_time'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    wf = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_NEW)
    wf.set('parent_id', REQUEST.USER.get_id())
    wf.set('workflow_title', REQUEST.form['title'].value.decode('UTF8').strip())
    try:
        wf.set('workflow_start_time', REQUEST.user2isodate(REQUEST, REQUEST.form['start_time'].value.decode('UTF8')))
    except ValueError:
        raise RuntimeError, REQUEST.TLS('tls_invdateformat')
    if REQUEST.form['due_time'].value.decode('UTF8').strip():
        try:
            wf.set('workflow_due_time', REQUEST.user2isodate(REQUEST, REQUEST.form['due_time'].value.decode('UTF8')))
        except ValueError:
            raise RuntimeError, REQUEST.TLS('tls_invdateformat')
    else:
        wf.set('workflow_due_time', None)
    wf.set('workflow_description', REQUEST.form['description'].value.decode('UTF8').strip())
    if REQUEST.form.has_key('related_persons'):
        try:
            wf.set('related_persons', [int(REQUEST.form['related_persons'].value)])
        except AttributeError:
            wf.set('related_persons', REQUEST.form['related_persons'])
    else:
        wf.set('related_persons', [])
    wf_flags = 0
    if REQUEST.form.has_key('is_serial'):
        wf_flags |= _Workflow.WORKFLOW_SERIAL
    if REQUEST.form.has_key('email_start'):
        wf_flags |= _Workflow.WORKFLOW_INIT_EMAIL
    if REQUEST.form.has_key('email_done'):
        wf_flags |= _Workflow.WORKFLOW_COMPL_EMAIL
    wf.set('workflow_flags', wf_flags)
    wf.save()
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = int(REQUEST.form['rel_id'].value)
      relations.add_relation(REQUEST, rel_id, wf.get_id())
    for rowkey in multiform.rows.keys():
        row = multiform.rows[rowkey]
        if not row.has_key('title') or not row['title'].strip():
            continue
        task = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_NEW)
        task.set('parent_id', REQUEST.USER.get_id())
        task.set('workflow_id', wf.get_id())
        task.set('title', row['title'])
        if row.has_key('desc') and row['desc'].strip():
            task.set('description', row['desc'])
        if row.has_key('start') and row['start'].strip():
            try:
                task.set('start_time', REQUEST.user2isodate(REQUEST, row['start']))
            except ValueError:
                raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        else:
            task.set('start_time', None)
        if row.has_key('due') and row['due'].strip():
            try:
                task.set('due_time', REQUEST.user2isodate(REQUEST, row['due']))
            except ValueError:
                raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        else:
            task.set('due_time', None)
        if row.has_key('related'):
            try:
                task.set('related_persons', [int(row['related'])])
            except TypeError:
                task.set('related_persons', row['related'])
        else:
            task.set('related_persons', [])
        task.set('status', '')
        task.set('priority', '')
        task.set('category', '')
        task.set('workflow_sequence_id', rowkey)
        task.save()
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
        REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
        return apache.HTTP_MOVED_TEMPORARILY
    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_WORKFLOWS_URL+"workflowindex.py"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_workflows_menu(REQUEST, MY_MENU_ID))
    output.append(REQUEST.TLS('tls_workflow_saved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
