import mx.DateTime

import _Conf, _Log
from Menus import get_workflows_menu
import standard_html
import relations

import _Access, _InitTypes, _Workflow, _Todo, _RootObject, _Utils, _Usernote, MultiForm

import urllib

MY_MENU_ID = -1

def index(REQUEST):
    if REQUEST.form.has_key('_delete2'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            QUERY = """SELECT * FROM todos WHERE workflow_id=%d""" % del_id
            REQUEST.db.execute(QUERY.encode('UTF8'))
            dbresult = REQUEST.db.dictfetchall()
            for item in dbresult:
                todo_obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, item['todo_id'])
                todo_obj.delete()
            workflow_obj = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            workflow_obj.delete()

    if REQUEST.form.has_key('_delete'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'del_':
                del_ids.append(int(key[4:]))
        for del_id in del_ids:
            todo_obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            wf_id = todo_obj.get('workflow_id')
            todo_obj.set('workflow_id', None)
            todo_obj.set('workflow_sequence_id', None)
            todo_obj.save()
            if wf_id:
                REQUEST.su_by_id(_Conf.SUPERUSER)
                wf = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, wf_id)
                wf.refresh_complete()
                REQUEST.unsu()
    elif REQUEST.form.has_key('_add'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))
        for del_id in del_ids:
            todo_obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            REQUEST.db.execute("""SELECT coalesce(max(workflow_sequence_id), -1)+1 AS next_task FROM todos WHERE workflow_id=%d""" % int(REQUEST.form['workflow_id'].value))
            todo_obj.set('workflow_sequence_id', REQUEST.db.dictfetchone()['next_task'])
            todo_obj.set('workflow_id', int(REQUEST.form['workflow_id'].value))
            todo_obj.save()
        

    
    if REQUEST.form.has_key('edit'):
        return edit(REQUEST)
    elif REQUEST.form.has_key('tasks'):
        return tasks(REQUEST)
    elif REQUEST.form.has_key('new_tasks'):
        return new_tasks(REQUEST)
    elif REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, REQUEST.form['workflow_id'].value)
    elif REQUEST.form.has_key('clone'):
        return clone_form(REQUEST)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_workflows_menu(REQUEST, -1))
    if not REQUEST.form.has_key('workflow_id'):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    workflow_id = int(REQUEST.form['workflow_id'].value)

    workflow = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['workflow_id'].value))

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_edittodo = REQUEST.TLS('todo_edittodo')
    tls_save = REQUEST.TLS('tls_save')
    tls_title = REQUEST.TLS('tls_title')
    tls_start = REQUEST.TLS('todo_starttime')
    tls_due = REQUEST.TLS('todo_duetime')
    tls_related = REQUEST.TLS('tls_related')
    tls_desc = REQUEST.TLS('tls_description')
    tls_percent = REQUEST.TLS('todo_percentcomplete')
    tls_workflow = REQUEST.TLS('tls_workflow')
    workflow_title = _Utils.html_quote(workflow.get('workflow_title'))
    workflow_start = REQUEST.iso2userdate(workflow.get('workflow_start_time'))
    workflow_due = REQUEST.iso2userdate(workflow.get('workflow_due_time'))
    workflow_desc = _Utils.newline2br(_Utils.html_quote(workflow.get('workflow_description')))
    percent_complete = str(workflow.get('percent_complete')) + "%"
    if workflow.get('related_persons'):
        workflow_related = _Utils.sql_parse_array(REQUEST, workflow.get('related_persons'))
    else:
        workflow_related = []


    tls_workflow_flags = REQUEST.TLS('tls_workflow_flags')
    wf_flags = ""
    if workflow.get('workflow_flags') & _Workflow.WORKFLOW_SERIAL:
        wf_flags += "%s<br>" % REQUEST.TLS('tls_workflow_serial')
    else:
        wf_flags += "%s<br>" % REQUEST.TLS('tls_workflow_parallel')
    if workflow.get('workflow_flags') & _Workflow.WORKFLOW_INIT_EMAIL:
        wf_flags += "%s<br>"% REQUEST.TLS('tls_workflow_initmail')
    if workflow.get('workflow_flags') & _Workflow.WORKFLOW_COMPL_EMAIL:
        wf_flags += "%s<br>"% REQUEST.TLS('tls_workflow_completemail')
    if workflow.get('workflow_flags') & _Workflow.WORKFLOW_SERIAL:
        IS_SERIAL = 1
    else:
        IS_SERIAL = 0

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute((u"""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id%s""" % right_param).encode('UTF8'))
    related_persons = REQUEST.db.dictfetchall()
    persons_out = []
    for person in related_persons:
        if person['person_id'] in workflow_related:
            persons_out.append(u"""%s<BR>""" % (person['item_name'].decode('UTF8')))
    related_persons = "\n".join(persons_out)
    del persons_out

    menu = menu_output(REQUEST, workflow)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_title)s:</TD>
    <TD class="td_listing1" width="80%%">%(workflow_title)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_start)s:</TD>
    <TD class="td_listing0">%(workflow_start)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_due)s:</TD>
    <TD class="td_listing1">%(workflow_due)s</TD>
  </TR>
  <TR class="tr_listing0" valign="top">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_related)s:</TD>
    <TD class="td_listing0">%(related_persons)s</TD>
  </TR>
  <TR class="tr_listing1" valign="top">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_desc)s:</TD>
    <TD class="td_listing1">%(workflow_desc)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_percent)s:</TD>
    <TD class="td_listing0">%(percent_complete)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD  class="td_listing1">%(tls_workflow_flags)s:</TD>
    <TD  class="td_listing1">%(wf_flags)s</TD>
  </TR>
</TABLE>
"""%locals())
    sortby = [
'title ASC, due_time ASC, priority ASC', 'title DESC, due_time ASC, priority ASC',
'creator_name ASC, due_time ASC, priority ASC', 'creator_name DESC, due_time ASC, priority ASC',
'priority ASC, due_time ASC', 'priority DESC, due_time ASC',
'category ASC', 'category DESC',
'status ASC', 'status DESC',
'due_time ASC, priority ASC', 'due_time DESC, priority ASC',
'percent_complete ASC, due_time ASC, priority ASC', 'percent_complete DESC, due_time ASC, priority ASC',
]
    tls_tasks = REQUEST.TLS('tls_todos')
    tls_done = REQUEST.TLS('todo_done')
    tls_title = REQUEST.TLS('tls_title')
    tls_creator = REQUEST.TLS('tls_creator')
    tls_priority = REQUEST.TLS('tls_priority')
    tls_category = REQUEST.TLS('tls_category')
    tls_status = REQUEST.TLS('tls_status')
    tls_due = REQUEST.TLS('todo_due')
    tls_onlyme = REQUEST.TLS('todo_onlyme')
    tls_select_others = REQUEST.TLS('todo_select_others')
    tls_edit_info = REQUEST.TLS('tls_edit_info')
    tls_edit_tasks = REQUEST.TLS('tls_edit_tasks')
    tls_new_tasks = REQUEST.TLS('tls_workflow_newtasks')
    tls_responsible = REQUEST.TLS('tls_responsible')
    tls_gantt = REQUEST.TLS('tls_gantt')
    tls_clone = REQUEST.TLS('tls_clone')
    tls_sortby_no = REQUEST.TLS('tls_no')
    base_todo_url = _Conf.BASE_TODO_URL
    BASE_WORKFLOWS_URL = _Conf.BASE_WORKFLOWS_URL

    DEFAULT_SORTBY = 10
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())   
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by'])
    if IS_SERIAL:
        sortby_no = tls_sortby_no
        sortby_title = tls_title
        sortby_creator = tls_creator
        sortby_priority = tls_priority
        sortby_category = tls_category
        sortby_status = tls_status
        sortby_due = tls_due
        sortby_complete = tls_done
    else:
        sortby_no = u"""%s""" % tls_sortby_no
        sortby_title = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=0">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_title)
        sortby_creator = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=2">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
        sortby_priority = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=4">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_priority)
        sortby_category = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=6">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_category)
        sortby_status = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=8">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_status)
        sortby_due = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=10">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_due)
        sortby_complete = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=12">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_done)
        if sortby_id == 0:
            sortby_title = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=1">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_title)
        elif sortby_id == 1:
            sortby_title = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=0">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_title)
        elif sortby_id == 2:
            sortby_creator = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=3">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
        elif sortby_id == 3:
            sortby_creator = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=2">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
        elif sortby_id == 4:
            sortby_priority = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=5">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_priority)
        elif sortby_id == 5:
            sortby_priority = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=4">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_priority)
        elif sortby_id == 6:
            sortby_category = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=7">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_category)
        elif sortby_id == 7:
            sortby_category = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=6">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_category)
        elif sortby_id == 8:
            sortby_status = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=9">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_status)
        elif sortby_id == 9:
            sortby_status = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=8">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_status)
        elif sortby_id == 10:
            sortby_due = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=11">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_due)
        elif sortby_id == 11:
            sortby_due = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=10">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_due)
        elif sortby_id == 12:
            sortby_complete = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=13">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_done)
        elif sortby_id == 13:
            sortby_complete = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=12">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_done)
    del formstring

    if not REQUEST.form.has_key('gantt'):
        if IS_SERIAL:
            QUERY = u"""SELECT t.*, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND i.creator_id=p.item_id AND t.workflow_id=%d ORDER BY workflow_sequence_id asc """ % (workflow_id)
        else:
            QUERY = u"""SELECT t.*, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND i.creator_id=p.item_id AND t.workflow_id=%d ORDER BY %s """ % (workflow_id, sortby[sortby_id])
        REQUEST.db.execute(QUERY.encode('UTF8'))
        dbresult = REQUEST.db.dictfetchall()
        BASE_ICON_URL = _Conf.BASE_ICON_URL

        REQUEST.db.execute("""SELECT person_id, first_name || ' ' || last_name as person_name from persons""")
        res = REQUEST.db.fetchall()
        persons_dict = {}
        for row in res:
            persons_dict[row[0]] = row[1].decode('UTF8')


        if IS_SERIAL:
            serial_html = u"""\n      <TD class="td_listing1b" nowrap>%(sortby_no)s</TD>\n""" % locals()
        else:
            serial_html = u""

        output.append(u"""
    <BR>
    <BR>
    <TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
    <TR>
            <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
            <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
            <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<a href="%(BASE_WORKFLOWS_URL)sworkflowedit.py?workflow_id=%(workflow_id)s" class="blackboldlink"><b>%(tls_tasks)s</a></b>&nbsp;&nbsp;</TD>
            <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
            <TD>&nbsp;</TD>
            <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
            <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<a href="%(BASE_WORKFLOWS_URL)sworkflowedit.py?workflow_id=%(workflow_id)s&gantt=1" class="blackboldlink"><b>%(tls_gantt)s</b></a>&nbsp;&nbsp;</TD>
            <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
            <TD width="100%%">&nbsp;</TD>
    </TR>
    </TABLE>
    <TABLE class="td_normal" cellpadding="0" cellspacing="0">
    <TR>
      <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>%(serial_html)s
      <TD class="td_listing1b" nowrap>%(sortby_complete)s</TD>
      <TD class="td_listing1b">%(sortby_title)s</TD>
      <TD class="td_listing1b" nowrap>%(tls_responsible)s</TD>
      <TD class="td_listing1b" nowrap>%(sortby_priority)s</TD>
      <TD class="td_listing1b" nowrap>%(sortby_due)s</TD>
    </TR>""" % locals())
        index = 0
        now = _Utils.utc_now_mx()
        now = mx.DateTime.DateTime(now.year, now.month, now.day)
        serial_percent_check = 0
        for item in dbresult:
            item['class_type'] = index % 2
            index += 1
            item['BASE_TODO_URL'] = _Conf.BASE_TODO_URL
            item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

            item['markredstart'] = item['markredend'] = u""
            if item['priority'] is None: item['priority'] = "&nbsp;"
            if item['due_time'] is None:
                item['due_time'] = "&nbsp;"
            else:
                if item['percent_complete'] < 100 and now >= item['due_time']:
                    item['markredstart'] = u"<FONT color='red'>"
                    item['markredend'] = u"</FONT>"
                item['due_time'] = REQUEST.iso2userdate(item['due_time'])

            if isinstance(item['priority'], str):
                item['priority'] = item['priority'].decode('UTF8')
            item['creator_name'] = _Utils.sql_parse_array(REQUEST, item['related_persons'])
            if item['creator_name'] == []:
                item['creator_name'] = "&nbsp;"
            else:
                p_out = ""
                for person in item['creator_name']:
                    p_out = p_out + persons_dict.get(person, "N/A") + "<BR>"
                item['creator_name'] = p_out[0:-4]
            if isinstance(item['title'], str):
                item['title'] = _Utils.html_quote(item['title'].decode('UTF8'))
            
            
            if(item['percent_complete'] == 0):
                item['complete_str'] = """<IMG src="%slgreen.gif" width="50" height="4" border=0 alt="0%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
            elif(item['percent_complete'] == 100):
                item['complete_str'] = """<IMG src="%sdgreen.gif" width="50" height="4" border=0 alt="100%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
            else:
                item['first_percent']=(int) (item['percent_complete']/2)
                item['second_percent']=50 - item['first_percent']
                item['tls_complete'] = REQUEST.TLS('todo_complete')
                item['complete_str'] = ("""<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(first_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s"><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(second_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s">""" % item)
            item['returl'] = urllib.quote("%sworkflowedit.py?workflow_id=%d" % (_Conf.BASE_WORKFLOWS_URL, item['workflow_id']))
            if item['percent_complete'] <> 100:
                serial_percent_check = serial_percent_check + 1
            if IS_SERIAL:
                item['workflow_sequence_id'] = item['workflow_sequence_id'] + 1
                item['serial_html'] = u"""\n            <TD width="1%%" class="td_listing%(class_type)d">%(workflow_sequence_id)s</TD>\n""" % item
            else:
                item['serial_html'] = u""
            if serial_percent_check == 1 and dbresult[-1]<>item:
                    item['class_type2'] = index % 2
                    item['tls_upcoming'] = REQUEST.TLS('tls_upcoming_tasks')
                    item['serial_upcoming_html'] = u"""
    <TR>
      <TD class="td_listing%(class_type2)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
      <TD class="td_listing%(class_type2)db" nowrap colspan="6">%(tls_upcoming)s</TD>
    </TR>""" % item
                    index += 1
            else:
                item['serial_upcoming_html'] = u""
            output.append(u"""<TR>
      <TD width="1%%" class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>%(serial_html)s
      <TD width="1%%" class="td_listing%(class_type)d" style="text-align: center">
          <TABLE border=0 width=54 cellpadding=1 cellspacing=0 bgcolor="#000000">
            <TR>
              <TD>
                <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 bgcolor="#FFFFFF">
                  <TR>
                    <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                  </TR>
                  <TR>
                    <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                    <TD bgcolor="#FFFFFF" width="100%%">%(complete_str)s</TD>
                    <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                  </TR>
                  <TR>
                    <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                  </TR>
                </TABLE>
              </TD>
            </TR>
          </TABLE>
       </TD>
      <TD class="td_listing%(class_type)d" width="40%%"><A class="td_listing" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)d&returl=%(returl)s">%(markredstart)s%(title)s%(markredend)s</A></TD>
      <TD class="td_listing%(class_type)d" width="20%%" nowrap>%(markredstart)s%(creator_name)s%(markredend)s</TD>
      <TD class="td_listing%(class_type)d" width="14%%" nowrap>%(markredstart)s%(priority)s%(markredend)s</TD>
      <TD class="td_listing%(class_type)d" width="14%%" nowrap>%(markredstart)s%(due_time)s%(markredend)s</TD>
    </TR>%(serial_upcoming_html)s""" % item)
        output.append("""\
    </TABLE>
    """)
    else:
        SQL = """\
SELECT
t.title,
coalesce(t.start_time, i.create_time) as start,
coalesce(t.due_time, (SELECT l.change_time from item_log l where i.item_id=l.item_id and l.field_name='percent_complete' and l.new_value='100' order by change_time desc limit 1)) as due
FROM
items i, todos t where i.item_id=t.todo_id and t.workflow_id=%s order by start asc, due asc""" % workflow_id
        REQUEST.db.execute(SQL)
        res = REQUEST.db.fetchall()
        min = workflow.get('workflow_start_time')
        max = workflow.get('workflow_due_time')
        res2 = []
        res2.append((workflow.get('item_name').encode('UTF8'), min, max))
        for row in res:
            if row[1] and row[2] and row[2]>row[1]:
                if row[1]<min:
                    min = row[1]
                if row[2]>max:
                    max = row[2]
                res2.append(row)
        dur = (max - min).hours
        step = dur/8.00
        tmp = min
        maxwidth = 600
        output.append(u"""
<BR>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
<TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
    <TD class="td_listing1b" colspan="10">%(tls_gantt)s</TD>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
</TR>
<TR>
    <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>""" % locals())
        for i in range(0, 9):
            output.append(u"""<TD><b>%s</b>&nbsp;</TD>""" % REQUEST.iso2userdate(tmp))
            tmp = tmp + mx.DateTime.DateTimeDelta(0, step)
        output.append(u"""
    <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
</TR>""" % locals())
        if not dur: dur  = 1
        for row in res2:
            title = _Utils.shorten_string(_Utils.html_quote_show(row[0].decode('UTF8')), 25)
            w1 = int((row[1] - min).hours/dur*maxwidth)
            w2 = int((row[2] - row[1]).hours/dur*maxwidth)
            w3 = int((max - row[2]).hours/dur*maxwidth)
            duration = "%s - %s" % (REQUEST.iso2userdate(row[1]), REQUEST.iso2userdate(row[2]))
            i1 = """<img src="%sspacer.gif" width="%s" height="10" border="0" alt="">""" % (_Conf.BASE_ICON_URL, w1)
            i2 = """<img style="border: 1px solid black;" src="%sdgreen.gif" width="%s" height="10" border="0" alt="" title="%s">""" % (_Conf.BASE_ICON_URL, w2, duration)
            i3 = """<img src="%sspacer.gif" width="%s" height="10" border="0" alt="">""" % (_Conf.BASE_ICON_URL, w3)
            output.append(u"""
<TR>
    <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
    <TD class="td_listing_noborder" nowrap>%(title)s</TD>
    <TD colspan="9" nowrap>%(i1)s%(i2)s%(i3)s</TD>
    <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
</TR>""" % locals())
        output.append(u"""</TABLE>""")


    if _Access.get_item_right(REQUEST, workflow.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        output.append(u"""\
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing_noborder" width="100%%"><FORM method="POST" action="%(BASE_WORKFLOWS_URL)sworkflowedit.py"><input type="hidden" name="workflow_id" value="%(workflow_id)d"><input type="submit" name="edit" value="%(tls_edit_info)s" class="input2">&nbsp;<input type="submit" name="tasks" value="%(tls_edit_tasks)s" class="input2">&nbsp;<input type="submit" name="new_tasks" value="%(tls_new_tasks)s" class="input2">&nbsp;<input type="submit" name="clone" value="%(tls_clone)s" class="input2"></FORM></TD>
  </TR>
</TABLE>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(get_workflows_menu(REQUEST, -1))
    if not REQUEST.form.has_key('workflow_id'):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    workflow_id = int(REQUEST.form['workflow_id'].value)
    workflow = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['workflow_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_WORKFLOWS_URL = _Conf.BASE_WORKFLOWS_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_edittodo = REQUEST.TLS('todo_edittodo')
    tls_save = REQUEST.TLS('tls_save')
    tls_title = REQUEST.TLS('tls_title')
    tls_start = REQUEST.TLS('todo_starttime')
    tls_due = REQUEST.TLS('todo_duetime')
    tls_related = REQUEST.TLS('tls_related')
    tls_desc = REQUEST.TLS('tls_description')
    tls_percent = REQUEST.TLS('todo_percentcomplete')
    tls_workflow = REQUEST.TLS('tls_workflow')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_save = REQUEST.TLS('tls_save')
    tls_delete = REQUEST.TLS('tls_delete')
    tls_deletesel = REQUEST.TLS('tls_delete')
    email_confirm_del = REQUEST.TLS('tls_confirm_del')
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    workflow_title = _Utils.html_quote_edit(workflow.get('workflow_title'))
    workflow_start = REQUEST.iso2userdate(workflow.get('workflow_start_time'))
    workflow_due = REQUEST.iso2userdate(workflow.get('workflow_due_time'))
    workflow_desc = _Utils.html_quote_edit(workflow.get('workflow_description'))
    workflow_complete = workflow.get('percent_complete')
    if workflow.get('related_persons'):
        workflow_related = _Utils.sql_parse_array(REQUEST, workflow.get('related_persons'))
    else:
        workflow_related = []

    tls_workflow_flags = REQUEST.TLS('tls_workflow_flags')
    wf_flags = ""
    if workflow.get('workflow_flags') & _Workflow.WORKFLOW_SERIAL:
        wf_flags += "%s<br>" % REQUEST.TLS('tls_workflow_serial')
    else:
        wf_flags += "%s<br>" % REQUEST.TLS('tls_workflow_parallel')
    if workflow.get('workflow_flags') & _Workflow.WORKFLOW_INIT_EMAIL:
        wf_flags += "%s<br>"% REQUEST.TLS('tls_workflow_initmail')
    if workflow.get('workflow_flags') & _Workflow.WORKFLOW_COMPL_EMAIL:
        wf_flags += "%s<br>"% REQUEST.TLS('tls_workflow_completemail')

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute((u"""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id%s""" % right_param).encode('UTF8'))
    related_persons = REQUEST.db.dictfetchall()
    related_persons = filter(None, map(lambda x: (_Access.get_item_right(REQUEST, REQUEST.USER.get_parent_id(REQUEST), x['person_id']) > _Access.ACCESS_NONE and x) or None, related_persons))
    persons_out = ["""<SELECT class="textfield1" name="related_persons" multiple size="5">"""]
    for person in related_persons:
        if person['person_id'] in workflow_related:
            persons_out.append(u"""<OPTION value="%d" SELECTED>%s""" % (person['person_id'], person['item_name'].decode('UTF8')))
        else:
            persons_out.append(u"""<OPTION value="%d">%s""" % (person['person_id'], person['item_name'].decode('UTF8')))
    persons_out.append("""</SELECT>""")
    related_persons = "\n".join(persons_out)

    menu = menu_output(REQUEST, workflow)
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append(u"""\
<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.editform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
  function check_values()
  {
    if (!document.editform.title.value||!document.editform.start_time.value||!document.editform.due_time.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
%(datecheck_js)s
// -->
</SCRIPT>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="editform" action="%(BASE_WORKFLOWS_URL)sworkflowedit.py/save" method="POST" onsubmit="return check_values();">
<INPUT type="hidden" name="workflow_id" value="%(workflow_id)s">
  <TR>
    <TD colspan="3">%(menu)s</TD>
  </TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_title)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" width="80%%"><INPUT class="textfield3" size="50" type="text" name="title" value="%(workflow_title)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_start)s%(REQ_FIELD)s</TD>
    <TD class="td_listing0"><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="start_time" id="start_time" value="%(workflow_start)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_due)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1"><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="due_time" id="due_time" value="%(workflow_due)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('due_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_related)s</TD>
    <TD class="td_listing0">%(related_persons)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD  class="td_listing1" colspan="2">%(tls_desc)s<BR><TEXTAREA class="textarea1" name="description" rows="3" cols="20">%(workflow_desc)s</TEXTAREA></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_percent)s</TD>
    <TD class="td_listing0">%(workflow_complete)d%%</TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD  class="td_listing1">%(tls_workflow_flags)s</TD>
    <TD  class="td_listing1">%(wf_flags)s</TD>
  </TR>""" % locals())
    if _Access.get_item_right(REQUEST, workflow.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        output.append(u"""
  <TR>
    <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing_noborder" width="100%%" colspan="2"><input type="submit" name="_save" value="%(tls_save)s" class="input2">&nbsp;<INPUT type="submit" class="input2" name="_delete" value="%(tls_deletesel)s" onClick="return confirm('%(email_confirm_del)s');"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    else:
        output.append(u"""
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def tasks(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_workflows_menu(REQUEST, -1))
    if not REQUEST.form.has_key('workflow_id'):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    workflow_id = int(REQUEST.form['workflow_id'].value)
    workflow = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['workflow_id'].value))
    
#
#    Already related tasks...
#
    
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_tasks = REQUEST.TLS('tls_todos')
    tls_done = REQUEST.TLS('todo_done')
    tls_title = REQUEST.TLS('tls_title')
    tls_creator = REQUEST.TLS('tls_responsible')
    tls_priority = REQUEST.TLS('tls_priority')
    tls_due = REQUEST.TLS('todo_due')
    tls_onlyme = REQUEST.TLS('todo_onlyme')
    tls_select_others = REQUEST.TLS('todo_select_others')
    tls_edit_info = REQUEST.TLS('tls_edit_info')
    tls_edit_tasks = REQUEST.TLS('tls_edit_tasks')
    tls_complete = REQUEST.TLS('todo_complete')
    base_todo_url = _Conf.BASE_TODO_URL
    BASE_WORKFLOWS_URL = _Conf.BASE_WORKFLOWS_URL
    QUERY = u"""SELECT t.*, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND i.creator_id=p.item_id AND t.workflow_id=%d ORDER BY workflow_sequence_id, due_time desc""" % (workflow_id)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_related_tasks = REQUEST.TLS('tls_related_tasks')
    tls_other_tasks = REQUEST.TLS('tls_other_tasks')
    tls_object = REQUEST.TLS('log_workflow_id')
    object_name = workflow.get('item_name')


    REQUEST.db.execute("""SELECT person_id, first_name || ' ' || last_name as person_name from persons""")
    res = REQUEST.db.fetchall()
    persons_dict = {}
    for row in res:
        persons_dict[row[0]] = row[1].decode('UTF8')


    output.append(u"""
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
  <TD width="100%%" class="object_name">%(tls_object)s: %(object_name)s</TD>
</TR>
<TR>
  <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="15" border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM method="POST" action="%(BASE_WORKFLOWS_URL)sworkflowedit.py">
<INPUT type="hidden" name="workflow_id" value="%(workflow_id)s">
<INPUT type="hidden" name="tasks" value="1">
  <TR>
    <TD colspan=6 width="100%%">
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
          <TD nowrap><span class="t3">%(tls_related_tasks)s</span></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" nowrap>&nbsp;</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" nowrap>%(tls_complete)s</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b">%(tls_title)s</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" nowrap>%(tls_creator)s</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" nowrap>%(tls_priority)s</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" nowrap>%(tls_due)s</TD>
  </TR>""" % locals())
    index = 0
    now = _Utils.utc_now_mx()
    now = mx.DateTime.DateTime(now.year, now.month, now.day)
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_TODO_URL'] = _Conf.BASE_TODO_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        item['markredstart'] = item['markredend'] = u""
        if item['priority'] is None: item['priority'] = "&nbsp;"
        if item['due_time'] is None:
            item['due_time'] = "&nbsp;"
        else:
            if item['percent_complete'] < 100 and now >= item['due_time']:
                item['markredstart'] = u"<FONT color='red'>"
                item['markredend'] = u"</FONT>"
            item['due_time'] = REQUEST.iso2userdate(item['due_time'])

        if isinstance(item['priority'], str):
            item['priority'] = item['priority'].decode('UTF8')
        item['creator_name'] = _Utils.sql_parse_array(REQUEST, item['related_persons'])
        if item['creator_name'] == []:
            item['creator_name'] = "&nbsp;"
        else:
            p_out = ""
            for person in item['creator_name']:
                p_out = p_out + persons_dict.get(person, "N/A") + "<BR>"
            item['creator_name'] = p_out[0:-4]
        if isinstance(item['title'], str):
            item['title'] = _Utils.html_quote(item['title'].decode('UTF8'))
        
        
        if(item['percent_complete'] == 0):
            item['complete_str'] = """<IMG src="%slgreen.gif" width="50" height="4" border=0 alt="0%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        elif(item['percent_complete'] == 100):
            item['complete_str'] = """<IMG src="%sdgreen.gif" width="50" height="4" border=0 alt="100%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        else:
            item['first_percent']=(int) (item['percent_complete']/2)
            item['second_percent']=50 - item['first_percent']
            item['tls_complete'] = REQUEST.TLS('todo_complete')
            item['complete_str'] = ("""<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(first_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s"><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(second_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s">""" % item)
        output.append(u"""\
  <TR>
   <TD class="td_listing%(class_type)d" width="5%%"  style="text-align: center"><INPUT type="checkbox" name="del_%(todo_id)d"></TD>
   <TD class="td_listing%(class_type)d" style="text-align: center">
      <TABLE border=0 width=54 cellpadding=1 cellspacing=0 bgcolor="#000000">
        <TR>
          <TD>
            <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 bgcolor="#FFFFFF">
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                <TD bgcolor="#FFFFFF" width="100%%">%(complete_str)s</TD>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
   </TD>
   <TD class="td_listing%(class_type)d" width="40%%"><A class="td_listing" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)d">%(markredstart)s%(title)s%(markredend)s</A></TD>
   <TD class="td_listing%(class_type)d" width="20%%" nowrap>%(markredstart)s%(creator_name)s%(markredend)s</TD>
   <TD class="td_listing%(class_type)d" width="15%%" nowrap>%(markredstart)s%(priority)s%(markredend)s</TD>
   <TD class="td_listing%(class_type)d" width="15%%" nowrap>%(markredstart)s%(due_time)s%(markredend)s</TD>
  </TR>""" % item)
    output.append("""</TABLE>""")
    
    output.append(u"""\
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing_noborder"><img src="%sspacer.gif" width=10 height=10 border=0 alt=""></TD>
    <TD class="td_listing_noborder" width="100%%"><INPUT type="submit" name="_delete" class="input2" value="%s"></TD>
  </TR>
</TABLE>""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('tls_remove')))
#
#    Selection of everything else...
#
    sortby = [
'title ASC', 'title DESC',
'creator_name ASC', 'creator_name DESC',
'priority ASC', 'priority DESC',
'category ASC', 'category DESC',
'status ASC', 'status DESC',
'due_time ASC', 'due_time DESC',
'percent_complete ASC', 'percent_complete DESC',
]
    DEFAULT_SORTBY = 12
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())   
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by'])
    sortby_title = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=0">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_title)
    sortby_creator = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=2">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
    sortby_priority = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=4">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_priority)
    sortby_due = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=10">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_due)
    sortby_complete = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=12">%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_done)
    if sortby_id == 0:
        sortby_title = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=1">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_title)
    elif sortby_id == 1:
        sortby_title = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=0">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_title)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=3">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=2">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_creator)
    elif sortby_id == 4:
        sortby_priority = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=5">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_priority)
    elif sortby_id == 5:
        sortby_priority = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=4">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_priority)
    elif sortby_id == 10:
        sortby_due = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=11">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_due)
    elif sortby_id == 11:
        sortby_due = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=10">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_due)
    elif sortby_id == 12:
        sortby_complete = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=13">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_done)
    elif sortby_id == 13:
        sortby_complete = u"""<A class="blackboldlink" href="%sworkflowedit.py%ssort_by=12">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_WORKFLOWS_URL, formstring, tls_done)
    del formstring
    
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_TODO])
    if right_param:
        right_param = " AND " + right_param
    
    REQUEST.db.execute("""SELECT person_id, first_name || ' ' || last_name as person_name from persons""")
    res = REQUEST.db.fetchall()
    persons_dict = {}
    for row in res:
        persons_dict[row[0]] = row[1].decode('UTF8')
    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = None

    try:
        show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        show_groups = None

    if show_groups:
        dic = {}
        REQUEST.db.execute("""SELECT members from calendar_groups where group_id in (%s)""" % ",".join(map(str, show_groups)))
        group_members = map(lambda x:_Utils.sql_parse_array(REQUEST, x[0]), REQUEST.db.fetchall())
        for gr in group_members:
            for member in gr:
                dic[member]=1
        group_members = dic.keys()
        if show_users:
            show_users+=group_members
        else:
            show_users=group_members

    if show_users: # Show involved people
        users_limit = []
        for userid in show_users:
            users_limit.append("""i.creator_id = %d""" % userid)
            if REQUEST.db.version < 740:
                users_limit.append("""t.related_persons @ '{%d}'::int[]""" % userid)
            else:
                users_limit.append("""%d=ANY(t.related_persons)""" % userid)
        users_limit = "\n     (%s) " % " OR ".join(users_limit)
    else: # show only personal stuff
        if REQUEST.db.version < 740:
            users_limit = """\n     (i.creator_id = %d OR t.related_persons @ '{%d}'::int[])""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
        else:
            users_limit = """\n     (i.creator_id = %d OR %d=ANY(t.related_persons))""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())

    QUERY = u"""SELECT COUNT(*) AS count_all FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id %s AND workflow_id IS NULL AND %s""" % (right_param, users_limit)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sworkflowedit.py%sqs=" % (_Conf.BASE_WORKFLOWS_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sworkflowedit.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_WORKFLOWS_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sworkflowedit.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_WORKFLOWS_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    QUERY = u"""SELECT t.*, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p 
    WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id %s AND workflow_id IS NULL AND %s ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, users_limit, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    
    output.append(u"""\
<BR>
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD colspan=6 width="100%%">
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
          <TD nowrap><span class="t3">%(tls_other_tasks)s</span></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b">&nbsp;</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" nowrap>%(sortby_complete)s</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b">%(sortby_title)s</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" nowrap>%(tls_creator)s</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" nowrap>%(sortby_priority)s</TD>
   <TD style="border-top: 1px solid #CCCCCC" class="td_listing1b" nowrap>%(sortby_due)s</TD>
  </TR>""" % locals())
    index = 0
    now = _Utils.utc_now_mx()
    now = mx.DateTime.DateTime(now.year, now.month, now.day)
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_TODO_URL'] = _Conf.BASE_TODO_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        item['markredstart'] = item['markredend'] = u""
        if item['priority'] is None: item['priority'] = "&nbsp;"
        if item['due_time'] is None:
            item['due_time'] = "&nbsp;"
        else:
            if item['percent_complete'] < 100 and now >= item['due_time']:
                item['markredstart'] = u"<FONT color='red'>"
                item['markredend'] = u"</FONT>"
            item['due_time'] = REQUEST.iso2userdate(item['due_time'])

        if isinstance(item['priority'], str):
            item['priority'] = item['priority'].decode('UTF8')
        item['creator_name'] = _Utils.sql_parse_array(REQUEST, item['related_persons'])
        if item['creator_name'] == []:
            item['creator_name'] = "&nbsp;"
        else:
            p_out = ""
            for person in item['creator_name']:
                p_out = p_out + persons_dict.get(person, "N/A") + "<BR>"
            item['creator_name'] = p_out[0:-4]
        if isinstance(item['title'], str):
            item['title'] = _Utils.html_quote(item['title'].decode('UTF8'))
        
        
        if(item['percent_complete'] == 0):
            item['complete_str'] = """<IMG src="%slgreen.gif" width="50" height="4" border=0 alt="0%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        elif(item['percent_complete'] == 100):
            item['complete_str'] = """<IMG src="%sdgreen.gif" width="50" height="4" border=0 alt="100%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        else:
            item['first_percent']=(int) (item['percent_complete']/2)
            item['second_percent']=50 - item['first_percent']
            item['tls_complete'] = REQUEST.TLS('todo_complete')
            item['complete_str'] = ("""<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(first_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s"><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(second_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s">""" % item)
        output.append(u"""<TR>
  <TD class="td_listing%(class_type)d" width="5%%"  style="text-align: center"><INPUT type="checkbox" name="sel_%(todo_id)d"></TD>
  <TD class="td_listing%(class_type)d" style="text-align: center">
      <TABLE border=0 width=54 cellpadding=1 cellspacing=0 bgcolor="#000000">
        <TR>
          <TD>
            <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 bgcolor="#FFFFFF">
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                <TD bgcolor="#FFFFFF" width="100%%">%(complete_str)s</TD>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
   </TD>
  <TD class="td_listing%(class_type)d" width="40%%"><A class="td_listing" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)d">%(markredstart)s%(title)s%(markredend)s</A></TD>
  <TD class="td_listing%(class_type)d" width="20%%" nowrap>%(markredstart)s%(creator_name)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d" width="15%%" nowrap>%(markredstart)s%(priority)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d" width="15%%" nowrap>%(markredstart)s%(due_time)s%(markredend)s</TD>
</TR>""" % item)
    output.append("""\
</TABLE>
""")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(u"""\
<BR>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing_noborder"><img src="%sspacer.gif" width=10 height=10 border=0 alt=""></TD>
    <TD class="td_listing_noborder" width="100%%"><INPUT type="submit" name="_add" class="input2" value="%s"></TD>
  </TR>
</TABLE>
</FORM>""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('tls_add')))
    return "\n".join(output)
    
def save(REQUEST):
    if not REQUEST.form.has_key('workflow_id'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output = []
    output.append(standard_html.html_header(REQUEST))
   
    workflow = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['workflow_id'].value))
    if REQUEST.form.has_key('_delete'):
        workflow.delete()
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_WORKFLOWS_URL+"workflowindex.py"
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(get_workflows_menu(REQUEST, -1))
        output.append(standard_html.html_footer(REQUEST))
        return "\n".join(output)

    ref_url = REQUEST.SERVER_URL+_Conf.BASE_WORKFLOWS_URL+"workflowedit.py?workflow_id="+REQUEST.form['workflow_id'].value
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_workflows_menu(REQUEST, -1))
    if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    workflow.set('workflow_title', REQUEST.form['title'].value)
    if REQUEST.form['start_time'].value:
        try: workflow.set('workflow_start_time', REQUEST.user2isodate(REQUEST, REQUEST.form['start_time'].value))
        except ValueError:
            raise RuntimeError, REQUEST.TLS('tls_invdateformat')
    else:
        workflow.set('workflow_start_time', None)
    if REQUEST.form['due_time'].value:
        try: workflow.set('workflow_due_time', REQUEST.user2isodate(REQUEST, REQUEST.form['due_time'].value))
        except ValueError:
            raise RuntimeError, REQUEST.TLS('tls_invdateformat')
    else:
        workflow.set('workflow_due_time', None)
    workflow.set('workflow_description', REQUEST.form['description'].value)
    if REQUEST.form.has_key('related_persons'):
        try:
            workflow.set('related_persons', [int(REQUEST.form['related_persons'].value)])
        except AttributeError:
            workflow.set('related_persons', REQUEST.form['related_persons'])
    else:
        workflow.set('related_persons', [])
    workflow.save()
    output.append(REQUEST.TLS('tls_workflow_saved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


def relations_contents(REQUEST):
    if not REQUEST.form.has_key('workflow_id') or not REQUEST.form['workflow_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    workflow_id = REQUEST.form['workflow_id'].value
    obj = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['workflow_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WORKFLOW_URL = _Conf.BASE_WORKFLOWS_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_workflows_menu(REQUEST, -1))
    menu = menu_output(REQUEST, obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    relation_output = relations.show_relations(REQUEST, obj)
    output.append(relation_output)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def notes_contents(REQUEST):
    if not REQUEST.form.has_key('workflow_id') or not REQUEST.form['workflow_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['workflow_id'].value)
    obj = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, obj_id)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_workflows_menu(REQUEST, -1))
    menu = menu_output(REQUEST, obj)
    menu = u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals()
    BASE_WORKFLOWS_URL = _Conf.BASE_WORKFLOWS_URL
    returl = "%(BASE_WORKFLOWS_URL)sworkflowedit.py?workflow_id=%(obj_id)s&note=1" % locals()
    returl = urllib.quote(returl)
    show_menu = "workflows"
    output.append(_Usernote.note_out(REQUEST, obj, obj_id, returl, menu, show_menu))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def show_log(REQUEST, obj_id):
    obj = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(obj_id))
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_workflows_menu(REQUEST, -1))
    menu = menu_output(REQUEST, obj)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
  <TR>
    <TD>%(menu)s</TD>
  </TR>
</TABLE>""" % locals())
    output.append(_Log.standard_log_output(REQUEST, obj_id))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST, obj):
    if not REQUEST.form.has_key('workflow_id') or not REQUEST.form['workflow_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output=[]
    workflow_id = int(REQUEST.form['workflow_id'].value)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WORKFLOW_URL = _Conf.BASE_WORKFLOWS_URL

    tls_viewclient = REQUEST.TLS('clients_view')
    tls_info = REQUEST.TLS('contact_info')
    tls_relations = REQUEST.TLS('tls_relations')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_notes = REQUEST.TLS('compmenu_todo_notes')
    tls_log = REQUEST.TLS('log_log')
    relations_count = relations.relations_count(REQUEST, obj)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT count(*) FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s""" % (workflow_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    note_count = REQUEST.db.fetchone()[0]


    active = 0
    if REQUEST.form.has_key('rel') and REQUEST.form['rel'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_WORKFLOW_URL)sworkflowedit.py?workflow_id=%(workflow_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_WORKFLOW_URL)sworkflowedit.py?workflow_id=%(workflow_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('note') and REQUEST.form['note'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_WORKFLOW_URL)sworkflowedit.py?workflow_id=%(workflow_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_WORKFLOW_URL)sworkflowedit.py?workflow_id=%(workflow_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('log') and REQUEST.form['log'].value=='1':
      active = 1
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_WORKFLOW_URL)sworkflowedit.py?workflow_id=%(workflow_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_WORKFLOW_URL)sworkflowedit.py?workflow_id=%(workflow_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_WORKFLOW_URL)sworkflowedit.py?workflow_id=%(workflow_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_WORKFLOW_URL)sworkflowedit.py?workflow_id=%(workflow_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()


    tls_object = REQUEST.TLS('log_workflow_id')
    object_name =  _Utils.html_quote_show(obj.get('item_name'))
    output.append(standard_html.standard_objname(REQUEST, tls_object, object_name, obj.get('item_type_id')))
    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el5)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)

def new_tasks(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(get_workflows_menu(REQUEST, -1))
    if not REQUEST.form.has_key('workflow_id'):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    workflow_id = int(REQUEST.form['workflow_id'].value)
    workflow = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['workflow_id'].value))
    workflow_name = workflow.get('item_name')
    
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_WORKFLOWS_URL = _Conf.BASE_WORKFLOWS_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_title = REQUEST.TLS('tls_title')
    tls_save = REQUEST.TLS('tls_save')
    tls_start = REQUEST.TLS('todo_starttime')
    tls_due = REQUEST.TLS('todo_duetime')
    tls_related = REQUEST.TLS('tls_responsible_per')
    tls_desc = REQUEST.TLS('tls_description')
    tls_task = REQUEST.TLS('tls_todo')
    tls_workflow = REQUEST.TLS('tls_workflow')
    tls_add_tasks = REQUEST.TLS('tls_workflow_newtasks')
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      returl = REQUEST.form['returl'].value
    else:
      returl = ""

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute(("""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id AND p.person_id<>%d%s""" % (REQUEST.USER.get_id(), right_param)).encode('UTF8'))
    related_persons = REQUEST.db.dictfetchall()

    datecheck_js = REQUEST.datecheck_js(REQUEST)

    n = 0
    tasks = []
    num_rows = 5
    while(n<num_rows):
        if(n%2) == 0:
            td_class = 1
        else:
            td_class = 0
        task_num = n+1
        if n == 0:
            extra_style = """ style="border-top: 1px solid #CCCCCC" """
        else:
            extra_style = ""
        tasks.append(u"""
  <TR class="tr_listing%(td_class)s">
    <TD %(extra_style)s class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD %(extra_style)s class="td_listing%(td_class)s">
      <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
        <TR>
          <TD colspan="4">%(tls_task)s %(task_num)d</TD>
        </TR>
        <TR valign="top">
          <TD class="td_listing%(td_class)sbb">%(tls_title)s<br><input type="text" name="form_%(n)d_title" class="textfield2"></TD>
          <TD class="td_listing%(td_class)sbb">%(tls_due)s<br><input size="10" name="form_%(n)d_due" id="form_%(n)d_due" type="text" class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('form_%(n)d_due', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
          <TD class="td_listing%(td_class)sbb" valign="top" >%(tls_related)s<br><div id="%(n)d"><SELECT size="3" multiple name="form_%(n)d_related"><OPTION>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</SELECT>&nbsp;<A href="javascript:void(0);" OnClick="rel_popup('%(BASE_GENERAL_URL)spopuprel.py?ret=form_%(n)d_related&amp;num=%(n)d', 'form_%(n)d_related');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" align="top" style="position: relative; top: 2px;"></A></DIV></TD>
          <TD class="td_listing%(td_class)sbb">%(tls_desc)s<br><input name="form_%(n)d_desc" size=40 type="text" class="textfield2"></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>""" % locals())
        n+=1
    alltasks = "\n".join(tasks)

    tls_object = REQUEST.TLS('log_workflow_id')
    object_name = workflow.get('item_name')
    output.append(u"""\
<SCRIPT type="text/JavaScript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.addform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}

function check_values()
{
  return true;
}
%(datecheck_js)s

function rel_popup(url)
{
    window.open(url,'popuprel','width=750,height=170,scrollbars=no');
}
// -->
</SCRIPT>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
  <TD width="100%%" class="object_name">%(tls_object)s: %(object_name)s</TD>
</TR>
<TR>
  <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="15" border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_WORKFLOWS_URL)sworkflowedit.py/save_new_tasks" onsubmit="return check_values();">
<INPUT type="hidden" name="returl" value="%(returl)s">
<INPUT type="hidden" name="workflow_id" value="%(workflow_id)s">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
        <TD><img src="%(BASE_ICON_URL)scf_ico2.jpg" width=20 height=20 border=0 alt="" vspace="5"></TD>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
        <TD nowrap><span class="t3">%(tls_add_tasks)s</span></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
%(alltasks)s
<TR class="tr_listing0">
  <TD class="td_listing_noborder"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing_noborder"><INPUT type="submit" class="input2" name="_save" value="%(tls_save)s">&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def save_new_tasks(REQUEST):
    if not REQUEST.form.has_key('workflow_id'):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    workflow_id = int(REQUEST.form['workflow_id'].value)
    wf = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['workflow_id'].value))
    multiform = MultiForm.MultiForm(REQUEST)
    for rowkey in multiform.rows.keys():
        row = multiform.rows[rowkey]
        if not row.has_key('title') or not row['title'].strip():
            continue
        task = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_NEW)
        task.set('parent_id', REQUEST.USER.get_id())
        task.set('workflow_id', wf.get_id())
        task.set('title', row['title'])
        if row.has_key('desc') and row['desc'].strip():
            task.set('description', row['desc'])
        if row.has_key('due') and row['due'].strip():
            try:
                task.set('due_time', REQUEST.user2isodate(REQUEST, row['due']))
            except ValueError:
                raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        else:
            task.set('due_time', None)
        if row.has_key('related'):
            try:
                task.set('related_persons', [int(row['related'])])
            except TypeError:
                task.set('related_persons', row['related'])
        else:
            task.set('related_persons', [])
        task.set('status', '')
        task.set('priority', '')
        task.set('category', '')
        task.set('workflow_sequence_id', rowkey)
        task.save()
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
        REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
        return apache.HTTP_MOVED_TEMPORARILY
    output = []

    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_WORKFLOWS_URL+"workflowedit.py?workflow_id="+REQUEST.form['workflow_id'].value
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_workflows_menu(REQUEST, -1))
    output.append(REQUEST.TLS('tls_workflow_saved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def clone_form(REQUEST):
    if not REQUEST.form.has_key('workflow_id') or not REQUEST.form['workflow_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    workflow_id = int(REQUEST.form['workflow_id'].value)
    workflow = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['workflow_id'].value))

    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(get_workflows_menu(REQUEST, MY_MENU_ID))
    
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_WORKFLOWS_URL = _Conf.BASE_WORKFLOWS_URL
    tls_save = REQUEST.TLS('tls_preview')
    tls_title = REQUEST.TLS('tls_title')
    tls_start = REQUEST.TLS('todo_starttime')
    tls_due = REQUEST.TLS('todo_duetime')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_clone_workflow = REQUEST.TLS('tls_cloneworkflow')
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    
    form_title = workflow.get('workflow_title')
    form_start_time = REQUEST.iso2userdate(workflow.get('workflow_start_time')) or ""
    form_due_time = REQUEST.iso2userdate(workflow.get('workflow_due_time')) or ""
    related_persons = _Utils.sql_parse_array(REQUEST, workflow.get('related_persons')) or []
    p_str = ""
    for person in related_persons:
        p_str = p_str + u"""<INPUT type="hidden" name="related_persons" value="%s">""" % person
    description = workflow.get('description') or u""
    workflow_flags = workflow.get('workflow_flags')
    if workflow_flags & _Workflow.WORKFLOW_SERIAL:
        is_serial= u"""<INPUT type="hidden" name="is_serial" value="1">"""
    else:
        is_serial=""
    if workflow_flags & _Workflow.WORKFLOW_INIT_EMAIL:
        email_start=u"""<INPUT type="hidden" name="email_start" value="1">"""
    else:
        email_start=""
    if workflow_flags & _Workflow.WORKFLOW_COMPL_EMAIL:
        email_done=u"""<INPUT type="hidden" name="email_done" value="1">"""
    else:
        email_done=""
    
    tasks = []
    SQL = """SELECT title, start_time, due_time, description, related_persons FROM todos where workflow_id=%d""" % workflow_id
    REQUEST.db.execute(SQL)
    res = REQUEST.db.fetchall()
    n = 0
    for row in res:
        tasks.append(u"""<input type="hidden" name="form_%d_title" value="%s">""" % (n, _Utils.html_quote_edit(row[0].decode('UTF8')) or ''))
        if row[1] is None:
            tasks.append(u"""<input type="hidden" name="form_%d_start" value="%s">""" % (n, ''))
        else:
            tasks.append(u"""<input type="hidden" name="form_%d_start" value="%s">""" % (n, REQUEST.iso2userdate(row[1]) or ''))
        if row[2] is None:
            tasks.append(u"""<input type="hidden" name="form_%d_due" value="%s">""" % (n, ''))
        else:
            tasks.append(u"""<input type="hidden" name="form_%d_due" value="%s">""" % (n, REQUEST.iso2userdate(row[2]) or ''))
        tasks.append(u"""<input type="hidden" name="form_%d_desc" value="%s">""" % (n, _Utils.html_quote_edit(row[3].decode('UTF8')) or ''))
        rp = _Utils.sql_parse_array(REQUEST, row[4]) or []
        for r in rp:
            tasks.append(u"""<input type="hidden" name="form_%d_related" value="%s">""" % (n, r))
        n = n + 1
    task_str = "\n".join(tasks)
    output.append(u"""
<TABLE class="td_normal_noborder" cellpadding="0" cellspacing="0">
<FORM name="addform" method="POST" action="%(BASE_WORKFLOWS_URL)sworkflowadd.py">
<INPUT type="hidden" name="wf_id" value="%(workflow_id)s">
%(p_str)s
%(is_serial)s
%(email_start)s
%(email_done)s
%(task_str)s
<INPUT type="hidden" name="description" value="%(description)s">
<TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)stitle_16.gif" width=20 height=20 border=0 alt="" vspace="5"></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=7 height=1 border=0 alt=""></TD>
    <TD nowrap><span class="t3">%(tls_clone_workflow)s</span></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE class="td_normal" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing1ke" nowrap>%(tls_title)s:</TD>
    <TD class="td_listing1" nowrap><INPUT class="textfield3" type="text" name="title" size="50" value="%(form_title)s"></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing0ke" nowrap>%(tls_start)s:</TD>
    <TD class="td_listing0" nowrap><INPUT size="10" class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="start_time"  id="start_time" value="%(form_start_time)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1ke" nowrap>%(tls_due)s:</TD>
    <TD class="td_listing1" nowrap><INPUT size="10" class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="due_time" id="due_time" value="%(form_due_time)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('due_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
    <TD class="td_listing1" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing_noborder" colspan="2"><INPUT type="submit" class="input2" name="_save" value="%(tls_save)s"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>
<BR>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)